SystemOrganization addCategory: #'Qwaq-Sound'!
SystemOrganization addCategory: #'Qwaq-Sound-API'!
SystemOrganization addCategory: #'Qwaq-Sound-Chat'!
SystemOrganization addCategory: #'Qwaq-Sound-Codec'!
SystemOrganization addCategory: #'Qwaq-Sound-OpenAL'!
SystemOrganization addCategory: #'Qwaq-Sound-POTS'!
SystemOrganization addCategory: #'Qwaq-Sound-POTS-Asterisk'!
SystemOrganization addCategory: #'Qwaq-Sound-POTS-Dev'!
SystemOrganization addCategory: #'Qwaq-Sound-POTS-Feedback'!
SystemOrganization addCategory: #'Qwaq-Sound-POTS-Streams'!
SystemOrganization addCategory: #'Qwaq-Sound-Recording'!
SystemOrganization addCategory: #'Qwaq-Sound-Session'!
SystemOrganization addCategory: #'Qwaq-Sound-Speaker'!
SystemOrganization addCategory: #'Qwaq-Sound-Tests'!

QControlStreamSubscription subclass: #QPhoneUserSubscription
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Streams'!

!QPhoneUserSubscription commentStamp: '<historical>' prior: 0!
Passes requests/commands to the QPhoneUser.!

!QPhoneUserSubscription class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPhoneUserSubscription methodsFor: 'datagram-handling' stamp: 'jcg 8/31/2008 14:54'!
handleCommand: dgram
	"Handle a command that has come up to the root of the multi-cast tree."
	^user handleCommandDatagram: dgram! !

!QPhoneUserSubscription methodsFor: 'initialize' stamp: 'jcg 8/31/2008 14:52'!
user: aQPhoneUser
	user := aQPhoneUser! !

!SoundCodec class methodsFor: '*Qwaq-Sound' stamp: 'jcg 2/25/2009 18:18'!
samplingRate
	"If this codec is hardwired to a specific sampling-rate, answer it.  Otherwise, answer nil."
	^nil! !

!SoundCodec methodsFor: '*Qwaq-Sound' stamp: 'jcg 6/20/2008 11:53'!
destroy
	"No-op... QSpeexCodec needs to be explicitly destroyed, but we don't."! !

QControlStreamInput subclass: #QPhoneControlStreamInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Streams'!

!QPhoneControlStreamInput commentStamp: '<historical>' prior: 0!
Only exists for the traffic-tag.

(I began adding a 'trafficTag' instance-variable to TMediaStreamEndpoint, but realized that there would need to be a way to propagate the tag downstream to other inputs/outputs... I didn't want to get into that right now).!

!QPhoneControlStreamInput class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPhoneControlStreamInput methodsFor: 'accessing' stamp: 'jcg 7/17/2008 16:10'!
trafficTag
	"Default categorization for traffic through the channel"
	^ ControlTag! !

!Integer methodsFor: '*Qwaq-Sound' stamp: 'jcg 5/31/2010 21:00'!
asFourCC
	"Create a FourCC string from the number.  Useful for debugging OS X error-codes."
	| result | 
	self < 0 ifTrue: [self error: 'number must be >= 0'].
	result := String new: 4.
	result basicAt: 1 put: ((self bitShift: -24) bitAnd: 255).
	result basicAt: 2 put: ((self bitShift: -16) bitAnd: 255).
	result basicAt: 3 put: ((self bitShift: -8) bitAnd: 255).
	result basicAt: 4 put: (self bitAnd: 255).
	^result
	! !

Object subclass: #QAudioChunkSpacer
	instanceVariableNames: 'loop queue interval consumer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS'!

!QAudioChunkSpacer commentStamp: '<historical>' prior: 0!
We send sound in 80ms chunks (which we should perhaps revisit), but both iaxclient and the Speex jitter-buffer expect 20ms chunks.  We run into problems when we break the 80ms into 4 20ms chunks, and immediately push all 4 into either Speex or iaxclient.  Instead, we want to space the chunks out.  That is what this class does.

Instance variables:
	loop	- 	does the processing
	queue	- 	holds Arrays of 20ms chunks (typically 4).  When an array is 
				dequeued, the first chunk is played immediately, and a pause 
				is inserted before each subsequent chunk is played.
	interval	-	how long to pause before passing the next chunk to the consumer
	consumer	-	the object that is actually processing the chunks!

!QAudioChunkSpacer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioChunkSpacer methodsFor: 'accessing' stamp: 'jcg 8/21/2008 14:18'!
consumer: con
	consumer := con! !

!QAudioChunkSpacer methodsFor: 'initialize' stamp: 'jcg 9/16/2008 15:46'!
destroy
	consumer := nil.
	loop stop.! !

!QAudioChunkSpacer methodsFor: 'accessing' stamp: 'jcg 8/21/2008 15:12'!
enqueue: collectionOfChunks
	queue nextPut: collectionOfChunks! !

!QAudioChunkSpacer methodsFor: 'initialize' stamp: 'jcg 8/21/2008 15:08'!
initialize
	interval := 20 "milliseconds".
	queue := SharedQueue new.
	loop := QSafeProcessLoop new.
	loop
		priority: Processor highIOPriority;
		actionBlock: [self processNextChunks];
		handlerBlock: 
			[:err | QLogger logError: 'error: ', err description, '   consumer: ', consumer];
		start.! !

!QAudioChunkSpacer methodsFor: 'accessing' stamp: 'jcg 8/21/2008 14:18'!
interval: msecs
	interval := msecs! !

!QAudioChunkSpacer methodsFor: 'private' stamp: 'jcg 8/21/2008 14:17'!
processNextChunks
	| nextChunks |
	nextChunks := queue nextOrNil.

	"If no chunks are ready, or if we have nobody to consume them, wait at most 5ms before checking again."
	(nextChunks isNil or: [consumer isNil]) 
		ifTrue: [^(Delay forMilliseconds: (5 min: interval)) wait].

	"Process the chunks."
	nextChunks 
		do: [:chunk | consumer ifNotNilDo: [:c | c handleAudioChunk: chunk]]
		separatedBy: [(Delay forMilliseconds: interval) wait].! !

Object subclass: #QAudioDeviceManager
	instanceVariableNames: 'audioSession deviceCheckStart deviceCheckInterval defaultPlayer defaultRecorder playerDevices recorderDevices selectedPlayerDevice selectedRecorderDevice'
	classVariableNames: 'SoundEnabled'
	poolDictionaries: ''
	category: 'Qwaq-Sound-Session'!

!QAudioDeviceManager commentStamp: 'jcg 4/6/2010 15:09' prior: 0!
Keeps track of the speakers and microphone devices available to us, and manages which ones are currently active.!

!QAudioDeviceManager class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioDeviceManager class methodsFor: 'utility' stamp: 'jcg 4/6/2010 18:35'!
flattenedDeviceList: playerOrRecorderDevices
	"Flatten the current list of devices into a String of the same form as persisted in user-preferences."
	^ String streamContents: [:s | 
		| sorted |
		sorted := (playerOrRecorderDevices sort: [:a :b | a <= b]).
		sorted do: [:dev | s nextPutAll: dev] separatedBy: [s cr]
	].	! !

!QAudioDeviceManager class methodsFor: 'utility' stamp: 'bgf 5/29/2010 11:20'!
playerDevices
	"Answer a list of the available player devices considered by Forums.
	We do not alter the plugin or the Smallalk primitive access."

	self soundIsEnabled ifFalse: [ ^ #() ].
	[
		^Smalltalk platformName = 'Win32' 
			ifTrue:["No primary/default" SoundPlayer playerDevices allButFirst]
			ifFalse:[SoundPlayer playerDevices]
	] on: Error do: [ :ex |
		QLogger logWarning: 'Cannot get sound player list: ', (ex description).
		^ #()
	].! !

!QAudioDeviceManager class methodsFor: 'utility' stamp: 'jcg 4/7/2010 11:54'!
reasonableDefaultDeviceFrom: anOrderedCollection
	"Answer a good choice for a default from the given list of available devices.
	Typically the last thing plugged in, depending on how the platform orders stuff."
	anOrderedCollection ifEmpty: [^nil].
	^Smalltalk platformName = 'Win32' 
		ifTrue: [anOrderedCollection first]
		ifFalse: [anOrderedCollection last] ! !

!QAudioDeviceManager class methodsFor: 'utility' stamp: 'bgf 5/29/2010 11:20'!
recorderDevices
	"Answer a list of the available player devices considered by Forums.
	We do not alter the plugin or the Smallalk primitive access."

	self soundIsEnabled ifFalse: [ ^ #() ].
	[
		^Smalltalk platformName = 'Win32' 
			ifTrue:["No primary/default" SoundRecorder recorderDevices allButFirst]
			ifFalse:[SoundRecorder recorderDevices]
	] on: Error do: [ :ex|
		QLogger logWarning: 'Cannot get sound recorder list: ', (ex description).
		^ #()
	].! !

!QAudioDeviceManager class methodsFor: 'class variables' stamp: 'bgf 5/29/2010 11:19'!
soundIsEnabled
	^ SoundEnabled ifNil: [ true ]! !

!QAudioDeviceManager class methodsFor: 'class variables' stamp: 'bgf 5/29/2010 11:19'!
soundIsEnabled: bSound
	SoundEnabled := (bSound = true).		"Keep it boolean"! !

!QAudioDeviceManager methodsFor: 'initialize' stamp: 'jcg 4/6/2010 15:08'!
audioSession: aQAudioSession
	"Set the audio-session that this device-manager will use for the rest of its life."
	audioSession := aQAudioSession! !

!QAudioDeviceManager methodsFor: 'private' stamp: 'jcg 6/15/2010 23:53'!
checkForDeviceChange: startTime
	| msg flattened prefs pluginDevice playersChanged recordersChanged |
	startTime == deviceCheckStart ifFalse: [^self "somebody else's problem now"].

	"Don't check until we're back from away.  This avoids potential side-effects,
	 such as inadvertently turning sound on."
	audioSession ui isAway ifTrue: [
		(self future: deviceCheckInterval) checkForDeviceChange: startTime.
		^self
	].

	"Message that appears in QSoundDialog to explain to the user
	 what sort of change has occurred."
	msg := nil.

	prefs := audioSession ui preferences.

	"Check if the lists of audio-player/recorder devices have changed."
	playerDevices := self class playerDevices.
	flattened := QAudioDeviceManager flattenedDeviceList: playerDevices.
	(playersChanged := prefs audioPlayers ~= flattened) ifTrue: [
		msg := 'Available devices have changed'.
		prefs audioPlayers: flattened.
	].
	recorderDevices := self class recorderDevices.
	flattened := QAudioDeviceManager flattenedDeviceList: recorderDevices.
	(recordersChanged := prefs audioRecorders ~= flattened) ifTrue: [
		msg := 'Available devices have changed'.
		prefs audioRecorders: flattened.
	].

	"Check if the selected audio-player/recorder devices have changed."
	pluginDevice := SoundPlayer defaultPlayer.
	playersChanged ifTrue:[
		"If the player devices have changed, try to pick the last user-selected
		device so that unplugging and replugging automatically picks the 'right' choice."
		pluginDevice := playerDevices detect:[:any| any = selectedPlayerDevice] ifNone:[pluginDevice].
	].
	(pluginDevice notNil and: [defaultPlayer = pluginDevice]) ifFalse: [
		pluginDevice ifNil: [
			"Try to find a suitable device."
			pluginDevice := QAudioDeviceManager 
								reasonableDefaultDeviceFrom: playerDevices
		].
		pluginDevice 
			ifNil: [QLogger logWarning: 'no player devices are available' every: 60000]
			ifNotNil: [
				self setDefaultPlayerDevice: pluginDevice.
				"Don't change existing message... the first one set is more important."
				msg ifNil: [msg := 'Computer speaker choice has been changed']].
	].
	pluginDevice := SoundRecorder defaultRecorder.
	recordersChanged ifTrue:[
		"If the recorder devices have changed, try to pick the last user-selected
		device so that unplugging and replugging automatically picks the 'right' choice."
		pluginDevice := recorderDevices detect:[:any| any = selectedRecorderDevice] ifNone:[pluginDevice].
	].
	(pluginDevice notNil and: [defaultRecorder = pluginDevice]) ifFalse: [
		pluginDevice ifNil: [
			"Try to find a suitable device."
			pluginDevice := QAudioDeviceManager 
								reasonableDefaultDeviceFrom: recorderDevices
		].
		pluginDevice 
			ifNil: [QLogger logWarning: 'no recorder devices are available' every: 60000]
			ifNotNil: [
				self setDefaultRecorderDevice: pluginDevice.
				"Don't change existing message... the first one set is more important."
				msg ifNil: [msg := 'Computer microphone choice has been changed.']].
	].

	"Devices have changed... figure out how much resetting is necessary to do, and do it."
	(playersChanged or:[recordersChanged]) ifTrue: [
		(Smalltalk platformName = 'Win32') 
			ifTrue: [
				"We could slice this finer: if devices are only removed, not added,
				 then the OpenAL reset is not necessary."
				audioSession nextResetShouldUnloadOpenAL.
				"Trigger the reset sound via the UI... 
				 this will result in a #future send that we'll process shortly."
				"The original idea was to immediately do just the QAudioSession parts 
				 (since we're already in the correct event-loop), but ensuring that the UI 
				 would be reset properly proved to be too complicated.  Anyway, there's 
				 nothing really wrong with doing it this way".
				audioSession ui 
					signal: #resetSound 
					with: 'detected change in list of available players/recorders'
			]
			ifFalse: [
				"Something has changed, either the lists of available devices, or the 
				 currently selected device.  We don't want to do a full reset-sound, so
				 let's just reset the audio-interace."
				audioSession 
					stopMicrophoneRecordingDuring: [audioSession resetAudioInterface].
			].
	].
	
	msg ifNotNil: [
		"Something has changed, either the lists of available devices, or the 
		 currently selected device.  Notify any interested parties... let them
		 sort out the details."
		audioSession ui
			signal: #ensureOpenSoundDialog
			with: msg.
	].

	(self future: deviceCheckInterval) checkForDeviceChange: startTime.! !

!QAudioDeviceManager methodsFor: 'accessing' stamp: 'jcg 4/6/2010 18:23'!
defaultPlayer
	"Answer our cached idea of the default recorder device."
	^defaultPlayer! !

!QAudioDeviceManager methodsFor: 'accessing' stamp: 'jcg 4/6/2010 18:23'!
defaultRecorder
	"Answer our cached idea of the default recorder device."
	^defaultRecorder! !

!QAudioDeviceManager methodsFor: 'accessing' stamp: 'jcg 4/7/2010 22:37'!
deviceCheckInterval: msecs
	"Set how often the device-manager will check if the lists of available player/recorder devices have changed."
	deviceCheckInterval := msecs! !

!QAudioDeviceManager methodsFor: 'future' stamp: 'jcg 4/11/2010 11:48'!
futureDo: aSelector at: deltaMSecs args: args
	"Enqueue a message on the event queue.  The compiler has been modified to generate this message when the #future message appears in the source code."
	audioSession 
		ifNotNil: [:sess | sess futureDo: aSelector receiver: self at: deltaMSecs args: args]
		ifNil: [QLogger logInfo: 'audioSession unavailable for future-send of #', aSelector].
	^nil
! !

!QAudioDeviceManager methodsFor: 'future' stamp: 'jcg 5/7/2010 11:59'!
futureSend: aSelector at: deltaMSecs args: args
	"Enqueue a message on the event queue.  The compiler has been modified to generate this message when the #future message appears in the source code.  Answers a promise that will be resolved with the result of performing the message."
	^audioSession 
		ifNotNil: [:sess | sess futureSend: aSelector receiver: self at: deltaMSecs args: args]
		ifNil: [
			QLogger logInfo: 'audioSession unavailable for future-send of #', aSelector.
			TPromise new fulfill: nil
		].
! !

!QAudioDeviceManager methodsFor: 'private' stamp: 'jcg 4/8/2010 12:40'!
getEchoCancellationFor: deviceNamestring
	| val |
	val := audioSession ui preferences machinePreferences 
		perform: (self preference: deviceNamestring property: 'aec' isSetter: false).
	^ val ifNil: [true] ifNotNil: [val asBoolean]! !

!QAudioDeviceManager methodsFor: 'private' stamp: 'jcg 4/8/2010 09:18'!
getRecordLevelFor: deviceNamestring
	| val |
	val := audioSession ui preferences machinePreferences 
		perform:  (self preference: deviceNamestring property: 'level' isSetter: false).
	^val ifNotNil: [val asNumber]! !

!QAudioDeviceManager methodsFor: 'private' stamp: 'jcg 4/8/2010 09:19'!
getRecordThresholdFor: deviceNamestring
	| val |
	val := audioSession ui preferences machinePreferences 
		perform:  (self preference: deviceNamestring property: 'threshold' isSetter: false).
	^val ifNotNil: [val asNumber]! !

!QAudioDeviceManager methodsFor: 'initialize' stamp: 'jcg 4/6/2010 15:26'!
initialize
	super initialize.
	deviceCheckInterval := 1000 "msecs".! !

!QAudioDeviceManager methodsFor: 'initialize' stamp: 'ar 6/3/2010 10:42'!
initializeDevicesFromPreferences
	"Set initial values for the player/recorder device lists, and the default devices."
	| prefs |
	prefs := audioSession ui preferences.
	playerDevices 
		ifNotNil: [QLogger logInfo: 'player devices are already initialized']
		ifNil: [playerDevices := prefs audioPlayers].
	recorderDevices 
		ifNotNil: [QLogger logInfo: 'recorder devices are already initialized']
		ifNil: [recorderDevices := prefs audioRecorders].

	defaultPlayer ifNil: [self setManualPlayerDevice: prefs audioPlayer].
	defaultRecorder ifNil: [self setManualRecorderDevice: prefs audioRecorder].
! !

!QAudioDeviceManager methodsFor: 'accessing' stamp: 'jcg 4/7/2010 22:39'!
playerDevices
	"Answer the cached list of player devices."
	^playerDevices! !

!QAudioDeviceManager methodsFor: 'private' stamp: 'jcg 4/8/2010 09:34'!
preference: deviceNamestring property: aString isSetter: aBoolean
	"Create machine preference selector (which will appear in an XML file)."
	| s |
	s := ((deviceNamestring ifNil: ['']) encodeForHTTP), '?', aString.
	^aBoolean ifTrue: [s, ':'] ifFalse: [s].! !

!QAudioDeviceManager methodsFor: 'accessing' stamp: 'jcg 4/7/2010 22:39'!
recorderDevices
	"Answer the cached list of recorder devices."
	^recorderDevices! !

!QAudioDeviceManager methodsFor: 'accessing' stamp: 'ar 6/3/2010 14:57'!
setDefaultPlayerDevice: devName
	audioSession assertIsInTurn.
	devName ifNil: [^QLogger logWarning: 'cannot set nil player-device... exiting'].
	defaultPlayer := SoundPlayer defaultPlayer.
	defaultPlayer = devName ifTrue: [
		SoundPlayer defaultPlayer ifNotNil: [
			"If plugin's idea of default device is nil, that means the list of devices has
			 changed, so we need to set the device again (even though Smalltalk's idea
			 of the device hasn't changed.  Otherwise, nothing to do, so exit early."
			^self
		]
		ifNil: [QLogger logInfo: 'SoundPlugin defaultPlayer changed to nil... resetting'].
	].

	QLogger logInfo: 'Selecting player ', devName, '  (previously: ', defaultPlayer, ')'.
	audioSession ui preferences audioPlayer: devName.

	"XXXXX: the OS X SoundPlugin is somewhat borked.  If you unplug a device and replug
	 it, OS X assigns it a new deviceID.  However, if you try to set the new device as default,
	 the plugin finds the stale deviceID from before the unplug.  Sending this message 
	 causes the device list to be recreated with valid deviceIDs.
	 See getDeviceNameOfID() in sqMacAudioDeviceList.c, which uses the stale values."
	SoundPlayer numberOfPlayerDevices.

	audioSession microphone echoCancellationEnabled 
		ifFalse: [SoundPlayer defaultPlayer: devName]
		ifTrue: [
			"If AEC is turned on, we need it to restart the microphone so
			 that it is configured to cancel sound from the new output device."
			audioSession stopMicrophoneRecordingDuring: [
				SoundPlayer defaultPlayer: devName.
			].
		].

	"Check whether we were successful."
	defaultPlayer := SoundPlayer defaultPlayer.
	defaultPlayer = devName ifFalse: [
		QLogger logWarning: 
			'could not set player to: ', devName, '  (is now: ', defaultPlayer, ')'.
	].

	"OpenAL also needs to know what device to use."
	defaultPlayer ifNotNil: [
		"This is to avoid (harmless) log-warnings about failing to destroy the
		 OpenAL context.  What happens is that #openALDevice: causes the
		 current context to be destroyed within QAudioPlugin, but the Squeak
		 OpenAL object doesn't know it.  When #resetAudioInterface is called,
		 we destroy the OpenAL object and therefore try to destroy the context
		 again... at this point, the plugin has a NULL context, and won't destroy
		 the requested context because it doesn't match.  		 
		 We avoid this by first destroying the context before changing the 
		 OpenAL device-name (we probably want to do this more generally 
		 within #openALDevice:, but I don't want to introduce any new bugs 
		 immediately before a release)."
		audioSession audioInterface ifNotNil: [:ai | ai destroy].

		audioSession openALDevice: defaultPlayer.
		audioSession resetAudioInterface
	].

	"Update the QSoundDialog, etc."
	audioSession ui signal: #audioDeviceSettingsChanged.! !

!QAudioDeviceManager methodsFor: 'accessing' stamp: 'ar 6/3/2010 16:12'!
setDefaultRecorderDevice: devName
	| mic |
	audioSession assertIsInTurn.
	devName ifNil: [^QLogger logWarning: 'cannot set nil recorder-device... exiting'].
	defaultRecorder := SoundRecorder defaultRecorder.
	defaultRecorder = devName ifTrue: [
		SoundRecorder defaultRecorder ifNotNil: [
			"If plugin's idea of default device is nil, that means the list of devices has
			 changed, so we need to set the device again (even though Smalltalk's idea
			 of the device hasn't changed.  Otherwise, nothing to do, so exit early."
			^self
		]
		ifNil: [QLogger logInfo: 'SoundPlugin defaultRecorder changed to nil... resetting'].
	].

	QLogger logInfo: 'Selecting recorder ', devName, '  (previously: ', defaultRecorder, ')'.
	audioSession ui preferences audioRecorder: devName.

	"XXXXX: the OS X SoundPlugin is somewhat borked.  If you unplug a device and replug
	 it, OS X assigns it a new deviceID.  However, if you try to set the new device as default,
	 the plugin finds the stale deviceID from before the unplug.  Sending this message 
	 causes the device list to be recreated with valid deviceIDs.
	 See getDeviceNameOfID() in sqMacAudioDeviceList.c, which uses the stale values."
	SoundRecorder numberOfRecorderDevices.

	audioSession stopMicrophoneRecordingDuring: [
		SoundRecorder defaultRecorder: devName.
	].
	"Check whether we were successful."
	defaultRecorder := SoundRecorder defaultRecorder.
	defaultRecorder = devName ifFalse: [
		QLogger logWarning: 'could not set recorder to: ', devName,'  (is now: ', defaultRecorder, ')'.
	].

	defaultRecorder ifNotNil: [
		QLogger logInfo: 'updating microphone record-level and threshold'.
		mic := audioSession microphone.
		(self getRecordLevelFor: defaultRecorder) 
			ifNotNilDo: [:level | mic recordLevel: level].
		(self getRecordThresholdFor: defaultRecorder) 
			ifNotNilDo: [:thresh | mic noiseThreshold: thresh].
		SoundRecorder supportsEchoCancellation ifTrue: [
			(self getEchoCancellationFor: defaultRecorder) ifNotNilDo: [:wantAEC |
				audioSession stopMicrophoneRecordingDuring: [
					mic enableEchoCancellation: wantAEC
				].
			].
		].
	].
	
	"Update the QSoundDialog, etc."
	audioSession ui signal: #audioDeviceSettingsChanged.
! !

!QAudioDeviceManager methodsFor: 'accessing' stamp: 'ar 6/3/2010 10:42'!
setManualPlayerDevice: devName
	"Sets the device from a user's selection"
	audioSession assertIsInTurn.
	selectedPlayerDevice := devName.
	self setDefaultPlayerDevice: devName.
! !

!QAudioDeviceManager methodsFor: 'accessing' stamp: 'ar 6/3/2010 10:42'!
setManualRecorderDevice: devName
	"Sets the device from a user's selection"
	audioSession assertIsInTurn.
	selectedRecorderDevice := devName.
	self setDefaultRecorderDevice: devName.
! !

!QAudioDeviceManager methodsFor: 'device-checker' stamp: 'jcg 4/6/2010 15:41'!
startCheckingForDeviceChanges
	"Start checking for device changes.  This triggers a recursive future-send; to avoid triggering multiple send-chains, we record the start-time, and terminate a chain if the time changes (see #checkForDeviceChange:)"
	audioSession assertIsInTurn. "explode if we're not"
	(self future: deviceCheckInterval) 
		checkForDeviceChange: (deviceCheckStart := Time millisecondClockValue).

! !

!QAudioDeviceManager methodsFor: 'device-checker' stamp: 'jcg 4/8/2010 00:18'!
stopCheckingForDeviceChanges
	"Stop checking for device changes."
	audioSession assertIsInTurn. "explode if we're not"
	deviceCheckStart := nil.
! !

Object subclass: #QAudioFormat
	instanceVariableNames: 'codecClass samplingRate numChannels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Speaker'!

!QAudioFormat commentStamp: '<historical>' prior: 0!
Simple holder-object for audio-format parameters.  Typically, users of the QClientSpeaker framework set the audio-format of the QClientSpeakerInput.  Format changes propagate down to the speaker, and cause a new speaker-output to be created.!

!QAudioFormat class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioFormat class methodsFor: 'instance creation' stamp: 'jcg 8/17/2009 12:04'!
codecClass: cls samplingRate: rate numChannels: num
	^self new 
		codecClass: cls samplingRate: rate numChannels: num;
		yourself! !

!QAudioFormat methodsFor: 'comparing' stamp: 'jcg 8/17/2009 12:01'!
= aQAudioFormat
	self class == aQAudioFormat class ifFalse: [^false].
	codecClass == aQAudioFormat codecClass ifFalse: [^false].
	samplingRate == aQAudioFormat samplingRate ifFalse: [^false].
	numChannels == aQAudioFormat numChannels ifFalse: [^false].! !

!QAudioFormat methodsFor: 'accessing' stamp: 'jcg 8/17/2009 12:02'!
codecClass
	^codecClass! !

!QAudioFormat methodsFor: 'initialize' stamp: 'jcg 8/17/2009 12:03'!
codecClass: cls samplingRate: rate numChannels: num
	codecClass := cls.
	samplingRate := rate.
	numChannels := num.! !

!QAudioFormat methodsFor: 'accessing' stamp: 'jcg 8/17/2009 12:02'!
numChannels
	^samplingRate! !

!QAudioFormat methodsFor: 'accessing' stamp: 'jcg 8/17/2009 12:02'!
samplingRate
	^samplingRate! !

Object subclass: #QAudioSink
	instanceVariableNames: 'handle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Codec'!

!QAudioSink commentStamp: 'jcg 9/5/2008 17:10' prior: 0!
Used for:
	- playing audio through jitterbuffer
	- mixing multiple audio-streams together before sending them to POTS

Subclasses act as audio "pipeline stages" along the lines of GStreamer elements (or DirectShow).  The common feature of all subclasses is that they are 'ticked' by a high-priority timer process in QAudioPlugin (of course, the actions that they take when ticked are different).!

!QAudioSink class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioSink methodsFor: 'initialize' stamp: 'jcg 9/5/2008 17:43'!
createHandle
	handle := self primCreateHandle.! !

!QAudioSink methodsFor: 'initialize' stamp: 'jcg 9/5/2008 17:45'!
destroy
	self destroyHandle.! !

!QAudioSink methodsFor: 'initialize' stamp: 'jcg 9/5/2008 17:45'!
destroyHandle
	handle ifNotNilDo: [:h |
		handle := nil.
		self primDestroyHandle: h.
	]! !

!QAudioSink methodsFor: 'private-accessing' stamp: 'jcg 2/27/2010 01:47'!
getEventTimings
	| timings stream bigEndian version numEntries numDiscarded events |
	timings := handle ifNotNilDo: [:h | self primGetEventTimings: h].
	timings ifNil: [^nil].
	stream := ReadStream on: timings.
	bigEndian := Smalltalk isBigEndian.
	bigEndian ifTrue: [
		QLogger 
			logWarning: '#getEventTimings not tested for big-endian machines'
			every: 60000.
	].
	version := (stream next: 4) longAt: 1 bigEndian: bigEndian.
	numEntries := (stream next: 4) longAt: 1 bigEndian: bigEndian.
	numDiscarded := (stream next: 4) longAt: 1 bigEndian: bigEndian.
	stream next: 20.  "skip next 5 reserved integers"
	events := OrderedCollection new.
	(numEntries max: 0) timesRepeat: [
		| appTime utcTime |
		appTime := (stream next: 4) longAt: 1 bigEndian: bigEndian.
		utcTime := (stream next: 8) asInteger "XXXXX: ok with big-endian?".
		events add: appTime->utcTime.
	].
	^ {version. numEntries. numDiscarded. events}

	! !

!QAudioSink methodsFor: 'private-accessing' stamp: 'jcg 6/24/2008 10:42'!
handle
	"This should only be called by other sub-instances of QAudioSink."
	^handle! !

!QAudioSink methodsFor: 'initialize' stamp: 'jcg 9/5/2008 17:43'!
initialize
	self createHandle.
! !

!QAudioSink methodsFor: 'playing' stamp: 'jcg 2/25/2010 00:55'!
playSoundData: data timestamp: timestamp
	"Common interface between sinks that you can push data into.  Should only be implemented by subclasses that you push data into from Squeak, not those that get data from upstream sinks in the pipeline."
	self subclassResponsibility! !

!QAudioSink methodsFor: 'primitives' stamp: 'jcg 6/23/2008 00:20'!
prim: myHandle addSource: sourceHandle
	<primitive: 'primitiveSinkAddSource' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSink methodsFor: 'primitives' stamp: 'jcg 6/23/2008 00:20'!
prim: myHandle removeSource: sourceHandle
	<primitive: 'primitiveSinkRemoveSource' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSink methodsFor: 'primitives' stamp: 'jcg 8/12/2009 16:28'!
primControl: handleInt ctlType: type ctlValue: value
	"Make it easier to add new ways to control sinks without writing new Slang for each one."
	<primitive: 'primitiveSinkControl' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSink methodsFor: 'primitives' stamp: 'jcg 6/23/2008 00:20'!
primCreateHandle
	"Subclasses need separate creation primitives, obviously."
	self subclassResponsibility! !

!QAudioSink methodsFor: 'primitives' stamp: 'jcg 6/24/2008 00:02'!
primDestroyHandle: h
	<primitive: 'primitiveDestroySink' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSink methodsFor: 'primitives' stamp: 'jcg 2/27/2010 00:48'!
primGetEventTimings: myHandle
	<primitive: 'primitiveSinkGetEventTimings' module: 'QAudioPlugin'>
	^self primitiveFailed! !

QAudioSink subclass: #QAudioSinkBufferedResampler
	instanceVariableNames: 'inputSamplingRate outputSamplingRate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Codec'!

!QAudioSinkBufferedResampler commentStamp: '<historical>' prior: 0!
Resamples 20ms audio-segments and stores them in a plugin-side ring-buffer.  Like QAudioSinkSpeex, it is intended to be the source of a pipeline (you push data into it from Squeak, it doesn't pull from another sink).!

!QAudioSinkBufferedResampler class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioSinkBufferedResampler methodsFor: 'accessing' stamp: 'jcg 6/30/2010 08:35'!
bufferedFrameCount: frameCount "# of 20ms frames"
	[handle ifNotNil: [:h | self prim: h setBufferedFrameCount: frameCount]]
		on: Error 
		do: [:err | QLogger logWarning: 'failed to set sink buffer size: ', err description]! !

!QAudioSinkBufferedResampler methodsFor: 'accessing' stamp: 'jcg 6/10/2009 14:26'!
inputSamplingRate
	^inputSamplingRate! !

!QAudioSinkBufferedResampler methodsFor: 'accessing' stamp: 'jcg 6/10/2009 14:28'!
inputSamplingRate: newRate
	inputSamplingRate == newRate ifTrue: [^self "no change"].
	inputSamplingRate := newRate.
	handle ifNotNil: [self prim: handle setInputSamplingRate: inputSamplingRate]! !

!QAudioSinkBufferedResampler methodsFor: 'accessing' stamp: 'jcg 6/10/2009 14:26'!
outputSamplingRate
	^outputSamplingRate! !

!QAudioSinkBufferedResampler methodsFor: 'accessing' stamp: 'jcg 6/10/2009 14:28'!
outputSamplingRate: newRate
	outputSamplingRate == newRate ifTrue: [^self "no change"].
	outputSamplingRate := newRate.
	handle ifNotNil: [self prim: handle setOutputSamplingRate: outputSamplingRate]! !

!QAudioSinkBufferedResampler methodsFor: 'playing' stamp: 'jcg 2/25/2010 00:56'!
playSoundData: data timestamp: timestamp "ignored, for now"
	"Common interface between sinks that you can push data into."
	self pushRawAudio: data ! !

!QAudioSinkBufferedResampler methodsFor: 'primitives' stamp: 'jcg 6/9/2009 15:23'!
prim: handleInt pushRawAudio: aSoundBuffer
	<primitive: 'primitiveSinkPushRawAudio' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkBufferedResampler methodsFor: 'primitives' stamp: 'jcg 6/28/2010 12:29'!
prim: handleInt setBufferedFrameCount: frameCount "number of 20ms frames"
	<primitive: 'primitiveSinkSetBufferedFrameCount' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkBufferedResampler methodsFor: 'primitives' stamp: 'jcg 6/9/2009 15:21'!
prim: handleInt setInputSamplingRate: rate "in Hz"
	<primitive: 'primitiveSinkSetInputSamplingRate' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkBufferedResampler methodsFor: 'primitives' stamp: 'jcg 6/9/2009 15:22'!
prim: handleInt setOutputSamplingRate: rate "in Hz"
	<primitive: 'primitiveSinkSetOutputSamplingRate' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkBufferedResampler methodsFor: 'primitives' stamp: 'jcg 6/10/2009 18:01'!
primCreateHandle
	<primitive: 'primitiveCreateSinkBufferedResampler' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkBufferedResampler methodsFor: 'actions' stamp: 'jcg 6/10/2009 13:19'!
pushRawAudio: soundBuffer
	handle ifNotNil: [
		self prim: handle pushRawAudio: soundBuffer
	].! !

QAudioSink subclass: #QAudioSinkFeedback
	instanceVariableNames: 'source channel audioFrames debugRecording'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Codec'!

!QAudioSinkFeedback commentStamp: '<historical>' prior: 0!
Pipes sound received from the 'source' back into Squeak for debuggin'.

For lack of a better place to put it, here is the workspace code I used while debugging the jitter-buffer.


[	recorder := SoundRecorder new samplingRate: 16000.
	recorder clearRecordedSound.
        
	recorder startRecording.
        
	recorder resumeRecording.

        

	(Delay forSeconds: 10) wait.

        

	recorder stopRecording.

] fork



snd := recorder recordedSound asSampledSound.

spx := QSpeexCodec encodeSpeexInChunksOf320: snd.



QwaqAudioSession primSetPluginVerbosity: 10.
QwaqAudioSession primSetPluginVerbosity: 5.
QwaqAudioSession primSetPluginVerbosity: 0.


oal ifNotNil: [oal destroy]. oal := OpenAL new. oal makeCurrent.

spxSink := QAudioSinkSpeex new.

	oalSink := QAudioSinkOpenAL new.

	oalSink source: spxSink.
	
debugSink := QAudioSinkDebugFeedback new.

debugSink source: spxSink.



oalSink destroy. spxSink destroy. debugSink destroy. oalSink := spxSink := debugSink := nil.



pattern := Array streamContents: [:s | 
	300 timesRepeat: [s nextPut: #put; nextPut: #get].
	s nextPut: #get; nextPut: #get.
	s nextPut: #put; nextPut: #put.
	"s nextPut: #get; nextPut: #put."
	100 timesRepeat: [s nextPut: #put; nextPut: #get].
].
spxSink playThroughSpeexBytesTicking: spx usingPattern: pattern.
spxSink playThroughSpeexBytesTicking: spx.


spxSink playThroughSpeexBytes: spx.




spxSink resetJitterbufferTimestamps.
spxSink jitterBufferCtl: 13 value: -7.

debugSink makeSound play.
debugSink resetAudioFrames.


snd play


Smalltalk unloadModule: 'QAudioPlugin'

oal ifNotNil: [oal destroy]. oal := OpenAL new. oal makeCurrent.

QwaqAudioSession primSetPluginVerbosity: 5.
spxSink2 := QAudioSinkSpeex new.

oalSink2 := QAudioSinkOpenAL new.

oalSink2 source: spxSink2.


spxSink2 playThroughSpeexBytes: spx.


oalSink2 playThroughSpeexBytesTestingJB: spx.



oalSink2 destroy. spxSink2 destroy. oalSink2 := spxSink2 := nil.

!

!QAudioSinkFeedback class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioSinkFeedback methodsFor: 'initialize' stamp: 'jcg 6/12/2009 20:27'!
createHandle
	channel ifNil: [
		channel := QAudioFeedbackChannel new.
		channel eventHandler: self.
	].
	handle := self primCreateHandle: channel getHandle.! !

!QAudioSinkFeedback methodsFor: 'accessing' stamp: 'jcg 9/22/2008 18:51'!
decodedFrameCount
	^audioFrames size! !

!QAudioSinkFeedback methodsFor: 'initialize' stamp: 'jcg 9/16/2008 23:00'!
destroyHandle
	super destroyHandle.
	channel ifNotNilDo: [:ch | ch destroy. channel := nil].
! !

!QAudioSinkFeedback methodsFor: 'debugging' stamp: 'jcg 8/12/2009 18:41'!
finishDebugRecording
	"Use #startDebugRecording to start recording a SampledSound, and #finishDebugRecording to obtain it."
	^debugRecording ifNotNilDo: [:dbg |
		debugRecording := nil.
		SampledSound samples: dbg contents samplingRate: 16000.
	]! !

!QAudioSinkFeedback methodsFor: 'initialize' stamp: 'jcg 9/6/2008 18:35'!
initialize
	super initialize.
	self resetAudioFrames.! !

!QAudioSinkFeedback methodsFor: 'accessing' stamp: 'jcg 8/10/2009 14:55'!
makeSound
	| stream |
	audioFrames isEmpty ifTrue: [^nil].
	stream := WriteStream on: (SoundBuffer newMonoSampleCount: 640).
	[audioFrames nextOrNil] whileNotNilDo: [:frame |
		stream nextPutAll: frame buffer
	].
	^ SampledSound samples: stream contents samplingRate: 16000.
	! !

!QAudioSinkFeedback methodsFor: 'accessing' stamp: 'jcg 8/10/2009 15:00'!
nextAudioFrame
	^audioFrames nextOrNil! !

!QAudioSinkFeedback methodsFor: 'primitives' stamp: 'jcg 9/6/2008 18:30'!
primCreateHandle: feedbackChannelHandle
	<primitive: 'primitiveCreateSinkForDebugFeedback' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkFeedback methodsFor: 'feedback-events' stamp: 'jcg 8/12/2009 18:42'!
processFeedbackChannelEvent:  aQDecodedAudioSegmentFeedback from: channel
	audioFrames nextPut: aQDecodedAudioSegmentFeedback.
	self signal: #receivedFrame.

	"See #start/finishDebugRecording"
	debugRecording ifNotNilDo: [:dbg |
		dbg nextPutAll: aQDecodedAudioSegmentFeedback buffer
	].! !

!QAudioSinkFeedback methodsFor: 'private' stamp: 'jcg 9/6/2008 18:57'!
removeSource
	source ifNil: [^self].
	(handle isNil | source handle isNil) ifTrue: [^source := nil].
	self prim: handle removeSource: source handle.
	source := nil.
! !

!QAudioSinkFeedback methodsFor: 'initialize' stamp: 'jcg 8/10/2009 14:50'!
resetAudioFrames
	audioFrames := SharedQueue new.! !

!QAudioSinkFeedback methodsFor: 'private' stamp: 'jcg 9/6/2008 18:56'!
source: aQAudioSink
	source == aQAudioSink ifTrue: [^self].
	self removeSource.
	source := aQAudioSink.
	source ifNil: [^self].
	source handle 
		ifNil: ["XXXXX: not sure if we should raise an alarm if source doesn't have a handle"]
		ifNotNil: [self prim: handle addSource: source handle].
	^source
! !

!QAudioSinkFeedback methodsFor: 'debugging' stamp: 'jcg 8/12/2009 18:41'!
startDebugRecording
	"Use #startDebugRecording to start recording a SampledSound, and #finishDebugRecording to obtain it."
	self finishDebugRecording.
	debugRecording := WriteStream on: (SoundBuffer newMonoSampleCount: 100).! !

QAudioSink subclass: #QAudioSinkMixer
	instanceVariableNames: 'sources'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Codec'!

!QAudioSinkMixer commentStamp: '<historical>' prior: 0!
Mixes the output from a number of other sinks.

See example on class side: #mixWAVFiles:repeatTimes:!

!QAudioSinkMixer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioSinkMixer class methodsFor: 'testing' stamp: 'jcg 3/31/2010 11:32'!
mixWAVFiles: fileNames repeatTimes: repeats
	"Encode the specified files as Speex, play them through the speex jitter-buffer, mix the results, and read them back into the image.  Each file may be played 1 or more times, according to the corresponding value in 'repeats'. See the following snippet for an example... the mic-check is played 12 times, and all other files played once."

"fileNames := #(
	'Qwaq-MicCheck-16000Hz.wav'
	'MatrixReloaded-FightBeforeOracle.wav'
	'MatrixReloaded-ArchitectSceneShort.wav'
	'Saul-ShaClackClack.wav'
	'Slam-Amethyst.wav'
).

mixedSound := QAudioSinkMixer
					mixWAVFiles: fileNames
					repeatTimes: #(12 1 1 1 1).

mixedSound play."
	| interval sounds encoded spxSinks mixSink outSink promises mixedSound |

	interval := 20. "milliseconds per Speex frame"
	QAudioSession primAudioPluginTickerSetInterval: interval.
	QAudioSession primAudioPluginTickerStart.

	sounds := fileNames collect: [:fname |
		| file snd |
		file := FileStream readOnlyFileNamed: fname.
		snd := SampledSound fromWaveStream: file.
		file close.
		snd.
	].

	encoded := OrderedCollection new.
	sounds withIndexDo: [:snd :i |
		| bytes stream |
		bytes := QSpeexCodec encodeSpeexInChunksOf320: snd.
		"Concatenate multiple copies together."
		stream := WriteStream on: ByteArray new.
		(repeats at: i) timesRepeat: [stream nextPutAll: bytes].
		bytes := stream contents.
		encoded add: bytes.
	].

	spxSinks := encoded collect: [:ignore | QAudioSinkSpeex new].
	mixSink := QAudioSinkMixer new.
	outSink := QAudioSinkFeedback new.

	"Hook up the pipeline."
	spxSinks do: [:src | mixSink addSource: src].
	outSink source: mixSink.

	promises := OrderedCollection new.
	spxSinks withIndexDo: [:spx :i | 
		promises add: (spx playThroughSpeexBytes: (encoded at: i))
	].
	promises do: [:p | p wait].
	(Delay forMilliseconds: 500) wait.

	mixedSound := outSink makeSound.
	spxSinks do: [:src | src destroy].
	mixSink destroy.
	outSink destroy.

	^mixedSound! !

!QAudioSinkMixer methodsFor: 'accessing' stamp: 'crl 4/23/2010 17:58'!
addSource: src "a QAudioSink"
	handle ifNil: [QLogger logWarning: 'I have no handle in #addSource:'. ^src].
	src handle 
		ifNil: [QLogger logWarning: 'src has no handle in #addSource:']
		ifNotNilDo: [:h |
			self prim: handle addSource: h.
			sources add: src].
	^src! !

!QAudioSinkMixer methodsFor: 'initialize' stamp: 'crl 4/23/2010 18:59'!
initialize
	super initialize.
	sources := OrderedCollection new! !

!QAudioSinkMixer methodsFor: 'primitives' stamp: 'jcg 5/14/2009 16:15'!
primCreateHandle
	<primitive: 'primitiveCreateSinkMixer' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkMixer methodsFor: 'accessing' stamp: 'crl 4/23/2010 17:58'!
removeSource: src "a QAudioSink"
	handle ifNil: [QLogger logWarning: 'I have no handle in #removeSource:'. ^src].
	src handle 
		ifNil: [QLogger logWarning: 'src has no handle in #removeSource:']
		ifNotNilDo: [:h |
			self prim: handle removeSource: h.
			sources remove: src].
	^src! !

QAudioSink subclass: #QAudioSinkOpenAL
	instanceVariableNames: 'source transform gain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Codec'!

!QAudioSinkOpenAL commentStamp: 'jcg 9/5/2008 17:25' prior: 0!
Plays sound received from the 'source'.  This is typically directly from a QAudioSinkSpeex (to provide de-jittered audio), but we might also play audio from eg: a QAudioSinkSpeexPOTS (to test whether we are mixing the audio streams together properly).

For debugging (to make sure that anything at all works) can also play uncompressed sound fed in from Squeak.!

!QAudioSinkOpenAL class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioSinkOpenAL methodsFor: 'initialize' stamp: 'jcg 6/8/2010 23:25'!
destroy
	"Disconnect source before destroying... as soon as this is done, we know that no more data will flow to the sink (even if the source already has some buffered in the plugin)."
	self removeSource.
	super destroy.! !

!QAudioSinkOpenAL methodsFor: 'accessing' stamp: 'jcg 8/20/2008 16:01'!
gain
	^ gain! !

!QAudioSinkOpenAL methodsFor: 'accessing' stamp: 'jcg 8/20/2008 16:13'!
gain: newGain
	gain = newGain ifTrue: [^self].
	gain := newGain.
	handle ifNotNil: [self primitiveSink: handle setGain: gain]
! !

!QAudioSinkOpenAL methodsFor: 'initialize' stamp: 'jcg 8/20/2008 16:01'!
initialize
	super initialize.
	transform := Matrix4x4 identity.
	gain := 1.0.! !

!QAudioSinkOpenAL methodsFor: 'utility/testing' stamp: 'jcg 9/9/2008 21:31'!
playThroughSpeexBytes: speexBytes
	"For testing.  Spawn a process that plays through the encoded Speex bytes."
	| interval  start targetTime stream decoder buffer |
	interval := 20.  "milliseconds per 'chunk' of speex"
	targetTime := interval negated * 2.
	start := Time millisecondClockValue.
	stream := ReadStream on: speexBytes.
	decoder := QSpeexCodec new.
	[
		[stream atEnd] whileFalse: [
			| numFrames |
			numFrames := stream next.
			'# of frames: ', numFrames displayAt: 0@0.

			numFrames timesRepeat: [
				| chunkSize chunk delay |
				chunkSize := stream next.
				chunk := stream next: chunkSize.
				'chunk size: ', chunk size displayAt: 0@30.

				buffer := SoundBuffer newMonoSampleCount: 320.
				decoder decode: chunk into: buffer.

				"XXXXX: obviously not robust (eg: what if handle is not there?)"
				self primitiveSinkPlayDebugAudioDirectlyViaOpenAL: handle soundBuffer: buffer.

				targetTime := targetTime + interval.
				delay := targetTime - (Time millisecondsSince: start).
				delay >= 0 
					ifTrue: [(Delay forMilliseconds: delay) wait]
					ifFalse: [QLogger log: '#playThroughSpeexBytes: delay<0 : ', delay from: self].
			].
		].
		decoder destroy.
		QLogger 
			log: '#playThroughSpeexBytes:  finished in ', (Time millisecondsSince: start), ' msecs'
			from: self.
	] forkAt: Processor lowIOPriority
	! !

!QAudioSinkOpenAL methodsFor: 'utility/testing' stamp: 'jcg 9/9/2008 21:34'!
playThroughSpeexBytesTestingJB: speexBytes
	"For testing.  Spawn a process that plays through the encoded Speex bytes."
	| interval  start targetTime stream decoder buffer |
	interval := 20.  "milliseconds per 'chunk' of speex"
	targetTime := interval negated * 2.
	start := Time millisecondClockValue.
	stream := ReadStream on: speexBytes.
	decoder := QSpeexCodec new.
	[
		[stream atEnd] whileFalse: [
			| numFrames |
			numFrames := stream next.
			'# of frames: ', numFrames displayAt: 0@0.

			numFrames timesRepeat: [
				| chunkSize chunk delay |
				chunkSize := stream next.
				chunk := stream next: chunkSize.
				'chunk size: ', chunk size displayAt: 0@30.

				buffer := SoundBuffer newMonoSampleCount: 320.
				decoder decodeUsingJB: chunk into: buffer.

				"XXXXX: obviously not robust (eg: what if handle is not there?)"
				self primitiveSinkPlayDebugAudioDirectlyViaOpenAL: handle soundBuffer: buffer.

				targetTime := targetTime + interval.
				delay := targetTime - (Time millisecondsSince: start).
				delay >= 0 
					ifTrue: [(Delay forMilliseconds: delay) wait]
					ifFalse: [QLogger log: '#playThroughSpeexBytesToTestJB: delay<0 : ', delay from: self].
			].
		].
		decoder destroy.
		QLogger 
			log: '#playThroughSpeexBytesToTestJB:  finished in ', (Time millisecondsSince: start), ' msecs'
			from: self.
	] forkAt: Processor lowIOPriority
	! !

!QAudioSinkOpenAL methodsFor: 'primitives' stamp: 'jcg 6/23/2008 23:57'!
primCreateHandle
	<primitive: 'primitiveCreateSinkOpenAL' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkOpenAL methodsFor: 'primitives' stamp: 'jcg 8/20/2008 16:07'!
primitiveSink: handleInt setGain: newGain
	"handle is an unsigned int, everything else is a float"
	<primitive: 'primitiveSinkSetGainOpenAL' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkOpenAL methodsFor: 'primitives' stamp: 'jcg 8/20/2008 23:12'!
primitiveSink: handleInt setRefDist: refDist maxDist: maxDist rolloff: rolloff innerAngle: innerAngle outerAngle: outerAngle outerGain: outerGain
	"handle is an unsigned int, everything else is a float"
	<primitive: 'primitiveSinkSetInitialPropertiesOpenAL' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkOpenAL methodsFor: 'primitives' stamp: 'jcg 6/26/2008 11:02'!
primitiveSinkPlayDebugAudioDirectlyViaOpenAL: handle soundBuffer: aSoundBuffer
	"handle is an unsigned int, everything else is a float"
	<primitive: 'primitiveSinkPlayDebugAudioDirectlyViaOpenAL' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkOpenAL methodsFor: 'primitives' stamp: 'jcg 6/25/2008 11:10'!
primitiveSinkSetTransformOpenAL: handle posX: posX posY: posY posZ: posZ dirX: dirX dirY: dirY dirZ: dirZ
	"handle is an unsigned int, everything else is a float"
	<primitive: 'primitiveSinkSetTransformOpenAL' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkOpenAL methodsFor: 'private' stamp: 'jcg 6/23/2008 00:13'!
removeSource
	source ifNil: [^self].
	(handle isNil | source handle isNil) ifTrue: [^source := nil].
	self prim: handle removeSource: source handle.
	source := nil.
! !

!QAudioSinkOpenAL methodsFor: 'accessing' stamp: 'bgf 8/21/2008 21:30'!
setRefDist: refDist maxDist: maxDist rolloff: rolloff innerAngle: innerAngle outerAngle: outerAngle outerGain: outerGain
	"Set a whole bunch of OpenAL properties at once... typically only done at initialization."
	handle ifNotNil: [

		[
		self 
			primitiveSink: handle 
			setRefDist: refDist 
			maxDist: maxDist 
			rolloff: rolloff 
			innerAngle: innerAngle 
			outerAngle: outerAngle 
			outerGain: outerGain
		] on: Error do: [ 
			QLogger logWarning: 'QAudioSink setup primitive failed (work in progress?)'
		].
	]! !

!QAudioSinkOpenAL methodsFor: 'accessing' stamp: 'jcg 6/22/2008 17:04'!
source
	^source! !

!QAudioSinkOpenAL methodsFor: 'private' stamp: 'jcg 6/9/2010 02:02'!
source: aQAudioSink
	source == aQAudioSink ifTrue: [^self].
	self removeSource.
	source := aQAudioSink.
	source ifNil: [^self].
	source handle 
		ifNil: [QLogger logWarning: 'source has no handle']
		ifNotNil: [self prim: handle addSource: source handle].
	^source
! !

!QAudioSinkOpenAL methodsFor: 'accessing' stamp: 'jcg 6/25/2008 11:00'!
transform
	^ transform! !

!QAudioSinkOpenAL methodsFor: 'accessing' stamp: 'jcg 6/25/2008 11:35'!
transform: newTransform
	transform = newTransform ifTrue: [^self].
	transform := newTransform.
	handle ifNotNil: [
		| pos dir |
		pos := transform translation.
		dir := transform column3 normalized.
		self 
			primitiveSinkSetTransformOpenAL: handle 
			posX: pos x posY: pos y posZ: pos z
			dirX: dir x dirY: dir y dirZ: dir z.
	]
! !

QAudioSink subclass: #QAudioSinkPOTS
	instanceVariableNames: 'sources'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS'!

!QAudioSinkPOTS class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioSinkPOTS methodsFor: 'initialize' stamp: 'jcg 6/22/2008 17:03'!
initialize
	super initialize.
	sources := OrderedCollection new.! !

!QAudioSinkPOTS methodsFor: 'primitives' stamp: 'jcg 6/23/2008 23:58'!
primCreateHandle
	<primitive: 'primitiveCreateSinkPOTS' module: 'QAudioPlugin'>
	^self primitiveFailed! !

QAudioSink subclass: #QAudioSinkPortAudio
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Codec'!

!QAudioSinkPortAudio commentStamp: 'jcg 6/5/2009 11:09' prior: 0!
Plays sound using the cross-platform PortAudio API.!

!QAudioSinkPortAudio class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioSinkPortAudio methodsFor: 'primitives' stamp: 'jcg 6/5/2009 10:43'!
primCreateHandle
	<primitive: 'primitiveCreateSinkPortAudio' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkPortAudio methodsFor: 'private' stamp: 'jcg 6/6/2009 14:19'!
removeSource
	source ifNil: [^self].
	(handle isNil | source handle isNil) ifTrue: [^source := nil].
	self prim: handle removeSource: source handle.
	source := nil.
! !

!QAudioSinkPortAudio methodsFor: 'accessing' stamp: 'jcg 5/31/2009 11:18'!
source
	^source! !

!QAudioSinkPortAudio methodsFor: 'accessing' stamp: 'jcg 5/31/2009 11:18'!
source: aQAudioSink
	source == aQAudioSink ifTrue: [^self].
	self removeSource.
	source := aQAudioSink.
	source ifNil: [^self].
	source handle 
		ifNil: ["XXXXX: not sure if we should raise an alarm if source doesn't have a handle"]
		ifNotNil: [self prim: handle addSource: source handle].
	^source
! !

QAudioSink subclass: #QAudioSinkSpeex
	instanceVariableNames: 'marginRange currentMargin shortWindow longWindow profiler lastMarginAdjustTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Codec'!

!QAudioSinkSpeex commentStamp: 'jcg 9/5/2008 17:19' prior: 0!
Provides Squeak-side API for pushing audio into a jitter-buffer.  When "ticked" (see superclass comment) it pulls a decoded audio-frame out of the jitter-buffer; this frame can then be used by sinks further down the pipeline.!

!QAudioSinkSpeex class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioSinkSpeex class methodsFor: 'utility' stamp: 'jcg 9/27/2008 14:17'!
parseDebugRecordFile: filePath
	| file result | 
	file := FileStream fileNamed: filePath.
	result := self parseDebugRecordStream: file.
	file close.
	^result! !

!QAudioSinkSpeex class methodsFor: 'utility' stamp: 'jcg 9/27/2008 15:01'!
parseDebugRecordStream: strm
	| events | 

	events := OrderedCollection new.
	[strm atEnd] whileFalse: [
		| evt |
		evt := strm upTo: $-.
		evt caseOf: {
			['put'] -> [
				| timeStamp size bytes |
				strm next. "skip $[ "
				timeStamp := (strm upTo: $]) asInteger.
				strm next. "skip $- "
				size := (strm upTo: $-) asInteger.
				bytes := TObjectID basicNew: size.
				bytes readHexFrom: strm.
				bytes := bytes asByteArray.
				events add: (evt -> {timeStamp. bytes}).
			].
			['get'] -> [
				| timeStamp size bytes |
				strm next. "skip $[ "
				timeStamp := (strm upTo: $]) asInteger.
				strm next. "skip $- "
				size := (strm upTo: $-) asInteger.
				bytes := TObjectID basicNew: size.
				bytes readHexFrom: strm.
				bytes := bytes asByteArray.
				events add: (evt -> {timeStamp. bytes}).
			].
			['reset1'] -> [
				events add: evt->nil.
			].
			['reset2'] -> [
				events add: evt->nil.
			].
		} otherwise: [QLogger logWarning: 'did not understand event: ', evt].
		strm upTo: Character lf.
	].
	^events! !

!QAudioSinkSpeex methodsFor: 'private' stamp: 'jcg 3/18/2010 14:23'!
adjustJitterbufferMargin
	"Decide whether we need to adjust the jitterbuffer margin."
	| stats |
	lastMarginAdjustTime := Time coarseClockValue.
	stats := self stats.
	(longWindow extrapolationRateFor: stats) ifNotNilDo: [:rate |
		(rate = 0.0 and: [currentMargin > marginRange min]) ifTrue: [
			"Drop the margin by 80ms."
			self currentMargin: currentMargin - 1280.
		].
	].
	(shortWindow extrapolationRateFor: stats) ifNotNilDo: [:rate |
		(rate >= 0.01 and: [currentMargin < marginRange max]) ifTrue: [
			"Increase the margin by 80ms."
			self currentMargin: currentMargin + 1280.
		].
	].
! !

!QAudioSinkSpeex methodsFor: 'playing' stamp: 'jcg 3/18/2010 14:18'!
beginSilentPeriod
	"Just received an end-of-utterance notification."
	self adjustJitterbufferMargin.
	self resetJitterbufferTimestamps.
	profiler clear.
	! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 10/16/2008 23:09'!
ctlGetActivityThreshold
	"Speex decoder activity threshold below which it is OK to do a jitter_buffer_update_delay(). "
	"#define QWAQ_JITTER_BUFFER_GET_ACTIVITY_THRESHOLD 101"
	^self jitterBufferCtl: 101 value: -1! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 9/22/2008 15:58'!
ctlGetAvailableCount
	^self jitterBufferCtl: 3 value: -1! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 9/22/2008 16:04'!
ctlGetConcealmentSize
	"Jitter buffer only does concealment in multiples of the size parameter provided."
	^self jitterBufferCtl: 9 value: -1! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 9/22/2008 16:03'!
ctlGetDelayStep
	"Jitter buffer only adjusts the delay in multiples of the step parameter provided."
	self jitterBufferCtl: 7 value: -1! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 9/22/2008 16:06'!
ctlGetLateCost
	"Equivalent cost of one percent late packet in timestamp units."
	^self jitterBufferCtl: 13 value: -1! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 9/22/2008 16:00'!
ctlGetMargin
	"Get minimum amount of extra buffering required (margin)."
	^self jitterBufferCtl: 1 value: -1! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 9/22/2008 16:05'!
ctlGetMaxLateRate
	"Absolute max amount of loss that can be tolerated regardless of the delay. Typical loss should be half of that or less."
	^self jitterBufferCtl: 11 value: -1! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 10/16/2008 23:09'!
ctlSetActivityThreshold: threshold
	"Speex decoder activity threshold below which it is OK to do a jitter_buffer_update_delay(). "
	"#define QWAQ_JITTER_BUFFER_SET_ACTIVITY_THRESHOLD 102"
	^self jitterBufferCtl: 102 value: threshold! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 9/22/2008 16:04'!
ctlSetConcealmentSize: cSize
	"Jitter buffer only does concealment in multiples of the size parameter provided."
	self jitterBufferCtl: 8 value: cSize! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 9/22/2008 16:03'!
ctlSetDelayStep: stepSize
	"Jitter buffer only adjusts the delay in multiples of the step parameter provided."
	self jitterBufferCtl: 6 value: stepSize! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 3/18/2010 12:39'!
ctlSetDisableDropping
	"Set whether the sink should enable dropping if we begin to buffer too much data (is enabled by default)."
	self ctlSetEnableDropping: 0! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 3/18/2010 12:39'!
ctlSetEnableDropping
	"Set whether the sink should enable dropping if we begin to buffer too much data (is enabled by default)."
	self ctlSetEnableDropping: 1! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 3/18/2010 12:39'!
ctlSetEnableDropping: zeroForFalseOneForTrue
	"Set whether the sink should enable dropping if we begin to buffer too much data (is enabled by default)."
	"#define QWAQ_JITTER_BUFFER_SET_ENABLE_DROPPING 103"
	^self jitterBufferCtl: 103 value: zeroForFalseOneForTrue! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 9/22/2008 16:05'!
ctlSetLateCost: cost
	"Equivalent cost of one percent late packet in timestamp units."
	self jitterBufferCtl: 12 value: cost! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 9/22/2008 16:00'!
ctlSetMargin: newMargin
	"Set minimum amount of extra buffering required (margin)."
	self jitterBufferCtl: 0 value: newMargin! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 9/22/2008 16:05'!
ctlSetMaxLateRate: rate
	"Absolute max amount of loss that can be tolerated regardless of the delay. Typical loss should be half of that or less."
	self jitterBufferCtl: 10 value: rate! !

!QAudioSinkSpeex methodsFor: 'private' stamp: 'crl 4/26/2010 12:20'!
currentMargin
	^currentMargin! !

!QAudioSinkSpeex methodsFor: 'private' stamp: 'jcg 8/20/2009 12:29'!
currentMargin: jbMargin
	currentMargin = jbMargin ifTrue: [^self "no change"].
	currentMargin := jbMargin.
	self ctlSetMargin: currentMargin.
	self signal: #marginChanged with: (currentMargin / 16 "convert to msecs")! !

!QAudioSinkSpeex methodsFor: 'decoding' stamp: 'jcg 6/10/2009 14:19'!
dechunkDejitterAndDecode: speexBytes
	"Decode our adhoc Speex wire protocol to obtain 20ms chunks of Speex-encoded sound."
	| stream numChunks |
	stream := ReadStream on: speexBytes.
	numChunks := stream next.
	numChunks timesRepeat: [
		self dejitterAndDecode: (stream next: (stream next "chunk size"))
	].! !

!QAudioSinkSpeex methodsFor: 'decoding' stamp: 'crl 3/11/2010 14:35'!
dechunkDejitterAndDecode: speexBytes timestamp: timestamp
	"Decode our adhoc Speex wire protocol to obtain 20ms chunks of Speex-encoded sound."
	| stream numChunks |
	stream := ReadStream on: speexBytes.
	numChunks := stream next.
	0 to: numChunks-1 do: [:i |
		self 
			dejitterAndDecode: (stream next: (stream next "chunk size"))
			timestamp: timestamp + (i*20)
			fudgeBy: i*20000.
	].! !

!QAudioSinkSpeex methodsFor: 'decoding' stamp: 'crl 3/11/2010 14:36'!
dejitterAndDecode: speexBytes
	"The notion of a timestamp is new, and is used to extend latency/jitter measurements into QAudioPlugin.  We don't have a meaning value to use here; we denote this with -1."
	self dejitterAndDecode: speexBytes timestamp: -1 fudgeBy: 0.
! !

!QAudioSinkSpeex methodsFor: 'decoding' stamp: 'jcg 3/18/2010 14:25'!
dejitterAndDecode: speexBytes timestamp: timestamp fudgeBy: microsecs
	handle ifNotNil: [
		profiler addPending: (timestamp -> (Time utcMicrosecondClock + microsecs)).
		self prim: handle pushEncodedSpeex: speexBytes timestamp: timestamp.
		"Periodically adjust the margin, if we haven't recently."
		((Time coarseMillisecondsSince: lastMarginAdjustTime) > 20000) 
			ifTrue: [self adjustJitterbufferMargin].
	]! !

!QAudioSinkSpeex methodsFor: 'initialize' stamp: 'jcg 2/27/2010 13:55'!
destroy
	super destroy.
	profiler stopProfiling.! !

!QAudioSinkSpeex methodsFor: 'initialize' stamp: 'jcg 3/18/2010 14:22'!
initialize
	super initialize.
	self marginRange: (160 "msecs" to: 560 "msecs").
	lastMarginAdjustTime := Time coarseClockValue.

	profiler := QAudioSinkEventProfiler new.
	profiler sink: self.
! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 9/27/2008 11:17'!
isDebugRecording
	| result |
	handle ifNil: [
		QLogger logWarning: '#isDebugRecording ... handle is nil'.
		^false "obviously not, if we don't even have a handle"
	].

	[result := self primIsDebugRecording: handle]
		on: Error 
		do: [:err | 
			QLogger logWarning: '#isDebugRecording ... ', err description.
			result := false
		].
	^result! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 8/21/2008 23:43'!
jitterBufferCtl: type value: value
	"Calls jitter_buffer_ctl()"	
	
	[^self prim: handle ctlType: type ctlValue: value]
		on: Error do: [QLogger logWarning: 'failed #jitterBufferCtl:value:']
! !

!QAudioSinkSpeex methodsFor: 'accessing' stamp: 'jcg 8/20/2009 13:42'!
marginRange: anInterval "in msecs"
	"Set the minimum and maximum jitterbuffer-margin values."

	"The margin range is given in msecs... for convenience, we convert it to samples
	 (since that is how it is specified to the Speex jitterbuffer).  At 16kHz, 1msec is
	 equivalent to 16 samples."
	marginRange := (anInterval min * 16) to: (anInterval max * 16).
	self currentMargin: marginRange min.
	shortWindow := QJitterbufferWindow new
										size: 100 "100 gets * 20ms = 2 seconds";
										yourself.
	longWindow := QJitterbufferWindow new
										size: 500 "500 gets * 20ms = 10 seconds";
										yourself.
										

! !

!QAudioSinkSpeex methodsFor: 'accessing' stamp: 'jcg 8/20/2009 14:08'!
millisecondsOfMargin
	^currentMargin / 16! !

!QAudioSinkSpeex methodsFor: 'playing' stamp: 'jcg 2/25/2010 00:54'!
playSoundData: data timestamp: timestamp
	"Common interface between sinks that you can push data into."
	self dechunkDejitterAndDecode: data timestamp: timestamp! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 5/7/2010 11:59'!
playThroughSpeexBytes: speexBytes
	"20ms at a time"
	"For testing.  Spawn a process that plays through the encoded Speex bytes.  Assumes that the ticker is not running... it must be ticked manually."
	| interval  start targetTime stream promise |
	interval := 20. "milliseconds per Speex frame"
	QAudioSession primAudioPluginTickerSetInterval: interval.
	QAudioSession primAudioPluginTickerStart.
	
	targetTime := 0.
	start := Time millisecondClockValue.
	stream := ReadStream on: speexBytes.
	promise := TPromise new.
	[
		[stream atEnd] whileFalse: [
			| numFrames |
			numFrames := stream next.
			'# of frames: ', numFrames displayAt: 0@0.

			"First push all of the frames to the plugin at once."
			numFrames timesRepeat: [
				
				| chunk |
				chunk := stream next: (stream next "chunk size").
				'chunk size: ', chunk size displayAt: 0@30.

				handle ifNotNil: [self prim: handle pushEncodedSpeex: chunk].
			].

			"Then pause to simulate the time before the next packet arrives"
			numFrames timesRepeat: [
				| delay |
				targetTime := targetTime + interval.
				delay := targetTime - (Time millisecondsSince: start).
				delay >= 0 
					ifTrue: [(Delay forMilliseconds: delay) wait]
					ifFalse: [QLogger logInfo: 
								'#playThroughSpeexBytes: delay<0 : ', delay].
			]
		].
"		QAudioSession primAudioPluginTickerStop."
		self resetJitterbufferTimestamps.



		QLogger log: '#playThroughSpeexBytes:  finished in ', 
											(Time millisecondsSince: start), ' msecs'.

		promise fulfill: (Time millisecondsSince: start).
	] forkAt: Processor lowIOPriority.
	
	^promise
	! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 5/7/2010 11:59'!
playThroughSpeexBytesTicking: speexBytes
	"20ms at a time"
	"For testing.  Spawn a process that plays through the encoded Speex bytes.  Assumes that the ticker is not running... it must be ticked manually."
	| interval  start targetTime stream promise |
	interval := 20. "milliseconds per Speex frame... simulate plugin-side ticking"
	targetTime := 0.
	start := Time millisecondClockValue.
	stream := ReadStream on: speexBytes.
	promise := TPromise new.
	[
		[stream atEnd] whileFalse: [
			| numFrames |
			numFrames := stream next.
			'# of frames: ', numFrames displayAt: 0@0.

			"First push all of the frames to the plugin at once."
			numFrames timesRepeat: [
				
				| chunk |
				chunk := stream next: (stream next "chunk size").
				'chunk size: ', chunk size displayAt: 0@30.

				handle ifNotNil: [self prim: handle pushEncodedSpeex: chunk].
			].

			"Then tick (decode & play) one decoded frame every 20ms"
			numFrames timesRepeat: [
				| delay |
				QAudioSession primAudioPluginTickerTickNow.

				targetTime := targetTime + interval.
				delay := targetTime - (Time millisecondsSince: start).
				delay >= 0 
					ifTrue: [(Delay forMilliseconds: delay) wait]
					ifFalse: [QLogger logInfo: 
								'#playThroughSpeexBytesTicking: delay<0 : ', delay].
			]
		].
		self resetJitterbufferTimestamps.
		QLogger log: '#playThroughSpeexBytesTicking:  finished in ', 
											(Time millisecondsSince: start), ' msecs'.

		promise fulfill: (Time millisecondsSince: start).
	] forkAt: Processor lowIOPriority.
	^promise
	! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 3/31/2010 11:34'!
playThroughSpeexBytesTicking: speexBytes usingPattern: eventPattern "Array of #put/#get"
	"For testing.  Spawn a process that plays through the encoded Speex bytes.  Assumes that the ticker is not running... it must be ticked manually.  Plays as fast as possible; best used with a QAudioSinkDebug."
	|  chunks chunkStream eventStream |

	"Gather all of the chunks at once."
	chunkStream := ReadStream on: speexBytes.
	chunks := OrderedCollection new.
	[chunkStream atEnd] whileFalse: [
		| numFrames |
		numFrames := chunkStream next.
		numFrames timesRepeat: [
			| chunk |
			chunk := chunkStream next: (chunkStream next "chunk size").
			chunks add: chunk.
		].
	].

	"Reuse 'chunkStream' for a slightly different purpose."
	chunkStream := ReadStream on: chunks.
	eventStream := ReadStream on: eventPattern.

	"Mow through 'chunkStream' as fast as we can."
	[chunkStream atEnd] whileFalse: [
		eventStream atEnd ifTrue: [eventStream reset].
		eventStream next caseOf: {
			[#put] -> [
				handle ifNotNil: [self 
									prim: handle 
									pushEncodedSpeex: chunkStream next]
			].
			[#get] -> [QAudioSession primAudioPluginTickerTickNow].
		}
	].
	QAudioSession primAudioPluginTickerTickNow. "one last tick"
	self resetJitterbufferTimestamps.
! !

!QAudioSinkSpeex methodsFor: 'primitives' stamp: 'jcg 8/21/2008 23:09'!
prim: handleInt ctlType: type ctlValue: value
	"Calls jitter_buffer_ctl()"
	<primitive: 'primitiveSinkJitterbufferCtlSpeex' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkSpeex methodsFor: 'primitives' stamp: 'jcg 10/29/2008 23:26'!
prim: handleInt getJitterbufferStats: stats "handle of a QJitterBufferStats"
	<primitive: 'primitiveSinkGetJitterbufferStats' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkSpeex methodsFor: 'primitives' stamp: 'jcg 6/27/2008 02:05'!
prim: handleInt pushEncodedSpeex: aByteArray
	"Push a chunk of Speex-encoded sound into the plugin."
	<primitive: 'primitiveSinkPushEncodedSpeex' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkSpeex methodsFor: 'primitives' stamp: 'jcg 3/18/2010 14:20'!
prim: handleInt pushEncodedSpeex: aByteArray timestamp: anInteger
	"Push a chunk of Speex-encoded sound into the plugin."
	<primitive: 'primitiveSinkPushEncodedSpeexWithTimestamp' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkSpeex methodsFor: 'primitives' stamp: 'jcg 9/27/2008 10:53'!
prim: handleInt startDebugRecording: aString
	"Start debug-recording for this sink: record EVERYTHING to a parseable file."
	<primitive: 'primitiveSinkStartSpeexDebugRecording' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkSpeex methodsFor: 'primitives' stamp: 'jcg 6/23/2008 23:58'!
primCreateHandle
	<primitive: 'primitiveCreateSinkSpeex' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkSpeex methodsFor: 'primitives' stamp: 'jcg 9/27/2008 11:18'!
primIsDebugRecording: handleInt
	"Check whether debug-recording is currently turned on for this sink."
	<primitive: 'primitiveSinkIsSpeexDebugRecording' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkSpeex methodsFor: 'primitives' stamp: 'jcg 8/20/2008 11:11'!
primResetJitterbufferTimestamps: handleInt
	"Push a chunk of Speex-encoded sound into the plugin."
	<primitive: 'primitiveSinkResetJitterbufferTimestamps' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkSpeex methodsFor: 'primitives' stamp: 'jcg 9/27/2008 10:52'!
primStopDebugRecording: handleInt
	"Stop debug-recording for this sink (when on, it records EVERYTHING)."
	<primitive: 'primitiveSinkStopSpeexDebugRecording' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSinkSpeex methodsFor: 'accessing' stamp: 'jcg 2/27/2010 14:22'!
profiler
	^profiler! !

!QAudioSinkSpeex methodsFor: 'private' stamp: 'jcg 8/20/2008 11:11'!
resetJitterbufferTimestamps
	handle ifNotNil: [
		self primResetJitterbufferTimestamps: handle
	]
! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 9/27/2008 11:00'!
startDebugRecording: filePath "a String"
	handle ifNil: [^QLogger logWarning: '#startDebugRecording: ... handle is nil'].
	[self prim: handle startDebugRecording: filePath]
		on: Error 
		do: [:err | QLogger logWarning: '#startDebugRecording: ... ', err description]! !

!QAudioSinkSpeex methodsFor: 'accessing' stamp: 'jcg 2/25/2010 12:09'!
stats
	"Obtain jitter-buffer stats from the plugin."
	| stats version |
	stats := QJitterbufferStats new.
	version := stats version.
	[self prim: handle getJitterbufferStats: stats getHandle]
		on: Error 
		do: [:err |
			QLogger logWarning: 'failed to obtain jitter-buffer stats: ', err description.
			^nil
		].
	stats version = version ifFalse: [
		"The version supported by the plugin isn't what we expected.
		 Log infrequently, so it's not unduly annoying for people with old VMs."
		QLogger 
			logWarning: 'jitterbuffer stats: expected version ', version, ' vs. ', stats version
			every: 300000.
	].
	^stats! !

!QAudioSinkSpeex methodsFor: 'utility/testing' stamp: 'jcg 9/27/2008 11:00'!
stopDebugRecording
	handle ifNil: [^QLogger logWarning: '#stopDebugRecording ... handle is nil'].
	[self primStopDebugRecording: handle]
		on: Error 
		do: [:err | QLogger logWarning: '#stopDebugRecording ... ', err description]! !

Object subclass: #QAudioSinkEventProfiler
	instanceVariableNames: 'sink mutex pendingTimings loopProcess window'
	classVariableNames: 'GlobalProfilingEnabled'
	poolDictionaries: ''
	category: 'Qwaq-Sound-Codec'!

!QAudioSinkEventProfiler commentStamp: 'jcg 2/27/2010 12:21' prior: 0!
Given an app-level event timestamp (typically obtained from a network datagram), determine how long it takes until the event has propagated through the sink that we're watching.!

!QAudioSinkEventProfiler class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioSinkEventProfiler class methodsFor: 'as yet unclassified' stamp: 'jcg 2/27/2010 14:56'!
isGlobalProfilingEnabled
	^ GlobalProfilingEnabled == true
	! !

!QAudioSinkEventProfiler class methodsFor: 'as yet unclassified' stamp: 'jcg 2/27/2010 15:42'!
toggleGlobalProfiling
	"Lame, but good enough for the developer-menu.   The lameness is because the GlobalProfilingEnabled setting does not affect newly-created QAudioSinkEventProfilers."
	GlobalProfilingEnabled == true
		ifTrue: [
			GlobalProfilingEnabled := false.
			self allInstancesDo: [:prof | [prof stopProfiling] on: Error do: []].
		]
		ifFalse: [
			GlobalProfilingEnabled := true.
			self allInstancesDo: [:prof | [prof startProfiling] on: Error do: []].
		]! !

!QAudioSinkEventProfiler methodsFor: 'start/stop' stamp: 'jcg 2/27/2010 13:18'!
addPending: assoc "Association from network-time to utc-microseconds"
	mutex critical: [
		"Don't bother adding it if we're not currently profiling."
		loopProcess ifNotNil: [pendingTimings add: assoc]
	].! !

!QAudioSinkEventProfiler methodsFor: 'start/stop' stamp: 'jcg 2/27/2010 14:14'!
clear
	mutex critical: [
		pendingTimings := OrderedCollection new.
		window := TWindowedStatistics forWindowDuration: 10000.
	]! !

!QAudioSinkEventProfiler methodsFor: 'initialize' stamp: 'jcg 2/27/2010 14:13'!
initialize
	super initialize.
	mutex := Mutex new.
	window := TWindowedStatistics forWindowDuration: 10000.! !

!QAudioSinkEventProfiler methodsFor: 'testing' stamp: 'jcg 2/27/2010 14:20'!
isProfiling
	^loopProcess notNil! !

!QAudioSinkEventProfiler methodsFor: 'start/stop' stamp: 'jcg 2/27/2010 14:15'!
oneSecondStats 
	^window oneSecondStats! !

!QAudioSinkEventProfiler methodsFor: 'private' stamp: 'jcg 2/27/2010 14:13'!
runProfilingLoop
	| delay |

[
	delay := Delay forMilliseconds: 200.
	
	"Once to 'prime the pump'."
	sink getEventTimings.
	delay wait.

	"Loop until we're no longer the loop-process."
	[loopProcess == Processor activeProcess] whileTrue: [
		| sinkTimings |
		sinkTimings := sink getEventTimings.
		mutex critical: [
			sinkTimings last do: [:assoc |
				| nextPending |
				"Discard entries in 'pendingTimings' that are earlier than what we 
				 obtained from the sink. "
				nextPending := nil.
				[pendingTimings notEmpty and: [pendingTimings first key <= assoc key]]
					whileTrue: [nextPending := pendingTimings removeFirst].
				
				"Check if the first pending timing matches the current one
				 we're processing from the sink.  If so, process it and discard it.
				 Otherwise, do nothing (it may match the next one from the sink."
				(nextPending notNil and: [nextPending key = assoc key]) ifTrue: [
					| diff |
					"How long apart are these values in real-time?"
					diff := ((assoc value - nextPending value) / 1000) rounded.
					window add: diff at: nextPending key.
				].
			].
		].			
		delay wait.
	].

] on: Error do: [:err | QLogger logWarning: 'error in #runProfilingLoop: ', err].! !

!QAudioSinkEventProfiler methodsFor: 'initialize' stamp: 'jcg 2/27/2010 12:19'!
sink: aQAudioSink
	sink := aQAudioSink! !

!QAudioSinkEventProfiler methodsFor: 'start/stop' stamp: 'jcg 2/27/2010 13:19'!
startProfiling
	mutex critical: [
		self stopProfiling.
		loopProcess := self 
							forkSuspended: #runProfilingLoop 
							at: Processor userInterruptPriority.
		loopProcess resume.
	]
! !

!QAudioSinkEventProfiler methodsFor: 'start/stop' stamp: 'jcg 2/27/2010 14:14'!
stopProfiling
	mutex critical: [
		loopProcess := nil. "will die on it's own"
		self clear.
	].! !

!QAudioSinkEventProfiler methodsFor: 'start/stop' stamp: 'jcg 2/27/2010 14:15'!
tenSecondStats 
	^window tenSecondStats! !

!QAudioSinkEventProfiler methodsFor: 'start/stop' stamp: 'crl 3/11/2010 15:27'!
window
	^window! !

Object subclass: #QClientSpeakerInput
	instanceVariableNames: 'speaker audioFormat myEventMap myScripts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Speaker'!

!QClientSpeakerInput commentStamp: '<historical>' prior: 0!
A source of audio to be played out through a QClientSpeaker.  !

QClientSpeakerInput subclass: #QClientSpeakerChatInput
	instanceVariableNames: 'streamID subscription isInsane sanityCheckTime sanityFailureCount birthTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Speaker'!

!QClientSpeakerChatInput commentStamp: '<historical>' prior: 0!
Embodies the age-old voice-chat subscription behavior, which is refactored into this class so that QClientSpeaker can also play audio from other sources (in particular, streaming video).!

!QClientSpeakerChatInput class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QClientSpeakerChatInput class methodsFor: 'instance creation' stamp: 'jcg 2/26/2009 14:01'!
forSpeaker: aQClientSpeaker streamID: streamID
	^(super forSpeaker: aQClientSpeaker) 
									streamID: streamID; 
									yourself! !

!QClientSpeakerChatInput methodsFor: 'accessing' stamp: 'jcg 2/17/2010 16:48'!
age
	^DateAndTime now - birthTime! !

!QClientSpeakerChatInput methodsFor: 'initialize' stamp: 'jcg 2/27/2009 01:52'!
destroy
	super destroy.
	self destroySubscription.! !

!QClientSpeakerChatInput methodsFor: 'initialize' stamp: 'jcg 2/26/2009 17:23'!
destroySubscription
	"Don't rely on asynch cleanup, since some methods destroy followed by immediate resubscribe."
	subscription ifNotNilDo: [:sub |
		self subscriptionDestroyed: sub.		
		sub destroy.
		subscription := nil.
	]! !

!QClientSpeakerChatInput methodsFor: 'sanity' stamp: 'jcg 3/10/2009 15:24'!
errorDuringSanityCheck: reasonString
	"There was an error during the speaker sanity-check... report it, and turn off checking for this speaker."
	| description |
	description := String streamContents: [:s |
		s nextPutAll: 'Failed Voice-Speaker sanity check: ', reasonString; cr; cr.
		s tab; nextPutAll: 'streamID: ', (streamID ifNotNil: [streamID hex]); cr.
		s tab; nextPutAll: 'subscription: ', (subscription ifNotNilDo: [:sub | sub state]); cr.
		s tab; nextPutAll: 'isMute: ', speaker isMute; cr.
		s tab; nextPutAll: 'isAudible: ', speaker isAudible; cr.
		s tab; nextPutAll: 'isPlaying: ', speaker isPlaying; cr.
		s tab; nextPutAll: 'isLoopback: ', speaker isLoopback; cr.
	].

	"Log the error to the Transcript, and send a copy to Qwaq."
	QLogger logError: description from: self.
	speaker ui 
		ifNil: [QLogger logError: 'Cannot submit audio error report (no UI)' from: self]
		ifNotNilDo: [:ui | ui reportIncident: description].

	"Finally, stop the script; we don't want to keep generating error reports for a single speaker."
	speaker stopScript: #sanityCheckSpeakerActivity.
! !

!QClientSpeakerChatInput methodsFor: 'private-scripts' stamp: 'crl 3/3/2010 14:17'!
handleAudioData: data
	"We've hardwired the following format:
		Byte 1		: command byte for TMessageChannel
		Byte 2-5		: time since beginning of utterance
		Byte 6-9		: approximate server time, AKA 'encode time'
		Byte 10		: codec
		Byte 11-18	: record level
		Byte 19-end	: audio data"
	| codec audioData frameTime |

	self updateSanityCheckTime.

	speaker isMute ifTrue: [^self].
	
	codec := data at: 10.
	codec == 255 ifTrue: [^speaker beginSilentPeriod "end of audible interval"].

	codec == 0 ifTrue: [codec := nil].
	codec == 1 ifTrue: [codec := GSMCodec].
	codec == 2 ifTrue: [codec := QSpeexCodec].

	audioData := data copyFrom: 19 to: data size.

	frameTime := data networkUnsignedLongAt: 2.
	self setAudioFormatFromCodecClass: codec.
	speaker playSoundData: audioData timestamp: frameTime.



	false ifTrue: [
		| recordLevel |
		recordLevel := data networkDoubleAt: 11.
		Transcript show: 'OUTPUT LEVEL: ', recordLevel; cr
	].
	false ifTrue: [
		| serverTime |
		serverTime := data networkUnsignedLongAt: 6.
		'frame: ', frameTime, '      server: ', serverTime,  '          ' displayAt: 0@0
	].
	! !

!QClientSpeakerChatInput methodsFor: 'initialize' stamp: 'jcg 2/17/2010 16:46'!
initialize
	super initialize.
	isInsane := false.  "What, me insane?  Never!!!!!!"
	sanityCheckTime := Time millisecondClockValue.
	sanityFailureCount := 0.
	birthTime := DateAndTime now.
	audioFormat := QAudioFormat 
						codecClass: QSpeexCodec 
						samplingRate: 16000 
						numChannels: 1.! !

!QClientSpeakerChatInput methodsFor: 'testing' stamp: 'ar 3/17/2009 10:51'!
isChatInput
	"Distinguish speex encoded streaming chat inputs from others"
	^true! !

!QClientSpeakerChatInput methodsFor: 'testing' stamp: 'jcg 2/27/2009 16:35'!
isConnected
	subscription ifNotNilDo: [:sub | ^sub state == #connected].
	^false
! !

!QClientSpeakerChatInput methodsFor: 'testing' stamp: 'jcg 2/26/2009 17:33'!
isConnectedAndStreaming
	"#isConnectedAndPlaying sounds better, but would be misleading because #isPlaying has a distinct meaning."
	self isConnected ifFalse: [^false].
	^subscription isPaused not! !

!QClientSpeakerChatInput methodsFor: 'accessing' stamp: 'jcg 2/26/2009 17:56'!
jitter
	^ [subscription stream input jitter] on: Error do: [nil]! !

!QClientSpeakerChatInput methodsFor: 'accessing' stamp: 'jcg 2/26/2009 17:52'!
jitterStats: aTWindowedStats
	"Audio jitter statistics"
	subscription ifNotNil:[
		subscription stream ifNotNil:[
			subscription stream input ifNotNilDo:[:in| in jitterStats: aTWindowedStats]]].! !

!QClientSpeakerChatInput methodsFor: 'logging' stamp: 'jcg 2/17/2010 17:12'!
logName
	"Age and streamID will be useful for debugging."
	^self printString copyAfter: Character space
! !

!QClientSpeakerChatInput methodsFor: 'printing' stamp: 'jcg 5/13/2010 14:49'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	self age printOn: aStream.
	aStream 
		space;
		nextPutAll: (streamID ifNil: ['<no stream>'] ifNotNil: [:id | id shortHex]);
		nextPut: $).! !

!QClientSpeakerChatInput methodsFor: 'printing' stamp: 'jcg 2/27/2010 14:25'!
printStatisticsOn: strm
	| stats sink |
	subscription ifNil: [^self].

	"Print out jitter-buffer stats for this speaker."
	strm nextPutAll: (QStyles simplerLoginName: self sourceDescription), ':	'.
	speaker isUsingJitterbuffer ifFalse: [strm nextPutAll: ' (No jitter buffer)'. ^self].
	sink := speaker speakerOutput ifNotNilDo: [:out | out speexSink].
	stats := sink ifNotNilDo: [:snk | snk stats ].
	stats ifNil: [strm nextPutAll: ' (No jitter statistics)'. ^self].
	stats recentGets = 0 
		ifTrue: [strm nextPutAll: '  (No activity)']
		ifFalse: [
			strm 
				nextPutAll: 'Lost recent/total: ';
				nextPutAll: stats recentExtrapolationPercent printString;
				nextPut: $/;
				nextPutAll: stats totalExtrapolationPercent printString;
				nextPutAll: '%'.
			self jitter ifNotNilDo: [:j | 
				strm 
					nextPutAll: '  (jitter/margin: ';
					nextPutAll: (j roundTo: 0.1) printString;
					nextPutAll: '/';
					nextPutAll: speaker speakerOutput millisecondsOfMargin printString;
					nextPutAll: 'ms)'.
			].
			sink profiler isProfiling ifTrue: [
				| ten |
				ten := sink profiler tenSecondStats.
				strm nextPutAll: '       avg/max time in JB: ', ten first, '/', ten last, 'ms'.
			].
		]! !

!QClientSpeakerChatInput methodsFor: 'sanity' stamp: 'jcg 3/10/2009 15:26'!
sanityCheckSpeakerActivity 	
	"Listen for the replicated #action events that are used to update speech icons in the user-list... use it as a cue to sanity-check whether we are hearing sound."

	isInsane ifTrue: [^self "we already reported our insanity... exit early"].

	"Check if there is a reason that we shouldn't do the sanity test this time around.  If so, reset the failure-count and last-sanity-check-time (to reduce false positives)."
	self shouldTestSanity ifFalse: [^self updateSanityCheckTime].

		
	subscription ifNil: [^self errorDuringSanityCheck: 'subscription is nil'].
	subscription state == #connecting ifTrue: [^self "give it some time"].
	subscription state == #connected 
		ifFalse: [^self errorDuringSanityCheck: 'subscription is not connected'].

	"Although Andreas and I predicted that the audio packet would arrive before the volume notification (especially after tweaking #reallyPlaySound:at:samplingRate:codec: to send the sound before the volume notification), I reliably see the notification arrive first.  I allow for the possibility of up to five false-positives in a row, treating the sixth one as the real deal."
	(Time millisecondsSince: sanityCheckTime) > 2000 
		ifTrue: [
			sanityFailureCount := sanityFailureCount + 1.
			sanityCheckTime := Time millisecondClockValue.
		].
	sanityFailureCount > 5 
		ifTrue: [^self errorDuringSanityCheck: 'receiving notifications, but no sound'].

! !

!QClientSpeakerChatInput methodsFor: 'initialize' stamp: 'jcg 8/19/2009 16:19'!
setAudioFormatFromCodecClass: codecClass
	audioFormat codecClass == codecClass ifTrue: [^self "no change"].
	self audioFormat: (QAudioFormat
							codecClass: codecClass
							samplingRate: codecClass samplingRate
							numChannels: 1)! !

!QClientSpeakerChatInput methodsFor: 'sanity' stamp: 'jcg 2/26/2009 16:28'!
shouldTestSanity
	"Check if there is a reason that we shouldn't do the sanity test this time around."
	streamID ifNil: [^false].
	speaker isMute ifTrue: [^false].
	speaker isAudible ifFalse: [^false].
	speaker isPlaying ifFalse: [^false].
	speaker ui
			ifNil: [^false]
			ifNotNilDo: [:ui | ui readyForEvents ifFalse: [^false]].

	"All of the conditions were met."
	^true
	! !

!QClientSpeakerChatInput methodsFor: 'accessing' stamp: 'jcg 2/17/2010 15:55'!
sourceDescription
	"Textual description of the source of this audio."
	| desc |
	desc := subscription streamName ifNil: ['Unknown user'].
	(desc beginsWith: 'Voice stream for ') ifTrue: [
		desc := desc copyFrom: 18 to: desc size.
	].
	^desc! !

!QClientSpeakerChatInput methodsFor: 'accessing' stamp: 'jcg 2/26/2009 15:19'!
streamID
	^streamID! !

!QClientSpeakerChatInput methodsFor: 'initialize' stamp: 'jcg 3/7/2010 21:36'!
streamID: newStreamID
	| ctrlr |
	streamID := newStreamID.
	self destroySubscription.
	streamID ifNil: [^self "no media streaming audio source is specified"].
	(ctrlr := speaker mediaController) ifNil: [
		^self "probably out of phase with reconnect"
	].
	
	subscription := QControlStreamSubscription
						streamID: streamID
						mediaController: ctrlr
						inputClass: TAudioStreamInput
						outputClass: TAudioStreamOutput.
	subscription dataHandler: [:dgram | self handleAudioData: dgram data].
	speaker isLoopback ifTrue: [subscription forceConnectionToRouter].
	self startScript: #subscriptionDestroyed: when: {subscription. #destroyed}.
	self startScript: #subscriptionConnected: when: {subscription. #connected}.
	self startScript: #subscriptionFailed:because: when: {subscription. #connectionFailed}.

	"For backward compatibility with Howard's mobile client stuff, which still sends media data over the stream's main channel, prefixed by a 'Media' byte.  Also see comment in #createAudioDatagramPayload:at:codec:level: (in QStreamingSoundRelay). "
	self runScript: #handleAudioData: when: {subscription. #sendMedia}.

	subscription connectWithTimeout: 120000.
! !

!QClientSpeakerChatInput methodsFor: 'accessing' stamp: 'ar 3/17/2009 10:55'!
subscription
	"Need access to the subscription / stream for recording"
	^subscription! !

!QClientSpeakerChatInput methodsFor: 'private-scripts' stamp: 'ar 3/20/2009 10:37'!
subscriptionConnected: sub
	speaker critical: [
		subscription == sub ifFalse: [
			"This isn't the subscription that we expected  (this is a bug)."
			QLogger logError: 'connected to unexpected subscription' from: self.
			^self
		].
		self updatePlayState.

		"Without the guard below, demon tests fail here with nil stream or input,
	 	 perhaps from rapid on-off toggling of microphones."
		sub stream
			ifNil:[ QLogger logWarning: 'No stream.' ]
			ifNotNilDo: [ : ss | 
				ss input 
					ifNil: [ QLogger logWarning: 'No stream input.' ]
					ifNotNilDo: [ :ssi | ssi jitterStats: speaker jitterStats ]].
	].
	"Signal that the stream input is now ready (subscribed). 
	Used in recording when we need to find out when a new 
	client has established the subscription."
	speaker signal: #streamInputReady with: self.
! !

!QClientSpeakerChatInput methodsFor: 'private-scripts' stamp: 'jcg 2/26/2009 17:13'!
subscriptionDestroyed: sub
	speaker critical: [
		subscription := nil.
		self stopScript: #subscriptionConnected:.
		self stopScript: #subscriptionFailed:because:.
		self stopScript: #handleAudioData:.

		"Last, because we're probably running this script right now."
		self stopScript: #subscriptionDestroyed:.
	].
! !

!QClientSpeakerChatInput methodsFor: 'private-scripts' stamp: 'jcg 2/26/2009 17:27'!
subscriptionFailed: sub because: reasonString
	| msg |
	msg := 'Could not subscribe to audio stream ', sub streamID hex, 
			' because: ', reasonString.
	QLogger logError: msg  from: self.
	speaker ui ifNotNilDo: [:ui | 
		ui reportIncident: msg.
	]
! !

!QClientSpeakerChatInput methodsFor: 'playing' stamp: 'ar 3/20/2009 14:41'!
updatePlayState
	"Integrate a number of factors to decide whether we are currently playing or not."

	"NOTE: does not need to be in a critical section because all callers are in critical sections."
"	mutex critical: ["
		subscription ifNil: [^self].
		speaker shouldPlayStream 
			ifTrue: [subscription unpause]
			ifFalse: [subscription pause].
		self updateSanityCheckTime.
"	]."
	! !

!QClientSpeakerChatInput methodsFor: 'sanity' stamp: 'jcg 2/26/2009 16:35'!
updateSanityCheckTime
	"We're not insane yet... reset the counts."
	sanityCheckTime := Time millisecondClockValue.
	sanityFailureCount := 0.! !

!QClientSpeakerInput class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QClientSpeakerInput class methodsFor: 'instance creation' stamp: 'jcg 2/26/2009 14:02'!
forSpeaker: aQClientSpeaker
	^ self new 
			speaker: aQClientSpeaker; 
			yourself! !

!QClientSpeakerInput methodsFor: 'accessing' stamp: 'jcg 8/19/2009 15:36'!
audioFormat
	"Answer a QAudioFormat."
	^audioFormat! !

!QClientSpeakerInput methodsFor: 'accessing' stamp: 'jcg 8/17/2009 15:25'!
audioFormat: aQAudioFormat
	audioFormat = aQAudioFormat ifFalse: [
		audioFormat := aQAudioFormat.
		speaker ifNotNilDo: [:spkr | spkr audioFormat: aQAudioFormat]
	].! !

!QClientSpeakerInput methodsFor: 'initialize' stamp: 'jcg 2/27/2009 01:52'!
destroy! !

!QClientSpeakerInput methodsFor: 'testing' stamp: 'ar 3/17/2009 10:51'!
isChatInput
	"Distinguish speex encoded streaming chat inputs from others"
	^false! !

!QClientSpeakerInput methodsFor: 'testing' stamp: 'jcg 2/26/2009 17:32'!
isConnectedAndStreaming
	self subclassResponsibility! !

!QClientSpeakerInput methodsFor: 'accessing' stamp: 'jcg 2/26/2009 17:53'!
jitterStats: aTWindowedStats
	"Audio jitter statistics"
	self subclassResponsibility! !

!QClientSpeakerInput methodsFor: 'scripting' stamp: 'bgf 12/3/2009 14:31'!
myEventMap
	"Adapter so this can participate efficiently in event signalling like CObject"
	^myEventMap! !

!QClientSpeakerInput methodsFor: 'scripting' stamp: 'bgf 12/3/2009 14:31'!
myEventMap: aMap
	"Adapter so this can participate efficiently in event signalling like CObject"
	myEventMap := aMap! !

!QClientSpeakerInput methodsFor: 'scripting' stamp: 'bgf 12/3/2009 14:31'!
myScripts
	"Adapter so this can participate efficiently in event signalling like CObject"
	^ myScripts ifNil: [#() ]! !

!QClientSpeakerInput methodsFor: 'scripting' stamp: 'bgf 12/3/2009 14:31'!
myScripts: scripts
	"Adapter so this can participate efficiently in event signalling like CObject"
	^ myScripts := scripts! !

!QClientSpeakerInput methodsFor: 'printing' stamp: 'jcg 2/26/2009 17:46'!
printStatisticsOn: aStream
	self subclassResponsibility! !

!QClientSpeakerInput methodsFor: 'sanity' stamp: 'jcg 2/26/2009 16:12'!
sanityCheckSpeakerActivity
	"No-op... subclasses might choose to do something."
	! !

!QClientSpeakerInput methodsFor: 'accessing' stamp: 'jcg 3/30/2009 16:31'!
sourceDescription
	"Textual description of the source of this audio."
	^'(no description)'! !

!QClientSpeakerInput methodsFor: 'initialize' stamp: 'crl 1/11/2010 14:04'!
speaker
	^speaker! !

!QClientSpeakerInput methodsFor: 'initialize' stamp: 'jcg 8/19/2009 16:33'!
speaker: aQClientSpeaker
	speaker := aQClientSpeaker.
	audioFormat ifNotNil: [speaker audioFormat: audioFormat].! !

!QClientSpeakerInput methodsFor: 'accessing' stamp: 'jcg 2/26/2009 15:36'!
streamID
	"Support for finding a speaker by its streamID.  This only makes sense for voice-chat, since other QClientSpeakerInput subclasses don't use a replicated streamID to connect to their stream."
	^nil! !

!QClientSpeakerInput methodsFor: 'initialize' stamp: 'jcg 2/26/2009 15:45'!
streamID: newStreamID
	"This should never be called for a speaker that isn't for voice-chatting.  If it is, log a warning."

	"XXXX: Josh's current expectation (while doing the refactoring) is that this won't be called... if we notice that it is, we either need to fix that, or revise our expectation that it shouldn't be called."
	
	QLogger logWarning: 'unexpected #streamID: call'.! !

!QClientSpeakerInput methodsFor: 'playing' stamp: 'jcg 2/26/2009 16:45'!
updatePlayState
	self subclassResponsibility! !

QClientSpeakerInput subclass: #QClientSpeakerNetVidInput
	instanceVariableNames: 'player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Speaker'!

!QClientSpeakerNetVidInput commentStamp: '<historical>' prior: 0!
Accepts audio from a QStreamingVideoPlayer, and plays it through the speaker.!

!QClientSpeakerNetVidInput class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QClientSpeakerNetVidInput methodsFor: 'playing' stamp: 'jcg 4/10/2010 13:49'!
handleDecodedAudio: buf "a SoundBuffer" samplingRate: samplingRate
	| audioFormatUnchanged |
	audioFormatUnchanged := (audioFormat codecClass isNil)
									and: [audioFormat samplingRate == samplingRate].
	audioFormatUnchanged ifFalse: [
		"If we don't ensure this, we will deadlock."
		speaker isInTurn ifTrue: [self error: 'cannot handle decoded-audio in event-loop'].
		audioFormat := (QAudioFormat
							codecClass: nil
							samplingRate: samplingRate
							numChannels: 1).
		(speaker future audioFormat: audioFormat) wait.
	].

	"The notion of a timestamp is new, and is used to extend latency/jitter measurements into QAudioPlugin.  We don't have a meaning value to use here; we denote this with -1."
	speaker playSoundData: buf timestamp: -1.
! !

!QClientSpeakerNetVidInput methodsFor: 'initialize' stamp: 'jcg 8/17/2009 12:22'!
initialize
	super initialize.
	audioFormat := QAudioFormat 
						codecClass: nil 
						samplingRate: 0 "will update with the proper value when we know it"  
						numChannels: 1.! !

!QClientSpeakerNetVidInput methodsFor: 'testing' stamp: 'jcg 2/27/2009 15:42'!
isConnectedAndStreaming
	"This is for voice-streams in the performance panel.  Answer false so we don't show up there."
	^false! !

!QClientSpeakerNetVidInput methodsFor: 'no-ops' stamp: 'jcg 2/27/2009 15:44'!
jitterStats: ignore
	"This is for voice-streams in the performance panel; do nothing."
	! !

!QClientSpeakerNetVidInput methodsFor: 'initialize' stamp: 'jcg 3/6/2009 16:39'!
player: aQStreamingVideoPlayer
	player := aQStreamingVideoPlayer! !

!QClientSpeakerNetVidInput methodsFor: 'private' stamp: 'ar 3/20/2009 14:42'!
updatePlayState
	"Integrate a number of factors to decide whether we are currently playing or not."
	| netvidClient |
	player ifNil: [^self].
	netvidClient := player videoClient ifNil: [^self].	
	speaker shouldPlayStream 
		ifTrue: [netvidClient unpauseAudio]
		ifFalse: [netvidClient pauseAudio].
! !

Object subclass: #QJitterBufferTester
	instanceVariableNames: 'fileName origSnd speexSnd patterns params debugRecord'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Tests'!

!QJitterBufferTester commentStamp: 'jcg 10/16/2008 18:08' prior: 0!
Takes a WAV file as input, encodes it as Speex, and decodes it using all permutations of the specified parameter value ranges.  The audio resulting from each permutation is written into a WAV file.

It's also very handy to instantiate us from a QRecordedVoiceForDebugging like so: 'aQRVFD createQJitterBufferTester'.

Random snippets:

jbt := QJitterBufferTester fileName: 'mike16.wav' patterns: {pat}.
jbt := QJitterBufferTester fileName: 'mike16.wav' patterns: #((put get)).
jbt margin: 640.
jbt delayStep: (320 to: 640 by: 320).
jbt concealSize: (320 to: 1600 by: 320).
jbt maxLateRate: (1 to: 10 by: 3).
jbt lateCost: nil.

jbt margin: nil.
jbt delayStep: (320 to: 1280 by: 320).
jbt concealSize: (320 to: 1280 by: 320).
jbt maxLateRate: (2 to: 5 by: 3).
jbt lateCost: nil.

jbt go.

jbt trimmedFileName

pat := WriteStream on: Array new.  200 timesRepeat: [pat nextPutAll: #(put get)]. 
pat := pat contents.
pat := pat shuffled

!

!QJitterBufferTester class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QJitterBufferTester class methodsFor: 'instance creation' stamp: 'jcg 10/16/2008 16:23'!
speexSound: speexSnd patterns: listOfPatterns
	^ self new
			speexSound: speexSnd;
			patterns: listOfPatterns;
			yourself.! !

!QJitterBufferTester class methodsFor: 'instance creation' stamp: 'jcg 10/15/2008 15:51'!
wavFileName: wavFileName patterns: listOfPatterns
	^ self new
			fileName: wavFileName;
			patterns: listOfPatterns;
			yourself.! !

!QJitterBufferTester methodsFor: 'accessing' stamp: 'jcg 10/16/2008 23:18'!
activityThreshold: thresh "0 to 100"
	params at: 6 put: thresh

! !

!QJitterBufferTester methodsFor: 'accessing' stamp: 'jcg 9/22/2008 19:20'!
concealSize: cs "nil, integer, or interval"
	params at: 3 put: cs

! !

!QJitterBufferTester methodsFor: 'private' stamp: 'jcg 10/16/2008 16:46'!
createChunkStream
	| stream chunks |

	"Recently added the abililty to provide a collection of Speex chunks instead of creating one from a .wav file."
	speexSnd class isBytes ifFalse: [
		"Already chunked."
		^ReadStream on: speexSnd.
	].


	stream := ReadStream on: speexSnd.
	chunks := OrderedCollection new.
	[stream atEnd] whileFalse: [
		| numFrames |
		numFrames := stream next.
		numFrames timesRepeat: [
			| chunk |
			chunk := stream next: (stream next "chunk size").
			chunks add: chunk.
		].
	].
	^ ReadStream on: chunks! !

!QJitterBufferTester methodsFor: 'accessing' stamp: 'jcg 10/16/2008 16:40'!
debugRecord: bool
	"Should we turn on debug-recording (like in the UserPane context-menu)?"
	debugRecord := bool! !

!QJitterBufferTester methodsFor: 'accessing' stamp: 'jcg 9/22/2008 19:12'!
delayStep: ds "nil, integer, or interval"
	params at: 2 put: ds

! !

!QJitterBufferTester methodsFor: 'initialize' stamp: 'jcg 9/22/2008 15:49'!
fileName: wavFileName
	| file |
	fileName := wavFileName.
	file := FileStream readOnlyFileNamed: wavFileName.
	origSnd := SampledSound fromWaveStream: file.	
	file close.

	speexSnd := QSpeexCodec encodeSpeexInChunksOf320: origSnd.
	! !

!QJitterBufferTester methodsFor: 'running' stamp: 'jcg 10/16/2008 23:21'!
go
	| margin delayStep concealmentSize maxLateRate lateCost activityThreshold dir start end runNumber summaryFile |

	self prepareDirectoryForOutput.

	margin := params at: 1.
	margin isCollection ifFalse: [margin := {margin}].
	delayStep := params at: 2.
	delayStep isCollection ifFalse: [delayStep := {delayStep}].
	concealmentSize := params at: 3.
	concealmentSize isCollection ifFalse: [concealmentSize := {concealmentSize}].
	maxLateRate := params at: 4.
	maxLateRate isCollection ifFalse: [maxLateRate := {maxLateRate}].
	lateCost := params at: 5.
	lateCost isCollection ifFalse: [lateCost := {lateCost}].
	activityThreshold := params at: 6.
	activityThreshold isCollection ifFalse: [activityThreshold := {activityThreshold}].

	dir := self prepareDirectoryForOutput.

	start := Time now.
	runNumber := 0.

	1 to: patterns size do: [:patInd |
		margin do: [:m |
			delayStep do: [:ds |
				concealmentSize do: [:cs |
					maxLateRate do: [:mll |
						lateCost do: [:lc |
							activityThreshold do: [:athresh |
								runNumber := runNumber + 1.
								self 
									processAudioWithPattern: patInd
									margin: m
									delayStep: ds
									concealmentSize: cs
									maxLateRate: mll
									lateCost: lc
									activityThreshold: athresh
									outputDir: dir.
							]
						]
					]
				]
			]
		]
	].

	end := Time now.
	
	summaryFile := dir forceNewFileNamed: 'summary.txt'.
	summaryFile nextPutAll: 'Processed ', runNumber, ' runs in ', (start to: end) duration; cr.
	patterns withIndexDo: [:p :i |
		summaryFile cr; cr; nextPutAll: 'PATTERN ', i, '    '.
		p do: [:e | summaryFile nextPutAll: ' ', e]
	].
	summaryFile close.


! !

!QJitterBufferTester methodsFor: 'initialize' stamp: 'jcg 10/16/2008 23:18'!
initialize
	super initialize.
	"margin, delay-step, concealment-size, max-late-rate, late-cost, activity-threshold."
	params := Array new: 6. 
	debugRecord := false.
! !

!QJitterBufferTester methodsFor: 'accessing' stamp: 'jcg 9/22/2008 19:20'!
lateCost: lc "nil, integer, or interval"
	params at: 5 put: lc

! !

!QJitterBufferTester methodsFor: 'accessing' stamp: 'jcg 9/22/2008 19:12'!
margin: m "nil, integer, or interval"
	params at: 1 put: m

! !

!QJitterBufferTester methodsFor: 'accessing' stamp: 'jcg 9/22/2008 19:20'!
maxLateRate: mll "nil, integer, or interval"
	params at: 4 put: mll

! !

!QJitterBufferTester methodsFor: 'initialize' stamp: 'jcg 9/22/2008 15:49'!
patterns: listOfPatterns
	patterns := listOfPatterns.
	! !

!QJitterBufferTester methodsFor: 'private' stamp: 'jcg 9/24/2008 10:57'!
prepareDirectoryForOutput
	| dir tfn |
	dir := FileDirectory default.
	dir assureExistenceOfPath: 'JitterBufferTester'.
	dir := dir directoryNamed: 'JitterBufferTester'.
	tfn := self trimmedFileName.
	(dir directoryExists: tfn) 
		ifFalse: [dir createDirectory: tfn.]
		ifTrue: [ "delete contents of directory"
			(dir directoryNamed: tfn) deleteLocalFiles.
		].
	
	^dir directoryNamed: tfn.
	! !

!QJitterBufferTester methodsFor: 'private' stamp: 'jcg 3/31/2010 11:34'!
processAudioWithPattern: patInd margin: margin delayStep: delayStep concealmentSize: concealSize maxLateRate: maxLateRate lateCost: lateCost activityThreshold: activityThreshold outputDir: dir
	| speexSink debugSink chunkStream eventStream putCount getCount done fileBase logFile wavFile |

	fileBase := 'testPattern-', patInd, '---margin-', margin, '---delayStep-', delayStep, '---concealSize-', concealSize, '---maxLate-', maxLateRate, '---lateCost-', lateCost, '---activityThreshold-', activityThreshold.
	logFile := dir forceNewFileNamed: fileBase, '.txt'.

	"Initialize all parameters"
	speexSink := QAudioSinkSpeex new.
	debugSink := QAudioSinkFeedback new.
	debugSink source: speexSink.
	margin ifNotNil: [speexSink ctlSetMargin: margin].
	delayStep ifNotNil: [speexSink ctlSetDelayStep: delayStep].
	concealSize ifNotNil: [speexSink ctlSetConcealmentSize: concealSize].
	maxLateRate ifNotNil: [speexSink ctlSetMaxLateRate: maxLateRate].
	lateCost ifNotNil: [speexSink ctlSetLateCost: lateCost].
	activityThreshold ifNotNil: [speexSink ctlSetActivityThreshold: activityThreshold].
	debugRecord ifTrue: [
		speexSink startDebugRecording: (dir fullPathFor: 'DebugRecord-',fileBase, '.txt') 
	].
	putCount := getCount := 0.

	"Create streams that we will use to process the sound."
	chunkStream := self createChunkStream.
	eventStream := ReadStream on: (patterns at: patInd).

	logFile nextPutAll: 'PROCESSING WITH PARAMETERS: ';
		cr; tab; nextPutAll: 'pattern index: ', patInd;
		cr; tab; nextPutAll: 'margin: ', margin;
		cr; tab; nextPutAll: 'delayStep: ', delayStep;
		cr; tab; nextPutAll: 'concealSize: ', concealSize;
		cr; tab; nextPutAll: 'maxLateRate: ', maxLateRate;
		cr; tab; nextPutAll: 'lateCost: ', lateCost;
		cr; tab; nextPutAll: 'activityThreshold: ', activityThreshold;
		cr; nextPutAll: '. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .'.

	"Mow through 'chunkStream' as fast as we can."
	done := false.
	[done] whileFalse: [
		| event |
		eventStream atEnd ifTrue: [eventStream reset].
		event := eventStream next.
		event caseOf: {
			[#put] -> [
				chunkStream atEnd
					ifTrue: [done := true]
					ifFalse: [
						putCount := putCount + 1.
						speexSink dejitterAndDecode: chunkStream next.
					]
			].
			[#get] -> [
				| decoded available putSurplus |
				getCount := getCount + 1.
				QAudioSession primAudioPluginTickerTickNow.
				(Delay forMilliseconds: 1) wait. "enough time for debug-sink to read back frame."

				"Test some expected values."
				decoded := debugSink decodedFrameCount.
				available := speexSink ctlGetAvailableCount.
				putSurplus := putCount - getCount max: 0.
				getCount = decoded ifFalse: [
					logFile cr; tab; nextPutAll: 'expected ', getCount, ' decoded frames, but got: ', decoded.
				].
				putSurplus = available ifFalse: [
					logFile cr; tab; nextPutAll: 'expected ', putSurplus, ' available frames, but got: ', available, 
																						' (after get: ', getCount, ')'.
				]	
			].
			[#reset] -> [speexSink resetJitterbufferTimestamps].
		}
	].
	
	"Save the file we just generated."
	wavFile := dir forceNewFileNamed: fileBase, '.wav'.
	debugSink makeSound 
		ifNil: [logFile cr; cr; nextPutAll: 'FAILED TO READ ANY SAMPLES AT ALL FROM THE DEBUG SINK!!!!!!']
		ifNotNilDo: [:snd | snd storeWAVSamplesOn: wavFile].

	debugSink destroy.
	speexSink destroy.
	logFile close.
	wavFile close.! !

!QJitterBufferTester methodsFor: 'initialize' stamp: 'jcg 10/16/2008 16:22'!
speexSound: sound
	"'sound' is either a ByteArray as created by eg: #encodeSpeexInChunksOf320:, or a collection of raw Speex chunks."
	speexSnd := sound.
	! !

!QJitterBufferTester methodsFor: 'private' stamp: 'jcg 10/16/2008 16:44'!
trimmedFileName
	| index |
	
	[ "hack"
		index := fileName findString: '.wav'.
		index == 0 ifTrue: [self error: 'file suffix is not .wav'].
		^fileName copyFrom: 1 to: index-1.
	] on: Error do: [^'Default'].! !

Object subclass: #QJitterbufferWindow
	instanceVariableNames: 'size lastStats'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Codec'!

!QJitterbufferWindow commentStamp: '<historical>' prior: 0!
Hack to begin playing with auto-adjustment of jitterbuffer margins.!

!QJitterbufferWindow class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QJitterbufferWindow methodsFor: 'accessing' stamp: 'jcg 4/20/2010 12:40'!
extrapolationRateFor: stats
	"Answer nil if the window isn't full.  If it is, answer the extrapolation rate, and start a new window."
	| total extrapolations proportion |
	
	"Ugh."
	lastStats ifNil: [lastStats := stats].
	stats ifNil: [
		QLogger logWarning: 'no stats available' every: 10000.
		^nil
	].

	"Check if the window is full.  If not, answer nil."
	(stats totalGets - lastStats totalGets) >= size ifFalse: [^nil].

	"Get the differences in gets/extrapolations since the beginning of the window."
	total := stats totalGets - lastStats totalGets.
	extrapolations := stats totalExtrapolations - lastStats totalExtrapolations.
	proportion := extrapolations asFloat / total.

	"Start new window beginning with the current stats."
	lastStats := stats.

	"Compute and answer the extrapolation rate over this period."
	^ proportion
! !

!QJitterbufferWindow methodsFor: 'initialize' stamp: 'jcg 3/2/2009 00:51'!
size: numberOfGets
	size := numberOfGets.! !

Object subclass: #QPhoneManager
	instanceVariableNames: 'session mediaController user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS'!

!QPhoneManager commentStamp: '<historical>' prior: 0!
A client-side component that encapsulates the functionality required for one-phone-per-person.!

QPhoneManager subclass: #QFakePhoneManager
	instanceVariableNames: 'server asteriskHost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS'!

!QFakePhoneManager commentStamp: '<historical>' prior: 0!
At first, we'll use a hack where we're not connecting to a QPhoneServer on a different machine... instead we'll encapsulate our own phone-server.  We'll still communicate with it via a media-stream (so that it is an easy transition to move it onto it's own machine), but will avoid needing the service-provider as an intermediary to set up the initial media-stream.!

!QFakePhoneManager class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QFakePhoneManager methodsFor: 'initialize' stamp: 'jcg 7/27/2008 11:51'!
asteriskHost: hostname
	"Call this before initializing with session/media-controller."
	asteriskHost := hostname.! !

!QFakePhoneManager methodsFor: 'initialize' stamp: 'jcg 7/18/2008 12:04'!
destroy
	super destroy.
	server ifNotNilDo: [:s | 
		server := nil.
		s destroy
	]! !

!QFakePhoneManager methodsFor: 'initialize' stamp: 'jcg 8/14/2008 00:28'!
initialize
	super initialize.
	asteriskHost := 'ussc9-asterisk01.qwaq.com'.! !

!QFakePhoneManager methodsFor: 'initialize' stamp: 'jcg 7/27/2008 11:51'!
initializeForMediaController: aMediaController

	"Initialize subclass first, because it (currently) immediately adds a user, which requires the server to already be there."
	server := QPhoneServer new.
	server asteriskHost: asteriskHost.
	server mediaController: aMediaController.

	"Now let the superclass do its thing."
	super initializeForMediaController: aMediaController.! !

!QFakePhoneManager methodsFor: 'private' stamp: 'jcg 7/29/2008 10:03'!
obtainControlStreamID
	"Answer the streamID of the control-stream that the manager should subscribe to."
	[^server controlStreamIDFor: self userLogin]
		on: Error do: [:err |
			QLogger 
				log: 'ERROR (expected, no big deal)... ', 
						'failed to obtain phone control-stream: ', err description 
				from: self.
			^nil
		]! !

!QFakePhoneManager methodsFor: 'accessing' stamp: 'jcg 7/26/2008 15:10'!
server
	^server! !

!QFakePhoneManager methodsFor: 'private' stamp: 'jcg 7/27/2008 12:01'!
userLogin
	"We want to have the option of overriding this in a subclass for testing."
	^ session userLogin! !

!QPhoneManager class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPhoneManager class methodsFor: 'instance creation' stamp: 'jcg 7/11/2008 12:00'!
forSession: aCroquetSession
	^ super new initializeForSession: aCroquetSession ! !

!QPhoneManager class methodsFor: 'instance creation' stamp: 'jcg 7/11/2008 12:00'!
new
	"Needs a session."
	self shouldNotImplement! !

!QPhoneManager methodsFor: 'accessing' stamp: 'hrs 8/15/2008 16:59'!
audioSession
	^session audioSession! !

!QPhoneManager methodsFor: 'initialize' stamp: 'jcg 7/18/2008 13:37'!
destroy
	user ifNotNilDo: [:u | 
		user := nil.
		u destroy.
	].! !

!QPhoneManager methodsFor: 'initialize' stamp: 'jcg 8/14/2008 12:47'!
initializeForMediaController: aMediaController
	"Shouldn't be called directly...call #initializeForSession: instead (exception: when we want to set up a test-harness so that we can place calls without wasting time doing a full Forums login)."

	mediaController := aMediaController.

	"XXXXX: We definitely want to connect asynchronously... we don't want to wait to obtain the control-stream ID from the service provider.  However, this is a really dodgy way to do it."
	"XXXXX: If reconnect is necessary, how does the phone-user obtain the appropriate streamID?  Maybe obtaining and bashing it in here isn't the right thing."
	user := QPhoneUserOnClient new
							name: self userLogin;
							sessionID: session sessionID;
							mediaController: mediaController;
							yourself.
	[user streamID: self obtainControlStreamID] fork.
	! !

!QPhoneManager methodsFor: 'initialize' stamp: 'jcg 7/26/2008 13:47'!
initializeForSession: aCroquetSession
	session := aCroquetSession.
	self initializeForMediaController: session mediaController.
! !

!QPhoneManager methodsFor: 'private' stamp: 'jcg 7/11/2008 12:26'!
obtainControlStreamID
	"Answer the streamID of the control-stream that the manager should subscribe to."

	self notYetImplemented. "will make a service-provider request that will cause the phone-server to publish a stream; the SP request will then return the streamID."! !

!QPhoneManager methodsFor: 'accessing' stamp: 'jcg 7/18/2008 17:33'!
user
	^user! !

Object subclass: #QPhoneServer
	instanceVariableNames: 'mediaController users asteriskHost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS'!

!QPhoneServer commentStamp: '<historical>' prior: 0!
Server-side component that manages connections to logged-in phone users, and orchestrates calls.!

!QPhoneServer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPhoneServer methodsFor: 'initialize' stamp: 'jcg 7/26/2008 02:21'!
asteriskHost: hostnameString
	asteriskHost := hostnameString.! !

!QPhoneServer methodsFor: 'accessing' stamp: 'jcg 7/21/2008 17:27'!
controlStreamIDFor: userName
	| user |

	user := users 
				at: userName 
				ifAbsentPut: [self createUserNamed: userName].
	user publishControlStreamIfNecessary.
	^ user controlStreamID
	! !

!QPhoneServer methodsFor: 'configuration' stamp: 'jcg 7/27/2008 12:14'!
createUserNamed: userName
	"XXXXX: quick hack"
	| user |
	user := QPhoneUserOnServer new.
	user 
		name: userName 
		password: (self passwordFromUsername: userName) 
		host: asteriskHost.
	user mediaController: mediaController.
	^user
		! !

!QPhoneServer methodsFor: 'initialize' stamp: 'jcg 8/13/2008 18:28'!
destroy
	"Don't iterate over 'users' itself, because destroying a user will modify the dictionary."
	users values do: [:u | u future destroy].
	users := Dictionary new.! !

!QPhoneServer methodsFor: 'initialize' stamp: 'jcg 7/10/2008 14:18'!
initialize
	super initialize.
	users := Dictionary new.
	! !

!QPhoneServer methodsFor: 'initialize' stamp: 'jcg 7/11/2008 12:50'!
mediaController: hub
	mediaController := hub! !

!QPhoneServer methodsFor: 'hacks' stamp: 'jcg 7/27/2008 11:30'!
passwordFromUsername: userName
	"Compute an obfuscated password."
	^(TCryptoRandom hashMessage: userName reversed) hex! !

!QPhoneServer methodsFor: 'accessing' stamp: 'jcg 7/26/2008 15:12'!
userNamed: userName
	^ users at: userName ifAbsent: [nil]! !

Object subclass: #QPhoneTestHarness
	instanceVariableNames: 'sessionID dispatcher router controller manager asteriskHost asteriskUsername microphone'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Dev'!

!QPhoneTestHarness commentStamp: '<historical>' prior: 0!
This allows us to test end-to-end phonestuff without needing to do a full Forums login.

Use it thusly:

h := QPhoneTestHarness new.
h initializeForAsteriskHost: '10.10.2.122' andUsername: 'josh.gargus@qwaq.com'.
c := h clientUser placeCallTo: 'andreas.raab@qwaq.com'.
c := h clientUser placeCallTo: 'david.smith@qwaq.com'.
c := h clientUser placeCallTo: 'greg.nuyens@qwaq.com'.
h serverUser callAt: callID.

h clientUser callsDo: [:c | c state == #ringingInbound 
								ifTrue: [h clientUser future answerCall: c callID]].

h startRecording.
h stopRecording.

h serverUser destroy

h destroy. h := nil. c := nil.

QPhoneTestHarness cleanup!

!QPhoneTestHarness class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPhoneTestHarness class methodsFor: 'utility' stamp: 'jcg 9/6/2008 14:39'!
cleanup
	QPhoneTestHarness allInstances do: [:h | h destroy].
	QPhoneUser allSubInstances do: [:u | u destroy].
	QPhoneUserFeedbackChannel allSubInstances do: [:f | f destroy].! !

!QPhoneTestHarness methodsFor: 'accessing' stamp: 'jcg 7/26/2008 15:09'!
clientUser
	^manager user! !

!QPhoneTestHarness methodsFor: 'initialize' stamp: 'jcg 7/26/2008 15:04'!
destroy
	manager ifNotNilDo: [:m |
		manager := nil.
		m destroy.
	].
	controller ifNotNilDo: [:c |
		controller := nil.
		c destroy.
	].
	router ifNotNilDo: [:r | 
		router := nil.
		r destroy.
	].
	dispatcher ifNotNilDo: [:d | 
		dispatcher := nil.
		d destroy.
	].! !

!QPhoneTestHarness methodsFor: 'initialize' stamp: 'jcg 10/14/2008 12:22'!
initialize
		
	dispatcher := TConnectionDispatcher new.
	dispatcher listenOn: self defaultPort.

	router := QStreamingRouter new.
	router dispatcher: dispatcher.
	router beMediaRouter.

	sessionID := TObjectID new.
	controller := self createController: 'ctrl'.

	microphone := QMicrophone new.
	microphone codec: GSMCodec new.
	microphone streamer: self.
	
	! !

!QPhoneTestHarness methodsFor: 'initialize' stamp: 'jcg 7/27/2008 12:04'!
initializeForAsteriskHost: hostname andUsername: username
	"Must call this before actually using this class."
	asteriskHost := hostname.
	asteriskUsername := username.

	manager := QFakePhoneManager basicNew initialize.
	manager asteriskHost: hostname.
	manager initializeForSession: self "QPhoneTestHarness pretends to be a session".! !

!QPhoneTestHarness methodsFor: 'accessing' stamp: 'jcg 8/13/2008 23:51'!
manager
	^manager! !

!QPhoneTestHarness methodsFor: 'session-alike' stamp: 'jcg 7/27/2008 12:01'!
mediaController
	"So that we act enough like a QwaqCroquetSession to fool a QPhoneManager."
	^ controller! !

!QPhoneTestHarness methodsFor: 'sound' stamp: 'jcg 9/1/2008 14:07'!
playSound: data at: frameTime samplingRate: samplingRate codec: codec level: level
	self clientUser ifNotNilDo: [:cu | cu callsDo: [:c |
		c playSound: data at: frameTime samplingRate: samplingRate codec: codec level: level
	]]! !

!QPhoneTestHarness methodsFor: 'sound' stamp: 'jcg 7/30/2008 01:58'!
sendEndOfAudiblePeriod
	"Pretending to be a 'streamer'... see QVoiceRecorder>>audiblePeriodEnded."! !

!QPhoneTestHarness methodsFor: 'accessing' stamp: 'jcg 7/26/2008 15:12'!
serverUser
	^manager server userNamed: self clientUser name! !

!QPhoneTestHarness methodsFor: 'sound' stamp: 'jcg 7/30/2008 01:54'!
start
	"Pretending to be a 'streamer'... see QVoiceRecorder>>startRecording."! !

!QPhoneTestHarness methodsFor: 'sound' stamp: 'jcg 10/14/2008 12:23'!
startRecording
	microphone startRecording; resumeRecording.! !

!QPhoneTestHarness methodsFor: 'sound' stamp: 'jcg 10/14/2008 12:23'!
stopRecording
	microphone stopRecording! !

!QPhoneTestHarness methodsFor: 'session-alike' stamp: 'jcg 7/27/2008 12:02'!
userLogin
	"So that we act enough like a QwaqCroquetSession to fool a QPhoneManager."
	^ asteriskUsername! !

Object subclass: #QRecordedVoiceForDebug
	instanceVariableNames: 'events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Tests'!

!QRecordedVoiceForDebug commentStamp: 'jcg 10/24/2008 18:34' prior: 0!
Reads debug-files that Forums records for a particular user's voice stream.

Currently handles "version 1.1" files... if the top of your debug-file doesn't have a line that says (something like) version-1.0, then it is too old.

Example usage (copy the following into a workspace):

"Parse the file, assigning the result to 'rec'."
rec := QRecordedVoiceForDebug 
			newFromFileNamed: 'DebugRecord--eric.raab-AT-qwaq.com--5-55-18pm.txt'.

"Look at the raw events parsed from the file.  The second one is probably more useful, since you probably don't want to be looking at ASCII versions of either encoded Speex or decoded WAV."
rec events. 
rec eventsWithoutBinaryData.

"Save WAV files containing 1) the actual data that was played through OpenAL (and recorded in the log file) 2) audio decoded from the speex input, without processing by the jitter-buffer."
rec soundFromPutsOnly storeWAVOnFileNamed: 'WithoutJitter.wav'.
rec soundFromGetsOnly storeWAVOnFileNamed: 'ExactReproduction.wav'

"Play the same sounds within Squeak."
rec soundFromPutsOnly play.
rec soundFromGetsOnly play.

"Get some basic information about how many audio frames were extrapolated, as opposed to being decoded from real data.  The first expression answers the proportion of extrapolated frames. The second expression answers a list of associations between the 'event index' (into the list of raw events) where a run of extrapolations begins, and the length of the run."
rec extrapolationRate.
rec extrapolationRuns. 

"Say that 'extrapolationRuns' has an entry '4837->35'... this means that event #4837 is the beginning of a 700ms period where there is no real data to decode.  How do we find where this shows up in the .WAV file that we output above?  Easy."
rec timeOfEventAtIndex: 4837.

"If we care about only a particular time range, we can create a copy with only the desired range.  The times are specified in seconds."
rec2 := rec trimFrom: 40 to: 60.
rec2 extrapolationRate.

"Create a QJitterBufferTester from the recorded data.  If we are using the same QAudioPlugin, then we should be able to exactly replicate the original output by playing the original input with the actual sequence of gets/puts.  An output .WAV will be stored in JitterBufferTester/Default (plus some other files that you can ignore)."
tester := rec createQJitterBufferTester.
tester go.

"Alternately, you can experiment with how it would have sounded with different JB parameters."
tester margin: (2560 to: 7680 by: 2560).
tester concealSize: #(320 640 1280 2560).
tester activityThreshold: 10.
tester go.!

!QRecordedVoiceForDebug class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QRecordedVoiceForDebug class methodsFor: 'instance creation' stamp: 'jcg 10/15/2008 22:29'!
newFromFileNamed: filePath
	| fileStream newGuy | 
	fileStream := FileStream readOnlyFileNamed: filePath.
	fileStream ifNil: [^nil].
	[newGuy := self newFromStream: fileStream] ensure: [fileStream close].
	^newGuy
! !

!QRecordedVoiceForDebug class methodsFor: 'instance creation' stamp: 'jcg 10/15/2008 21:46'!
newFromStream: fileStream
	^ self new initializeFromStream: fileStream; yourself
! !

!QRecordedVoiceForDebug methodsFor: 'accessing' stamp: 'jcg 10/16/2008 01:11'!
allGets
	^ events select: [:assoc | self isGet: assoc]
! !

!QRecordedVoiceForDebug methodsFor: 'accessing' stamp: 'jcg 10/24/2008 17:04'!
allGetsBeforeIndex: index
	"Answer all 'gets' whose event index is < 'index'."
	| col |
	col := OrderedCollection new.
	self indicesOfGets do: [:i |
		i >= index ifTrue: [^col "done"].
		col add: (events at: i)
	].
	^col
! !

!QRecordedVoiceForDebug methodsFor: 'accessing' stamp: 'jcg 10/16/2008 16:35'!
allParams
	^ events select: [:assoc | self isParam: assoc]
! !

!QRecordedVoiceForDebug methodsFor: 'accessing' stamp: 'jcg 10/16/2008 01:11'!
allPuts
	^ events select: [:assoc | self isPut: assoc]
! !

!QRecordedVoiceForDebug methodsFor: 'accessing' stamp: 'jcg 10/16/2008 01:11'!
allPutsAndGets
	^ events select: [:assoc | self isPutOrGet: assoc]
! !

!QRecordedVoiceForDebug methodsFor: 'accessing' stamp: 'jcg 10/16/2008 17:33'!
allPutsAndGetsAndResets
	^ events select: [:assoc | self isPutOrGetOrReset: assoc]
! !

!QRecordedVoiceForDebug methodsFor: 'accessing (amount buffered)' stamp: 'jcg 10/16/2008 01:23'!
amountsBufferedInJB
	"Answer the number of packets buffered in the JB."
	| lastVal |
	lastVal := 0.
	^events collect: [:assoc |
		(self isPutOrGet: assoc) ifTrue: [lastVal := assoc value second].
		(assoc key = 'reset2') ifTrue: [lastVal := 0].
		lastVal
	].
! !

!QRecordedVoiceForDebug methodsFor: 'accessing (amount buffered)' stamp: 'jcg 10/16/2008 01:29'!
changesInAmountBufferedInJB
	"Answer the number of packets buffered in the JB."
	| amounts changes |
	amounts := self amountsBufferedInJB.
	changes := OrderedCollection new.
	1 to: amounts size - 1 do: [:i | changes add: (amounts at: i+1) - (amounts at: i)].
	^changes asArray! !

!QRecordedVoiceForDebug methodsFor: 'accessing' stamp: 'jcg 10/16/2008 23:24'!
createQJitterBufferTester
	"Create a QJitterBufferTester initialized with our specific input data and sequence of puts/gets.  Assuming that the same binary QAudioPlugin was used to create this initial recording, the output of the QJitterBufferTester should be (essentially?) identical.  Also useful for seeing which parameters improve JB performance."
	| putsAndGets spxData qjbt |
	putsAndGets := self allPutsAndGetsAndResets reject: [:assoc | 
		(assoc key = 'put2') | (assoc key = 'reset2').
	].
	putsAndGets := putsAndGets collect: [:assoc | (assoc key allButLast) -> assoc value].
	spxData := putsAndGets 
					select: [:assoc | assoc key = 'put'] 
					thenCollect: [:assoc | assoc value third].
	putsAndGets := putsAndGets collect: [:assoc | assoc key].

	qjbt := QJitterBufferTester speexSound: spxData patterns: {putsAndGets}.
	qjbt debugRecord: true.

	self allParams do: [:assoc |
		| p val |
		p := assoc value first.
		val := assoc value second.
		p caseOf: {
			['margin'] -> [qjbt margin: val].
			['delayStep'] -> [qjbt delayStep: val].
			['concealSize'] -> [qjbt concealSize: val].
			['maxLateRate'] -> [qjbt maxLateRate: val].
			['lateCost'] -> [qjbt lateCost: val].
			['activityThreshold'] -> [qjbt activityThreshold: val].
		} otherwise: 
			[QLogger logWarning: '#createQJitterBufferTester... unknown param: ', p].
	].

	^qjbt
! !

!QRecordedVoiceForDebug methodsFor: 'accessing' stamp: 'jcg 10/16/2008 01:40'!
events
	"The raw events."
	^events! !

!QRecordedVoiceForDebug methodsFor: 'private' stamp: 'jcg 10/24/2008 18:25'!
events: listOfEvents
	"Bash in some new events."
	events := listOfEvents! !

!QRecordedVoiceForDebug methodsFor: 'accessing' stamp: 'jcg 10/16/2008 22:37'!
eventsWithoutBinaryData
	"The raw events, stripped of large binary data which is distracting to look at."
	^events collect: [:assoc |
		(self isPutOrGet: assoc)
			ifFalse: [assoc]
			ifTrue: [assoc key -> (assoc value allButLast)]
	]! !

!QRecordedVoiceForDebug methodsFor: 'accessing' stamp: 'jcg 10/24/2008 16:52'!
extrapolationIndexDifferences
	"How far apart are JB extrapolation events (i.e. do they cluster together?).  Probably superceded by #extrapolationRuns."
	| indices |
	indices := self extrapolationIndices.
	^((1 to: indices size-1) collect: [:i | (indices at: i+1) - (indices at: i)]) asArray
! !

!QRecordedVoiceForDebug methodsFor: 'accessing' stamp: 'jcg 10/16/2008 01:51'!
extrapolationIndices
	| indices |
	indices := OrderedCollection new.
	events withIndexDo: [:assoc :i | assoc key = 'get2' ifTrue: [indices add: i]].
	^indices asArray! !

!QRecordedVoiceForDebug methodsFor: 'accessing (statistics)' stamp: 'jcg 10/16/2008 01:18'!
extrapolationRate
	"Answer the percentage of gets that are extrapolations, rather than actual decoded speex data."
	| gets goodCnt extrapCnt | 
	gets := self allGets.
	goodCnt := (gets select: [:assoc | assoc key = 'get0']) size.
	extrapCnt := (gets select: [:assoc | assoc key = 'get2']) size.
	^ (extrapCnt asFloat) / (goodCnt + extrapCnt)
	! !

!QRecordedVoiceForDebug methodsFor: 'accessing' stamp: 'jcg 10/22/2008 21:29'!
extrapolationRuns
	"Answers a list of associations, where the key is the index of the start of a run of extrapolations, and the value is the length of the run."
	| differences indices runStart runSize runs|
	differences := self extrapolationIndexDifferences.
	indices := self extrapolationIndices.

	runStart := 0.
	runSize := 1.
	runs := OrderedCollection new.
	differences withIndexDo: [:diff :i |
		diff = 1 
			ifTrue: [
				runSize := runSize + 1.
			]
			ifFalse: [
				runs add: (indices at: runStart+1)->runSize.
				runStart := i.
				runSize := 1.
			]
	].
	^ runs ! !

!QRecordedVoiceForDebug methodsFor: 'accessing' stamp: 'jcg 10/24/2008 16:43'!
indicesOfGets
	"Answer a collection containing the indices of all 'get' events."
	| col |
	col := OrderedCollection new.
	events withIndexDo: [:assoc :i | (self isGet: assoc) ifTrue: [col add: i]].
	^col! !

!QRecordedVoiceForDebug methodsFor: 'initialize' stamp: 'jcg 10/15/2008 21:52'!
initializeFromStream: aStream
	events := OrderedCollection new.
	[aStream atEnd] whileFalse: [
		| line |
		line := aStream upTo: Character lf.
		self parseLine: line
	]! !

!QRecordedVoiceForDebug methodsFor: 'private' stamp: 'jcg 10/16/2008 01:09'!
isGet: assoc
	^ assoc key beginsWith: 'get'! !

!QRecordedVoiceForDebug methodsFor: 'private' stamp: 'jcg 10/16/2008 16:34'!
isParam: assoc
	^ assoc key beginsWith: 'param'! !

!QRecordedVoiceForDebug methodsFor: 'private' stamp: 'jcg 10/16/2008 01:09'!
isPut: assoc
	^ assoc key beginsWith: 'put'! !

!QRecordedVoiceForDebug methodsFor: 'private' stamp: 'jcg 10/16/2008 01:10'!
isPutOrGet: assoc
	^ (self isPut: assoc) or: [self isGet: assoc]! !

!QRecordedVoiceForDebug methodsFor: 'private' stamp: 'jcg 10/16/2008 17:33'!
isPutOrGetOrReset: assoc
	^ (self isPut: assoc) or: [self isGet: assoc] or: [self isReset: assoc]! !

!QRecordedVoiceForDebug methodsFor: 'private' stamp: 'jcg 10/16/2008 01:19'!
isReset: assoc
	^ assoc key beginsWith: 'reset'! !

!QRecordedVoiceForDebug methodsFor: 'accessing (amount buffered)' stamp: 'jcg 10/16/2008 01:35'!
largeChangesInAmountBufferedInJB
	"Answer the indices of events where the amount buffered changed by > 1."
	| changes indices |
	changes := self changesInAmountBufferedInJB.
	indices := OrderedCollection new.
	changes withIndexDo: [:v :i | v abs > 1 ifTrue: [indices add: i]].
	^indices asArray
! !

!QRecordedVoiceForDebug methodsFor: 'accessing' stamp: 'jcg 10/24/2008 17:04'!
numberOfGetsBeforeIndex: index
	"Answer the number of 'gets' whose event index is < 'index'."
	^ (self allGetsBeforeIndex: index) size! !

!QRecordedVoiceForDebug methodsFor: 'private' stamp: 'jcg 3/18/2010 02:04'!
parseDrop: strm
	| evt time available activity  |
	evt := strm upTo: $-.
	strm next.  "skip $[ "
	time := (strm upTo: $-) asInteger.
	available := (strm upTo: $-) asInteger.
	activity := (strm upTo: $]) asInteger.
		
	strm next.  "skip $- "

	events add: evt -> {time. available. activity}.

! !

!QRecordedVoiceForDebug methodsFor: 'private' stamp: 'jcg 10/16/2008 22:43'!
parseGet: strm
	| evt time available activity size bytes buf  |
	evt := strm upTo: $-.
	strm next.  "skip $[ "
	time := (strm upTo: $-) asInteger.
	evt = 'get0' 
		ifTrue: [
			"We only record activity for successfully  decoded packets."
			available := (strm upTo: $-) asInteger.
			activity := (strm upTo: $]) asInteger.
		]
		ifFalse: [
			available := (strm upTo: $]) asInteger.
			activity := nil.
		].


	
	strm next.  "skip $- "

	evt = 'get9' 
		ifTrue: [buf := SoundBuffer newMonoSampleCount: 320]
		ifFalse: [
			size := (strm upTo: $-) asInteger.
			bytes := TObjectID basicNew: size.
			bytes readHexFrom: strm.
			bytes := bytes asByteArray.
			buf := SoundBuffer fromLittleEndianByteArray: bytes.
		].
	events add: evt -> {time. available. activity. buf}.

! !

!QRecordedVoiceForDebug methodsFor: 'private' stamp: 'jcg 3/18/2010 02:02'!
parseLine: lineString
	| evt strm |
	strm := lineString readStream.
	evt := strm upTo: $-.
	strm peek ifNil: [Transcript cr; show: 'could not parse line: ', (lineString first: 15), '...'].
	strm reset.
	
	[
		(evt beginsWith: 'put') ifTrue: [^self parsePut: strm].
		(evt beginsWith: 'get') ifTrue: [^self parseGet: strm].
		(evt beginsWith: 'reset') ifTrue: [^self parseReset: strm].
		(evt beginsWith: 'param') ifTrue: [^self parseParam: strm].
		(evt beginsWith: 'drop') ifTrue: [^self parseDrop: strm].
		(evt beginsWith: 'version') ifTrue: [^self parseVersion: strm].
	] 	on: Error 
		do: [:err | ^Transcript cr; show: 'error while processing ', evt, ': ', err description].

	Transcript cr; show: 'unknown event: ', evt, '  from line: ', (lineString first: 15), ' ...'
! !

!QRecordedVoiceForDebug methodsFor: 'private' stamp: 'jcg 10/15/2008 22:24'!
parseParam: strm
	| evt param val  |
	evt := strm upTo: $-.
	param := strm upTo: $-.
	val := strm upToEnd asNumber.
	events add: evt -> {param. val}.

! !

!QRecordedVoiceForDebug methodsFor: 'private' stamp: 'jcg 10/15/2008 22:40'!
parsePut: strm
	| evt time available size bytes |
	evt := strm upTo: $-.
	strm next.  "skip $[ "
	time := (strm upTo: $-) asInteger.
	available := (strm upTo: $]) asInteger.
	strm next.  "skip $- "
	size := (strm upTo: $-) asInteger.
	bytes := TObjectID basicNew: size.
	bytes readHexFrom: strm.
	bytes := bytes asByteArray.
	events add: evt -> {time. available. bytes}.

! !

!QRecordedVoiceForDebug methodsFor: 'private' stamp: 'jcg 10/16/2008 00:22'!
parseReset: strm
	| evt putTime getTime |
	evt := strm upTo: $-.
	strm next.  "skip $[ "
	putTime := (strm upTo: $-) asInteger.
	getTime := (strm upTo: $]) asInteger.
	events add: evt -> {putTime. getTime}.

! !

!QRecordedVoiceForDebug methodsFor: 'private' stamp: 'jcg 10/15/2008 22:23'!
parseVersion: strm
	| evt version  |
	evt := strm upTo: $-.
	version := strm upToEnd asNumber.
	events add: evt -> {version}.

! !

!QRecordedVoiceForDebug methodsFor: 'accessing (amount buffered)' stamp: 'jcg 10/22/2008 21:50'!
putsThatDidNotAffectAmountsBufferedInJB
	"Answer the indices of 'put1s' that didn't increase the # of packets buffered in the JB."
	| indices |
	indices := OrderedCollection new.
	events withIndexDo: [:assoc :i |
		assoc key = 'put1' ifTrue: [
			| change |
			change := assoc value second - (events at: i-1) value second.
			change = 1 ifFalse: [indices add: i].
		]
	].
	^indices

! !

!QRecordedVoiceForDebug methodsFor: 'accessing (sounds)' stamp: 'jcg 10/22/2008 20:54'!
soundFromGetsOnly
	| strm |
	strm := WriteStream on: (SoundBuffer newMonoSampleCount: 320).
	self allGets do: [:assoc |
		strm nextPutAll: assoc value fourth
	].
	^ SampledSound samples: strm contents samplingRate: 16000! !

!QRecordedVoiceForDebug methodsFor: 'accessing (sounds)' stamp: 'jcg 10/15/2008 22:53'!
soundFromPutsOnly
	| strm spx into |

	spx := QSpeexCodec new.
	into := SoundBuffer newMonoSampleCount: 320.
	strm := WriteStream on: (SoundBuffer newMonoSampleCount: 320).
	[
		self allPuts do: [:assoc |
			"We ignore 'put2' because the corresponding 'put3' will take care of it."
			assoc key = 'put2' ifFalse: [
				spx decode: assoc value third into: into.
				strm nextPutAll: into.
			].
		].
	] ensure: [spx destroy].
	^ SampledSound samples: strm contents samplingRate: 16000! !

!QRecordedVoiceForDebug methodsFor: 'accessing' stamp: 'jcg 10/24/2008 17:14'!
timeOfEventAtIndex: index
	"Answer the approximate real-time that the event occurred at (our only source of 'real-time' are the gets, which occurs quite steadily every 20ms... we answer the time of the immediately-preceding 'get')."
	^ (self numberOfGetsBeforeIndex: index+1) / 50 asFloat! !

!QRecordedVoiceForDebug methodsFor: 'accessing' stamp: 'jcg 10/24/2008 18:28'!
trimFromTime: startTime "a Float" to: endTime "also a Float"
	"Create another instance with only the events from the specified time range."
	| time startIndex endIndex |
	time := 0.
	startIndex := 1.
	events withIndexDo: [:assoc :i |
		(self isGet: assoc) ifTrue: [time := time + 0.02].
		time <= startTime ifTrue: [startIndex := i].
		time < endTime ifTrue: [endIndex := i].
	].
	^self clone 
			events: (events copyFrom: startIndex to: endIndex);
			yourself.! !

Object subclass: #QSoundEffects
	instanceVariableNames: 'audioSession sounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound'!

!QSoundEffects commentStamp: '<historical>' prior: 0!
A manager for standard Qwaq sound effects.

This is a harness-side object that maintains a dictionary
of common sound effects.  The participant UI arranges
to play these sounds in response to signals from the space.
(Some effects are also played directly by the UI.)

See my class methods for convenient methods which
can be used in-space to play sound effects for TFrame activity.

My method #defaultEffectList lists all the default
sound effects available for any participant.
!

!QSoundEffects class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSoundEffects class methodsFor: 'utilities' stamp: 'bgf 11/6/2006 16:56'!
play: aSymbol for: aTFrame

	"Play a named sound effect.  For use within Croquet spaces.
	 The Participant UI system arranges
	 to handle the soundEffect signal and play the sound."

	(aTFrame root) ifNotNilDo: [ :root| 
		root signal: #soundEffect with: aSymbol with: aTFrame
	].! !

!QSoundEffects methodsFor: 'initialize-release' stamp: 'bgf 6/20/2009 20:56'!
addSound: sampledSound atKey: aKey gain: aScalar
	"Extend the sound effect list with the given entry."
	sounds at: aKey
		put: ((QClientSoundFrame new) 
			sampledSound: sampledSound;
			maxDistance: 800.0;
			referenceDistance: 20.0;
			gain: aScalar;
			session: audioSession;
			yourself).
! !

!QSoundEffects methodsFor: 'initialize-release' stamp: 'bgf 2/6/2009 21:27'!
audioSession: anAudioSession

	"Initialize or change the current croquetView;
	 the view must always be set before playing sounds."

	audioSession := anAudioSession.
	sounds values do: [ :aClientSound |
		aClientSound session: anAudioSession
	].! !

!QSoundEffects methodsFor: 'initialize-release' stamp: 'bgf 8/28/2009 10:05'!
defaultEffectList

	"The master list of named sound effects;
	 the format for each entry is { Name .  SampledSound . Gain }."

	^ {
		{#chime . (QSounds chime) . 0.04}.
		{#click . (QSounds click) . 0.01}.
		{#beep .  (QSounds beep) . 0.02 }.
		{#switch . (QSounds switch). 0.008}.
		{#softClick . (QSounds click). 0.003}.
		{#blip . (QSounds blip) . 0.08 }.
		{#softBlip . (QSounds blip) . 0.01 }.

		"UI sounds for avatar transitions."
		{#changeSpace .  (QSounds changeSpace)  . 0.04}.
		{#warpPosition .  (QSounds changeSpace)  . 0.01}.
		{#avatarEnter . (QSounds avatarEnter) . 0.04}.
		{#softAvatarEnter . (QSounds avatarEnter) . 0.01 }.
		{#avatarLeave . (QSounds avatarLeave). 0.04}.
		{#softAvatarLeave . (QSounds avatarLeave). 0.01}.

		"Common widget sounds"
		{#acceptDrop . (QSounds acceptDrop). 0.0075}.
		{#discardObject . (QSounds discardObject). 0.02}.
		{#online . (QSounds online) . 0.08 }.
		{#offline . (QSounds offline) . 0.08 }.

		"Chat pane."
		{#veryLoudMessage . (QSounds message) . 0.5}.
		{#loudMessage . (QSounds message) . 0.05}.
		{#message . (QSounds message) . 0.015}.

		"mechanical and electronic"
		{#iris . (QSounds iris). 0.1}.
		{#spring . (QSounds spring). 0.03}.
		{#tingle .(QSounds tingle). 0.2}.
		{#lift . (QSounds lift) . 0.1}.
		{#laser . (QSounds laser) . 0.1}.
	}.! !

!QSoundEffects methodsFor: 'initialize-release' stamp: 'bgf 8/9/2007 11:09'!
destroy

	sounds ifNotNil: [
		sounds valuesDo: [ : sf | sf destroy ].
	].
	sounds := Dictionary new.! !

!QSoundEffects methodsFor: 'accessing' stamp: 'jcg 2/15/2007 14:05'!
effectAt: aSymbol
	^ sounds at: aSymbol ifAbsent: [nil]! !

!QSoundEffects methodsFor: 'initialize-release' stamp: 'bgf 10/31/2006 11:39'!
initialize

	sounds := Dictionary new.

	"Load the master list."
	self defaultEffectList do: [ :description |
		 self addSound: description second atKey: description first gain: description third.
	].

	"Note that you must call view:aCroquetView before playing sounds."! !

!QSoundEffects methodsFor: 'playing sound' stamp: 'bgf 10/31/2006 10:34'!
playEffect: aSymbol at: aVector3

	"Play the named sound effect, positioned at the given spatial position."

	sounds at: aSymbol ifPresent: [ :sound| sound playAt: aVector3].! !

Object subclass: #QSpeakerManager
	instanceVariableNames: 'speakers view audioSession activeSpace isMute mutex listenerRegion regionAttenuation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Speaker'!

!QSpeakerManager commentStamp: '<historical>' prior: 0!
(c) 2007 Qwaq Inc.  QSpeakerManager holds a number of QClientSpeakers that recieve and play sound streaming audio on behalf of speakers that are replicated on Croquet islands.!

!QSpeakerManager class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSpeakerManager methodsFor: 'accessing' stamp: 'jcg 4/10/2010 08:27'!
audioSession
	^ audioSession! !

!QSpeakerManager methodsFor: 'initialize' stamp: 'jcg 5/13/2010 15:12'!
audioSession: myAudioSession
	myAudioSession ifNil: [^audioSession := nil].
	audioSession ifNotNil: [self error: 'audio-session is already set'].
	audioSession := myAudioSession.
	self future checkSpeakerSanity.! !

!QSpeakerManager methodsFor: 'events' stamp: 'sn 5/13/2011 22:58'!
beMute
	mutex critical: [
		isMute ifFalse: [
			isMute := true.
			view ifNotNil: [ view owner statusInfo: 'Audio output is off.' translateMe ].
			speakers do: [:spk | spk mutingChanged ].	
		]].! !

!QSpeakerManager methodsFor: 'events' stamp: 'sn 5/13/2011 22:58'!
beUnmute
	mutex critical: [
		isMute ifTrue: [
			isMute := false.
			view ifNotNilDo: [:v | v owner statusInfo: 'Audio output is on.' translateMe].
			speakers do: [:spk | spk mutingChanged ].
		]].! !

!QSpeakerManager methodsFor: 'sanity' stamp: 'jcg 5/13/2010 16:26'!
checkSpeakerSanity
	| mySpeakers allSpeakers certifiedInsane shouldBeDead shouldBeAlive voiceChatIDs |
	certifiedInsane := false.  "not yet"

	mySpeakers := speakers asIdentitySet.
	allSpeakers := QClientSpeaker allInstances.

	"Find all client-speakers that should be dead, but aren't.
	 (all living speakers should be known to the speaker-manager)."	
	shouldBeDead := (allSpeakers difference: mySpeakers) select: [:sp | sp timeSinceDeath isNil].
	shouldBeDead do: [:sp |
		certifiedInsane := true.
		QLogger logWarning: (String streamContents: [:st |
			st nextPutAll: 'undead speaker found outside of speaker-manager'.
			self printInsaneSpeaker: sp on: st.
		]).
	].

	"Find all client-speakers that should be alive, but aren't. 
	 (all speakers in the speaker-manager should be alive)."	
	shouldBeAlive := mySpeakers select: [:sp | sp timeSinceDeath notNil].
	shouldBeAlive do: [:sp |
		certifiedInsane := true.
		QLogger logWarning: (String streamContents: [:st |
			st nextPutAll: 'speaker in manager has been dead for ', sp timeSinceDeath, 'ms'.
			self printInsaneSpeaker: sp on: st.
		]).
	].

	"Find all the client-speakers with voice-chat inputs.  Ensure that there are no
	 duplicate stream-IDs."
	voiceChatIDs := Set new.
	mySpeakers do: [:sp |
		sp speakerInput ifNotNil: [:input |
			input class == QClientSpeakerChatInput ifTrue: [
				input streamID ifNotNil: [:id |
					(voiceChatIDs includes: id)
						ifFalse: [voiceChatIDs add: id]
						ifTrue: [
							certifiedInsane := true.
							QLogger logWarning: 'multiple inputs with stream: ', id hex]]]]].

	certifiedInsane ifTrue: [
		"The event-loop will catch and report this error.   
		 We avoid spamming ourselves with these error-reports
		 by not rescheduling another sanity-test with #future:."
		self error: 'failed speaker sanity check'
	].

	(self future: 12345) checkSpeakerSanity.! !

!QSpeakerManager methodsFor: 'accessing' stamp: 'jcg 5/17/2010 12:20'!
clientSpeakersWithStreamID: streamID
	"Answer a collection containing all QClientSpeakers that are subscribed to the specified stream-id."
	audioSession assertIsInTurn.
	mutex critical: [
		^speakers select: [:spkr | spkr streamID = streamID].
	]! !

!QSpeakerManager methodsFor: 'private' stamp: 'bgf 9/8/2008 14:27'!
createSpeakerClientFor: speakerRef controller: aController
	
	| spkr |
	spkr := QClientSpeaker for: speakerRef manager: self controller:  aController.
	view ifNotNil: [
		spkr isMe: (view sessionID = (speakerRef get: #sessionID))
	].

	^ spkr! !

!QSpeakerManager methodsFor: 'actions' stamp: 'crl 4/23/2010 17:25'!
createSpeakerOutputFor: audioFormat
	"Delegate to the audio-interface to create the appropriate type of speaker-output, then do whatever other setup is necessary."
	| output |
	audioSession assertIsInTurn.
	output := audioSession audioInterface createSpeakerOutputFor: audioFormat.
	audioSession isRecordingSession ifTrue: [audioSession mixOutputForRecording: output].
	^output! !

!QSpeakerManager methodsFor: 'locking' stamp: 'jcg 8/9/2009 23:48'!
critical: aBlock
	mutex critical: [aBlock value]! !

!QSpeakerManager methodsFor: 'initialize' stamp: 'jcg 5/17/2010 10:36'!
destroy
	self destroyAllSpeakers.! !

!QSpeakerManager methodsFor: 'resources' stamp: 'jcg 5/19/2010 00:36'!
destroyAllSpeakers
	speakers copy do: [:speaker | speaker destroy].
	speakers ifNotEmpty: [
		QLogger logWarning: 'speakers remain in #destroyAllSpeakers'.
		speakers := Dictionary new.	"Probably belt&braces, as the destroys do removes."
	].! !

!QSpeakerManager methodsFor: 'private' stamp: 'jcg 5/24/2010 11:44'!
destroySpeaker: clientSpeaker
	"Doesn't matter whether you destroy the speaker this way, or by directly sending it #destroy."
	audioSession assertIsInTurn.
	mutex critical: [
		| oid |
		oid := clientSpeaker objectID.
		speakers at: oid ifPresent: [:spkr |
			spkr == clientSpeaker 
				ifTrue: [speakers removeKey: oid]
				ifFalse: [
					"Under normal conditions (i.e. not after reconnect/sync-loss), 
					 this is definitely unexpected, and should be looked at with
					 suspicion.  When a reconnect/sync-loss has happened, I'm 
					 not quite sure how to interpret it.  I don't see how it would 
					 happen, but I'm not sure that it represents a serious problem."
					QLogger logWarning: 'mismatch in #destroySpeaker for ', oid
				].
		].
	].
	clientSpeaker destroy.
! !

!QSpeakerManager methodsFor: 'resources' stamp: 'ar 4/16/2011 17:46'!
discardIsland: aStaleIslandRef
	"Per-forum logout support."
	audioSession assertIsInTurn.
	speakers copy do: [ : spkr |
		spkr ref island value = aStaleIslandRef value  ifTrue: [ spkr destroy ].
	].! !

!QSpeakerManager methodsFor: 'future' stamp: 'jcg 4/11/2010 11:49'!
futureDo: aSelector at: deltaMSecs args: args
	"Enqueue a message on the event queue.  The compiler has been modified to generate this message when the #future message appears in the source code."
	audioSession 
		ifNotNil: [:sess | sess futureDo: aSelector receiver: self at: deltaMSecs args: args]
		ifNil: [QLogger logInfo: 'audioSession unavailable for future-send of #', aSelector].
	^nil
! !

!QSpeakerManager methodsFor: 'future' stamp: 'jcg 5/7/2010 12:02'!
futureSend: aSelector at: deltaMSecs args: args
	"Enqueue a message on the event queue.  The compiler has been modified to generate this message when the #future message appears in the source code.  Answers a promise that will be resolved with the result of performing the message."
	^audioSession 
		ifNotNil: [:sess | sess futureSend: aSelector receiver: self at: deltaMSecs args: args]
		ifNil: [
			QLogger logInfo: 'audioSession unavailable for future-send of #', aSelector.
			TPromise new fulfill: nil
		].
! !

!QSpeakerManager methodsFor: 'initialize' stamp: 'jcg 5/20/2010 18:00'!
initialize
	mutex := Mutex new.	"Protects speakers table."
	self reset.
! !

!QSpeakerManager methodsFor: 'future' stamp: 'jcg 4/10/2010 08:44'!
isInTurn
	^audioSession isInTurn! !

!QSpeakerManager methodsFor: 'testing' stamp: 'jcg 2/23/2007 14:16'!
isMute
	^ isMute! !

!QSpeakerManager methodsFor: 'testing' stamp: 'ar 3/27/2009 13:31'!
isRecordingSession
	"Answers true if the client is currently recording the session (in which case voice streams should not be paused even when mute etc)"
	^(self audioSession ifNil:[^false]) isRecordingSession! !

!QSpeakerManager methodsFor: 'accessing' stamp: 'jcg 10/20/2008 12:25'!
jitterBufferActivityThreshold: zeroTo100
	"The Speex jitter-buffer has a way to check the 'activity' (roughly, 'volume') of the previously decoded frame.  It also has a way to hint that 'now would be a good time to extrapolate or drop a frame'.  We use a heuristic that says 'when the activity is below a threshold, hint to the jitter-buffer that now is a good time to make time adjustments'.  This method sets this threshold."
	"XXXXX: more for testing than production, since newly-created speakers will still have the default activity-threshold."
	speakers do: [:spkr | spkr jitterBufferActivityThreshold: zeroTo100].! !

!QSpeakerManager methodsFor: 'accessing' stamp: 'bgf 2/19/2008 17:03'!
listenerRegion
	"The sound region occupied by the listener right now."
	^ listenerRegion
! !

!QSpeakerManager methodsFor: 'accessing' stamp: 'jcg 5/5/2010 17:19'!
listenerRegion: aRegionRef attenuation: listenerRegionAttenuation

	"The current listener has moved to a new sound region...
	 update the speakers to play with appropriate attenuation."
	audioSession assertIsInTurn.
	listenerRegion := aRegionRef.
	regionAttenuation := listenerRegionAttenuation.
	speakers do: [ :speaker |
		speaker listenerRegion: aRegionRef attenuation: listenerRegionAttenuation
	].! !

!QSpeakerManager methodsFor: 'accessing' stamp: 'bgf 9/8/2008 13:04'!
listenerTransform
	"The position of the listener to all my speakers."
	^ self audioSession ifNotNilDo: [ :as | as  listenerTransform ]! !

!QSpeakerManager methodsFor: 'sanity' stamp: 'jcg 5/19/2010 00:58'!
printInsaneSpeaker: spkr on: aStream
	"Used internally by #checkSpeakerSanity and #updateSpeakersInIsland:."
	aStream cr; tab; nextPutAll: 'age: ', spkr timeSinceBirth, 'ms'; cr; tab.
	aStream nextPutAll: 'island valid: ', spkr ref island value isValidFarRef; cr; tab.
	spkr speakerInput
		ifNil: [aStream nextPutAll: 'no speaker-input']
		ifNotNil: [:in |
			aStream nextPutAll: 'speaker-input:     '.
			in printOn: aStream].
	aStream cr; tab.
	spkr speakerOutput
		ifNil: [aStream nextPutAll: 'no speaker-output']
		ifNotNil: [:out |
			aStream nextPutAll: 'speaker-output:     '.
			out printOn: aStream]! !

!QSpeakerManager methodsFor: 'actions' stamp: 'jcg 5/15/2010 02:39'!
recreateAllSpeakers
	"Destroy all QClientSpeakers, and recreate them from the on-island QSpeakers."
	audioSession assertIsInTurn.
	view ifNil: [^QLogger logWarning: 'no view in #recreateAllSpeakers'].
	view
		allIslandsCritical: [
			self destroyAllSpeakers.
			audioSession allIslands do: [:island | self updateSpeakersInIsland: island]
		]
		ifLocked: [
			QLogger logInfo: '#recreateAllSpeakers cannot get island-lock... will retry'.
			(self future: 500) recreateAllSpeakers.
		]
! !

!QSpeakerManager methodsFor: 'accessing' stamp: 'bgf 2/19/2008 17:03'!
regionAttenuation
	"The attenuation of the sound region occupied by the listener right now."
	^ regionAttenuation
! !

!QSpeakerManager methodsFor: 'initialize' stamp: 'jcg 5/20/2010 18:00'!
reset
	"Restore to initial state."
	speakers ifNotNil: [ speakers copy do: [:spkr | spkr destroy] ].
	speakers := Dictionary new.
	isMute := false.
	regionAttenuation := 0.
	listenerRegion := nil.
	activeSpace := nil.! !

!QSpeakerManager methodsFor: 'accessing' stamp: 'jcg 2/26/2009 23:30'!
speakerAt: objectID
	"Answer the speaker with the specified ID, or nil if the speaker doesn't exist."
	mutex critical: [
		^speakers at: objectID ifAbsent: [nil].
	].
! !

!QSpeakerManager methodsFor: 'accessing' stamp: 'jcg 4/9/2007 11:04'!
speakers
	^ speakers! !

!QSpeakerManager methodsFor: 'actions' stamp: 'jcg 10/30/2009 15:56'!
updateAllPlayStates
	speakers do: [:sp | sp updatePlayState].! !

!QSpeakerManager methodsFor: 'resources' stamp: 'ar 4/16/2011 17:46'!
updateSpeakersInIsland: anIsland
	"Keep replicated speakers in sync with non-replicated speaker clients.
	 This replaces the speakers list, rather than editing it."
	| speakersChanged oldSpeakers |
	anIsland isValidFarRef ifFalse: [ ^self ].
	anIsland mutex critical: [
		| mcontrol |
		speakersChanged := false.
		oldSpeakers := speakers copy.
		mcontrol := view session mediaController.
		"The speaker matchup destroys speakers, involving speaker and far-ref locking.
	       Since destroyAllSpeakers can fire in island-locked situations like resetSound,
	       we lock the island to ensure we're always taking island-lock first, then taking
		 speaker-lock within.  (The pesky bit is destroying client speakers which must
		 remove far-ref script triggers.)"
		speakers := TClientObject 
						matchupWithResources: QSpeaker resourceType 
						in: anIsland
						existing: speakers
						create: [:ref | 
							speakersChanged := true.
							self createSpeakerClientFor: ref controller: mcontrol]
						destroy:[:client | 
							"We typically don't destroy the speaker here... when eg: we 
							 close an MP4 panel, or when someone leaves the room, we 
							 do it via QClientSpeaker>>onDestroy, which runs when the
							 replicated QSpeaker signals #destroyed.  I'm curious to see 
							 if destroying a speaker here is correlated with failing 
							 speaker sanity-check."
							speakersChanged := true.
							client destroy].
	].
	speakers valuesDo: [ : spkr | spkr setupTransform ].
	speakersChanged ifTrue:[
		"Sanity check... any speakers that were removed from the speaker-list must have
		 been destroyed.  If not, this is mysterious and bad."
		(oldSpeakers values difference: speakers values) do: [:spkr |
			spkr timeSinceDeath ifNil: [
				"There is an undead speaker that is no longer in the speaker-dict.
				 Log it and kill it."
				QLogger logWarning: (String streamContents: [:st |
					st nextPutAll: 'just unleashed a zombie speaker... better kill it quick'.
					self printInsaneSpeaker: spkr on: st
				]).
				spkr destroy.
				"Extra-paranoid, because Howard's 3.5.09 test found a zombie even
				 though we killed the ones that we unleashed (or though we did).  See
				 the bug report 'OpenQwaq Bug Report: QTest -- test4@chonkaa.com'
				 from May 21, 2010 at 4:22pm"
				spkr timeSinceDeath ifNil: [QLogger logWarning: 'failed to kill zombie!!!!?!!'].
			].
		].
		"Signal for UI and other interested parties to respond."
		view owner signal: #clientSpeakersChanged.
		self signal: #clientSpeakersChanged.
	].! !

!QSpeakerManager methodsFor: 'actions' stamp: 'jcg 5/15/2010 01:04'!
useAudioInterface: newAudioInterface forSession: audioSession
	"All playing speakers must use the new audio interface.  If we destroy and re-create them, they will."
	self recreateAllSpeakers.
! !

!QSpeakerManager methodsFor: 'accessing' stamp: 'jcg 2/23/2007 10:58'!
view
	^ view! !

!QSpeakerManager methodsFor: 'initialize' stamp: 'jcg 5/20/2010 17:59'!
view: newView
	view == newView ifTrue: [^self "no change"].
	audioSession assertIsInTurn.
	self reset.
	"This assumes that view-setting is either to enter or finish a Croquet session,
	 it doesn't handle any sort of 'migrating' to a different view in-session."
	view := newView.! !

Object subclass: #QSpeexCodec
	instanceVariableNames: 'handle decodeBuffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Codec'!

!QSpeexCodec commentStamp: 'jcg 5/11/2008 17:06' prior: 0!
We don't try to be a well-behaved SoundCodec subclass; there are assumptions throughout the Squeak sound code that assume a fixed bit-rate encoder, and I don't want to bother with generalizing the code.

Frame sizes:
	- narrowband (8kHz):	20ms / 160samples / 320bytes
	- wideband (16kHz):		20ms / 320samples / 640bytes

Random notes:
=========

For a particular (probably non-representative) sample sound, I observed the following performance characteristics:
	- 11.68 sec to play
	- 0.305 sec to encode (average of 10 times)
	- 0.045 sec to decode (average of 10 times)
From this, we can estimate CPU requirements of wideband Speex (relative to 2.4GHz MacBook Pro) at:
	- 2.6% for encoding
	- 0.4% for decoding

The following is a simple test to ensure that the codec is working:

origSnd := (FMSound lowMajorScaleOn: FMSound clarinet2) asSampledSound.
frameSize := 640.
bufs := origSnd samples splitIntoBuffersOfSize: frameSize. bufs removeLast.

codec := QSpeexCodec new.

encoded := bufs collect: [:b | codec encode: b].

decoded := encoded collect: [:b | 
	| tmp |
	tmp := SoundBuffer new: frameSize.
	codec decode: b into: tmp.
	tmp
].

stream := WriteStream on: (SoundBuffer new: frameSize).
decoded do: [:b | stream nextPutAll: b].
newSnd := SampledSound samples: stream contents samplingRate: 16000.
newSnd play.

!

!QSpeexCodec class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSpeexCodec class methodsFor: 'utilities-old' stamp: 'jcg 8/19/2008 22:13'!
decodeSpeexBytes: bytes
	"For workspace hacking.  Decodes old format where 4 bytes denote the length of the next encoded chunk (this isn't what we currently use in production)."
	| stream  decoder |
	decoder := QSpeexCodec new.
	stream := WriteStream on: (SoundBuffer newMonoSampleCount: 16000).
	self speexBytes: bytes chunksDo: [:chunk |
		stream nextPutAll: (decoder decodeCompressedDataNoReset: chunk).
	].
	decoder destroy.
	^ SampledSound samples: stream contents samplingRate: 16000	
! !

!QSpeexCodec class methodsFor: 'utilities' stamp: 'jcg 8/19/2008 00:12'!
encodeSpeexInChunksOf1280: aSound "16kHz sound"
	"For workspace hacking."
	| samples stream codec |

	samples := aSound samples.
	stream := WriteStream on: ByteArray new.
	codec := QSpeexCodec new.
	1 to: samples size by: 1280 do: [:i |
		i+1279 <= samples size ifTrue: [
			| encoded |
			encoded := codec encodeSoundBufferNoReset: (samples copyFrom: i to: i+1279).
			stream nextPutAll: encoded.
		].
	].
	codec destroy.
	^ stream contents! !

!QSpeexCodec class methodsFor: 'utilities' stamp: 'jcg 8/19/2008 00:11'!
encodeSpeexInChunksOf320: aSound "16kHz sound"
	"For workspace hacking."
	| samples stream codec |

	samples := aSound samples.
	stream := WriteStream on: ByteArray new.
	codec := QSpeexCodec new.
	1 to: samples size by: 320 do: [:i |
		i+319 <= samples size ifTrue: [
			| encoded |
			encoded := codec encodeSoundBufferNoReset: (samples copyFrom: i to: i+319).
			stream nextPutAll: encoded.
		].
	].
	codec destroy.
	^ stream contents! !

!QSpeexCodec class methodsFor: 'utilities' stamp: 'jcg 8/19/2008 00:29'!
recordSomeSpeex: seconds
	"For workspace hacking."
	| recorder |

	recorder := SoundRecorder new samplingRate: 16000.
	recorder clearRecordedSound.
	recorder startRecording.
	recorder resumeRecording.

	(Delay forSeconds: seconds) wait.

	recorder stopRecording.

	^ self encodeSpeexInChunksOf1280: recorder recordedSound
! !

!QSpeexCodec class methodsFor: 'accessing' stamp: 'jcg 2/25/2009 18:32'!
samplingRate
	"If this codec is hardwired to a specific sampling-rate, answer it.  Otherwise, answer nil."
	^16000 "Speex Wideband"! !

!QSpeexCodec class methodsFor: 'utilities-old' stamp: 'jcg 8/19/2008 22:13'!
speexBytes: bytes chunksDo: aBlock
	"For workspace hacking.  Iterates over chunks in old format: 4 bytes denote the length of the next encoded chunk (this isn't what we currently use in production)."
	| stream decoder |
	stream := ReadStream on: bytes.
	decoder := QSpeexCodec new.
	[stream atEnd] whileFalse: [
			| chunkSize chunk |
			chunkSize := (stream next: 4) networkUnsignedLongAt: 1.
			chunk := stream next: chunkSize.
			aBlock value: chunk.
	].
	decoder destroy.
	! !

!QSpeexCodec methodsFor: 'actions' stamp: 'jcg 5/11/2008 00:07'!
decode: bytes into: aSoundBuffer
	| result |
	self verifyValidBufferSize: aSoundBuffer.
	result := self primSpeex: handle decode: bytes into: aSoundBuffer.
	result == 1 ifTrue: [self error: 'output buffer was not big enough'].
	result == 2 ifTrue: [self error: 'output buffer was not completely filled'].
	result == 0 ifFalse: [self error: 'unexpected result: ', result].
! !

!QSpeexCodec methodsFor: 'compatibility' stamp: 'ar 3/18/2009 16:28'!
decode: inputBytes offset: inputOffset into: buf "a SoundBuffer"
	"Polymorphic with QAudioDecoder for streamed playback.  
	The input isn't a raw Speex byte-stream... see #encodeSoundBufferNoReset: ."
	| inputStream outputStream numFrames |
	inputStream := ReadStream on: inputBytes.
	inputStream position: inputOffset.
	inputStream atEnd ifTrue:[^buf primFill: 0].
	numFrames := inputStream next.
	outputStream := WriteStream on: buf.
	decodeBuffer ifNil:[decodeBuffer := SoundBuffer newMonoSampleCount: self samplesPerFrame].
	numFrames timesRepeat: [ | encodedFrame |
		encodedFrame := inputStream next: (inputStream next).
		self decode: encodedFrame into: decodeBuffer.
		outputStream nextPutAll: decodeBuffer.
	].
	^buf! !

!QSpeexCodec methodsFor: 'actions' stamp: 'jcg 6/2/2008 11:28'!
decodeAndPlay: bytes 
	| result |
	self error: 'NOT THE RIGHT API'.  "Need to pass in timestamp, for sure.  What else?"
	result := self primSpeex: handle decodeAndPlay: bytes.
	result == 0 ifFalse: [self error: 'unexpected result: ', result].
! !

!QSpeexCodec methodsFor: 'compatibility' stamp: 'ar 3/18/2009 16:08'!
decodeCompressedDataNoReset: bytes
	"Compatibility with existing SoundCodec subclasses.  
	The input isn't a raw Speex byte-stream... see #encodeSoundBufferNoReset: ."
	| inputStream outputStream numFrames |
	inputStream := ReadStream on: bytes.
	numFrames := inputStream next.
	outputStream := WriteStream on: 
					(SoundBuffer newMonoSampleCount: numFrames * self samplesPerFrame).
	decodeBuffer ifNil:[decodeBuffer := SoundBuffer newMonoSampleCount: self samplesPerFrame].
	numFrames timesRepeat: [ | encodedFrame |
		encodedFrame := inputStream next: (inputStream next).
		self decode: encodedFrame into: decodeBuffer.
		outputStream nextPutAll: decodeBuffer.
	].
	^ outputStream contents! !

!QSpeexCodec methodsFor: 'actions' stamp: 'jcg 9/8/2008 18:08'!
decodeUsingJB: bytes into: aSoundBuffer
	"For testing only."
	| result |
	self verifyValidBufferSize: aSoundBuffer.
	result := self primSpeex: handle decodeUsingJB: bytes into: aSoundBuffer.
	result == 1 ifTrue: [self error: 'output buffer was not big enough'].
	result == 2 ifTrue: [self error: 'output buffer was not completely filled'].
	result == 0 ifFalse: [self error: 'unexpected result: ', result].
! !

!QSpeexCodec methodsFor: 'initialize' stamp: 'jcg 6/23/2008 11:13'!
destroy
	handle ifNotNilDo: [:h |
		handle := nil.
		self primSpeexDestroyHandle: h.
	].! !

!QSpeexCodec methodsFor: 'actions' stamp: 'jcg 5/11/2008 00:08'!
encode: aSoundBuffer
	self verifyValidBufferSize: aSoundBuffer.
	^self primSpeex: handle encode: aSoundBuffer! !

!QSpeexCodec methodsFor: 'compatibility' stamp: 'jcg 7/3/2008 09:24'!
encodeSoundBufferNoReset: aSoundBuffer
	"Compatibility with existing SoundCodec subclasses."
	| inputStream outputStream frame encodedFrames outputSize |

	"Break the frame up into normal Speex-sized frames.  Our encoder/decoder can deal with multiples of this size, but the jitter-buffer can't (at least not without directly using the low-level jitter buffer, and I don't posess the mad skillz).  Instead, we use the high-level, Speex-specific JB found in speex_jitter_buffer.c ...  to do this we jump though a few hoops here."
	inputStream := ReadStream on: aSoundBuffer.
	encodedFrames := OrderedCollection new.
	[(frame := inputStream next: self samplesPerFrame) isEmpty] 
		whileFalse: [encodedFrames add: (self encode: frame)].

	"Now that we have individually-encoded frames, concatentate them.  Prepend each encoded frame with its size in bytes, and prepend the whole thing with the number of encoded frames."
	outputSize := encodedFrames inject: 1 + encodedFrames size into: [:sz :fr | sz + fr size].
	outputStream := WriteStream on: (ByteArray new: outputSize).
	outputStream nextPut: encodedFrames size.
	encodedFrames do: [:fr | 
		outputStream nextPut: fr size.
		outputStream nextPutAll: fr
	].
	^ outputStream contents! !

!QSpeexCodec methodsFor: 'initialize' stamp: 'jcg 5/11/2008 00:08'!
initialize
	handle := self primSpeexCreateHandle.! !

!QSpeexCodec methodsFor: 'primitives' stamp: 'jcg 6/10/2008 08:48'!
primSpeex: handleToUse decode: bytes into: aSoundBuffer
	"Take compressed bytes as input, fill aSoundBuffer with uncompressed audio."
	<primitive: 'primitiveSpeexDecode' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QSpeexCodec methodsFor: 'primitives' stamp: 'jcg 6/10/2008 08:48'!
primSpeex: handleToUse decodeAndPlay: bytes
	"Take compressed bytes as input, decode and dejitter them, and play them within the plugin."
	<primitive: 'primitiveSpeexDecodeAndPlay' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QSpeexCodec methodsFor: 'primitives' stamp: 'jcg 9/8/2008 18:09'!
primSpeex: handleToUse decodeUsingJB: bytes into: aSoundBuffer
	"For testing only."
	"Take compressed bytes as input, fill aSoundBuffer with uncompressed audio."
	<primitive: 'primitiveSpeexDecodeToTestJB' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QSpeexCodec methodsFor: 'primitives' stamp: 'jcg 6/10/2008 08:48'!
primSpeex: handleToUse encode: aSoundBuffer
	"Take a SoundBuffer as input, return a ByteArray containing the compressed bytes.  Assume that aSoundBuffer contains an even multiple of the Speex frame size."
	<primitive: 'primitiveSpeexEncode' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QSpeexCodec methodsFor: 'primitives' stamp: 'jcg 5/21/2008 14:53'!
primSpeexCreateHandle
	<primitive: 'primitiveSpeexCreateHandle' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QSpeexCodec methodsFor: 'primitives' stamp: 'jcg 6/20/2008 11:52'!
primSpeexDestroyHandle: handleToDestroy
	<primitive: 'primitiveSpeexDestroyHandle' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QSpeexCodec methodsFor: 'primitives' stamp: 'jcg 5/21/2008 14:53'!
primTestBufferSize: aSoundBuffer
	"See if we can figure out how big the soundbuffer is"
	<primitive: 'primitiveTestBufferSize' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QSpeexCodec methodsFor: 'accessing' stamp: 'jcg 5/13/2008 22:36'!
samplesPerFrame
	"We only support Speex wideband for now (20ms of 16kHz sound)"
	^320! !

!QSpeexCodec methodsFor: 'private' stamp: 'jcg 5/13/2008 22:36'!
verifyValidBufferSize: aSoundBuffer
	"Raise an error if the buffer's size is not an even multiple of the frame size."
	(aSoundBuffer size \\ self samplesPerFrame) == 0 ifFalse: [
		self error: 'buffer size must be a multiple of frame size'
	].! !

Object subclass: #QTimedSequenceCorrelation
	instanceVariableNames: 'name size expectedData actualData expectedTimes actualTimes worstActualLatency jitterometer test latencyStats latencyThreshold jitterThreshold'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Tests'!

!QTimedSequenceCorrelation commentStamp: 'crl 3/22/2010 11:31' prior: 0!
'
	Each of my instances represents a correlation between expected and actual timed sequences, characterized by desired and actual latency and jitter, on behalf of a QSoundTest.!

QTimedSequenceCorrelation subclass: #QSoundCorrelation
	instanceVariableNames: 'averageNormalizedSampleDifference averageNormalizedSampleDifferenceThreshold maximumNormalizedSampleDifference maximumNormalizedSampleDifferenceThreshold'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Tests'!

!QSoundCorrelation class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSoundCorrelation class methodsFor: 'instantiation' stamp: 'crl 5/6/2010 14:19'!
named: name withLatencyThreshold: latencyThreshold jitterThreshold: jitterThreshold averageNormalizedSampleDifferenceThreshold: averageNormalizedSampleDifferenceThreshold andMaximumNormalizedSampleDifferenceThreshold: maximumNormalizedSampleDifferenceThreshold forTest: aQSoundTest
	^(
		super
			named: name
			withLatencyThreshold: latencyThreshold
			andJitterThreshold: jitterThreshold
			forTest: aQSoundTest
	)
		averageNormalizedSampleDifferenceThreshold: averageNormalizedSampleDifferenceThreshold 		maximumNormalizedSampleDifferenceThreshold: maximumNormalizedSampleDifferenceThreshold! !

!QSoundCorrelation methodsFor: 'accessing' stamp: 'crl 3/23/2010 16:35'!
actualData: aSampledSound
	actualData := aSampledSound! !

!QSoundCorrelation methodsFor: 'assertion' stamp: 'crl 5/12/2010 18:40'!
assertContent
	| decodedSamplesStream shiftAmount differenceSound expectedSamples differenceSamples info totalNormalizedSampleDifference numberOfSamples |

	info := (String new: 32) writeStream.
	expectedSamples := expectedData samples.
	decodedSamplesStream := actualData samples readStream.

	"The decoded sound as delivered by the feedback sink has some extra silence at the beginning, followed by some noise, and brief attenuation of the test signal. From visual inspection of the first few runs made of this test, the sounds correlate fairly well when the ninth positive peaks are matched."
	[decodedSamplesStream next abs < 200] whileTrue.
	[decodedSamplesStream next > 0] whileFalse.

	shiftAmount := (actualData sampleIndexOfPositivePeak: 9 startingAt: decodedSamplesStream position) - (expectedData sampleIndexOfPositivePeak: 9 startingAt: 0) + 1.
	differenceSound := expectedData - (actualData withoutFirst: shiftAmount).
	differenceSamples := differenceSound samples.
	numberOfSamples := differenceSamples size.
	maximumNormalizedSampleDifference := 0.

	"Find the largest normalized difference in corresponding samples between the original and decoded sounds."
	totalNormalizedSampleDifference := 0.
	1
		to: numberOfSamples
		do: [:index |
			| normalizedSampleDifference expectedSample |

			expectedSample := expectedSamples at: index.
			expectedSample = 0 ifTrue: [expectedSample := 1].
			normalizedSampleDifference := ((differenceSamples at: index) / expectedSample) abs asFloat.
			normalizedSampleDifference > maximumNormalizedSampleDifference ifTrue: [maximumNormalizedSampleDifference := normalizedSampleDifference].
			totalNormalizedSampleDifference := totalNormalizedSampleDifference + normalizedSampleDifference].

	averageNormalizedSampleDifference := totalNormalizedSampleDifference / (numberOfSamples * 60).

	info
		nextPutAll: 'average normalized sample difference: ';
		print: (averageNormalizedSampleDifference asFloat roundTo: 2);
		nextPutAll: ' (threshold is ';
		print: averageNormalizedSampleDifferenceThreshold;
		nextPutAll: 'maximum normalized sample difference: ';
		print: (maximumNormalizedSampleDifference asFloat roundTo: 2);
		nextPutAll: ' (threshold is ';
		print: maximumNormalizedSampleDifferenceThreshold;
		nextPut: $).
	QLogger logInfo: info contents.
	test assert: [(averageNormalizedSampleDifference < averageNormalizedSampleDifferenceThreshold) and: [maximumNormalizedSampleDifference < maximumNormalizedSampleDifferenceThreshold]]! !

!QSoundCorrelation methodsFor: 'initialization' stamp: 'crl 5/6/2010 14:23'!
averageNormalizedSampleDifferenceThreshold: theAverageNormalizedSampleDifferenceThreshold maximumNormalizedSampleDifferenceThreshold: theMaximumNormalizedSampleDifferenceThreshold
	averageNormalizedSampleDifferenceThreshold := theAverageNormalizedSampleDifferenceThreshold.
	maximumNormalizedSampleDifferenceThreshold := theMaximumNormalizedSampleDifferenceThreshold! !

!QSoundCorrelation methodsFor: 'control' stamp: 'crl 3/23/2010 18:52'!
playActualSound
	actualData play! !

!QSoundCorrelation methodsFor: 'control' stamp: 'crl 3/23/2010 18:51'!
playExpectedSound
	expectedData play! !

!QSoundCorrelation methodsFor: 'streaming' stamp: 'crl 5/6/2010 15:12'!
printSummaryOn: aStream
	super printSummaryOn: aStream.
	aStream
		cr;
		cr;
		nextPutAll: 'average normalized sample difference: ';
		tab;
		print: (averageNormalizedSampleDifference roundTo: 0.01)! !

!QTimedSequenceCorrelation class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QTimedSequenceCorrelation class methodsFor: 'instantiation' stamp: 'crl 4/27/2010 16:43'!
named: name withLatencyThreshold: theLatencyThreshold andJitterThreshold: theJitterThreshold forTest: aQSoundTest
	^(self new)
		name: name
		latencyThreshold: theLatencyThreshold
		jitterThreshold: theJitterThreshold
		test: aQSoundTest! !

!QTimedSequenceCorrelation methodsFor: 'accessing' stamp: 'crl 3/23/2010 16:05'!
actualDataAt: index
	^actualData at: index! !

!QTimedSequenceCorrelation methodsFor: 'accessing' stamp: 'crl 5/6/2010 18:33'!
actualDataAt: index put: data
	actualData at: index put: data.
	self actualTimeAt: index put: test elapsedTime! !

!QTimedSequenceCorrelation methodsFor: 'accessing' stamp: 'crl 3/23/2010 16:10'!
actualTimeAt: index
	^actualTimes at: index! !

!QTimedSequenceCorrelation methodsFor: 'accessing' stamp: 'crl 4/27/2010 17:18'!
actualTimeAt: index put: time
	jitterometer
		add: (expectedTimes at: index)
		at: time.
	^actualTimes at: index put: time! !

!QTimedSequenceCorrelation methodsFor: 'accessing' stamp: 'crl 3/23/2010 17:54'!
actualTimes
	^actualTimes! !

!QTimedSequenceCorrelation methodsFor: 'assertion' stamp: 'crl 3/23/2010 18:39'!
assert
	self
		assertContent;
		assertLatencyAndJitter! !

!QTimedSequenceCorrelation methodsFor: 'assertion' stamp: 'crl 5/19/2010 16:49'!
assertContent
	"Assert that the expected and actual data correlate with regard to content, desired maximum latency and jitter. Record the actual worst latency and jitter."

	| info dataMatches |

	info := (String new: 64) writeStream.
	dataMatches := actualData = expectedData.

	info
		nextPutAll: 'expected and actual ';
		nextPutAll: name;
		nextPutAll: ' data '.
	dataMatches ifFalse: [info nextPutAll: 'do not '].
	info nextPutAll: 'match'.
	QLogger logInfo: info contents.

	test assert: [dataMatches]! !

!QTimedSequenceCorrelation methodsFor: 'assertion' stamp: 'crl 5/19/2010 16:47'!
assertLatencyAndJitter
	"Assert that the expected and actual data correlate with regard to latency and jitter."
	"Assert that the latency mean plus standard deviation is less than a threshold, and that jitter is less than a threshold."

	| info totalStats meanPlusStandardDeviationLatency |

	info := (String new: 64) writeStream.

	1
		to: actualTimes size
		do: [:index |
			latencyStats
				add: ((actualTimes at: index) - (expectedTimes at: index))
				at: (actualTimes at: index)].

	totalStats := latencyStats totalStats.
	meanPlusStandardDeviationLatency := totalStats first + totalStats third.

	info
		nextPutAll: name;
		nextPutAll: ' latency stats... minimum: ';
		print: totalStats fourth;
		nextPutAll: ', maximum: ';
		print: totalStats fifth;
		nextPutAll: ', mean ';
		print: totalStats first;
		nextPutAll: ', standard deviation: ';
		print: totalStats third;
		nextPutAll: ', mean plus standard deviation: ';
		print: meanPlusStandardDeviationLatency;
		nextPutAll: ' (threshold is ';
		print: latencyThreshold;
		nextPutAll: '). Jitter: ';
		print: (jitterometer jitter roundTo: 2);
		nextPutAll: ' (threshold is ';
		print: jitterThreshold;
		nextPut: $).

	QLogger logInfo: info contents.

	test
		assert: [meanPlusStandardDeviationLatency < latencyThreshold]
		description: name, ' latency threshold exceeded';
		assert: [jitterometer jitter <= jitterThreshold]
		description: name, ' jitter threshold exceeded'! !

!QTimedSequenceCorrelation methodsFor: 'initialization' stamp: 'crl 4/28/2010 17:50'!
durationInSeconds: anInteger
	latencyStats := TWindowedStatistics forWindowDuration: anInteger * 1000! !

!QTimedSequenceCorrelation methodsFor: 'initialization' stamp: 'crl 3/23/2010 17:54'!
expectActualTimesOf: correlation
	expectedTimes := correlation actualTimes! !

!QTimedSequenceCorrelation methodsFor: 'initialization' stamp: 'crl 3/23/2010 17:55'!
expectData: aSequenceableCollection
	expectedData := aSequenceableCollection! !

!QTimedSequenceCorrelation methodsFor: 'accessing' stamp: 'crl 3/23/2010 16:10'!
expectedTimeAt: index
	^expectedTimes at: index! !

!QTimedSequenceCorrelation methodsFor: 'accessing' stamp: 'crl 3/23/2010 16:11'!
expectedTimeAt: index put: time
	^expectedTimes at: index put: time! !

!QTimedSequenceCorrelation methodsFor: 'initialization' stamp: 'crl 3/22/2010 13:44'!
initialize
	jitterometer := TJitterometer new! !

!QTimedSequenceCorrelation methodsFor: 'accessing' stamp: 'crl 3/23/2010 18:22'!
jitter
	^jitterometer jitter! !

!QTimedSequenceCorrelation methodsFor: 'initialization' stamp: 'crl 4/29/2010 11:24'!
name: aString latencyThreshold: theLatencyThreshold jitterThreshold: theJitterThreshold test: aQSoundTest
	name := aString.
	latencyThreshold := theLatencyThreshold.
	jitterThreshold := theJitterThreshold.
	test := aQSoundTest! !

!QTimedSequenceCorrelation methodsFor: 'streaming' stamp: 'crl 3/23/2010 18:15'!
printOn: aStream
	aStream
		nextPutAll: 'the ';
		nextPutAll: name;
		nextPutAll: ' correlation for ';
		print: test! !

!QTimedSequenceCorrelation methodsFor: 'streaming' stamp: 'crl 5/7/2010 18:38'!
printSummaryOn: aStream
	| totalStats position |

	totalStats := latencyStats totalStats.
	position := aStream position.

	aStream
		cr;
		nextPutAll: 'mean ';
		nextPutAll: name;
		nextPutAll: ' latency: ';
		space: (28 - (aStream position - position));
		tab;
		print: totalStats first;
		nextPutAll: 'ms';
		space: (36 - (aStream position - position));
		tab;
		nextPutAll: 'standard deviation: ';
		print: totalStats third;
		nextPutAll: 'ms';
		space: (70 - (aStream position - position));
		tab;
		nextPutAll: 'jitter: ';
		print: (jitterometer jitter roundTo: 0.01);
		nextPutAll: 'ms'! !

!QTimedSequenceCorrelation methodsFor: 'initialization' stamp: 'crl 3/23/2010 16:00'!
size: anInteger
	size := anInteger.
	expectedData := Array new: size.
	actualData := Array new: size.
	expectedTimes := Array new: size.
	actualTimes := Array new: size! !

Object subclass: #QwaqAudioInterface
	instanceVariableNames: 'audioSession'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-API'!

!QwaqAudioInterface commentStamp: 'jcg 2/18/2007 22:18' prior: 0!
(c) 2006-2007 Qwaq Inc.  Represents a particular audio API that sound should be played through.  Subclasses are used for each API; currently OpenAL and Squeak audio are supported.!

!QwaqAudioInterface class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QwaqAudioInterface methodsFor: 'initialize' stamp: 'jcg 2/18/2007 22:26'!
audioSession: aQwaqAudioSession
	audioSession := aQwaqAudioSession! !

!QwaqAudioInterface methodsFor: 'actions' stamp: 'jcg 2/19/2007 17:44'!
clearSounds
	"HACK!!  Clear low-level sound data; it will be lazily recreated if necessary.  Default doesn't do anything."! !

!QwaqAudioInterface methodsFor: 'actions' stamp: 'jcg 2/19/2007 15:18'!
createSoundFramePlayerFor: soundFrameRef
	"Create the appropriate type of sound frame player for this type of audio interface."
	self subclassResponsibility! !

!QwaqAudioInterface methodsFor: 'actions' stamp: 'jcg 8/21/2009 12:41'!
createSpeakerOutputFor: audioFormat
	"Create the appropriate type of output for this type of audio interface.  NOTE: should only be called via QSpeakerManager."
	self subclassResponsibility! !

!QwaqAudioInterface methodsFor: 'initialize' stamp: 'jcg 2/19/2007 17:46'!
destroy
	"Subclasses should extend this method."! !

!QwaqAudioInterface methodsFor: 'actions' stamp: 'jcg 2/19/2007 14:40'!
makeCurrent
	"Nothing to do; subclasses might."! !

!QwaqAudioInterface methodsFor: 'accessing' stamp: 'jcg 2/19/2007 14:30'!
openAL
	^ nil! !

!QwaqAudioInterface methodsFor: 'sound effects' stamp: 'jcg 2/19/2007 12:31'!
playSoundEffect: aSymbol at: aVector3
	"Play the named sound effect at the given spatial position; the sound is looked up in a QSoundEffects."
	self subclassResponsibility
	! !

!QwaqAudioInterface methodsFor: 'private' stamp: 'jcg 2/18/2007 22:26'!
soundEffects
	^ audioSession soundEffects! !

!QwaqAudioInterface methodsFor: 'testing' stamp: 'jcg 8/12/2009 00:15'!
supportsRecording
	"The default is to not support recording.  Subclasses should override if they do."
	^false! !

!QwaqAudioInterface methodsFor: 'actions' stamp: 'bgf 3/26/2009 13:18'!
useLowOutputVolume
	"Drop the overall volume to a fraction of normal.
	 Subclass can provide, to enhance the Push-to-talk experience.
	 Used for poor-mean's feedback prevention in press-to-talk;
	 should only be done if it can be done without mucking around
	 with user-visible device-volume settings etc, as that is too expensive and wide;
	 this needs to be quick and localized."! !

!QwaqAudioInterface methodsFor: 'actions' stamp: 'bgf 3/26/2009 13:00'!
useNormalOutputVolume
	"Restore default output volume.
	 Subclass can provide, to enhance the Push-to-talk experience."
! !

QwaqAudioInterface subclass: #QwaqSqueakAudioInterface
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-API'!

!QwaqSqueakAudioInterface commentStamp: '<historical>' prior: 0!
All sounds are played through Squeak sound API (provided by SoundPlugin).!

!QwaqSqueakAudioInterface class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QwaqSqueakAudioInterface methodsFor: 'actions' stamp: 'jcg 2/25/2007 23:57'!
createSoundFramePlayerFor: soundFrameRef
	"Create the appropriate type of sound frame player for this type of audio session."
	^ QSoundFramePlayerSqueak for: soundFrameRef in: audioSession! !

!QwaqSqueakAudioInterface methodsFor: 'actions' stamp: 'bgf 8/22/2009 13:13'!
createSpeakerOutputFor: aQAudioFormat
	"Create the appropriate type of output for this type of audio interface.  NOTE: should only be called via QSpeakerManager."
	| output |
	output := QClientSpeakerSqueakOutput new.
	[ 
		output audioFormat: aQAudioFormat.
	] on: Error do: [ :ex|
		"This is protection for Linux client-demons, which have no audio plugin yet."
		QLogger logWarning: 'Cannot configure speaker output: ', (ex description).
	].
	^output

! !

!QwaqSqueakAudioInterface methodsFor: 'initialize' stamp: 'jcg 6/1/2010 14:17'!
destroy
	super destroy.
	SoundPlayer stopPlayingAll.
	SoundPlayer shutDown.! !

!QwaqSqueakAudioInterface methodsFor: 'sound effects' stamp: 'bgf 1/10/2009 14:01'!
playSoundEffect: aSymbol at: aVector3
	"Play the named sound effect at the given spatial position; the sound is looked up in a QSoundEffects."
	| clientSound squeakSound params |

	clientSound := self soundEffects effectAt: aSymbol.
	clientSound ifNil: [
		QLogger logWarning: '#playSoundEffect:at: could not find sound: ', aSymbol.
		^self.
	].
	squeakSound := SampledSound
							samples: clientSound samples
							samplingRate: clientSound samplingRate.

	"XXXX: We don't match volumes perfectly with OpenAL, and we don't pan sound from left to right, but it's better than it was before." 
	"XXXX: It's not that we might have errors that we cannot anticipate here; this is just for safety as new functionality is added shortly before General Availability."
	params := [self pseudoSpatializationParametersFor: aVector3 referenceDistance: 0.5]
					on: Error 
					do: [:err |
							QLogger logWarning: 'PSEUDO-SPATIALIZATION: ', err description.
							#(0.5 0.5)
					].
	squeakSound loudness: (params first *0.05).		
						     "(0.05 balances effects to OpenAL results (db-logarithmic, not as drastic as it seems)
							 and makes effect levels more compatible with voice levels.)"
	squeakSound play
	! !

!QwaqSqueakAudioInterface methodsFor: 'spatialization' stamp: 'bgf 7/4/2007 14:16'!
pseudoSpatializationParametersFor: soundPosition referenceDistance: referenceDistance
	"Answer a 2-element array containing the attenuation factor and the pan.  Used for faking spatialization using Squeak sound.  This is based on the 'Inverse Distance Clamped' OpenAL attenuation model: 
	gain = AL_REFERENCE_DISTANCE / 
				(AL_REFERENCE_DISTANCE + AL_ROLLOFF_FACTOR *
														(distance - AL_REFERENCE_DISTANCE)); "

	"TODO: Handle different ROLLOFF_FACTORs; we currently always use the default of 1 because no Croquet code sets it."
	| vector distance rollOff attenuationFactor divisor earVector pan |
	vector := soundPosition - audioSession listenerPosition.
	distance := vector length.
	distance < 1.0 ifTrue: [ "Too close to bother (dodge math edge conditions.)"
		^ #(0.5  0.5) 
	].	

	rollOff := 1.0.

	"Compute the amount that the sound is attenuated due to distance."
	divisor := referenceDistance + (rollOff * (distance - referenceDistance)).
	attenuationFactor := [referenceDistance / divisor min: 1.0 max: 0.0] on: ZeroDivide do: [1.0].

	"Compute the orientation relative to the listener's right ear."
	earVector := audioSession listenerTransform lookSide.
	pan := ((earVector safelyNormalized dot: vector safelyNormalized) + 1) / 2.

	^ {attenuationFactor. pan}
! !

!QwaqSqueakAudioInterface methodsFor: 'spatialization' stamp: 'jcg 2/25/2007 10:45'!
updateListenerPosition: transform
	"We pseudo-spatialize sounds by updating their volume/panning to simulate their position relative to the listener only as they start to play (so nothing needs to be done here)."

	"TODO: we still need to spatialize the voice chat."! !

Object subclass: #QOpenALResource
	instanceVariableNames: 'properties handle'
	classVariableNames: ''
	poolDictionaries: 'OpenALConstants'
	category: 'Qwaq-Sound-OpenAL'!

!QOpenALResource commentStamp: '<historical>' prior: 0!
State for a lazily generated OpenALName (a named openAL resource.)
This is a variant of TOpenALResource that does not use 'Broadcaster' event-scripting.
It is only suitable for off-TIsland use, i.e. must be used only in the client harness.!

QOpenALResource subclass: #QOpenALBuffer
	instanceVariableNames: 'data format size samplingRate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-OpenAL'!

!QOpenALBuffer commentStamp: '<historical>' prior: 0!
State for a lazily-generated OpenAL sound-buffer resource.
This is a variant of TSoundBuffer that does not use 'Broadcaster' event-scripting.
It is only suitable for off-TIsland use, i.e. must be used only in the client harness.!

!QOpenALBuffer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QOpenALBuffer class methodsFor: 'as yet unclassified' stamp: 'bgf 9/8/2008 01:57'!
data: soundBuffer samplingRate: frequency format: formatToken
	^ self new data: soundBuffer samplingRate: frequency format: formatToken! !

!QOpenALBuffer class methodsFor: 'as yet unclassified' stamp: 'bgf 9/8/2008 01:57'!
data: soundBuffer samplingRate: frequency sampleSize: sampleSize stereo: stereoFlag
	^ self new data: soundBuffer 
		samplingRate: frequency 
		sampleSize: sampleSize 
		stereo: stereoFlag! !

!QOpenALBuffer methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:57'!
data
	^ data! !

!QOpenALBuffer methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:57'!
data: soundBuffer samplingRate: frequency format: formatToken

	data := soundBuffer.
	format := formatToken.
	size := soundBuffer byteSize.
	samplingRate := frequency asInteger.
! !

!QOpenALBuffer methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:57'!
data: soundBuffer samplingRate: frequency sampleSize: sampleSize stereo: stereoFlag

	| formatToken |

	stereoFlag ifTrue: [
		sampleSize = 16 ifTrue: [ formatToken := ALFormatStereo16 ].
		sampleSize = 8 ifTrue: [ formatToken := ALFormatStereo8 ].
	] ifFalse: [
		sampleSize = 16 ifTrue: [ formatToken := ALFormatMono16 ].
		sampleSize = 8 ifTrue: [ formatToken := ALFormatMono8 ].
	].

	formatToken ifNil: [ ^ self ].

	self data: soundBuffer samplingRate: frequency format: formatToken
! !

!QOpenALBuffer methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:57'!
format
	^ format! !

!QOpenALBuffer methodsFor: 'initialize' stamp: 'bgf 9/8/2008 01:57'!
initialize
	super initialize.
	size = 0.! !

!QOpenALBuffer methodsFor: 'testing' stamp: 'bgf 9/8/2008 01:57'!
isEmpty
	^ size = 0! !

!QOpenALBuffer methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:57'!
resourceNameClass
	"Class of the corresponding OpenALName subclass."
	^ OpenALBufferName! !

!QOpenALBuffer methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:57'!
samplingRate
	^ samplingRate! !

!QOpenALBuffer methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:57'!
size
	^ size! !

!QOpenALResource class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QOpenALResource methodsFor: 'initialize' stamp: 'ar 6/22/2010 11:33'!
delete
	self deprecated: 'everyone else uses #destroy, we should too.'.
	self destroy.! !

!QOpenALResource methodsFor: 'initialize' stamp: 'bgf 9/8/2008 02:05'!
destroy

	self invalidate.
	handle := nil.

! !

!QOpenALResource methodsFor: 'initialize' stamp: 'bgf 9/8/2008 02:05'!
initialize
	super initialize.
	properties := Dictionary new.
! !

!QOpenALResource methodsFor: 'invalidation' stamp: 'bgf 11/18/2008 19:44'!
invalidate
	"Discard the underlying resource."
	handle ifNotNil: [ 
		| h | 
		h := handle.
		handle := nil.
		h invalidate: self
	].
! !

!QOpenALResource methodsFor: 'initialize' stamp: 'bgf 9/8/2008 03:33'!
openALHandle: oalName

	(handle notNil and: [ handle ~= oalName])  ifTrue: [
		"Unexpected; would need analysis if this was seen."
		QLogger logWarning: 'Creating second oal name handle.'.
	].

	handle := oalName! !

!QOpenALResource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:57'!
resourceNameClass
	"Class of the corresponding OpenALName subclass."

	self subclassResponsibility.! !

!QOpenALResource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 03:33'!
setProperty: aSymbol value: aValue
	"Record the property, and pass it along if I have a live OpenAL name"
	properties at: aSymbol put: aValue.
	handle ifNotNil: [
		handle perform: (aSymbol, ':') asSymbol with: aValue
	].! !

QOpenALResource subclass: #QSoundSource
	instanceVariableNames: 'buffer state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-OpenAL'!

!QSoundSource commentStamp: '<historical>' prior: 0!
State for a lazily-generated OpenAL sound-source resource.
This is a variant of TSoundSource that does not use 'Broadcaster' event-scripting.
It is only suitable for off-TIsland use, i.e. must be used only in the client harness.!

!QSoundSource class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:58'!
buffer
	^ buffer! !

!QSoundSource methodsFor: 'buffering' stamp: 'bgf 9/8/2008 01:58'!
buffer: aTSoundBuffer
	buffer := aTSoundBuffer.! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:58'!
coneInnerAngle

	^ properties at: #coneInnerAngle! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 02:17'!
coneInnerAngle: aFloat

	aFloat isNumber ifFalse: [ 
		QLogger logWarning: 'coneInnerAngle not a number: ', aFloat.
		^self ].
	self setProperty: #coneInnerAngle value: (aFloat asFloat).! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:58'!
coneOuterAngle

	^ properties at: #coneOuterAngle! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 02:17'!
coneOuterAngle: aFloat

	aFloat isNumber ifFalse: [ 
		QLogger logWarning: 'coneOuterAngle not a number: ', aFloat.
		^self ].
	self setProperty: #coneOuterAngle value: (aFloat asFloat).! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:58'!
coneOuterGain

	^ properties at: #coneOuterGain! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 02:16'!
coneOuterGain: aFloat

	aFloat isNumber ifFalse: [ 
		QLogger logWarning: 'coneOuterGain not a number: ', aFloat.
		^self ].
	self setProperty: #coneOuterGain value: (aFloat asFloat).! !

!QSoundSource methodsFor: 'initialize' stamp: 'bgf 9/8/2008 01:58'!
destroy
	super destroy.
	buffer ifNotNil: [
		buffer destroy.
		buffer := nil.
	].! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:58'!
direction

	| direction |
	direction := properties at: #direction.
	^ Vector3 x: (direction at: 1) y: (direction at: 2) z: (direction at: 3).! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 02:16'!
direction: aVector

	self setProperty: #direction value: aVector! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:58'!
gain

	^ properties at: #gain! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 02:16'!
gain: aFloat

	aFloat isNumber ifFalse: [ 
		QLogger logWarning: 'Gain not a number: ', aFloat.
		^self ].
	self setProperty: #gain value: (aFloat asFloat)! !

!QSoundSource methodsFor: 'initialize' stamp: 'bgf 5/29/2009 23:20'!
initialize

	super initialize.
	buffer := nil.
	state := ALInitial.

	"Set the initial values for all properties."
	properties at: #coneInnerAngle put: 360.0.
	properties at: #coneOuterAngle put: 360.0.
	properties at: #coneOuterGain put: 0.0.
	properties at: #direction put: #(0.0 0.0 0.0).
	properties at: #gain put: 0.5.
	properties at: #looping put: false.
	properties at: #maxDistance put: 1000.0.
	properties at: #pitch put: 1.0.
	properties at: #position put: #(0.0 0.0 0.0).
	properties at: #referenceDistance put: 1.0.
	properties at: #rolloffFactor put: 1.0.! !

!QSoundSource methodsFor: 'testing' stamp: 'bgf 9/8/2008 01:58'!
isPaused
	^ self state = ALPaused! !

!QSoundSource methodsFor: 'testing' stamp: 'bgf 9/8/2008 01:58'!
isPlaying
	^ self state = ALPlaying! !

!QSoundSource methodsFor: 'testing' stamp: 'bgf 9/8/2008 01:58'!
isStopped
	^ self state = ALStopped! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:58'!
looping

	^ properties at: #looping! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 02:15'!
looping: aBool

	self setProperty: #looping value: aBool! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:58'!
maxDistance

	^ properties at: #maxDistance! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 02:15'!
maxDistance: aFloat

	aFloat isNumber ifFalse: [ 
		QLogger logWarning: 'maxDistance not a number: ', aFloat.
		^self ].
	self setProperty: #maxDistance value: aFloat asFloat.! !

!QSoundSource methodsFor: 'controls' stamp: 'bgf 9/8/2008 02:14'!
pause
	handle ifNotNil: [ handle pause ].
	state := ALPaused.! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:58'!
pitch

	^ properties at: #pitch! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 02:14'!
pitch: aFloat

	aFloat isNumber ifFalse: [ 
		QLogger logWarning: 'Pitch not a number: ', aFloat.
		^self ].
	self setProperty: #pitch value: aFloat asFloat.! !

!QSoundSource methodsFor: 'controls' stamp: 'bgf 9/8/2008 02:13'!
play
	handle ifNotNil: [ handle play ].
	state := ALPlaying.! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:58'!
position

	| position |
	position := properties at: #position.
	^ Vector3 x: (position at: 1) y: (position at: 2) z: (position at: 3)! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 02:13'!
position: aB3DVector3

	self setProperty: #position value: aB3DVector3.! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:58'!
position: posVector direction: dirVector

	self position: posVector; direction: dirVector.! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:58'!
properties
	^ properties! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:58'!
referenceDistance

	^ properties at: #referenceDistance! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 02:13'!
referenceDistance: aFloat

	aFloat isNumber ifFalse: [ 
		QLogger logWarning: 'Reference distance not a number: ', aFloat.
		^self ].
	self setProperty: #referenceDistance value: (aFloat asFloat).
! !

!QSoundSource methodsFor: 'render' stamp: 'bgf 5/29/2009 23:34'!
render: openAL

	| sourceID |

	openAL ifNil: [ ^ 0 ].
	openAL hasContext ifFalse: [ ^ 0].
	openAL isCurrent ifFalse: [ ^ 0 ].

	sourceID := (handle ifNotNil: [ handle alID ]).
	sourceID ifNil: [ 
		sourceID := (openAL nameOf: self) ifNotNilDo: [ : n | n alID ].	"Make one."
	].

	sourceID ifNil: [ ^ 0 ].	"Generally means OAL was stopped underneath us."
	openAL statusMutex critical: [
		state := openAL alGetSourcei: sourceID with: ALSourceState.
		openAL checkError: ('sound source check state ', sourceID).
	].

	^ 1! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:58'!
resourceNameClass
	"Class of the corresponding OpenALName subclass."
	^ OpenALSourceName! !

!QSoundSource methodsFor: 'controls' stamp: 'bgf 9/8/2008 02:12'!
rewind
	handle ifNotNil: [ handle rewind ].
	state := ALStopped.! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:58'!
rolloffFactor

	^ properties at: #rolloffFactor! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 03:02'!
rolloffFactor: aFloat

	aFloat isNumber ifFalse: [ ^self ].
	self setProperty: #rolloffFactor value: (aFloat asFloat).! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:58'!
state
	^ state! !

!QSoundSource methodsFor: 'controls' stamp: 'bgf 9/8/2008 02:12'!
stop
	handle ifNotNil: [ handle stop ].
	state := ALStopped.! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 01:58'!
transform: trans
	self position: trans translation.
	self direction: trans column3 normalized.! !

!QSoundSource methodsFor: 'accessing' stamp: 'bgf 9/8/2008 02:11'!
x: x y: y z: z

	self setProperty: #position value: { x.  y.  z }.
! !

QLozenge subclass: #QSoundFrame
	instanceVariableNames: 'gain isLooping referenceDistance maxDistance soundEffectName soundDocument alwaysLooping motionGrip'
	classVariableNames: ''
	poolDictionaries: 'OpenALConstants'
	category: 'Qwaq-Sound'!

!QSoundFrame commentStamp: '<historical>' prior: 0!
A reference to a SampledSound file, with a position in 3D space, 
under the control of harness #useSoundEffects.   
Sounds are resources, managed by the QAudioSession and played by QSoundFramePlayers.

They are also simple lozenge-icons in the space (although these are often made invisible);
clicking on the lozenge can play or stop the sound.

There are two mutually-exclusive ways to specify the sound:
 1) a soundEffectName: can be given.  This is a string specifying a prepackaged sound.
 2) a soundDocument can be given.  This is a QSharedDocument (suffix wav,aiff,aif),
     whose payload is a sound file.

Originally from OpenAL TSoundFrame.  
Differences include lazy creation of the underlying sound resources, and some details about how the transform is updated and passed along.

Consumes OpenAL resources only while playing.   This is done because positional sound sources in openAL are limited to a small number (16 seems common.) QSoundFrames are usually feedback sound effects that play when the user operates an in-space object, so any given QSoundFrame is seldom played. 


!

QSoundFrame subclass: #QClientSoundFrame
	instanceVariableNames: 'samples format samplingRate buffer source session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound'!

!QClientSoundFrame commentStamp: '<historical>' prior: 0!
(c) 2006-2007 Qwaq Inc.  A sound frame managed by the UI Harness (rather than residing in the TSpace).  
Used for global event sound effects.

We leave the machinery for playing the sound via OpenAL in this class (don't fix it if it ain't broken) even though we can also play it using the Squeak sound API (see #playSoundEffect:at: in the various subclasses of QwaqAudioInterface).
!

!QClientSoundFrame class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QClientSoundFrame methodsFor: 'render' stamp: 'bgf 1/10/2009 14:01'!
createBuffer
	"Assumes that 'soundBuffer', etc. have already been set properly."
	
	buffer := QOpenALBuffer data: samples samplingRate: samplingRate format: format.
	source ifNotNil: [
		"Source needs to be recreated."
		source destroy.
		source := nil.
	].! !

!QClientSoundFrame methodsFor: 'render' stamp: 'bgf 9/8/2008 02:48'!
createSource

	source := QSoundSource new.
	source referenceDistance: referenceDistance.
	source maxDistance: maxDistance.
	source gain: gain.
	source position: self globalPosition.
	source direction: self lookAt.

	"XXX See renderFrame: 
		source looping: isLooping."

	buffer ifNotNil: [
		source buffer: buffer.
	].
	^ source.! !

!QClientSoundFrame methodsFor: 'initialize' stamp: 'bgf 8/9/2007 11:11'!
destroy
	source ifNotNil: [ source stop.  source destroy.  source := nil ].
	buffer ifNotNil: [ buffer destroy.  buffer := nil ].
	super destroy.! !

!QClientSoundFrame methodsFor: 'render' stamp: 'bgf 8/27/2009 16:08'!
followUp
	"Background task to finish playing a sound, and clean up afterwards;
	 client-side sound has no future-sending or rendering loop to drive it."
	| openAL |
	openAL := self openAL.
	openAL ifNil: [^self "we must be playing through Squeak sound API"].
	[source notNil and:[ source isPlaying] and: [openAL notNil] and: [openAL hasContext]] 
		whileTrue: [
			openAL makeCurrent.
			source render: openAL.
			(Delay forMilliseconds: 10) wait.
		].
	(source notNil and: [ source isPlaying not ]) ifTrue: [
		(openAL isNil or: [openAL hasContext not]) ifTrue: [^self ].
		openAL makeCurrent.
		source buffer: nil.
		source invalidate.
		source destroy.
		source := nil.
	].
! !

!QClientSoundFrame methodsFor: 'initialize' stamp: 'bgf 12/12/2006 17:28'!
initialize

	super initialize.
	self gain: 0.5; 
		referenceDistance: 2.0; 
		maxDistance: 100.0.! !

!QClientSoundFrame methodsFor: 'private' stamp: 'bgf 2/6/2009 21:40'!
openAL
	"The OpenAL instance (access to that sound system), if one is available."
	^ session
		ifNil: [ nil]
		ifNotNil: [ session openAL ]! !

!QClientSoundFrame methodsFor: 'controls' stamp: 'bgf 2/6/2009 21:43'!
play
	"Play at the location of the current avatar."
	self playAt: session listenerPosition
	! !

!QClientSoundFrame methodsFor: 'controls' stamp: 'bgf 2/6/2009 21:29'!
playAt: aVector3

	| newSource |

	newSource := false.
	source ifNil: [
		self createSource.
		source position: aVector3.
		newSource := true.
	].
	source play.

	newSource ifTrue: [
		[self followUp] fork.
	].! !

!QClientSoundFrame methodsFor: 'loading' stamp: 'bgf 1/10/2009 14:03'!
sampledSound: aSampledSound
	"Use the given sound as my sound data."

	(aSampledSound isKindOf: SampledSound) ifFalse: [ 
		QLogger logWarning: 'Not a sampled sound: ', (aSampledSound class name).
		^ self ].
	samples := aSampledSound samples.
	samplingRate := aSampledSound originalSamplingRate.
	format := aSampledSound isStereo 
									ifTrue: [ALFormatStereo16]
									ifFalse: [ALFormatMono16].
	buffer ifNotNil: [
		buffer destroy.
		buffer := nil.
	].
	self createBuffer.! !

!QClientSoundFrame methodsFor: 'accessing' stamp: 'bgf 1/10/2009 14:01'!
samples
	"The samples from the original sampledSound"
	^ samples! !

!QClientSoundFrame methodsFor: 'accessing' stamp: 'bgf 1/10/2009 13:45'!
samplingRate
	^ samplingRate! !

!QClientSoundFrame methodsFor: 'accessing' stamp: 'bgf 2/6/2009 21:25'!
session: anAudioSession	
	session := anAudioSession! !

QSoundFrame subclass: #QRoamingSoundEffect
	instanceVariableNames: 'range interval active avatarRange'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound'!

!QRoamingSoundEffect commentStamp: '<historical>' prior: 0!
A sound that plays at random within a bounded space,
at random intervals.

The range is a TBox; the sounds jump randomly within this box.
The interval is a base number of seconds from which the random replays will be varied.
The avatarRange is a TBox; avatars outside this box will not hear the sound.!

!QRoamingSoundEffect class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QRoamingSoundEffect class methodsFor: 'defaults' stamp: 'bgf 1/29/2009 01:36'!
defaultIsVisible
	"For continuity... before there were sound-frame lozenges,
	 sound frames had no visible presence at...
	 so there may be sound effects laying about,
 	 that shouldn't just become blue-boxes for no reason."
	^ false! !

!QRoamingSoundEffect methodsFor: 'accessing' stamp: 'bgf 11/22/2006 12:00'!
avatarRange: aTBox
	"The avatar must be in this TBox to hear the sound frame."
	avatarRange := aTBox! !

!QRoamingSoundEffect methodsFor: 'persist' stamp: 'bgf 12/6/2006 15:06'!
constructFrom: pStream

	super constructFrom: pStream.

	self interval: (pStream readNumber: 'interval' default: interval).
	self avatarRange: (pStream readObject: 'avatarRange' default: avatarRange).
	self range: (pStream readObject: 'range' default: range).
! !

!QRoamingSoundEffect methodsFor: 'accessing' stamp: 'bgf 8/16/2009 16:15'!
dragAdapter
	^ nil! !

!QRoamingSoundEffect methodsFor: 'initialize' stamp: 'bgf 1/28/2007 22:21'!
initialize

	super initialize.
	active := false.
	interval := 60.
	range := TBox min: -50@-10@-50 max: 50@10@50.
	avatarRange := nil.
	! !

!QRoamingSoundEffect methodsFor: 'accessing' stamp: 'bgf 7/4/2006 19:51'!
interval: aNumberOfSeconds

	"The target interval; sounds will appear every [interval/2 ... interval*1.5] seconds."

	interval := aNumberOfSeconds.	! !

!QRoamingSoundEffect methodsFor: 'render' stamp: 'bgf 1/26/2009 14:20'!
isAudibleToAvatar: avatar
	"Get-compatible sound-query: is this sound audible to the given listener?"	
	^ (super isAudibleToAvatar: avatar)
	    and: [
			avatarRange isNil or: [
				avatarRange pointInBox: (avatar globalTransformReal translation) ]].
! !

!QRoamingSoundEffect methodsFor: 'stepping' stamp: 'bgf 11/22/2006 12:03'!
nextPosition

	self translation:
		((range min x asInteger to: range max x asInteger) atRandom) @
		((range min y asInteger to: range max y asInteger) atRandom) @
		((range min z asInteger to: range max z asInteger) atRandom).
! !

!QRoamingSoundEffect methodsFor: 'persist' stamp: 'bgf 12/6/2006 14:38'!
persistOn: pStream

	super persistOn: pStream.

	pStream storeObject: 'avatarRange' value: avatarRange default: nil.
	pStream storeObject: 'range' value: range default: nil.
	pStream storeNumber: 'interval' value: interval default: 60.
! !

!QRoamingSoundEffect methodsFor: 'accessing' stamp: 'bgf 1/10/2009 13:50'!
range: aTBox

	"The field of play in which the sounds will appear."

	range := aTBox.

	self referenceDistance: (range radius / 80.0).
	self maxDistance: (range radius / 3.0).
! !

!QRoamingSoundEffect methodsFor: 'events' stamp: 'bgf 8/16/2009 16:18'!
start
	active ifFalse: [
		active := true.
		"Defer the first step for a while so we don't jump away from an initial creation."
		(self future: 1000) play.
		(self future: 15000) step.
	]! !

!QRoamingSoundEffect methodsFor: 'stepping' stamp: 'bgf 8/16/2009 16:22'!
step

	active ifTrue: [
		self play.
		self isInEditBox ifFalse: [	
			"Cheap trick for easier manipulation."
			self nextPosition.
		].
		(self future: (interval * ((500 to: 1500) atRandom))) step.
	].! !

!QRoamingSoundEffect methodsFor: 'stepping' stamp: 'bgf 7/4/2006 19:54'!
stop

	active := false.
	! !

!QSoundFrame class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSoundFrame class methodsFor: 'accessing' stamp: 'sn 3/9/2013 14:01'!
addPropertyRows: propertyDialog forFrame: sfref

	"NO SUPER, since we don't UV-stuff, etc, from Geometry,
	 and cannot afford the space for all that stuff here."

	self addNameRowIfNeeded: propertyDialog forFrame: sfref.

	propertyDialog addRow: (
		(QScalarPropertyRow new )
			titleString: 'Gain (Volume)'translateMe;
			fetchBlock: [ :frame | frame get: #gain ] ;
			acceptBlock: [ :v :frame |  frame future gain: (v asFloat min: 1.0 max: 0.001) ] ;
			balloonHelp: 'The volume of the sound effect.'translateMe;
		yourself).
	propertyDialog addRow: (
		(QScalarPropertyRow new )
			titleString: 'Reference Distance'translateMe;
			fetchBlock: [ :frame | frame get: #referenceDistance ] ;
			acceptBlock: [ :v :frame | frame future referenceDistance: (v asFloat min: 10000.0 max: 0.0) ] ;
			balloonHelp: 'The attenuation reference distance (feet).'translateMe;
		yourself).
	propertyDialog addRow: (
		(QScalarPropertyRow new )
			titleString: 'Max Distance'translateMe;
			fetchBlock: [ :frame |  frame get: #maxDistance ] ;
			acceptBlock: [ :v :frame |  frame future maxDistance: (v asFloat min: 10000.0 max: 0.0) ] ;
			balloonHelp: 'The attenuation maximum distance (feet).'translateMe;
		yourself).
	propertyDialog addRow: (
		(QBooleanPropertyRow new )
			titleString: 'Always Looping'translateMe;
			fetchBlock: [ :frame |  frame get: #alwaysLooping ] ;
			acceptBlock: [ :v :frame |  frame future alwaysLooping: v  ] ;
			balloonHelp: 'If checked, the sound continues playing until removed.'translateMe;
		yourself).

	'INCOMPLETE'.   "Need to get the title accounting for mutliples."
	propertyDialog addRow: (
		(QVector3PropertyRow new)
			titleString: 'Position (in 'translateMe, ((sfref get:#parentForInspector) get:#objectName), ')';
			fetchBlock: [ :frame |  frame get:#positionForInspector ] ;
			acceptBlock: [ :v3 :frame |  frame future positionFromInspector: v3 ] ;
			balloonHelp: 'Center of the object relative to its container.'translateMe;
	 	yourself	).

	propertyDialog addRow: (
		self scalePropertyRow: sfref).
	propertyDialog addRow: (
		(QFrameHintsPropertyRow newForFrame: sfref)).
	propertyDialog addRow: (
		self templatePropertyRow: sfref).! !

!QSoundFrame class methodsFor: 'accessing' stamp: 'bgf 1/29/2009 23:45'!
canPlayDocument: aSharedDocument
	"I can play sound files"
	^ (aSharedDocument isKindOf: QSharedDocument) 
		and: [ aSharedDocument docType isSampledSound ]! !

!QSoundFrame class methodsFor: 'defaults' stamp: 'bgf 11/10/2009 15:56'!
defaultEventMask
	^ EventPointerOver + EventPointerDown! !

!QSoundFrame class methodsFor: 'lozenge' stamp: 'bgf 5/24/2009 16:27'!
defaultExtent
	^ 0.75@0.65! !

!QSoundFrame class methodsFor: 'defaults' stamp: 'bgf 1/28/2009 16:47'!
defaultIsSolid
	^ false! !

!QSoundFrame class methodsFor: 'defaults' stamp: 'bgf 1/29/2009 01:10'!
defaultIsVisible
	"By default, you can see the sound-lozenges."
	^ true! !

!QSoundFrame class methodsFor: 'defaults' stamp: 'bgf 1/28/2009 14:00'!
defaultMaterial
	"TGeometry override"
	^ QMaterials soundChipMaterial! !

!QSoundFrame class methodsFor: 'lozenge' stamp: 'bgf 5/24/2009 16:27'!
defaultRadius
	^ 0.06! !

!QSoundFrame class methodsFor: 'accessing' stamp: 'jcg 2/12/2007 22:02'!
resourceType
	^#soundFrames! !

!QSoundFrame methodsFor: 'editing' stamp: 'bgf 11/12/2009 13:30'!
actionsList
	"Play the sound from the inspector - handy for testing."
	^ { {#play . 'Play'}.
	      {#stop . 'Stop'}}! !

!QSoundFrame methodsFor: 'events' stamp: 'bgf 9/1/2009 11:20'!
addMenuActions: aMenu forEvent: anEvent
	
	self alwaysLooping ifFalse: [
		aMenu
			add: (self isLooping ifTrue: [ 'Stop' ] ifFalse: [  'Play' ])
		      target: self
			action: #play.
		aMenu addSeparator.
		aMenu
			add: 'Start Looping'
			target: self
			action: #alwaysLooping:
			argument: true.
	] ifTrue: [
		aMenu add: 'Stop'
			     target: self
				action: #alwaysLooping:
				argument: false.
	].! !

!QSoundFrame methodsFor: 'accessing' stamp: 'bgf 7/29/2008 19:04'!
alwaysLooping
	"If true, the sound is kept on and looping so long as it exists in the scene."
	^ alwaysLooping ifNil: [ false ]! !

!QSoundFrame methodsFor: 'accessing' stamp: 'bgf 1/29/2009 19:12'!
alwaysLooping: aBool
	"If true, the sound is kept on and looping so long as it exists in the scene.
	 This is used to create persistent ambient sounds."
	alwaysLooping = aBool ifFalse: [
		alwaysLooping := aBool.
		self isLooping: alwaysLooping.
	].
	alwaysLooping ifFalse: [ self stop ]! !

!QSoundFrame methodsFor: 'drag-drop' stamp: 'bgf 3/14/2010 17:50'!
applyStateVector: dropState
	"See #stateVector - this reapplies a captured state."
	self soundEffectName: (dropState first).
	self soundDocument: (
		dropState second ifNotNil: [ : pickle |   
			(TSceneReader new)  preserveObjectIDs: true; readScene: pickle 
		] ifNil: [
			nil
		]).
! !

!QSoundFrame methodsFor: 'accessing' stamp: 'bgf 1/29/2009 19:11'!
cachedSoundURI
	"The local file URI referring to my sound file in owner's cache,
	 if I'm configured to use the content of a shared-document sound.
	 The file may not always be present... 
	 but once the resource/doc-manager system has downloaded it,
	 this is where it will be."

	^ soundDocument ifNotNil: [ soundDocument asLocalFileUri ]! !

!QSoundFrame methodsFor: 'persist' stamp: 'bgf 1/28/2009 12:38'!
constructFrom: pStream
	super constructFrom: pStream.
	self constructSoundFrom: pStream.! !

!QSoundFrame methodsFor: 'persist' stamp: 'bgf 1/29/2009 19:10'!
constructSoundFrom: pStream

	"Persistence... the property subset that pertains specifically to my sound-playing role."
	self gain: (pStream readNumber: 'gain' default: gain).
	self referenceDistance: (pStream readNumber: 'referenceDistance' default: referenceDistance).
	self maxDistance: (pStream readNumber: 'maxDistance'  default:maxDistance).

	self soundEffectName: (
				"Legacy terminology - predates drag&drop sound, the effect was called 'soundFileName'"
				pStream readString: 'soundFileName' default: nil).

	self soundDocument: (pStream readObject: 'soundDocument' default: soundDocument).

	alwaysLooping := (pStream readBool: 'alwaysLooping' default: alwaysLooping).
	alwaysLooping == true ifTrue: [
		"Anytime after the load-time clock gets moving."
		(self future: 1000) play.
	].! !

!QSoundFrame methodsFor: 'drag-drop' stamp: 'bgf 1/29/2009 19:09'!
consumeDrop: payload avatar: avatar selection: aTXSel

	"Accept drops of sound-file cards."

	(self isDropTarget: payload) ifFalse: [ ^ false ].

	^ self displayCard: payload fromUser: avatar! !

!QSoundFrame methodsFor: 'editing' stamp: 'bgf 3/11/2010 10:43'!
consumeTransferredCard: aQFileCard fromUser: anAvatar
	"Post data-copy callback...
	 install the sound-document referred to by the card,
	 which may have been pulled into the forum from inventory."
	(self isDropTarget: aQFileCard) ifFalse: [ ^ false ].
	self soundDocument: aQFileCard content fromUser: anAvatar.
	^ false
	! !

!QSoundFrame methodsFor: 'drag-drop' stamp: 'bgf 1/29/2009 19:09'!
content
	"File card workalike... my content is my sound document, if I have one."
	^ self soundDocument ifNil: [ nil ]! !

!QSoundFrame methodsFor: 'drag-drop' stamp: 'bgf 1/29/2009 02:05'!
copyToInventory: event

	"If I have a sound-document, just copy that.
	 Otherwise, as a fallback until sound-effects are held as sound-documents,
	 copy myself whole instead."
	self soundDocument ifNotNil: [
		event avatar addContentToInventory: self soundDocument
	] ifNil: [
		super copyToInventory: event.
	].! !

!QSoundFrame methodsFor: 'accessing' stamp: 'bgf 3/13/2009 04:29'!
destroy
	self unregisterResource.
	soundDocument ifNotNil: [
		soundDocument unregisterResource
	].
	super destroy.
! !

!QSoundFrame methodsFor: 'editing' stamp: 'bgf 3/11/2010 10:45'!
displayCard: aFileCard fromUser: avatar

	"Document-drop handling.   Assumes the card has already been vetted
	 as acceptable for me (i.e. a sound document.)"

	| tmp |

	"Usual rigamorole - we're creating a dependency on this resource,
	 so we need an in-forum copy of it."
	tmp := QFileCard new copyFrom: aFileCard.
	(tmp transferToCurrentForum: avatar) ifTrue: [
		self startScript: #consumeTransferredCard:fromUser:
			withArguments: {tmp . avatar} 
			when: {tmp . #transferComplete}.
		^ true.
	].
	self soundDocument: tmp content fromUser: avatar.
	^ false

	! !

!QSoundFrame methodsFor: 'accessing' stamp: 'bgf 2/6/2010 20:25'!
documents
	^ soundDocument ifNotNil: [  { soundDocument } ] ifNil: [ #() ]! !

!QSoundFrame methodsFor: 'accessing' stamp: 'bgf 8/16/2009 00:48'!
dragAdapter
	^ motionGrip! !

!QSoundFrame methodsFor: 'accessing' stamp: 'bgf 12/6/2006 15:39'!
gain
	^ gain! !

!QSoundFrame methodsFor: 'accessing' stamp: 'jcg 2/13/2007 09:57'!
gain: aNumber
	gain = aNumber ifTrue: [^self "gain didn't change"].
	gain := aNumber.
	self signal: #gainChanged with: gain! !

!QSoundFrame methodsFor: 'resources' stamp: 'bgf 1/31/2009 17:11'!
holdsDocument: aSharedDocument
	"Allows Locate from the inspector document list."
	^ soundDocument = aSharedDocument! !

!QSoundFrame methodsFor: 'initialize' stamp: 'bgf 11/10/2009 16:38'!
initialize
	super initialize.	

	gain := 1.0.
	isLooping := false.
	alwaysLooping := false.
	referenceDistance := 5.
	maxDistance := 500.0.

	(motionGrip := QMotionAdapter forLuggage: self grip: self)
		isDroppable: true;  
		isAttractedToSurfaces: true;
		surfacePolicy: #surface;
		openSpacePolicy: #viewer.

	self checkAlpha.! !

!QSoundFrame methodsFor: 'render' stamp: 'bgf 1/26/2009 14:19'!
isAudibleToAvatar: avatar
	"Harness-side rendering test - is this sound audible in the given rendering?
	 The default rule checks that the avatar is in the same space."
	^ avatar notNil and: [ self root = avatar root ]! !

!QSoundFrame methodsFor: 'drag-drop' stamp: 'bgf 1/29/2009 19:05'!
isDropTarget: payload
	^ (payload respondsTo: #kind)
		and: [ payload kind = #document ]
		and: [ self class canPlayDocument: (payload content) ]! !

!QSoundFrame methodsFor: 'accessing' stamp: 'bgf 12/12/2006 19:08'!
isLooping
	"Does the sound repeat forever?"
	^ isLooping! !

!QSoundFrame methodsFor: 'accessing' stamp: 'jcg 2/13/2007 11:57'!
isLooping: aBool
	"Does the sound repeat forever?"
	isLooping = aBool ifTrue: [^self "the looping status didn't change"].
	isLooping := aBool.
	self signal: #loopingChanged with: isLooping! !

!QSoundFrame methodsFor: 'accessing' stamp: 'bgf 6/1/2009 23:10'!
isPlacementLocked: bool
	super isPlacementLocked: bool.
	motionGrip isEnabled: bool not! !

!QSoundFrame methodsFor: 'drag-drop' stamp: 'bgf 1/29/2009 19:05'!
kind
	"The kind of content I represent, when used as a drag-drop payload.
	 This is a workalike for file-card #kind."
	^ self soundDocument ifNotNil: [ #document ] ifNil: [ #sound ]! !

!QSoundFrame methodsFor: 'accessing' stamp: 'jcg 2/13/2007 10:14'!
maxDistance
	^ maxDistance! !

!QSoundFrame methodsFor: 'accessing' stamp: 'jcg 2/13/2007 10:14'!
maxDistance: aNumber
	maxDistance = aNumber ifTrue: [^self "max distance didn't change"].
	maxDistance := aNumber.
	self signal: #maxDistanceChanged with: maxDistance.! !

!QSoundFrame methodsFor: 'drag-drop' stamp: 'bgf 1/29/2009 19:03'!
payload
	"For my motion-adaptor's drag-drop behavior...
	 I'm droppable in-space as a QSoundDocument;
	 so SoundFrames can be dragged directly into Rolodexes."
	^ self soundDocument ifNil: [ self ]! !

!QSoundFrame methodsFor: 'persist' stamp: 'bgf 1/28/2009 13:55'!
persistOn: pStream
	super persistOn: pStream.
	self persistSoundOn: pStream.
! !

!QSoundFrame methodsFor: 'persist' stamp: 'bgf 1/29/2009 19:10'!
persistSoundOn: pStream

	"Persistence... the property subset that pertains specifically to my sound-playing role."
	pStream storeString: 'soundFileName' value: soundEffectName default: nil.
	pStream storeObject: 'soundDocument' value: soundDocument default: nil.
	pStream storeNumber: 'referenceDistance' value: referenceDistance default: 5.
	pStream storeNumber: 'maxDistance' value:maxDistance default: 500.0.
	pStream storeNumber: 'gain' value: gain default: 1.0.
	pStream storeBool: 'alwaysLooping' value: self alwaysLooping default: false.
! !

!QSoundFrame methodsFor: 'controls' stamp: 'bgf 7/29/2008 19:03'!
play
	self signal: #startPlaying.

	"The sound frame player logic uses isLooping as a sub-state of playing,
	 and reflects its changes back here, so we cannot just use isLooping for control."
	self alwaysLooping ifTrue: [
		self isLooping: true
	].! !

!QSoundFrame methodsFor: 'events' stamp: 'bgf 1/29/2009 17:45'!
pointerClick: event
	"We leave control of clicks up to the harness,
	 since only the harness knows the actual play state."
	(event nrClicks = 1) ifTrue: [
		self signal: #userClick with: (event avatar sessionID).
		self unhilite.
	].! !

!QSoundFrame methodsFor: 'events' stamp: 'bgf 3/3/2010 08:07'!
pointerEnter: event
	self hilite.
	event avatar signal: #statusMessage with: 'Sound: ', (self objectName).! !

!QSoundFrame methodsFor: 'events' stamp: 'bgf 1/28/2009 16:49'!
pointerLeave: event
	self unhilite.! !

!QSoundFrame methodsFor: 'events' stamp: 'bgf 1/28/2009 16:49'!
pointerOver: event
	self hilite.! !

!QSoundFrame methodsFor: 'accessing' stamp: 'bgf 12/6/2006 15:39'!
referenceDistance
	^referenceDistance! !

!QSoundFrame methodsFor: 'accessing' stamp: 'jcg 2/13/2007 10:17'!
referenceDistance: aNumber
	referenceDistance = aNumber ifTrue: [^self "reference distance didn't change"].
	referenceDistance := aNumber.
	self signal: #referenceDistanceChanged with: referenceDistance.! !

!QSoundFrame methodsFor: 'resources' stamp: 'jcg 2/12/2007 22:03'!
registerResource
	"Register the resource."
	self island registerResource: self type: self resourceType.! !

!QSoundFrame methodsFor: 'resources' stamp: 'jcg 2/12/2007 22:01'!
resourceType
	"Answer the resource type of the receiver"
	^self class resourceType! !

!QSoundFrame methodsFor: 'accessing' stamp: 'bgf 4/8/2008 00:24'!
root: newRoot
	frameRoot 
		ifNotNil: [ self unregisterResource ].
	super root: newRoot.
	frameRoot 
		ifNotNil: [ self registerResource ].! !

!QSoundFrame methodsFor: 'accessing' stamp: 'bgf 1/29/2009 19:01'!
soundDocument
	"If non-nil, a  QSharedDocument referring to a sound file (wav, or aiff)"
	^ soundDocument ! !

!QSoundFrame methodsFor: 'accessing' stamp: 'bgf 3/13/2009 04:30'!
soundDocument: aSharedDocument
	"Use the given document as my sound file;
	 this is the direct accessor,
	 the argument should be my own copy of the document-object."

	(soundDocument = aSharedDocument) ifTrue: [ ^ self ].
		
	"Release registration of previous sound, if any."
	soundDocument ifNotNil: [ soundDocument unregisterResource ].

	soundDocument := aSharedDocument.
	soundDocument ifNotNil: [
		soundDocument registerResource.
		soundEffectName := nil.
		self objectName: (soundDocument shortName).
	].
	self signal: #sampledSoundChanged.
! !

!QSoundFrame methodsFor: 'drag-drop' stamp: 'bgf 3/13/2010 08:53'!
soundDocument: soundDoc fromUser: avatar
	"Accept drops of sound-file cards."

	| old new |
	old := self stateVector.
	self soundDocument: soundDoc.
	new := self stateVector.

	(old hasEqualElements: new) ifFalse: [	
		avatar recordAction: #frame:oldState:newState:description:
			class: QStateVectorAction
			arguments: {  self . old. new .  'Drop Sound' }.
	].
! !

!QSoundFrame methodsFor: 'accessing' stamp: 'bgf 1/29/2009 17:12'!
soundEffectName
	"A name of one of the predefined sound-effects known to QSounds"
	^ soundEffectName! !

!QSoundFrame methodsFor: 'accessing' stamp: 'bgf 1/29/2009 18:51'!
soundEffectName: fileName
	
	"Use the named sound effect (via QSounds find:) as my sampled sound.
	 Note that QSounds must be used to manage these sounds;
	 this is the path for pre-packaged sound effects."

	soundEffectName := fileName.
	fileName ifNotNil: [
		self soundDocument: nil.
		self objectName: fileName.
	].
	self signal: #sampledSoundChanged.
! !

!QSoundFrame methodsFor: 'drag-drop' stamp: 'bgf 3/12/2010 07:14'!
stateVector
	"Capture the state of the sound document or effect-name, for undo-redo"
	| pickle |
	soundDocument ifNotNil: [
		pickle := (TSceneWriter new)
					preserveObjectIDs: true;
					storeScene: soundDocument
	].	
	^ { soundEffectName .  pickle }! !

!QSoundFrame methodsFor: 'controls' stamp: 'bgf 7/29/2008 19:02'!
stop
	self alwaysLooping ifFalse: [
		self isLooping: false.
	].
	self signal: #stopPlaying.
	! !

!QSoundFrame methodsFor: 'resources' stamp: 'jcg 2/12/2007 22:03'!
unregisterResource
	"Unregister the resource"
	self island unregisterResource: self type: self resourceType.! !

!QSoundFrame methodsFor: 'controls' stamp: 'bgf 3/3/2010 08:08'!
userPlay
	"An explicit play-click from a user action... meaning really play."
	self root signal: #infoMessage with: 'Playing ', (self objectName).
	self stop; play.

! !

!QSoundFrame methodsFor: 'controls' stamp: 'bgf 3/3/2010 08:09'!
userStop
	"An explicit stop from a user action... meaning really stop,
	 no matter what my always-Looping setting said."

	self root signal: #infoMessage with: 'Stopped ', (self objectName).
	self isLooping: false.
	self signal: #stopPlaying.
	
! !

QwaqAudioInterface subclass: #QwaqOpenALInterface
	instanceVariableNames: 'openAL listenerGain savedGain'
	classVariableNames: ''
	poolDictionaries: 'OpenALConstants'
	category: 'Qwaq-Sound-API'!

!QwaqOpenALInterface class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QwaqOpenALInterface class methodsFor: 'defaults' stamp: 'bgf 4/28/2009 21:17'!
defaultListenerGain
	^ 1.5		"Higher to calibrate Squeak playback and OpenAL playback somewhat."! !

!QwaqOpenALInterface methodsFor: 'actions' stamp: 'jcg 2/19/2007 17:45'!
clearSounds
	"HACK!! Clear all OpenAL sound sources; they will be lazily re-created if necessary."
	openAL ifNotNil: [openAL nameManager deleteSources].! !

!QwaqOpenALInterface methodsFor: 'private' stamp: 'jcg 4/9/2010 15:53'!
createOpenALContext

	"Our first contact with OpenAL; create and initialize the OpenAL context.
	 Caller should be prepared to deal with errors being raised."

	QLogger logInfo: 'instantiating OpenAL context'.
	[
		openAL := OpenAL new.
		(openAL checkError: 'initialize') ifTrue: [
			openAL destroy.
			openAL := nil.
			self error: 'Cannot initialize Open AL.'.
		].
		openAL makeCurrent.
		(openAL checkError: 'make current') ifTrue: [
			QLogger logWarning: 'Cannot make OpenAL current.'.
			openAL destroy.
			openAL := nil.
			self error: 'Cannot make OpenAL current.'.
		].
	] on: Error do: [ :ex |
		"Probably means a problem FFI'ing into the open al module;
	       signal this as an error so it comes front and center."
		openAL := nil.
		self error: ('Cannot initialize Open AL:\' withCRs), ex description.
	].
	QLogger logInfo: 'OpenAL devices ', openAL allDevices.
		

	"This is supposed to be set by default, but doesn't appear to be.  Dammit."
	openAL alDistanceModel: ALInverseDistanceClamped. 
	openAL checkError: 'distance model'.

	self listenerGain: (self listenerGain).

	(Smalltalk platformName = 'Mac OS') ifTrue: [
		"Reduces Mac OS OpenAL problems... convert buffers
	 	 when the data is loaded into the buffer, rather than upon rendering."
		openAL alEnable: 16rF001.	"ALC_CONVERT_DATA_UPON_LOADING"
		openAL checkError: 'ALC_CONVERT_DATA_UPON_LOADING'.
	].! !

!QwaqOpenALInterface methodsFor: 'actions' stamp: 'jcg 2/26/2007 00:04'!
createSoundFramePlayerFor: soundFrameRef
	"Create the appropriate type of sound frame player for this type of audio session."
	^ QSoundFramePlayerOpenAL for: soundFrameRef in: audioSession! !

!QwaqOpenALInterface methodsFor: 'actions' stamp: 'jcg 8/21/2009 12:41'!
createSpeakerOutputFor: aQAudioFormat
	"Create the appropriate type of output for this type of audio interface.  NOTE: should only be called via QSpeakerManager."
	| output | 
	output := QClientSpeakerPipelineOutput
				newForAudioFormat: aQAudioFormat 
				useOpenAL: true.
	output usesSpeexInput ifTrue: [
		output marginRange: audioSession jitterbufferMarginRange.
	].
	^ output! !

!QwaqOpenALInterface methodsFor: 'initialize' stamp: 'jcg 2/19/2007 14:34'!
destroy
	super destroy.
	openAL ifNotNil: [openAL destroy].
	openAL := nil.! !

!QwaqOpenALInterface methodsFor: 'initialize' stamp: 'bgf 3/26/2009 12:50'!
initialize
	super initialize.

	[self createOpenALContext] ifError: [:msg |
		QLogger logWarning: 'Cannot start spatial sound: ', msg.
		openAL := nil.
	].

	listenerGain := self class defaultListenerGain.
	savedGain = nil.
	! !

!QwaqOpenALInterface methodsFor: 'accessing' stamp: 'bgf 5/29/2009 23:39'!
isMute: bFlag

	"NOTE: we leave this method here, even though it isn't currently called, because Brad went to some trouble to get this right, and we might possibly need it later."

	"Mute or unmute all spatial sound at once,
     through the simple means of setting listener gain to 0.
     Save listener gain so that mute/unmute will recover the right value.

	Internally, we use a non-nil 'savedGain' value to indicate
	when we're muted, rather than really set to have gain=0.0 "

	openAL ifNil:[^self].
	bFlag == (savedGain notNil) ifTrue:[^self "Already muted/unmuted, so do nothing."].

	bFlag ifTrue: [
		savedGain := listenerGain.
		listenerGain := 0.0.
		self signal: #mute.
	] ifFalse: [
		listenerGain := savedGain.
		savedGain := nil.
		self signal: #unmute.
	].
	openAL makeCurrent.
	openAL statusMutex critical: [
		openAL alListenerf: ALGain with: listenerGain.
		openAL checkError: 'Listener gain for mute ', bFlag.
	].! !

!QwaqOpenALInterface methodsFor: 'accessing' stamp: 'jcg 2/18/2007 22:34'!
listenerGain
	^ listenerGain! !

!QwaqOpenALInterface methodsFor: 'accessing' stamp: 'bgf 3/26/2009 12:52'!
listenerGain: aNumber
	listenerGain := aNumber.
	openAL ifNotNil: [ self makeCurrent ].
	openAL ifNotNil: [
		openAL alListenerf: ALGain with: self listenerGain.
	].! !

!QwaqOpenALInterface methodsFor: 'actions' stamp: 'jcg 2/19/2007 14:40'!
makeCurrent
	self makeOpenALCurrent ! !

!QwaqOpenALInterface methodsFor: 'private' stamp: 'jcg 2/19/2007 14:39'!
makeOpenALCurrent

	openAL ifNil: [^self].
	openAL isCurrent ifTrue: [^self].

	openAL currentContext ifNotNil: [
		openAL alListenerf: ALGain with: 0.0.	"Mute the old context."
	].
	openAL makeCurrent.
	openAL alListenerf: ALGain with: self listenerGain.
! !

!QwaqOpenALInterface methodsFor: 'accessing' stamp: 'jcg 2/18/2007 22:35'!
openAL
	^ openAL! !

!QwaqOpenALInterface methodsFor: 'sound effects' stamp: 'jcg 2/19/2007 12:35'!
playSoundEffect: aSymbol at: aVector3
	"Play the named sound effect at the given spatial position; the sound is looked up in a QSoundEffects."

	"This is a bit ugly... ideally we would handle the playing of the effect through OpenAL.  As it is, the QwaqSqueakAudioInterface playes the effect, but for OpenAL we use the code in QClientSoundFrame; it would be more symmetrical for us to handle the playing here."
	self soundEffects playEffect: aSymbol at: aVector3! !

!QwaqOpenALInterface methodsFor: 'testing' stamp: 'jcg 8/9/2009 10:18'!
supportsRecording
	^true! !

!QwaqOpenALInterface methodsFor: 'spatialization' stamp: 'bgf 5/29/2009 23:36'!
updateListenerPosition: transform

	| position orientation |

	openAL ifNil: [ ^ self ].
	openAL isCurrent ifFalse: [ ^ self ]. "Ignore updates for now."

	position := transform translation.
	orientation := ((transform lookAt negated) asFloatArray, transform lookUp asFloatArray).

	openAL statusMutex critical: [
		openAL checkError: 'preparing for position'.
		openAL alListener3f: ALPosition with: position x with: position y with: position z.
		openAL checkError: ('listener position ', position).
		openAL alListenerfv: ALOrientation with: orientation.
		openAL checkError: ('listener orientation ', orientation).
	].! !

!QwaqOpenALInterface methodsFor: 'actions' stamp: 'bgf 4/6/2009 15:35'!
useLowOutputVolume
	"Used for poor-mean's feedback prevention in press-to-talk;
	 lower the global sound output level.  Only done in OPenAL,
	 where we can do it by touching a parameter rather than the system volume/etc."
	self listenerGain: (self class defaultListenerGain / 2.0).
! !

!QwaqOpenALInterface methodsFor: 'actions' stamp: 'bgf 3/26/2009 12:53'!
useNormalOutputVolume
	"Restore default output volume."
	self listenerGain: self class defaultListenerGain.! !

QwaqSqueakAudioInterface subclass: #QwaqPortAudioInterface
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'OpenALConstants'
	category: 'Qwaq-Sound-API'!

!QwaqPortAudioInterface commentStamp: '<historical>' prior: 0!
Play audio via the cross-platform PortAudio library.  

NOTE: At first only streaming sounds are played through PortAudio; the rest are played through the Squeak sound interface (that's why this is currently a subclass of QwaqSqueakAudioInterface.!

!QwaqPortAudioInterface class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QwaqPortAudioInterface methodsFor: 'actions' stamp: 'jcg 9/10/2009 15:47'!
createSpeakerOutputFor: aQAudioFormat
	"Create the appropriate type of output for this type of audio interface.  NOTE: should only be called via QSpeakerManager."
	| useDangerousExperimentalCode output |

	"XXXXX: Don't change this unless you know exactly what you're doing.
		- doesn't support Windows yet.
		- Josh is probably going to disable stuff in the QAudioPlugin for now."
	useDangerousExperimentalCode := false.

	useDangerousExperimentalCode ifFalse: [
		^super createSpeakerOutputFor: aQAudioFormat
	].
	output := QClientSpeakerPortAudioOutput new.
	[ 
		output audioFormat: aQAudioFormat.
	] on: Error do: [ :ex|
		"This is protection for Linux client-demons, which have no audio plugin yet."
		QLogger logWarning: 'Cannot configure speaker port output: ', (ex description).
	].
	^output! !

!QwaqPortAudioInterface methodsFor: 'initialize' stamp: 'jcg 3/31/2010 11:33'!
initialize
	super initialize.

	"Required for PortAudio to pick the proper output device (input too, although this may not be sufficient... but that's for later)."
	[QAudioSession primPortAudioResetDevice]
		on: Error 
		do: [:err | QLogger logWarning: 'failed to reset PortAudio device: ', err]..! !

ExternalStructure subclass: #QDecodedAudioSegmentFeedback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Codec'!

!QDecodedAudioSegmentFeedback commentStamp: '<historical>' prior: 0!
A decoded audio-segment returned from the plugin via a feedback-channel.!

!QDecodedAudioSegmentFeedback class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QDecodedAudioSegmentFeedback class methodsFor: 'field definition' stamp: 'jcg 6/13/2009 12:55'!
fields
	"QDecodedAudioSegmentFeedback defineFields"
	^#(
		(type 'long')
		(buffer 'unsigned char*')
	)! !

!QDecodedAudioSegmentFeedback methodsFor: 'accessing' stamp: 'jcg 6/12/2009 20:17'!
buffer
	"NOT automatically generated."
	^SoundBuffer fromLittleEndianByteArray: 
						(handle copyFrom: 5 to: handle size)! !

!QDecodedAudioSegmentFeedback methodsFor: 'accessing' stamp: 'jcg 9/6/2008 19:36'!
type
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!QDecodedAudioSegmentFeedback methodsFor: 'accessing' stamp: 'jcg 9/6/2008 19:36'!
type: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

ExternalStructure subclass: #QEncodedAudioSegmentFeedback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Codec'!

!QEncodedAudioSegmentFeedback commentStamp: '<historical>' prior: 0!
An encoded audio-segment returned from the plugin via a feedback-channel.!

!QEncodedAudioSegmentFeedback class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QEncodedAudioSegmentFeedback class methodsFor: 'field definition' stamp: 'jcg 6/13/2009 13:00'!
fields
	"QEncodedAudioSegmentFeedback defineFields"
	^#(
		(type 'long')
		(bufferSize 'ulong')
		(buffer 'char*')
	)! !

!QEncodedAudioSegmentFeedback methodsFor: 'accessing' stamp: 'jcg 6/13/2009 13:00'!
buffer
	"NOT automatically generated."
	^handle copyFrom: 9 to: handle size! !

!QEncodedAudioSegmentFeedback methodsFor: 'accessing' stamp: 'jcg 6/13/2009 13:00'!
bufferSize
	"This method was automatically generated"
	^handle unsignedLongAt: 5! !

!QEncodedAudioSegmentFeedback methodsFor: 'accessing' stamp: 'jcg 6/13/2009 13:00'!
bufferSize: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 5 put: anObject! !

!QEncodedAudioSegmentFeedback methodsFor: 'accessing' stamp: 'jcg 6/13/2009 13:00'!
type
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!QEncodedAudioSegmentFeedback methodsFor: 'accessing' stamp: 'jcg 6/13/2009 13:00'!
type: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

ExternalStructure subclass: #QJitterbufferStats
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Codec'!

!QJitterbufferStats commentStamp: 'jcg 3/18/2010 13:17' prior: 0!
A structure used to retrieve statistics about the performance of a QAudioSinkSpeex.  It is passed into #primitiveSinkGetJitterbufferStats, which fills it in.  The primitive checks the size of the struct, and doesn't write out-of-bounds; instead, the primitive fails.  This might occur if the plugin is newer than the code in the Squeak image.  On the other hand, if the code in the Squeak image is newer, then some of the fields might not be filled in.  The primitive fills in the version, so that you can determine which fields are valid afterward.

Version 1 fields:
	version (long)					-	specifies the version of the stats.
	totalGets (long)				-	jitterbuffer gets since the "Beginning of Time"
	totalExtrapolations (long) 		-	jitterbuffer extrapolated gets since the "BoT"
	recentGets (long)				-	gets since the previous query
	recentExtrapolations (long)	-	extrapolated gets since the previous query

Version 2 fields:
	totalDrops (long)				-	dropped packets since the "BoT"
	recentDrops (long)				-	dropped packets since the previous query
	amountBuffered (long)			-	number of samples buffered in the sink

Version 3 fields:
	(none yet, still at version 2)!

!QJitterbufferStats class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QJitterbufferStats class methodsFor: 'field definition' stamp: 'jcg 3/18/2010 13:14'!
fields
	"QJitterbufferStats defineFields"
	^#(
		"Version 1 fields"
		(version 'long')
		(totalGets 'long')
		(totalExtrapolations 'long')
		(recentGets 'long')
		(recentExtrapolations 'long')
		"Version 2 fields"
		(totalDrops 'long')
		(recentDrops 'long')
		(amountBuffered 'long')
	)! !

!QJitterbufferStats methodsFor: 'accessing' stamp: 'jcg 3/18/2010 13:14'!
amountBuffered
	"This method was automatically generated"
	^handle signedLongAt: 29! !

!QJitterbufferStats methodsFor: 'accessing' stamp: 'jcg 3/18/2010 13:14'!
amountBuffered: anObject
	"This method was automatically generated"
	handle signedLongAt: 29 put: anObject! !

!QJitterbufferStats methodsFor: 'printing' stamp: 'jcg 10/31/2008 12:19'!
printOn: aStream
	super printOn: aStream.
	aStream 
		nextPutAll: '(recent:';
		nextPutAll: self recentExtrapolationPercent printString; 
		nextPutAll: '%,  total:';
		nextPutAll: self totalExtrapolationPercent printString;
		nextPutAll: '%)'.! !

!QJitterbufferStats methodsFor: 'accessing' stamp: 'jcg 3/18/2010 00:42'!
recentDrops
	"This method was automatically generated"
	^handle signedLongAt: 25! !

!QJitterbufferStats methodsFor: 'accessing' stamp: 'jcg 3/18/2010 00:42'!
recentDrops: anObject
	"This method was automatically generated"
	handle signedLongAt: 25 put: anObject! !

!QJitterbufferStats methodsFor: 'accessing-stats' stamp: 'jcg 10/31/2008 12:16'!
recentExtrapolationPercent
	| gets |
	gets := self recentGets.
	gets == 0 ifTrue: [^0.0].
	^ (100 * self recentExtrapolations asFloat / gets) roundTo: 0.1! !

!QJitterbufferStats methodsFor: 'accessing' stamp: 'jcg 10/29/2008 18:20'!
recentExtrapolations
	"This method was automatically generated"
	^handle signedLongAt: 17! !

!QJitterbufferStats methodsFor: 'accessing' stamp: 'jcg 10/29/2008 18:20'!
recentExtrapolations: anObject
	"This method was automatically generated"
	handle signedLongAt: 17 put: anObject! !

!QJitterbufferStats methodsFor: 'accessing' stamp: 'jcg 10/29/2008 18:20'!
recentGets
	"This method was automatically generated"
	^handle signedLongAt: 13! !

!QJitterbufferStats methodsFor: 'accessing' stamp: 'jcg 10/29/2008 18:20'!
recentGets: anObject
	"This method was automatically generated"
	handle signedLongAt: 13 put: anObject! !

!QJitterbufferStats methodsFor: 'initialize' stamp: 'jcg 3/18/2010 00:56'!
setHandle: anObject
	"Typical Squeak code would override #initialize, but we don't have a handle at that time."
	super setHandle: anObject.
	self version: 2.
! !

!QJitterbufferStats methodsFor: 'accessing' stamp: 'jcg 3/18/2010 00:42'!
totalDrops
	"This method was automatically generated"
	^handle signedLongAt: 21! !

!QJitterbufferStats methodsFor: 'accessing' stamp: 'jcg 3/18/2010 00:42'!
totalDrops: anObject
	"This method was automatically generated"
	handle signedLongAt: 21 put: anObject! !

!QJitterbufferStats methodsFor: 'accessing-stats' stamp: 'jcg 10/31/2008 12:15'!
totalExtrapolationPercent
	| gets |
	gets := self totalGets.
	gets == 0 ifTrue: [^0.0].
	^ (100 * self totalExtrapolations asFloat / gets) roundTo: 0.1! !

!QJitterbufferStats methodsFor: 'accessing' stamp: 'jcg 10/29/2008 18:20'!
totalExtrapolations
	"This method was automatically generated"
	^handle signedLongAt: 9! !

!QJitterbufferStats methodsFor: 'accessing' stamp: 'jcg 10/29/2008 18:20'!
totalExtrapolations: anObject
	"This method was automatically generated"
	handle signedLongAt: 9 put: anObject! !

!QJitterbufferStats methodsFor: 'accessing' stamp: 'jcg 10/29/2008 18:20'!
totalGets
	"This method was automatically generated"
	^handle signedLongAt: 5! !

!QJitterbufferStats methodsFor: 'accessing' stamp: 'jcg 10/29/2008 18:20'!
totalGets: anObject
	"This method was automatically generated"
	handle signedLongAt: 5 put: anObject! !

!QJitterbufferStats methodsFor: 'accessing' stamp: 'jcg 10/29/2008 18:20'!
version
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!QJitterbufferStats methodsFor: 'accessing' stamp: 'jcg 10/29/2008 18:20'!
version: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

!SoundBuffer class methodsFor: '*Qwaq-Sound' stamp: 'jcg 9/6/2008 20:12'!
fromLittleEndianByteArray: aByteArray
	"Convert the given ByteArray (stored with the most significant byte first) into 16-bit sample buffer."

	| n buf src w |
	n := aByteArray size // 2.
	buf := SoundBuffer newMonoSampleCount: n.
	src := 1.
	1 to: n do: [:i |
		w := ((aByteArray at: src+1) bitShift: 8) + (aByteArray at: src ).
		w > 32767 ifTrue: [w := w - 65536].
		buf at: i put: w.
		src := src + 2].
	^ buf
! !

!SoundBuffer methodsFor: '*Qwaq-Sound' stamp: 'jcg 5/10/2008 19:09'!
splitIntoBuffersOfSize: sampleCount
	| splitBuffers |
	sampleCount odd ifTrue: [self error: 'must split into even-sized buffers'].
	splitBuffers := OrderedCollection new.
	1 to: self size by: sampleCount do: [:start |
		splitBuffers add: (self copyFrom: start to: (start+sampleCount-1 min: self size))
	].
	^splitBuffers! !

CPlayer subclass: #QPhoneTestPlayer
	instanceVariableNames: ''
	classVariableNames: 'LastAsteriskHost LastAsteriskUser'
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Dev'!

QPhoneTestPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="pane" toSet="pane:" changeEvent="paneChanged">pane</field>
	<field toGet="harness" toSet="harness:" changeEvent="harnessChanged">harness</field>
</fields>'!

!QPhoneTestPlayer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPhoneTestPlayer methodsFor: 'initialize' stamp: 'jcg 8/14/2008 00:44'!
destroy
	self destroyHarness.
	super destroy.! !

!QPhoneTestPlayer methodsFor: 'initialize' stamp: 'jcg 8/14/2008 00:47'!
destroyHarness
	harness ifNotNil: [
		QLogger logInfo: 'destroying phone-test harness'.
		harness destroy.
		harness := nil.
		pane phoneManager: nil
	].! !

!QPhoneTestPlayer methodsFor: 'impersonation' stamp: 'jcg 7/31/2008 16:47'!
floatingPanelArea
	^ (Rectangle origin: 0@0 corner: 1000@1000)! !

!QPhoneTestPlayer methodsFor: 'accessing' stamp: 'jcg 7/31/2008 16:35'!
harness
	"Answer the harness of the receiver"
	<bewareOf: #harnessChanged>
	^self propertyValueAt: #harness! !

!QPhoneTestPlayer methodsFor: 'accessing' stamp: 'jcg 7/31/2008 16:35'!
harness: aValue
	"Modify the receiver's harness"
	^self propertyValueAt: #harness put: aValue with: #harnessChanged! !

!QPhoneTestPlayer methodsFor: 'initialize' stamp: 'jcg 8/13/2008 23:44'!
initialize
	super initialize.
	self define: #pane as: QDemoPhonePane new.
	pane owner: self.
	pane position: 100@100.
	
! !

!QPhoneTestPlayer methodsFor: 'initialize' stamp: 'jcg 8/14/2008 00:53'!
initializeHarness
	<on: opened>
	self destroyHarness.

	LastAsteriskHost := CDialog 
								request: 'Asterisk hostname?' 
								initialAnswer: LastAsteriskHost
								centerAt: pane center.
	LastAsteriskUser := CDialog 
								request: 'Asterisk username?' 
								initialAnswer: LastAsteriskUser
								centerAt: pane center.

	harness := QPhoneTestHarness new.
	harness 
		initializeForAsteriskHost: LastAsteriskHost 
		andUsername: LastAsteriskUser.
	pane phoneManager: harness manager.
! !

!QPhoneTestPlayer methodsFor: 'impersonation' stamp: 'jcg 8/15/2008 12:47'!
mainView
	"So that we act enough like a CroquetView to fool a QPhoneManager."
	^ harness ifNotNil: [harness mainView]! !

!QPhoneTestPlayer methodsFor: 'impersonation' stamp: 'jcg 7/31/2008 16:47'!
mediaController
	"So that we act enough like a QwaqCroquetSession to fool a QPhoneManager."
	^ harness mediaController! !

!QPhoneTestPlayer methodsFor: 'impersonation' stamp: 'jcg 7/31/2008 16:47'!
menu
	"I guess I can also pretend to be a menu."
	^self! !

!QPhoneTestPlayer methodsFor: 'accessing' stamp: 'jcg 7/31/2008 16:35'!
pane
	"Answer the pane of the receiver"
	<bewareOf: #paneChanged>
	^self propertyValueAt: #pane! !

!QPhoneTestPlayer methodsFor: 'accessing' stamp: 'jcg 7/31/2008 16:35'!
pane: aValue
	"Modify the receiver's pane"
	^self propertyValueAt: #pane put: aValue with: #paneChanged! !

!QPhoneTestPlayer methodsFor: 'impersonation' stamp: 'hrs 9/2/2008 11:12'!
session
	^self harness "which will impersonate a session"! !

!QPhoneTestPlayer methodsFor: 'initialize' stamp: 'jcg 7/31/2008 16:38'!
setupCostume
	super setupCostume.
	self addLast: pane.! !

!QPhoneTestPlayer methodsFor: 'impersonation' stamp: 'jcg 7/31/2008 16:47'!
userLogin
	"So that we act enough like a QwaqCroquetSession to fool a QPhoneManager."
	^harness userLogin! !

TClientObject subclass: #QClientSpeaker
	instanceVariableNames: 'manager audioSession speakerOutput speakerInput transform isAudible isPlaying isLoopback mediaController soundRegion regionAttenuation currentAttenuation volume mutex isMe jitterBufferActivityThreshold jitterStats audioFormat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Speaker'!

!QClientSpeaker commentStamp: 'jcg 8/10/2009 00:35' prior: 0!
(c) 2007 Qwaq Inc.  Handles the playing of audio that comes in over a media stream.

IMPORTANT INVARIANT:
Several other places in the code (eg: QAudioRecorder#onSpeakersChanged) assume that speakers already have a speaker-output, and that this output doesn't change over the lifetime of the speaker.  Whenever we would need to change the output (i.e. when we change from OpenAL to Squeak sound), we destroy all of the client-speakers and recreate them with new outputs.

Instance Variables:
	manager	-	The QSpeakerManager that manages this speaker.
	streamID	-	ID of the media stream that audio data is received from.
	subscription	- 	Subscription to the media stream that audio data is received from.
	soundOutput -	Instance of QVoiceChat.  Interface to low-level audio output (Squeak/OpenAL).
	transform	-	Position of the speaker; used for spatializing sound.
	isMute		-	Whether this speaker is muted (even if the state of it's replicated speaker
					would suggest that it should be audible).
	isAudible	-	Given the position of the listener, is the speaker audible?  Updated each
					render cycle.
	isLoopback	-	For testing, we sometimes want to receive our own audio all the way from 
					the router instead taking a local shortcut.
	mediaController - The controller that we receive streaming audio data from.
	soundRegion - 	Identifies the region the speaker is currently in (for attenuation).
	regionAttenuation - 	Ranges from 0 (none) to 1 (complete) attenuation. 
	currentAttenuation -	Caches the current region-based attenuation factor.
	mutex		-	For synchronization.

SANITY CHECKING:
We've observed that we sometimes don't hear audio even though the volume icon in the users-pane shows that the microphone is picking up audio.  This is baaaad, so we piggy-back on the user-pane notification event to ensure that we are receiving audio.  If we are not, then we silently mail an error report.  Hopefully this will help to track down the underlying problem.!

!QClientSpeaker class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QClientSpeaker class methodsFor: 'instance creation' stamp: 'ar 10/22/2007 12:23'!
for: replicatedObjectRef manager: speakerManager controller: aController
	^(self new)
		mediaController: aController;
		manager: speakerManager; 
		ref: replicatedObjectRef;
		yourself! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'jcg 8/19/2009 15:36'!
audioFormat
	"Answer a QAudioFormat."
	^audioFormat! !

!QClientSpeaker methodsFor: 'actions' stamp: 'jcg 4/10/2010 12:58'!
audioFormat: newFormat "aQAudioFormat"
	audioSession isInTurn ifFalse: [self future audioFormat: newFormat].
	audioFormat = newFormat ifTrue: [^self "nothing to do"].
	audioFormat := newFormat.
	self destroySpeakerOutput.
	(isPlaying and: [audioFormat notNil]) ifTrue: [self createSpeakerOutput]! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'bgf 7/29/2007 22:33'!
audioInterface
	^ self audioSession ifNotNilDo: [ :session | session audioInterface ]! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'bgf 7/29/2007 22:33'!
audioSession
	^ manager ifNotNil: [manager audioSession]! !

!QClientSpeaker methodsFor: 'initialize' stamp: 'bgf 4/7/2008 22:43'!
beLoopbackSound
	"Become loopback - resubscribe with the stream forced through the router."
	self beLoopbackSound: true! !

!QClientSpeaker methodsFor: 'initialize' stamp: 'jcg 2/26/2009 15:42'!
beLoopbackSound: bLoop
	"Turn myself into a loop-back sound, 
	 forcing to send data all the way upstream and back,
	 or if bLoop is false, stop that effect and go back to a normal subscription."
	mutex critical: [
		isLoopback := bLoop.

		"HACK.  We only expect this to be called on a voice-chat speaker.  However, instead of just sending #streamID: to ourselves, we send it to our 'speakerInput'... in the case that it is something other than a QClientSpeakerChatInput, we can notice and log a warning."
		speakerInput 
			ifNil: [self streamID: (ref get: #streamID)]
			ifNotNilDo: [:in | in streamID: (ref get: #streamID)].
	].
! !

!QClientSpeaker methodsFor: 'playing' stamp: 'jcg 8/19/2009 12:33'!
beginSilentPeriod
	"There won't be any sound-data pushed into the output for an indefinite period.  Notify the output so that it can react however is appropriate."
	speakerOutput ifNotNilDo: [:out | out beginSilentPeriod]! !

!QClientSpeaker methodsFor: 'private' stamp: 'crl 5/3/2010 10:32'!
createSpeakerOutput
	audioSession assertIsInTurn.
	mutex critical: [
		| interface |
		self destroySpeakerOutput.
		interface := self audioInterface ifNil: [
			QLogger logWarning: 'no audio-interface; cannot create speaker-input'.
			^self
		].
		audioFormat ifNil: [
			"This always happens for a newly-created speaker (when #play is called).
			 Don't worry about it."
			^self
		].
		QLogger logInfo: 'creating speaker output for ', self objectID hex.
		speakerOutput := manager createSpeakerOutputFor: audioFormat.
		speakerOutput speaker: self.
		speakerOutput attenuation: self currentAttenuation.
		speakerOutput volume: volume.
		speakerOutput jitterBufferActivityThreshold: jitterBufferActivityThreshold.
		isPlaying
			ifTrue: [speakerOutput play]
			ifFalse: [speakerOutput stop].
		speakerOutput updatePlayState.
	].
	"Since speakers ignore xform updates until there is an output,
	 and region changes may be signaled before any of this is listening."
	self setupTransform! !

!QClientSpeaker methodsFor: 'hacks' stamp: 'jcg 2/26/2009 17:13'!
critical: aBlock
	mutex critical: [aBlock value]! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'bgf 2/19/2008 16:56'!
currentAttenuation
	"The current attenuation imposed by sound region rules;
	 varies as the listener and the speakers move."
	^ currentAttenuation! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'jcg 2/26/2009 11:15'!
currentAttenuation: aScalar
	"The current attenuation imposed by sound region rules;
	 varies as the listener and the speakers move."
	currentAttenuation := aScalar.	
	speakerOutput ifNotNil: [ speakerOutput attenuation: aScalar ].! !

!QClientSpeaker methodsFor: 'initialize' stamp: 'jcg 5/19/2010 00:45'!
destroy
	"This is done indirectly through the manager to preserve top-down lock acquisition;
	 see privateDestroy for the meat of the method.
	 In subclasses, extend privateDestroy - not this method!! "
	audioSession assertIsInTurn.
	manager 
		ifNil: [^self "already destroyed"]
		ifNotNilDo: [:m |
			manager := nil.
			self destroySpeakerInput; stop.
			m destroySpeaker: self.
			super destroy.
		]
! !

!QClientSpeaker methodsFor: 'private' stamp: 'jcg 2/26/2009 17:24'!
destroySpeakerInput
	mutex critical: [
		speakerInput ifNotNilDo: [:in | 
			speakerInput := nil.
			in destroy.
		]
	]
! !

!QClientSpeaker methodsFor: 'initialize' stamp: 'jcg 8/17/2009 14:00'!
destroySpeakerOutput
	mutex critical: [
		speakerOutput ifNotNilDo: [:out |
			speakerOutput := nil.
			out destroy
		].
	].! !

!QClientSpeaker methodsFor: 'future' stamp: 'jcg 4/11/2010 11:48'!
futureDo: aSelector at: deltaMSecs args: args
	"Enqueue a message on the event queue.  The compiler has been modified to generate this message when the #future message appears in the source code."
	audioSession 
		ifNotNil: [:sess | sess futureDo: aSelector receiver: self at: deltaMSecs args: args]
		ifNil: [QLogger logInfo: 'audioSession unavailable for future-send of #', aSelector].
	^nil
! !

!QClientSpeaker methodsFor: 'future' stamp: 'jcg 5/7/2010 11:59'!
futureSend: aSelector at: deltaMSecs args: args
	"Enqueue a message on the event queue.  The compiler has been modified to generate this message when the #future message appears in the source code.  Answers a promise that will be resolved with the result of performing the message."
	^audioSession 
		ifNotNil: [:sess | sess futureSend: aSelector receiver: self at: deltaMSecs args: args]
		ifNil: [
			QLogger logInfo: 'audioSession unavailable for future-send of #', aSelector.
			TPromise new fulfill: nil
		].
! !

!QClientSpeaker methodsFor: 'initialize' stamp: 'jcg 5/13/2010 15:16'!
initialize
	super initialize.
	isAudible := false. "assume that we can't be heard until we know better."
	isMe := false.
	isPlaying := false.
	isLoopback := false.
	volume := 0.0.
	regionAttenuation := 0.
	currentAttenuation := 0.
	jitterBufferActivityThreshold := 0. "off by default"
	mutex := Mutex new.! !

!QClientSpeaker methodsFor: 'initialize' stamp: 'jcg 4/10/2010 12:35'!
initializeForRef 
	super initializeForRef.
	transform := ref get: #globalTransformReal.
	self onRegionChanged: (ref get: #region).
	self onVolumeChanged: (ref get: #volume).
	(ref get: #isPlaying) ifTrue: [self play] ifFalse: [self stop].
	(ref get: #streamID) ifNotNilDo: [:id | self streamID: id].! !

!QClientSpeaker methodsFor: 'testing' stamp: 'jcg 2/26/2009 16:27'!
isAudible
	^isAudible! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'jcg 4/3/2008 13:35'!
isAudible: bool
	mutex critical: [
		isAudible == bool ifTrue: [^self].
		isAudible := bool.
		self updatePlayState.
	]! !

!QClientSpeaker methodsFor: 'testing' stamp: 'jcg 2/26/2009 17:33'!
isConnectedAndStreaming
	"#isConnectedAndPlaying sounds better, but would be misleading because #isPlaying has a distinct meaning."
	^speakerInput 
			ifNil: [false]
			ifNotNilDo: [:in | in isConnectedAndStreaming]! !

!QClientSpeaker methodsFor: 'initialize' stamp: 'crl 4/29/2010 16:06'!
isDestroyed 
	^manager isNil! !

!QClientSpeaker methodsFor: 'future' stamp: 'jcg 4/10/2010 12:19'!
isInTurn
	^audioSession isInTurn! !

!QClientSpeaker methodsFor: 'testing' stamp: 'jcg 2/26/2009 15:17'!
isLoopback
	"For voice-chat only... specify whether we want to force subscription to the router, rather than short-circuiting to the local media-controller."
	^isLoopback! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'bgf 9/8/2008 13:13'!
isMe
	"If true, this is the speaker for the local client's avatar...
	 set early during setup."
	^ isMe! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'bgf 9/8/2008 13:12'!
isMe: aBool
	"If true, this is the speaker for the local client's avatar...
	 set early during setup."
	isMe := aBool! !

!QClientSpeaker methodsFor: 'testing' stamp: 'bgf 4/8/2009 23:36'!
isMute
	"Is the speaker muted?  (True if there is no manager yet, or if the manager is muted.)"
	^ manager ifNil: [ true ] ifNotNil: [ manager isMute ]! !

!QClientSpeaker methodsFor: 'testing' stamp: 'jcg 2/23/2007 13:43'!
isPlaying
	^ isPlaying! !

!QClientSpeaker methodsFor: 'testing' stamp: 'jcg 2/26/2009 11:15'!
isRecordingForDebugging
	"Ask our voice-chat."
	speakerOutput ifNil: [^false].
	^speakerOutput isRecordingForDebugging! !

!QClientSpeaker methodsFor: 'testing' stamp: 'jcg 8/20/2009 15:45'!
isUsingJitterbuffer
	speakerOutput class == QClientSpeakerPortAudioOutput ifTrue: [^true].
	speakerOutput class == QClientSpeakerPipelineOutput 
		ifTrue: [^speakerOutput usesSpeexInput].
	^speakerOutput class == QClientSpeakerExternalOutput and:
									[QClientSpeakerExternalOutput useJitterbuffer]! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'ar 3/20/2009 16:54'!
jitterBufferActivityThreshold
	"The Speex jitter-buffer has a way to check the 'activity' (roughly, 'volume') of the previously decoded frame.  It also has a way to hint that 'now would be a good time to extrapolate or drop a frame'.  We use a heuristic that says 'when the activity is below a threshold, hint to the jitter-buffer that now is a good time to make time adjustments'.  This method sets this threshold."
	^jitterBufferActivityThreshold! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'jcg 2/26/2009 17:57'!
jitterBufferActivityThreshold: zeroTo100
	"The Speex jitter-buffer has a way to check the 'activity' (roughly, 'volume') of the previously decoded frame.  It also has a way to hint that 'now would be a good time to extrapolate or drop a frame'.  We use a heuristic that says 'when the activity is below a threshold, hint to the jitter-buffer that now is a good time to make time adjustments'.  This method sets this threshold."
	jitterBufferActivityThreshold = zeroTo100 ifTrue: [^self "no change"].
	jitterBufferActivityThreshold := zeroTo100.
	speakerOutput ifNotNilDo: [:out | out jitterBufferActivityThreshold: zeroTo100].! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'ar 12/4/2008 16:50'!
jitterStats
	"Audio jitter statistics"
	^jitterStats! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'jcg 2/26/2009 17:53'!
jitterStats: aTWindowedStats
	"Audio jitter statistics"
	jitterStats := aTWindowedStats.
	speakerInput ifNotNilDo: [:in | in jitterStats: jitterStats]! !

!QClientSpeaker methodsFor: 'actions' stamp: 'bgf 8/8/2009 04:08'!
listenerRegion: aRegionRef attenuation: listenerRegionAttenuation

	"One of us (this speaker, or the listener) has changed sound regions.
	 Update with appropriate attenuation."

	| attenuation |
	(soundRegion value = aRegionRef  value) ifTrue: [
		^ self currentAttenuation: 0.0
	].

	aRegionRef isValidFarRef ifFalse: [
		"The listener is not in a region."
		^ self currentAttenuation: regionAttenuation.
	].

	soundRegion isValidFarRef ifFalse: [
		"I am not in a region."
		^ self currentAttenuation: listenerRegionAttenuation.
	].

	soundRegion island = aRegionRef island ifFalse: [
		"The listener is not in my island...
	 	 QClientSpeakers are kept for all islands, not just the active one.".
		^ self currentAttenuation: 0.0
	].

	"We're both in regions... let the Region decide the value,
	 so that in-space details like connecting-doors can be handled on-island."
	attenuation := (soundRegion get: #combinedAttenuation: with: aRegionRef).

	self currentAttenuation: (attenuation ifNil: [ 0.0 ] ).

! !

!QClientSpeaker methodsFor: 'initialize' stamp: 'jcg 5/24/2010 12:01'!
manager: aQSpeakerManager
	"Should only be called during speaker creation/initialization."
	(manager notNil or: [audioSession notNil])  
		ifTrue: [self error: 'speaker-manager has already been set'].
	aQSpeakerManager ifNil: [self error: 'new speaker-manager cannot be nil'].
	manager := aQSpeakerManager.
	audioSession := manager audioSession.
	audioSession ifNil: [self error: 'speaker-manager audio-session is nil'].
! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'ar 10/17/2007 11:48'!
mediaController
	^mediaController! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'ar 10/1/2007 14:59'!
mediaController: aMediaController
	mediaController := aMediaController! !

!QClientSpeaker methodsFor: 'actions' stamp: 'bgf 4/9/2009 01:33'!
mutingChanged
	"From manager, when it has muted or unmuted sound"
	mutex critical: [
		self updatePlayState.
	]! !

!QClientSpeaker methodsFor: 'initialize' stamp: 'jcg 4/10/2010 13:23'!
newInputOfClass: speakerInputClass
	| newInput |
	audioSession assertIsInTurn.
	newInput := speakerInputClass new.
	newInput speaker: self.
	self speakerInput: newInput.
	^newInput! !

!QClientSpeaker methodsFor: 'events' stamp: 'jcg 4/10/2010 15:28'!
onDestroy
	"This must happen in the QAudioSession's event loop."
	self future destroy.! !

!QClientSpeaker methodsFor: 'events' stamp: 'jcg 4/10/2010 12:26'!
onPlay
	"React to event from island... handle within QAudioSession event-loop."
	self future play! !

!QClientSpeaker methodsFor: 'events' stamp: 'ar 5/28/2010 10:18'!
onRegionChanged: region
	"I've moved to a new sound region... update my attenuation 
	 with new rules for the current listener region."
	(region notNil and: [region isValidFarRef not]) 
		ifTrue: [^QLogger logWarning: 'region is not a valid far-ref'].
	soundRegion == region ifFalse: [
		soundRegion := region.
		"Keep trying until region is resolved, or we tried for too long, or...
		 (see that method comment)."
		self future regionChanged: region tryAgainIn: 100.
	].
! !

!QClientSpeaker methodsFor: 'events' stamp: 'jcg 4/10/2010 12:26'!
onStop
	"React to event from island... handle within QAudioSession event-loop."
	self future stop! !

!QClientSpeaker methodsFor: 'events' stamp: 'jcg 4/10/2010 12:26'!
onStreamChanged: newStreamID
	"React to event from island... handle within QAudioSession event-loop."
	self future streamID: newStreamID! !

!QClientSpeaker methodsFor: 'events' stamp: 'jcg 4/10/2010 12:28'!
onUpdateTransform
	"React to event from island... handle within QAudioSession event-loop."
	self future updateTransform! !

!QClientSpeaker methodsFor: 'events' stamp: 'jcg 4/10/2010 12:53'!
onVolumeChanged: newVolume
	"React to event from island... handle within QAudioSession event-loop."
	self future volumeChanged: newVolume.! !

!QClientSpeaker methodsFor: 'actions' stamp: 'jcg 4/10/2010 12:23'!
play	
	audioSession assertIsInTurn.
	self audioInterface ifNil: [ ^ self ].
	mutex critical: [
		isPlaying ifTrue: [^self "already playing"].
		manager ifNil: [^self "destroyed"].
		isPlaying := true.
		self updatePlayState.
	].
	self createSpeakerOutput.! !

!QClientSpeaker methodsFor: 'playing' stamp: 'jcg 6/4/2010 12:36'!
playSoundData: data timestamp: timestamp
	| timeSinceDeath |
	"Stab in the dark about the 'fast-echo' bug: maybe we're still playing audio through
	 a dead speaker.  We don't have a hypothesis about how this would happen (I went 
	 through the code looking for a way), but we certainly want to notice/circumvent it."
	timeSinceDeath := self timeSinceDeath.
	(timeSinceDeath notNil and: [timeSinceDeath > 2000]) ifTrue: [
		^QLogger 
			logWarning: 
				(speakerInput ifNil: ['<no speaker input>'] ifNotNil: [speakerInput printString]),	
				' is trying to play audio through speaker that has been dead for ', 
				(timeSinceDeath // 1000), ' seconds'
			 every: 10000
	].

	speakerOutput 
		ifNotNilDo: [:out | out playSoundData: data timestamp: timestamp]
		ifNil: [QLogger logWarning: 'speaker has no output' every: 10000 "msecs"].! !

!QClientSpeaker methodsFor: 'printing' stamp: 'jcg 2/26/2009 17:49'!
printStatisticsOn: strm
	speakerInput
		ifNil: [strm nextPutAll: 'Speaker with no audio-source']
		ifNotNilDo: [:in | in printStatisticsOn: strm].
! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'bgf 2/19/2008 16:11'!
regionAttenuation
	"The sound attenuation imposed by the boundary of my sound region."
	^ regionAttenuation! !

!QClientSpeaker methodsFor: 'private' stamp: 'jcg 5/6/2010 15:25'!
regionChanged: region tryAgainIn: delayMSecs
	"I've moved to a new sound region... update my attenuation 
	 with new rules for the current listener region."
	soundRegion == region 
		ifFalse: [^QLogger logInfo: 'giving up on this region... there is a newer one'].
	manager ifNil: [^QLogger logInfo: 'giving up on this region... no manager'].

	"If the region is nil, or it is already resolved, then we'll skip over this."
	(region notNil and: [region isResolved not]) ifTrue: [
		"If we haven't already waited too long, wait again."
		delayMSecs > 1700 
			ifTrue: [QLogger logWarning: 'waited too long for region to resolve']
			ifFalse: [(self future: delayMSecs)  
						regionChanged: region 
						tryAgainIn: delayMSecs+100].
		^self "not resolved yet"
	].
	"If we're here, then the region has resolved."
	regionAttenuation := (region get:#attenuation) ifNil: [0.0].
	manager ifNotNilDo: [:man |
		self listenerRegion: man listenerRegion attenuation: man regionAttenuation
	].
! !

!QClientSpeaker methodsFor: 'initialize' stamp: 'jcg 5/5/2010 17:53'!
registerForEvents
	super registerForEvents.
	self runScript: #onStreamChanged: when: { ref. #streamChanged }.
	self runScript: #onPlay when: { ref. #playStarted }.
	self runScript: #onStop when: { ref. #playStopped }.
	self runScript: #onUpdateTransform when: { ref. #frameChanged }.

	self runScript: #onRegionChanged: when: { ref . #regionChanged }.
	self runScript: #onVolumeChanged: when: { ref. #volumeChanged }.
	
	"Used for sanity-checking that audio is getting through when it should."
	"XXXX: disabled... we're getting no useful information from this."
	false ifTrue: [self startScript: #sanityCheckSpeakerActivity when: { ref. #activity }].! !

!QClientSpeaker methodsFor: 'private-scripts' stamp: 'jcg 2/26/2009 18:25'!
sanityCheckSpeakerActivity 	
	"Listen for the replicated #action events that are used to update speech icons in the user-list... use it as a cue to sanity-check whether we are hearing sound.  We delegate the actual checking to our speaker-input."

	mutex critical: [
		speakerInput ifNil: [
			"Nobody to check sanity!!"
			^QLogger 
				logWarning: 'no input to check sanity in speaker: ', self objectID hex
				every: 20000 "msec".
		].
		speakerInput sanityCheckSpeakerActivity.
	]! !

!QClientSpeaker methodsFor: 'actions' stamp: 'jcg 4/10/2010 12:46'!
setupTransform
	"For setup, make sure both the sound region and the transform are current."
	self updateTransform.
	ref isValidFarRef ifTrue: [
		self onRegionChanged: (ref get: #region).
	].! !

!QClientSpeaker methodsFor: 'testing' stamp: 'jcg 11/16/2009 18:15'!
shouldPlayStream
	"Answer whether the input should play the stream associated with this 
	speaker or not."

	"If it's not audible (from the 3D avatar's point of view), it's not audible.  Period."
	isAudible ifFalse: [^false].

	"If sound output is not globally muted (and 'isPlaying', which IIRC is always true),
	 then it's audible."
	(self isMute not & isPlaying) ifTrue: [^true].

	"Last chance... if we're recording audio, and it's not the speaker attached to our 
	 avatar, then play the stream.  However, we use a separate path to record directly 
	 from the microphone, so if the speaker corresponds to our avatar, don't play the 
	 stream."
	isMe ifTrue: [^false].
	manager ifNotNilDo: [:m | m isRecordingSession ifTrue: [^true]].

	"If we fall through to here, then no-one wants to hear this speaker.  Don't play."
	^false 
! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'jcg 3/30/2009 16:41'!
sourceDescription
	"Textual description of the source of this audio."
	^speakerInput ifNil: ['(no description)'] ifNotNil: [speakerInput sourceDescription]! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'ar 3/17/2009 10:48'!
speakerInput
	^speakerInput! !

!QClientSpeaker methodsFor: 'initialize' stamp: 'jcg 4/10/2010 13:15'!
speakerInput: newSpeakerInput
	speakerInput == newSpeakerInput ifTrue: [^self "no change"].
	self destroySpeakerInput.
	speakerInput := newSpeakerInput.
	speakerInput ifNotNil: [speakerInput updatePlayState].! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'jcg 8/21/2009 12:38'!
speakerManager
	^manager! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'jcg 2/26/2009 11:54'!
speakerOutput
	^speakerOutput! !

!QClientSpeaker methodsFor: 'actions' stamp: 'jcg 4/10/2010 12:23'!
stop
	audioSession assertIsInTurn.
	mutex critical: [
		self destroySpeakerOutput.
		isPlaying ifFalse: [^self "already stopped"].
		isPlaying := false.
		self updatePlayState.
	]! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'jcg 2/26/2009 15:35'!
streamID
	"Support for finding a speaker by its streamID.  This only makes sense for voice-chat, since other QClientSpeakerInput subclasses don't use a replicated streamID to connect to their stream."
	^speakerInput ifNotNilDo: [:in | in streamID].
! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'jcg 5/19/2010 17:26'!
streamID: newStreamID
	"Only used for setting up a speaker-input for voice-chat... the other user of QClientSpeaker (the QNetVid* classes) set it directly via #speakerInput:."
	audioSession assertIsInTurn.

	(speakerInput notNil and: [speakerInput streamID = newStreamID]) ifTrue: [^self].
	self destroySpeakerInput.
	newStreamID ifNil: [^self].
	speakerInput := QClientSpeakerChatInput forSpeaker: self streamID: newStreamID.
! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'ar 3/20/2009 17:07'!
transform
	^transform! !

!QClientSpeaker methodsFor: 'private' stamp: 'jcg 4/3/2008 23:53'!
ui
	"Answer the QwaqParticipantUI."
	manager ifNil: [^nil].
	^manager view ifNotNilDo: [:v | v owner]! !

!QClientSpeaker methodsFor: 'private' stamp: 'bgf 9/24/2009 09:45'!
updateAudibleForView: tview audioSession: audSession
	"Update isAudible: to the current situation for this speaker.
	 Is the user still in the space with this sound, etc..."
	self isAudible: (
		ref isValidFarRef 
		and: [ ref island = tview activeIsland ]
		and: [ 
			"Note that we only get here if the islands match,
	 		 so when doing the global step check 'updateAllIslands',
	 		 we do very little for speakers in non-current islands."
			(tview owner roundTripSound = self)	
			or: [ 
				"Rather than risking lockup here, 
			       use the previous state if we can't get...
				 this test result changes only rarely.."
				ref critical: [ ref get: #isAudibleToAvatar: with: (tview avatar replica) ]
					ifLocked: [ isAudible ] ]
		] ).! !

!QClientSpeaker methodsFor: 'private' stamp: 'jcg 1/12/2010 23:20'!
updatePlayState
	"Integrate a number of factors to decide whether we are currently playing or not."

	"NOTE: does not need to be in a critical section because all callers are in critical 
sections."

"	mutex critical: ["
		speakerInput ifNotNilDo: [:in | in updatePlayState].
		speakerOutput ifNotNilDo: [:out | out updatePlayState].
"	]."
	! !

!QClientSpeaker methodsFor: 'actions' stamp: 'jcg 4/10/2010 12:28'!
updateTransform
	| lp sp rt |	
	audioSession assertIsInTurn.
	manager ifNil: [ ^ self ].		"Reset check"
	speakerOutput ifNil: [ ^ self ].
	sp := ref get: #globalTransformReal.
	sp ifNil: [ ^ self ].

	self isMe ifFalse: [
		"Don't let a speaker stand directly beside me, the stereo is too extreme."
		manager ifNil: [ ^ self ].		"Reset check"
		lp := manager listenerTransform.
		lp ifNotNil: [
			rt := lp inverse transformPoint: (sp translation).
			rt z abs < (rt x abs * 0.35) ifTrue: [
				sp translation: sp translation + (lp lookAt * 1.5 * (rt x)).
			] ifFalse: [
				"Numerical problem observed in Mac OS listener is front-on-center to the listener...
	 			 the sound audibility is completely lost in some numerical black hole."
				(rt x abs < 0.1) ifTrue: [
					sp addRotationAroundY: 2.
				]].
		]].

	speakerOutput ifNotNil: [speakerOutput updateTransform: sp].
	transform := sp.! !

!QClientSpeaker methodsFor: 'accessing' stamp: 'ar 3/20/2009 17:07'!
volume
	^volume! !

!QClientSpeaker methodsFor: 'private' stamp: 'jcg 4/10/2010 12:53'!
volumeChanged: newVolume
	volume := newVolume.
	speakerOutput ifNotNilDo: [:out | out volume: newVolume].! !

TClientObject subclass: #QSoundFramePlayer
	instanceVariableNames: 'audioSession referenceDistance maxDistance gain transform isLooping isAudible docRequest'
	classVariableNames: ''
	poolDictionaries: 'OpenALConstants'
	category: 'Qwaq-Sound-Session'!

!QSoundFramePlayer commentStamp: '<historical>' prior: 0!
(c) 2007 Qwaq Inc.  QSoundFramePlayer is an abstract class is responsible for playing the audio for its corresponding QSoundFrame.  It juggles multiple concerns:
	- subclasses allow the frame to play over multiple low-level sound APIs (eg: Squeak/OpenAL).
	- sounds are only audible if the listener is in the same space as the sound frame.
		(among other criteria)
	- looping sounds must play when they come into earshot, without a state change in the frame
	- the player/session must manage the limited number of sources supported by the hardware.
!

!QSoundFramePlayer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSoundFramePlayer class methodsFor: 'instance creation' stamp: 'jcg 5/19/2009 18:39'!
for: soundFrameRef in: audioSession
	^ self new
			audioSession: audioSession;
			ref: soundFrameRef;
			yourself! !

!QSoundFramePlayer methodsFor: 'initialize' stamp: 'jcg 5/19/2009 18:40'!
audioSession: sess "a QwaqAudioSession"
	audioSession := sess! !

!QSoundFramePlayer methodsFor: 'initialize' stamp: 'ar 4/16/2011 17:46'!
destroy
	"Subclasses should extend."

	"XXXXX: Don't want to call 'super destroy' because of the chance of destabilization
	 before 3.5 release."	
	death := Time millisecondClockValue.

	self scriptToSignalMapping do: [:assoc | self stopScript: assoc key]! !

!QSoundFramePlayer methodsFor: 'resources' stamp: 'bgf 1/29/2009 13:03'!
docRequest
	"If I'm waiting for shared-document retrieval, this is my DocumentRequest"
	^ docRequest! !

!QSoundFramePlayer methodsFor: 'resources' stamp: 'bgf 1/30/2009 02:20'!
docRequest: aDocRequest
	"If I'm waiting for shared-document retrieval, this is my DocumentRequest"

	docRequest := aDocRequest.
	self stopScript: #onFetchComplete:.
	docRequest ifNotNil: [
		self startScript: #onFetchComplete: when: { docRequest . #fetchComplete }.
	].
	! !

!QSoundFramePlayer methodsFor: 'accessing' stamp: 'jcg 2/25/2007 01:38'!
gain: newGain
	gain = newGain ifTrue: [^self "nothing changed"].
	gain := newGain.
	self updateGain! !

!QSoundFramePlayer methodsFor: 'private' stamp: 'jcg 5/19/2009 18:33'!
getSampledSound
	"Get the SampledSound for the sound-frame we're playing;
	 this is looked up in QSounds; only the sound's name is known on-island."

	| ss |
	ref isValidFarRef ifFalse: [ ^ nil ].
	audioSession ifNil: [ ^ nil ].

	"There are two alternatives... either a fixed soundEffect,
	 or a sound-resource that has been installed as a shared document."

	(ref get: #soundEffectName) ifNotNilDo: [ : effectName |
		ss := QSounds find: effectName.
		ss ifNil: [  QLogger logWarning: 'Unknown sound effect: ', effectName ].
		^ ss
		].

	(ref get: #cachedSoundURI) ifNotNilDo: [ :path |
		ss := QSounds current findSoundResource: path.
		ss ifNil: [
			| doc |
			"We don't have it yet... register interest in the fetching of it."
			doc := (ref get: #soundDocument).
			doc isValidFarRef ifTrue: [
				self docRequest: (audioSession documentManager ifNotNilDo: [ :dm | dm fetchDocument: doc]).
			]].
		^ ss
		].

	^ nil! !

!QSoundFramePlayer methodsFor: 'accessing' stamp: 'jcg 3/21/2007 16:56'!
id
	^ ref get: #objectID! !

!QSoundFramePlayer methodsFor: 'initialize' stamp: 'jcg 2/13/2007 10:09'!
initialize
	super initialize.
	isAudible := false.! !

!QSoundFramePlayer methodsFor: 'initialize' stamp: 'bgf 9/25/2009 20:09'!
initializeForRef
	super initializeForRef.
	referenceDistance := ref get: #referenceDistance.
	maxDistance := ref get: #maxDistance.
	gain := ref get: #gain.
	transform := ref get: #globalTransformReal .
	isLooping := ref get: #isLooping.
	self updateSampledSound.! !

!QSoundFramePlayer methodsFor: 'accessing' stamp: 'jcg 2/13/2007 15:33'!
isAudible: aBool
	"Subclasses should extend this method."
	isAudible := aBool.! !

!QSoundFramePlayer methodsFor: 'testing' stamp: 'jcg 2/26/2007 01:50'!
isLooping
	^ isLooping! !

!QSoundFramePlayer methodsFor: 'accessing' stamp: 'jcg 3/3/2007 02:24'!
looping: bool
	isLooping = bool ifTrue: [^self "nothing changed"].
	isLooping := bool.
	self updateLooping.
	! !

!QSoundFramePlayer methodsFor: 'accessing' stamp: 'bgf 1/28/2009 16:25'!
maxDistance: maxDist
	(maxDistance = maxDist) ifTrue: [^self "nothing changed"].
	maxDistance := maxDist.
	self updateMaxDistance.! !

!QSoundFramePlayer methodsFor: 'resources' stamp: 'bgf 1/29/2009 13:05'!
onFetchComplete: data
	"Signaled callback at conclusion of a document fetch attempt.
	 If we found the file, load it."
	data ifNotNil: [
		self updateSampledSound
	].
	self docRequest: nil.	  "Note: terminates me with a stopScript... don't add more below here."! !

!QSoundFramePlayer methodsFor: 'events' stamp: 'bgf 1/29/2009 13:08'!
onSampledSoundChanged
	"Signal from the sound-frame that its specified sound has changed."

	self docRequest: nil.	"I.e. disregard completion of any previous fetches."
	self updateSampledSound.! !

!QSoundFramePlayer methodsFor: 'events' stamp: 'jcg 5/19/2009 18:34'!
onUserClick: sessionID
	"A mouse-click on my sound-frame in the space.
	 Clicking a sound-frame does start/stop... 
	 and only the harness-side knows if I'm still playing, so we handle the click out here.
	 The on-island sound frame doesn't know how long a sound is, 
	 and doesn't know when the clients would have finished a previous play.

	 There is some risk of missing intentions, but it is quite small.
	 (I.e. if a user clicks to stop, 
	 and I run-out and stop during the event/signal roundtrip, then the click will do a start).   
	 But since it's never quite clear when a sound is fully run-to-end,
	 we can get away with a little imprecision at the tail-end of a sound.
	 The important thing is that starting a stopped sound works (albiet with lag)
	 and clicking when there is a lot of sound left should really stop.)"

	(audioSession isSessionOfUser: sessionID) ifTrue: [
		"The click came from my user... so I assume responsibility to handle it."
		ref isValidFarRef ifTrue: [
			self isPlaying ifTrue: [
				ref future userStop.
			] ifFalse: [
				ref future userPlay.
			]
		] ifFalse: [
			self stop.
		].
	].! !

!QSoundFramePlayer methodsFor: 'commands' stamp: 'jcg 2/14/2007 11:55'!
play
	isAudible ifFalse: [^self "Can't be heard, so don't play."].
	isLooping ifTrue: [^self "Is already playing in a loop, so don't play."].
	self privatePlay.! !

!QSoundFramePlayer methodsFor: 'private-abstract' stamp: 'jcg 2/13/2007 16:01'!
privatePlay
	self subclassResponsibility.! !

!QSoundFramePlayer methodsFor: 'accessing' stamp: 'jcg 2/25/2007 22:23'!
referenceDistance: refDist
	referenceDistance = refDist ifTrue: [^self "nothing changed"].
	referenceDistance := refDist.
	self updateReferenceDistance.! !

!QSoundFramePlayer methodsFor: 'initialize' stamp: 'jcg 3/28/2007 01:45'!
registerForEvents
	super registerForEvents.

	"TODO: this is a bit excessive, I think it would be better style to remove it."
	self scriptToSignalMapping do: 
		[:assoc | self runScript: assoc key when: { ref. assoc value }].! !

!QSoundFramePlayer methodsFor: 'initialize' stamp: 'bgf 1/29/2009 17:32'!
scriptToSignalMapping
	^	{ 
			#gain: -> #gainChanged .
			#play -> #startPlaying .
			#stop -> #stopPlaying .
			#looping: -> #loopingChanged .
			#onUserClick: -> #userClick .
			#updateTransformFromFrame -> #frameChanged .
			#maxDistance: -> #maxDistanceChanged .
			#referenceDistance: -> #referenceDistanceChanged .
			#onSampledSoundChanged -> #sampledSoundChanged .
			#destroy -> #destroyed .
		}! !

!QSoundFramePlayer methodsFor: 'commands' stamp: 'jcg 2/13/2007 17:04'!
stop
	self subclassResponsibility! !

!QSoundFramePlayer methodsFor: 'private' stamp: 'bgf 9/24/2009 09:45'!
updateAudibleForView: tview audioSession: audSession
	"Mark myself audible according to the current state of my sound-frame,
	 and whether my session's avatar is in the same space"

	self isAudible: (
		audSession soundEffectsAudible
		and: [ ref isValidFarRef ]
		and: [ ref island = tview activeIsland ]
		and: [ 
			"Note that we only get here if the islands match,
	 		 so when doing the global step check 'updateAllIslands',
	 		 we do very little for speakers in non-current islands."

			"Rather than risking lockup here,  use the previous state if we can't get...
			 this test result changes only rarely.."
			ref critical: [ ref get: #isAudibleToAvatar: with: (tview avatar replica) ]
				ifLocked: [ isAudible ] 
		] ).


! !

!QSoundFramePlayer methodsFor: 'private' stamp: 'jcg 2/25/2007 22:23'!
updateReferenceDistance
	self subclassResponsibility! !

!QSoundFramePlayer methodsFor: 'private-abstract' stamp: 'bgf 1/29/2009 12:32'!
updateSampledSound
	"Returns boolean true if a sound was loaded."
	self subclassResponsibility! !

!QSoundFramePlayer methodsFor: 'private' stamp: 'jcg 2/25/2007 01:31'!
updateTransform
	self subclassResponsibility! !

!QSoundFramePlayer methodsFor: 'events' stamp: 'jcg 3/21/2007 16:56'!
updateTransformFromFrame 
	| newTransform |
	newTransform := ref get: #globalTransform.
	transform = newTransform ifTrue: [^self "nothing changed"].
	transform := newTransform.
	self updateTransform.! !

QSoundFramePlayer subclass: #QSoundFramePlayerOpenAL
	instanceVariableNames: 'buffer source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Session'!

!QSoundFramePlayerOpenAL commentStamp: '<historical>' prior: 0!
(c) 2007 Qwaq Inc.  QSoundFramePlayerOpenAL is specialized to play sounds using OpenAL.!

!QSoundFramePlayerOpenAL class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSoundFramePlayerOpenAL class methodsFor: 'class initialization' stamp: 'bgf 3/9/2007 20:58'!
initialize
	"QSoundFramePlayerOpenAL initialize."
	Smalltalk addToShutDownList: self.! !

!QSoundFramePlayerOpenAL class methodsFor: 'class initialization' stamp: 'bgf 3/9/2007 21:18'!
shutDown: bQuitting
	super shutDown: bQuitting.

	"No matter what, we do not want sound source state in a saved image."
	self allInstancesDo: [ :i | [i destroySource] on: Error do: [:exc|] ]. ! !

!QSoundFramePlayerOpenAL methodsFor: 'private' stamp: 'bgf 9/8/2008 02:48'!
createSource
	source := QSoundSource new.
	source
		referenceDistance: referenceDistance;
		maxDistance: maxDistance;
		gain: gain;
		position: transform translation;
		direction: transform lookAt;
		looping: isLooping.
	buffer ifNotNil: [source buffer: buffer].

	"Force low-level OpenAL initialization."
	self openAL ifNotNilDo: [ : oal |
		oal nameOf: source.
	].
	^ source.! !

!QSoundFramePlayerOpenAL methodsFor: 'initialize' stamp: 'bgf 8/10/2007 00:12'!
destroy
	super destroy.
	self destroySource.
	buffer ifNotNil: [
		buffer destroy.
		buffer := nil.
	].

! !

!QSoundFramePlayerOpenAL methodsFor: 'private' stamp: 'bgf 8/7/2007 22:46'!
destroySource
	| id |
	source ifNotNil: [
		source stop.
		source destroy.
		source := nil.
	].! !

!QSoundFramePlayerOpenAL methodsFor: 'accessing' stamp: 'jcg 2/14/2007 13:59'!
isAudible: bool
	super isAudible: bool.
	isAudible 
		ifTrue: [
			(isLooping and: [source isNil]) ifTrue: [
				self createSource play.
			].
			source ifNotNil: [
				(self isSourceReallyPlaying: source) ifFalse: [self destroySource].
			].
		]
		ifFalse: [self destroySource]! !

!QSoundFramePlayerOpenAL methodsFor: 'accessing' stamp: 'bgf 1/29/2009 17:40'!
isPlaying
	^source notNil and: [self isSourceReallyPlaying: source ]! !

!QSoundFramePlayerOpenAL methodsFor: 'private' stamp: 'bgf 2/10/2009 21:57'!
isSourceReallyPlaying: src
	"Sigh.  Sending #isPlaying to the source only tests an instance variable; it doesn't ask OpenAL whether the source is really playing (eg: the sound might be finished)."
	| name |
	self openAL ifNotNilDo: [ : oal |
		name := oal nameOf: src ifAbsent: [nil].
		^ name ifNil: [false] ifNotNil: [name isPlaying]
	] ifNil: [
		^ false
	].! !

!QSoundFramePlayerOpenAL methodsFor: 'private' stamp: 'jcg 5/19/2009 18:35'!
openAL
	^ audioSession openAL! !

!QSoundFramePlayerOpenAL methodsFor: 'private' stamp: 'bgf 12/3/2007 23:40'!
privatePlay

	self openAL ifNotNilDo: [ :oal |
		source ifNil: [self createSource].
		oal log: 'player play'.
		(self isSourceReallyPlaying: source) ifFalse: [source play].
	].
! !

!QSoundFramePlayerOpenAL methodsFor: 'commands' stamp: 'jcg 2/19/2007 11:56'!
stop
	self destroySource.! !

!QSoundFramePlayerOpenAL methodsFor: 'private' stamp: 'jcg 2/25/2007 01:37'!
updateGain
	source ifNotNil: [source gain: gain]! !

!QSoundFramePlayerOpenAL methodsFor: 'private' stamp: 'jcg 2/25/2007 01:41'!
updateLooping
	source ifNotNil: [source looping: isLooping].! !

!QSoundFramePlayerOpenAL methodsFor: 'private' stamp: 'bgf 1/28/2009 16:24'!
updateMaxDistance
	source ifNotNil: [source maxDistance: maxDistance].! !

!QSoundFramePlayerOpenAL methodsFor: 'private' stamp: 'jcg 2/25/2007 22:24'!
updateReferenceDistance
	source ifNotNil: [source referenceDistance: referenceDistance].! !

!QSoundFramePlayerOpenAL methodsFor: 'private' stamp: 'bgf 2/25/2009 22:33'!
updateSampledSound
	| soundBuffer ss audioFormat |

	self destroySource.  "Source will be lazily recreated with the new buffer."
	buffer ifNotNil: [
		buffer destroy.  
		buffer := nil.
	].

	ss := self getSampledSound.
	ss ifNil: [ ^ false ].

	soundBuffer := ss samples.
	audioFormat := ss isStereo ifTrue: [ALFormatStereo16]
							    ifFalse: [ALFormatMono16].
	soundBuffer ifNotNil: [
		self openAL ifNotNilDo: [ :oal | oal log: 'new player buffer'].
		buffer := QOpenALBuffer
						data: soundBuffer
						samplingRate: (ss isStereo ifTrue:  [ ss originalSamplingRate // 2 ] ifFalse: [ ss originalSamplingRate ])
						format: audioFormat.

			"Brad notes... the only reason for the // 2 above is that it works on a high-rate stereo sound
	 		 that plays too fast if basic rate is used.  Seems Squeak treats stereo as two sampled-sounds,
		       and OpenAl has a different way to talk about the rate for the mixed thing.  Qwaq Mantis 1115."
	].

	^ buffer notNil
! !

!QSoundFramePlayerOpenAL methodsFor: 'private' stamp: 'jcg 2/25/2007 01:32'!
updateTransform
	source ifNotNil: [
		source position: transform translation.
		source direction: transform lookAt.
	]! !

QSoundFramePlayer subclass: #QSoundFramePlayerSqueak
	instanceVariableNames: 'sound'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Session'!

!QSoundFramePlayerSqueak commentStamp: '<historical>' prior: 0!
(c) 2007 Qwaq Inc.  QSoundFramePlayerSqueak is specialized to play sounds through Squeak's built-in audio APIs.!

!QSoundFramePlayerSqueak class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSoundFramePlayerSqueak methodsFor: 'private' stamp: 'jcg 2/15/2007 01:20'!
computeIterationCount
	"Answer a value appropriate for a RepeatingSound."
	^ isLooping ifTrue: [#forever] ifFalse: [1]! !

!QSoundFramePlayerSqueak methodsFor: 'concrete' stamp: 'jcg 2/19/2007 18:33'!
destroy
	super destroy.
	self stop! !

!QSoundFramePlayerSqueak methodsFor: 'private' stamp: 'jcg 2/26/2007 01:53'!
invalidateOutputVolume
	"We pseudo-spatialze sounds only as we begin to play them (not throughout their duration), except in the case of looping sounds."

	(isLooping & isAudible) ifTrue: [self pseudoSpatializeSound]! !

!QSoundFramePlayerSqueak methodsFor: 'accessing' stamp: 'jcg 2/15/2007 01:51'!
isAudible: aBool
	super isAudible: aBool.
	isAudible
		ifFalse: [self stop]
		ifTrue: [
			(isLooping and: [self isPlaying not]) ifTrue: [self privatePlay].
		].! !

!QSoundFramePlayerSqueak methodsFor: 'private' stamp: 'bgf 1/10/2009 12:30'!
isPlaying
	^ sound notNil and: [SoundPlayer isPlaying: sound]! !

!QSoundFramePlayerSqueak methodsFor: 'private' stamp: 'jcg 2/25/2007 19:52'!
privatePlay
	sound ifNil: [^self "no sound to play"].
	(SoundPlayer isPlaying: sound) ifTrue: [^self "already playing the sound"].
	self pseudoSpatializeSound. "based on relative position between listener and sound"
	SoundPlayer playSound: sound.! !

!QSoundFramePlayerSqueak methodsFor: 'private' stamp: 'jcg 5/19/2009 18:35'!
pseudoSpatializeSound

	"XXXX: should reduce code duplication by using #pseudoSpatializationParametersFor:referenceDistance: ...  I didn't merge them at this point so as not to risk regressions right before GA."

	"We base this on the 'Inverse Distance Clamped' OpenAL attenuation model :
	gain = AL_REFERENCE_DISTANCE / 
				(AL_REFERENCE_DISTANCE + AL_ROLLOFF_FACTOR *
														(distance - AL_REFERENCE_DISTANCE)); "

	"TODO: Handle different ROLLOFF_FACTORs; we currently always use the default of 1 because no Croquet code sets it."
	| vector distance rollOff attenuationFactor earVector pan |

	sound ifNil: [ ^ self ].
	vector := self vectorFromListenerToSound.
	distance := vector length.
	rollOff := 1.0.

	"Compute the amount that the sound is attenuated due to distance."
	attenuationFactor := referenceDistance / 
							(referenceDistance + (rollOff * (distance - referenceDistance))).
	attenuationFactor := attenuationFactor min: 1.0 max: 0.0.

	"Compute the orientation relative to the listener's right ear."
	earVector := audioSession listenerTransform lookSide.
	pan := ((earVector normalized dot: vector normalized) + 1) / 2.

	sound sound "a QMixedSound" adjustSoundAt: 1 pan: pan volume: attenuationFactor * gain.! !

!QSoundFramePlayerSqueak methodsFor: 'concrete' stamp: 'bgf 1/10/2009 12:31'!
stop
	sound ifNotNil: [ SoundPlayer pauseSound: sound ].! !

!QSoundFramePlayerSqueak methodsFor: 'private' stamp: 'jcg 2/25/2007 01:39'!
updateGain
	sound ifNotNil: [sound loudness: gain]! !

!QSoundFramePlayerSqueak methodsFor: 'private' stamp: 'jcg 2/25/2007 01:41'!
updateLooping
	sound ifNotNil: [sound iterationCount: self computeIterationCount].
! !

!QSoundFramePlayerSqueak methodsFor: 'private' stamp: 'bgf 1/28/2009 16:24'!
updateMaxDistance
	self invalidateOutputVolume
! !

!QSoundFramePlayerSqueak methodsFor: 'private' stamp: 'jcg 2/25/2007 22:23'!
updateReferenceDistance
	self invalidateOutputVolume
! !

!QSoundFramePlayerSqueak methodsFor: 'private' stamp: 'bgf 2/25/2009 23:02'!
updateSampledSound
	| mixedSound ss |

	self stop.
	sound := nil.

	ss := self getSampledSound.
	ss ifNil: [ ^ false ].

	(ss isKindOf: MixedSound) ifTrue: [

		"Won't be spatialized well, but should be audible."
		mixedSound := ss.

	] ifFalse: [
		mixedSound := QMixedSound new.
		mixedSound add: ss pan: 0.5 volume: gain.
		ss isStereo ifTrue: [
			QLogger logWarning: 'Stereo sound will not play properly when OpenAL is off.'.
		].
	].
	sound := RepeatingSound 
					repeat: mixedSound 
					count: self computeIterationCount.
	^ true! !

!QSoundFramePlayerSqueak methodsFor: 'private' stamp: 'jcg 2/25/2007 19:36'!
updateTransform
	self invalidateOutputVolume
! !

!QSoundFramePlayerSqueak methodsFor: 'private' stamp: 'jcg 5/19/2009 18:35'!
vectorFromListenerToSound
	^ transform translation - audioSession listenerPosition! !

QControlStreamOutput subclass: #QPhoneControlStreamOutput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Streams'!

!QPhoneControlStreamOutput commentStamp: '<historical>' prior: 0!
Only exists for the traffic-tag.

(I began adding a 'trafficTag' instance-variable to TMediaStreamEndpoint, but realized that there would need to be a way to propagate the tag downstream to other inputs/outputs... I didn't want to get into that right now).!

!QPhoneControlStreamOutput class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPhoneControlStreamOutput methodsFor: 'accessing' stamp: 'jcg 7/17/2008 16:10'!
trafficTag
	"Default categorization for traffic through the channel"
	^ ControlTag! !

TFrame subclass: #QSpeaker
	instanceVariableNames: 'isPlaying streamID region regionSigTime volume isForSecureVideo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Speaker'!

!QSpeaker commentStamp: '<historical>' prior: 0!
(c) 2007 Qwaq Inc.  QSpeaker acts as a speaker that plays spatialized sound that is transmitted over a media stream.  

The sound is actually played via a non-replicated QClientSpeaker that coordinates communication with the media router and interacts with the low-level sound API (Squeak sound or OpenAL).

Generates the following signals:
#playStarted	-	when speaker was paused, and then starts playing
#playStopped	-	when speaker was playing, then stops
#activity		-	when speaker is notified of sound activity at a particular volume
#streamChanged -	when router/streamID of the media stream changes

!

!QSpeaker class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSpeaker class methodsFor: 'accessing' stamp: 'bgf 1/17/2008 12:58'!
activityMessageInterval

	"Milliseconds between  showActivity:  future-sends 
	 that trigger visual reinforcement during sound transmission.
	 Determines the maximum rate at which future-sends are emitted
	 alongside the voice traffic of a single speaking user."
	
	^ 380! !

!QSpeaker class methodsFor: 'accessing' stamp: 'jcg 2/18/2007 22:11'!
resourceType
	^#streamingSpeakers! !

!QSpeaker methodsFor: 'controls' stamp: 'bgf 11/8/2008 15:13'!
destroy
	self streamID: nil.
	self stopPlaying.
	super destroy.
	self stopAllScripts.
	self unregisterResource.! !

!QSpeaker methodsFor: 'initialize' stamp: 'crl 4/19/2010 11:14'!
initialize
	super initialize.
	isPlaying := false.
	regionSigTime := nil.
	volume := 1.0.  "full volume"
	isForSecureVideo := false.

	self shouldPersist: false.	
		"Currently for use only as part of prebuilt components;
	 	 prevents round-trip sound creations from persisting."! !

!QSpeaker methodsFor: 'render' stamp: 'bgf 1/26/2009 14:21'!
isAudibleToAvatar: avatar 
	"Get-compatible sound-query: is this sound source audible to the given listener?
	 I'm not audible to myself 
	 (unless round-trip sound is enabled, in which case this test is not issued.)"

	^ (avatar notNil)
		and: [ self root  = avatar root ]
		and: [ (avatar isOrContains: self) not ]! !

!QSpeaker methodsFor: 'accessing' stamp: 'crl 4/15/2010 17:26'!
isForSecureVideo
	^isForSecureVideo! !

!QSpeaker methodsFor: 'testing' stamp: 'jcg 2/18/2007 20:57'!
isPlaying
	^ isPlaying! !

!QSpeaker methodsFor: 'accessing' stamp: 'crl 4/15/2010 17:25'!
markForSecureVideo
	isForSecureVideo := true! !

!QSpeaker methodsFor: 'accessing' stamp: 'bgf 6/10/2008 16:40'!
region
	"My current sound region"
	^ region! !

!QSpeaker methodsFor: 'accessing' stamp: 'bgf 12/4/2009 08:04'!
region: aSoundRegion

	| changed now |
	changed := false.
	region ~= aSoundRegion ifTrue: [
		region := aSoundRegion.
		changed := true.
	].

	"The signal (to a listener in the harness) is moderately expensive
	 in a crowded busy room; cap its frequency, as it is only here to repair discrepancies."
	now := Processor activeIsland millisecondClockValue.
	(changed 
		or: [ regionSigTime isNil ] 
		or: [ (Time milliseconds: now since: regionSigTime) > 500 ] )
	ifTrue: [
		"This is a trivial future simply to bump it into the next cycle.
		 (Lets addToNewSpace get the listener chain in place before the first signal.)"
		(self future: 1) signal: #regionChanged with: region.
		regionSigTime := now.
	].! !

!QSpeaker methodsFor: 'resources' stamp: 'jcg 2/18/2007 22:12'!
registerResource
	"Register this script as a resource"
	self island registerResource: self type: self resourceType.! !

!QSpeaker methodsFor: 'render' stamp: 'jcg 2/18/2007 20:55'!
renderFrame: ogl
	"Don't render anything."
	^ 0! !

!QSpeaker methodsFor: 'resources' stamp: 'jcg 2/18/2007 22:11'!
resourceType
	"Answer the resource type of the receiver"
	^self class resourceType! !

!QSpeaker methodsFor: 'accessing' stamp: 'bgf 4/8/2008 00:24'!
root: newRoot
	frameRoot 
		ifNotNil: [ self unregisterResource ].
	super root: newRoot.
	frameRoot 
		ifNotNil: [ self registerResource ].! !

!QSpeaker methodsFor: 'accessing' stamp: 'bgf 9/8/2008 14:26'!
sessionID
	^ (frameParent isKindOf: TAvatarReplica) ifTrue: [
		frameParent sessionID
	   ]! !

!QSpeaker methodsFor: 'persist' stamp: 'bgf 4/7/2009 22:07'!
shouldPersist
	"Speakers must be owned/managed by some container."
	^ false! !

!QSpeaker methodsFor: 'actions' stamp: 'jcg 2/18/2007 21:00'!
showActivity: volumeLevel
	"The avatar may want to indicate visually that I'm speaking."
	self signal: #activity with: volumeLevel.! !

!QSpeaker methodsFor: 'controls' stamp: 'bgf 11/8/2008 14:37'!
startPlaying
	isPlaying ifTrue: [^self "already stopped"].
	isPlaying := true.
	self signal: #playStarted.! !

!QSpeaker methodsFor: 'controls' stamp: 'bgf 11/8/2008 14:36'!
stopPlaying
	isPlaying ifFalse: [^self "already stopped"].
	isPlaying := false.
	self signal: #playStopped.! !

!QSpeaker methodsFor: 'accessing' stamp: 'jcg 2/18/2007 21:14'!
streamID
	^ streamID! !

!QSpeaker methodsFor: 'accessing' stamp: 'jcg 2/23/2007 11:06'!
streamID: newStreamID
	streamID = newStreamID ifTrue: [^self "nothing changed"].
	streamID := newStreamID.
	self signal: #streamChanged with: streamID! !

!QSpeaker methodsFor: 'resources' stamp: 'jcg 2/18/2007 22:12'!
unregisterResource
	"Unregister this script as a resource"
	self island unregisterResource: self type: self resourceType.! !

!QSpeaker methodsFor: 'accessing' stamp: 'bgf 9/24/2009 14:35'!
updateTransform

	self root ifNotNil: [
		super updateTransform.
		self region: (self root soundRegionContaining: (self globalTransform translation)).
	].! !

!QSpeaker methodsFor: 'accessing' stamp: 'jcg 3/17/2009 23:16'!
volume
	"Answer the volume level of this speaker, ranging from 0.0 to 1.0."
	^volume
! !

!QSpeaker methodsFor: 'accessing' stamp: 'jcg 3/17/2009 23:18'!
volume: newVolume
	"Set the volume level of this speaker, ranging from 0.0 to 1.0."
	volume = newVolume ifTrue: [^self "nothing changed"].
	volume := newVolume.
	self signal: #volumeChanged with: volume.! !

QControlStreamPublication subclass: #QAudioStreamPublication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Chat'!

!QAudioStreamPublication class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioStreamPublication class methodsFor: 'instance creation' stamp: 'jcg 3/6/2010 14:51'!
publishID: publishID mediaController: mediaController
	"We know what the input/output classes are, so don't require them as arguments."
	^self 
		publishID: publishID
		streamManager: mediaController mediaPlugin
		inputClass: TAudioStreamInput 
		outputClass: TAudioStreamOutput! !

!QAudioStreamPublication methodsFor: 'accessing' stamp: 'jcg 3/7/2010 00:32'!
jitter
	"Answer the 'send jitter' for our stream-input."
	^streamInput ifNotNil: [:in | in jitter]! !

QControlStreamPublication subclass: #QPhoneUserPublication
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Streams'!

!QPhoneUserPublication commentStamp: '<historical>' prior: 0!
Passes requests/commands to the QPhoneUser.!

!QPhoneUserPublication class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPhoneUserPublication methodsFor: 'datagram-handling' stamp: 'jcg 8/31/2008 14:55'!
handleCommand: dgram
	"Handle a command that has come up to the root of the multi-cast tree."
	^user handleCommandDatagram: dgram! !

!QPhoneUserPublication methodsFor: 'initialize' stamp: 'jcg 8/31/2008 14:52'!
user: aQPhoneUser
	user := aQPhoneUser! !

ExternalStructure subclass: #QAudioEncoderConfigAAC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'AACAudioObjectTypes'
	category: 'Qwaq-Sound-Codec'!

!QAudioEncoderConfigAAC commentStamp: 'jcg 4/15/2010 18:56' prior: 0!
MainConcept-specific parameters for creating an AAC encoder.

Values for "inputChannels":
1	mono
2	stereo
3	FL,FR,FC 					(front left-right-center)
4	FL,FR,FC,BC 				(front left-right-center, back center)
5	FL,FR,FC,BL,BR 				(front left-right-center, back left-right)
6	FL,FR,FC,LF,BL,BR  			(5.1 surround: front left-right-center, sub, back left-right)
8	FL,FR,FC,LF,BL,BR,SL,SR 	(7.1 surround: front left-right-center, sub, 
								 back left-right, side left-right)

Values for "mpegVersion"
6	MPEG2_AAC_AUDIO
7	MPEG4_AAC_AUDIO
16	MPEG4_AAC_AUDIO_PSP

Values for "aacObjectType"
2	AAC_LC	low-complexity
5	AAC_HE 	high-efficiency (unsupported)

Values for "audioBitrateIndex"
1		6kbits/sec
2		7kbits/sec
3		8kbits/sec
4		10kbits/sec
5		12kbits/sec
6		14kbits/sec
7		16kbits/sec
8		20kbits/sec
9		24kbits/sec
10		28kbits/sec
11		32kbits/sec
12		40kbits/sec
13		48kbits/sec
14		56kbits/sec
15		64kbits/sec
16		80kbits/sec
17		96kbits/sec
18		112kbits/sec
19		128kbits/sec
20		160kbits/sec
21		192kbits/sec
22		224kbits/sec
23		256kbits/sec
24		320kbits/sec
25		384kbits/sec
26		448kbits/sec
27		512kbits/sec
28		640kbits/sec
29		768kbits/sec
30		896kbits/sec
31		1024kbits/sec

Values for "headerType"
(we only support ADTS, but then strip off the header.  If we use "Raw"
 then we never see output from the recorder.   We've had no need yet
 for LATM/LOAS)
0		Raw
1		ADTS
2		LATM/LOAS

Values for "hfCutoff"
0				Use default for current sample rate
1				Don't use high-frequency cutoff
1000-40000	Remove all frequencies above the specified value

Values for "vbr"
0		Constant bitrate
1		Low-quality variable bitrate
2		Low-quality variable bitrate
3		Low-quality variable bitrate
4		Medium-quality variable bitrate
5		Medium-quality variable bitrate
6		Medium-quality variable bitrate
7		High-quality variable bitrate
8		High-quality variable bitrate
9		High-quality variable bitrate

Values for "he"
(value doesn't matter, because we only allow AAC_LC for "aacObjectType")
0		HE not used
1		HE implicit (v1)
2		HE implicit with PS (v2)

Values for "bitsPerSample"
8
16
24

Values for "protectAdtsStream"
(we don't support it because we're manually stripping off ADTS headers
 in QAudioEncoderAAC, and I don't know whether turning it on would break
 the code we use to strip the headers)
0		ADTS stream protection off
1		ADTS stream protection on	(unsupported)

!

!QAudioEncoderConfigAAC class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioEncoderConfigAAC class methodsFor: 'field definition' stamp: 'jcg 4/15/2010 18:05'!
fields
	"QAudioEncoderConfigAAC defineFields"

	^#(
		(inputChannels 'ulong')
		(mpegVersion 'ulong')
		(aacObjectType 'ulong')
		(audioBitrateIndex 'ulong')
		(headerType 'ulong')
		(hfCutoff 'ulong')
		(vbr 'ulong')
		(he 'ulong')
		(bitsPerSample 'ulong')
		(protectAdtsStream 'ulong')
		(reserved00 'ulong')
		(reserved01 'ulong')
		(reserved02 'ulong')
		(reserved03 'ulong')
		(reserved04 'ulong')
		(reserved05 'ulong')
		(reserved06 'ulong')
		(reserved07 'ulong')
		(reserved08 'ulong')
		(reserved09 'ulong')
		(reserved10 'ulong')
		(reserved11 'ulong')
		(reserved12 'ulong')
		(reserved13 'ulong')
		(reserved14 'ulong')
		(reserved15 'ulong')
		(reserved16 'ulong')
		(reserved17 'ulong')
		(reserved18 'ulong')
		(reserved19 'ulong')
		(reserved20 'ulong')
		(reserved21 'ulong')
		(reserved22 'ulong')
		(reserved23 'ulong')
		(reserved24 'ulong')
		(reserved25 'ulong')
		(reserved26 'ulong')
		(reserved27 'ulong')
		(reserved28 'ulong')
		(reserved29 'ulong')
		(reserved30 'ulong')
		(reserved31 'ulong')
		(reserved32 'ulong')
		(reserved33 'ulong')
		(reserved34 'ulong')
		(reserved35 'ulong')
		(reserved36 'ulong')
		(reserved37 'ulong')
		(reserved38 'ulong')
		(reserved39 'ulong')
		(reserved40 'ulong')
		(reserved41 'ulong')
		(reserved42 'ulong')
		(reserved43 'ulong')
		(reserved44 'ulong')
		(reserved45 'ulong')
		(reserved46 'ulong')
		(reserved47 'ulong')
		(reserved48 'ulong')
		(reserved49 'ulong')
		(reserved50 'ulong')
		(reserved51 'ulong')
		(reserved52 'ulong')
		(reserved53 'ulong')
	)! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
aacObjectType
	"This method was automatically generated"
	^handle unsignedLongAt: 9! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
aacObjectType: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 9 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
audioBitrateIndex
	"This method was automatically generated"
	^handle unsignedLongAt: 13! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
audioBitrateIndex: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 13 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
bitsPerSample
	"This method was automatically generated"
	^handle unsignedLongAt: 33! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
bitsPerSample: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 33 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
he
	"This method was automatically generated"
	^handle unsignedLongAt: 29! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
he: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 29 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
headerType
	"This method was automatically generated"
	^handle unsignedLongAt: 17! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
headerType: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 17 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
hfCutoff
	"This method was automatically generated"
	^handle unsignedLongAt: 21! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
hfCutoff: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 21 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
inputChannels
	"This method was automatically generated"
	^handle unsignedLongAt: 1! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
inputChannels: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 1 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
mpegVersion
	"This method was automatically generated"
	^handle unsignedLongAt: 5! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
mpegVersion: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 5 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
protectAdtsStream
	"This method was automatically generated"
	^handle unsignedLongAt: 37! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
protectAdtsStream: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 37 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved00
	"This method was automatically generated"
	^handle unsignedLongAt: 41! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved00: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 41 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved01
	"This method was automatically generated"
	^handle unsignedLongAt: 45! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved01: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 45 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved02
	"This method was automatically generated"
	^handle unsignedLongAt: 49! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved02: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 49 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved03
	"This method was automatically generated"
	^handle unsignedLongAt: 53! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved03: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 53 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved04
	"This method was automatically generated"
	^handle unsignedLongAt: 57! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved04: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 57 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved05
	"This method was automatically generated"
	^handle unsignedLongAt: 61! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved05: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 61 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved06
	"This method was automatically generated"
	^handle unsignedLongAt: 65! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved06: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 65 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved07
	"This method was automatically generated"
	^handle unsignedLongAt: 69! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved07: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 69 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved08
	"This method was automatically generated"
	^handle unsignedLongAt: 73! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved08: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 73 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved09
	"This method was automatically generated"
	^handle unsignedLongAt: 77! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved09: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 77 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved10
	"This method was automatically generated"
	^handle unsignedLongAt: 81! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved10: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 81 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved11
	"This method was automatically generated"
	^handle unsignedLongAt: 85! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved11: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 85 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved12
	"This method was automatically generated"
	^handle unsignedLongAt: 89! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved12: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 89 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved13
	"This method was automatically generated"
	^handle unsignedLongAt: 93! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved13: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 93 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved14
	"This method was automatically generated"
	^handle unsignedLongAt: 97! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved14: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 97 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved15
	"This method was automatically generated"
	^handle unsignedLongAt: 101! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved15: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 101 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved16
	"This method was automatically generated"
	^handle unsignedLongAt: 105! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved16: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 105 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved17
	"This method was automatically generated"
	^handle unsignedLongAt: 109! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved17: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 109 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved18
	"This method was automatically generated"
	^handle unsignedLongAt: 113! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved18: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 113 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved19
	"This method was automatically generated"
	^handle unsignedLongAt: 117! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved19: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 117 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved20
	"This method was automatically generated"
	^handle unsignedLongAt: 121! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved20: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 121 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved21
	"This method was automatically generated"
	^handle unsignedLongAt: 125! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved21: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 125 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved22
	"This method was automatically generated"
	^handle unsignedLongAt: 129! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved22: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 129 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved23
	"This method was automatically generated"
	^handle unsignedLongAt: 133! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved23: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 133 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved24
	"This method was automatically generated"
	^handle unsignedLongAt: 137! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved24: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 137 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved25
	"This method was automatically generated"
	^handle unsignedLongAt: 141! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved25: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 141 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved26
	"This method was automatically generated"
	^handle unsignedLongAt: 145! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved26: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 145 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved27
	"This method was automatically generated"
	^handle unsignedLongAt: 149! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved27: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 149 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved28
	"This method was automatically generated"
	^handle unsignedLongAt: 153! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved28: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 153 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved29
	"This method was automatically generated"
	^handle unsignedLongAt: 157! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved29: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 157 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved30
	"This method was automatically generated"
	^handle unsignedLongAt: 161! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved30: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 161 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved31
	"This method was automatically generated"
	^handle unsignedLongAt: 165! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved31: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 165 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved32
	"This method was automatically generated"
	^handle unsignedLongAt: 169! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved32: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 169 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved33
	"This method was automatically generated"
	^handle unsignedLongAt: 173! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved33: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 173 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved34
	"This method was automatically generated"
	^handle unsignedLongAt: 177! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved34: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 177 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved35
	"This method was automatically generated"
	^handle unsignedLongAt: 181! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved35: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 181 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved36
	"This method was automatically generated"
	^handle unsignedLongAt: 185! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved36: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 185 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved37
	"This method was automatically generated"
	^handle unsignedLongAt: 189! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved37: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 189 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved38
	"This method was automatically generated"
	^handle unsignedLongAt: 193! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved38: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 193 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved39
	"This method was automatically generated"
	^handle unsignedLongAt: 197! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved39: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 197 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved40
	"This method was automatically generated"
	^handle unsignedLongAt: 201! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved40: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 201 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved41
	"This method was automatically generated"
	^handle unsignedLongAt: 205! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved41: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 205 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved42
	"This method was automatically generated"
	^handle unsignedLongAt: 209! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved42: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 209 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved43
	"This method was automatically generated"
	^handle unsignedLongAt: 213! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved43: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 213 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved44
	"This method was automatically generated"
	^handle unsignedLongAt: 217! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved44: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 217 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved45
	"This method was automatically generated"
	^handle unsignedLongAt: 221! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved45: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 221 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved46
	"This method was automatically generated"
	^handle unsignedLongAt: 225! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved46: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 225 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved47
	"This method was automatically generated"
	^handle unsignedLongAt: 229! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved47: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 229 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved48
	"This method was automatically generated"
	^handle unsignedLongAt: 233! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved48: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 233 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved49
	"This method was automatically generated"
	^handle unsignedLongAt: 237! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved49: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 237 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved50
	"This method was automatically generated"
	^handle unsignedLongAt: 241! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved50: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 241 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved51
	"This method was automatically generated"
	^handle unsignedLongAt: 245! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved51: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 245 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved52
	"This method was automatically generated"
	^handle unsignedLongAt: 249! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved52: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 249 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved53
	"This method was automatically generated"
	^handle unsignedLongAt: 253! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
reserved53: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 253 put: anObject! !

!QAudioEncoderConfigAAC methodsFor: 'validation' stamp: 'jcg 4/16/2010 02:08'!
validate
	"Ensure that we're using valid values for all parameters."
	| val |
	Smalltalk isLittleEndian ifFalse: [self error: 'big-endian not handled yet'].

	(#(1 2 3 4 5 6 8) includes: self inputChannels) ifFalse: [self error: 'bad inputChannels'].
	(#(6 7 16) includes: self mpegVersion) ifFalse: [self error: 'bad mpegVersion'].
	(2 = self aacObjectType) ifFalse: [self error: 'bad aacObjectType'].
	(self audioBitrateIndex between: 1 and: 32) ifFalse: [self error: 'bad audioBitrateIndex'].
	(1 = self headerType) ifFalse: [self error: 'bad headerType'].
	val := self hfCutoff.
	(val = 0 or: [val = 1] or: [val between: 1000 and: 40000]) 
		ifFalse: [self error: 'bad hfCutoff'].
	(self vbr between: 0 and: 9) ifFalse: [self error: 'bad vbr'].
	(self he between: 0 and: 3) ifFalse: [self error: 'bad he'].
	(#(8 16 24) includes: self bitsPerSample) ifFalse: [self error: 'bad bitsPerSample'].
	(0 = self protectAdtsStream) ifFalse: [self error: 'bad protectAdtsStream'].
	
	


! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
vbr
	"This method was automatically generated"
	^handle unsignedLongAt: 25! !

!QAudioEncoderConfigAAC methodsFor: 'accessing' stamp: 'jcg 4/15/2010 18:05'!
vbr: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 25 put: anObject! !

QPluginFeedbackChannel subclass: #QAudioPluginFeedbackChannel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Feedback'!

!QAudioPluginFeedbackChannel commentStamp: '<historical>' prior: 0!
Feedback channel for handling phone events from QAudioPlugin.  Subclasses are used for various purposes.!

QAudioPluginFeedbackChannel subclass: #QAudioFeedbackChannel
	instanceVariableNames: ''
	classVariableNames: 'DecodedAudioFrame EncodedAudioFrame'
	poolDictionaries: ''
	category: 'Qwaq-Sound-Codec'!

!QAudioFeedbackChannel commentStamp: '<historical>' prior: 0!
Reads back audio-frames from QAudioPlugin, for debugging.!

!QAudioFeedbackChannel class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioFeedbackChannel class methodsFor: 'class initialization' stamp: 'jcg 6/12/2009 20:14'!
initialize
	DecodedAudioFrame := 1.
	EncodedAudioFrame := 2.! !

!QAudioFeedbackChannel methodsFor: 'initialize' stamp: 'jcg 6/12/2009 20:17'!
initializeTypeMap
	typeMap := {
		DecodedAudioFrame -> QDecodedAudioSegmentFeedback.
		EncodedAudioFrame -> QEncodedAudioSegmentFeedback.
	}! !

!QAudioPluginFeedbackChannel class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioPluginFeedbackChannel methodsFor: 'primitives' stamp: 'jcg 7/22/2008 02:00'!
primitive: hndl setLogging: trueOrFalse
	<primitive: 'primitiveFeedbackChannelSetLogging' module: 'QAudioPlugin'>
	^self primitiveFailed ! !

!QAudioPluginFeedbackChannel methodsFor: 'primitives' stamp: 'jcg 7/21/2008 11:35'!
primitiveCreateFeedbackChannel: bytes semaphoreIndex: semaphoreIndex
	"Fill 'bytes' with a pointer to a feedback channel (implement interface specified by superclass)."
	<primitive: 'primitiveCreateFeedbackChannel' module: 'QAudioPlugin'>
	self primitiveFailed! !

!QAudioPluginFeedbackChannel methodsFor: 'primitives' stamp: 'jcg 7/22/2008 01:37'!
primitiveDestroyFeedbackChannel: hndl
	"Destroy the feedback channel (implement interface specified by superclass)."
	<primitive: 'primitiveDestroyFeedbackChannel' module: 'QAudioPlugin'>
	self primitiveFailed! !

!QAudioPluginFeedbackChannel methodsFor: 'primitives' stamp: 'jcg 7/22/2008 01:38'!
primitiveGetEvent: hndl
	<primitive: 'primitiveFeedbackChannelReadEvent' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioPluginFeedbackChannel methodsFor: 'primitives' stamp: 'jcg 7/22/2008 01:38'!
primitivePopEvent: hndl
	<primitive: 'primitiveFeedbackChannelPopEvent' module: 'QAudioPlugin'>
	^self primitiveFailed ! !

TObject subclass: #QAudioRecorder
	instanceVariableNames: 'session voiceRelay micSink speakerManager mixer feedback aacConfig aacEncoder speakers clients isRecording'
	classVariableNames: ''
	poolDictionaries: 'AACAudioObjectTypes'
	category: 'Qwaq-Sound-Recording'!

!QAudioRecorder commentStamp: '<historical>' prior: 0!
Provides a single audio-stream mixed from "all" of the currently-audible sound sources.

HACK: the 'fixedBuf' iVar allows us to substitute a pre-encoded AAC chunk for debugging purposes.  See #initialize.!

!QAudioRecorder class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioRecorder class methodsFor: 'instance creation' stamp: 'jcg 8/9/2009 15:58'!
on: session "a QwaqAudioSession"
	^self new initializeForSession: session; yourself! !

!QAudioRecorder methodsFor: 'accessing' stamp: 'jcg 8/12/2009 14:22'!
aacConfig
	^aacConfig! !

!QAudioRecorder methodsFor: 'accessing' stamp: 'crl 1/22/2010 17:54'!
addClient: anObject
	clients add: anObject.
	clients size = 1 ifTrue: ["We're the first... need to start recording"
		self privateStartRecording
	].! !

!QAudioRecorder methodsFor: 'control' stamp: 'crl 1/22/2010 17:01'!
beginResetSound
	QLogger logInfo: 'begin reset sound'.
	self hasClients ifTrue: [self privateStopRecording]! !

!QAudioRecorder methodsFor: 'initialize' stamp: 'jcg 8/13/2009 17:47'!
createAudioSinks
	self destroyAudioSinks. "ensure a fresh start"
	micSink := QAudioSinkSpeex new.
	mixer := QAudioSinkMixer new.
	feedback := QAudioSinkFeedback new.
	mixer addSource: micSink.
	feedback source: mixer.
	self runScript: #onReceiveMixedFrame when: {feedback. #receivedFrame}.
! !

!QAudioRecorder methodsFor: 'private' stamp: 'jcg 4/15/2010 23:45'!
createEncoderConfig
	| config |
	config := QAudioEncoderConfigAAC new.
	config
		inputChannels: 1;		"mono sound"
		mpegVersion: 7;		"MPEG-4 AAC audio"
		aacObjectType: 2;		"AAC-LC: low-complexity"
		audioBitrateIndex: 1; 	"doesn't matter: we're using VBR anyway"
		headerType: 1;			"ADTS... it's just what we use"
		hfCutoff: 0;			"use default frequency cut-off"
		vbr: 4;					"low-medium quality variable bitrate"
		he: 0;					"no HE: we're using AAC-LC, not AAC-HE"
		bitsPerSample: 16;		"each sample is a 16-byte signed integer"
		protectAdtsStream: 0;	"we don't use ADTS stream protection"
		validate.				"ensure that we've chosen sane settings"
	^config

! !

!QAudioRecorder methodsFor: 'initialize' stamp: 'crl 1/22/2010 16:50'!
destroy
	self privateStopRecording! !

!QAudioRecorder methodsFor: 'initialize' stamp: 'jcg 8/13/2009 17:46'!
destroyAudioSinks
	feedback ifNotNilDo: [:fb |
		feedback := nil.
		fb destroy.
	].
	mixer ifNotNilDo: [:mx |
		mixer := nil.
		mx destroy
	].
	micSink ifNotNilDo: [:mic |
		micSink := nil.
		mic destroy.
	].
	self stopScript: #onReceiveMixedFrame.! !

!QAudioRecorder methodsFor: 'control' stamp: 'crl 1/22/2010 17:01'!
endResetSound
	self hasClients ifTrue: [
		"We do have clients, so we want to restart recording, but the audioInterface might have changed to one that doesn't support it."
		session audioInterface supportsRecording 
			ifTrue: [self privateStartRecording]
			ifFalse: [
				"XXXXX: this is not ideal... turning OpenAL back on won't currently
				 re-establish the audio in the session-recording/webcast.  But at
				 least it doesn't explode.  Use #startScript: instead of calling #inform: 
				 directly, because this is a scary place to open a dialog from."
				self owner 
					startScript: #inform: 
					withArguments: {'Audio recording was interrupted (OpenAL is no longer enabled)'}.
			].
	].
	QLogger logInfo: 'end reset sound'.! !

!QAudioRecorder methodsFor: 'future' stamp: 'crl 4/19/2010 18:31'!
futureDo: aSelector at: deltaMSecs args: args
	"Enqueue a message on the event queue.  The compiler has been modified to generate this message when the #future message appears in the source code."
	session 
		ifNotNil: [:sess | sess futureDo: aSelector receiver: self at: deltaMSecs args: args]
		ifNil: [QLogger logInfo: 'audioSession unavailable for future-send of #', aSelector].
	^nil
! !

!QAudioRecorder methodsFor: 'future' stamp: 'jcg 5/7/2010 11:59'!
futureSend: aSelector at: deltaMSecs args: args
	"Enqueue a message on the event queue.  The compiler has been modified to generate this message when the #future message appears in the source code.  Answers a promise that will be resolved with the result of performing the message."
	^session 
		ifNotNil: [:sess | sess futureSend: aSelector receiver: self at: deltaMSecs args: args]
		ifNil: [
			QLogger logInfo: 'audioSession unavailable for future-send of #', aSelector.
			TPromise new fulfill: nil
		].
! !

!QAudioRecorder methodsFor: 'accessing' stamp: 'crl 1/22/2010 16:15'!
hasClients
	^clients notEmpty! !

!QAudioRecorder methodsFor: 'initialize' stamp: 'crl 2/9/2010 15:42'!
initialize

	QLogger logInfo: 'starting session audio-recording'.

	super initialize.
	speakers := IdentitySet new.

	aacConfig := AACAudioSpecificConfig new.
	aacConfig audioObjectType: AacLC.
	aacConfig samplingFrequency: 16000.
	aacConfig channelConfiguration: 1.

	isRecording := false.
	clients := Set new! !

!QAudioRecorder methodsFor: 'initialize' stamp: 'crl 1/22/2010 16:51'!
initializeForSession: sess "a QwaqAudioSession"
	session := sess.
	speakerManager := session speakerManager.! !

!QAudioRecorder methodsFor: 'future' stamp: 'crl 4/19/2010 18:31'!
isInTurn
	^session isInTurn! !

!QAudioRecorder methodsFor: 'accessing' stamp: 'crl 1/22/2010 17:24'!
isRecording
	^isRecording! !

!QAudioRecorder methodsFor: 'private' stamp: 'crl 4/23/2010 16:58'!
mixOutputForRecording: aQClientSpeakerOutput
	aQClientSpeakerOutput mixForRecordingOn: self! !

!QAudioRecorder methodsFor: 'accessing' stamp: 'jcg 8/10/2009 14:45'!
mixer
	^mixer! !

!QAudioRecorder methodsFor: 'private' stamp: 'jcg 8/13/2009 18:14'!
onCaptureVoice: data from: subscription
	"This is a mashup of the relevant parts of #handleAudioData: and #addSoundData:codec: ."
	"Capture voice data from the given subscription
	We've hardwired the following format:
		Byte 1		: command byte for TMessageChannel
		Byte 2-5		: time since beginning of utterance
		Byte 6-9		: approximate server time
		Byte 10		: codec
		Byte 11-18	: record level
		Byte 19-end	: audio data"
	| codec reader numChunks |
	[
		codec := data at: 10.
		codec = 255 ifTrue:[
			"End of audible period"
			^micSink ifNotNilDo: [:sink | sink resetJitterbufferTimestamps]
		].
		codec = 2 ifFalse:[^self error: 'Unsupported codec: ', codec].
		reader := ReadStream on: data.
		reader next: 18. "skip to the good stuff, which starts at 19".
		numChunks := reader next.
		numChunks timesRepeat: [
			| chunk |
			chunk := reader next: (reader next "chunk size").
			micSink ifNotNilDo: [:sink | sink dejitterAndDecode: chunk]
		].
	] on: Error do: [:err |
		QLogger logWarning: 'error during session-audio-recording: ', err every: 5000.
	].! !

!QAudioRecorder methodsFor: 'private' stamp: 'crl 4/19/2010 18:34'!
onReceiveEncodedFrame: bytes
	self signal: #encodedRecordedAudioFrame with: bytes! !

!QAudioRecorder methodsFor: 'private' stamp: 'jcg 2/17/2010 12:50'!
onReceiveMixedFrame
	| frame |
	frame := feedback nextAudioFrame.
	aacEncoder ifNotNilDo: [:encoder |
		encoder encode: frame buffer.
		session signal: #recordedAudioFrame with: frame
	].! !

!QAudioRecorder methodsFor: 'private' stamp: 'sn 5/22/2013 13:21'!
onSpeakersChanged
	"We know that the speakers already have a speaker-output, and that it won't change (see QClientSpeaker class comment)."
	QLogger logInfo: 'speakers changed... recorder reacting'.
	speakerManager critical: [
		| newSpeakers deadSpeakers relay |
		"We only have to hook up speakers that we haven't seen before... we don't have to unhook dead speakers: the plugin-side version of our mixer-sink holds a weak-ref to them, so they're automatically released."
		newSpeakers := speakerManager speakers difference: speakers.
		newSpeakers valuesDo: [:spkr |
			spkr isMe 
				ifFalse: [
					"Double-dispatch... different types of 
					 speaker-output hook up differently."
					spkr speakerOutput ifNotNilDo: [:out | 
						"XXXXX: prevent explosions.  Trouble is, someone entering the 
						 space in the middle of recording won't have their voice recorded."
						self mixOutputForRecording: out
					].
				].
		].
		speakers := speakerManager speakers copy. "Now we're in sync."

		"Doesn't really have anything to do with the speaker-manager,
		 but let's use the critical section since we have it."
		relay := session voiceRelay.
		voiceRelay = relay ifFalse: [
			self stopScript: #onCaptureVoice:from:.
			voiceRelay := relay.
			voiceRelay ifNotNil: [
				self 
					runScript: #onCaptureVoice:from: 
					when: {voiceRelay. #sendingVoicePayload}.
			].
		].
	].! !

!QAudioRecorder methodsFor: 'accessing' stamp: 'crl 1/22/2010 16:48'!
owner
	"Answer the QwaqParticipantUI."
	^ session owner! !

!QAudioRecorder methodsFor: 'private' stamp: 'jcg 4/16/2010 02:09'!
privateStartRecording
	| aacEncoderConfig |
	session audioInterface
		ifNil: [self error: 'no audio-interface is enabled']
		ifNotNilDo: [:ai | 
			ai supportsRecording ifFalse: [
				self error: 'audio recording requires OpenAL to be enabled'
			].
			aacEncoderConfig := self createEncoderConfig.
			aacEncoder := QAudioEncoderAAC new.
			aacEncoder createHandle: aacEncoderConfig getHandle.
			self runScript: #onReceiveEncodedFrame: when: {aacEncoder. #encodedFrame}.
			self createAudioSinks.
			self
				runScript: #onSpeakersChanged 
				when: {speakerManager. #clientSpeakersChanged}.
			self onSpeakersChanged
		].

	isRecording := true.
	QLogger logInfo: 'started recording'.
			! !

!QAudioRecorder methodsFor: 'private' stamp: 'crl 4/23/2010 18:31'!
privateStopRecording
	self stopScript: #onSpeakersChanged.
	self stopScript: #onCaptureVoice:from:.
	voiceRelay := nil.
	self destroyAudioSinks.
	aacEncoder ifNotNilDo: [:enc |
		aacEncoder := nil.
		enc destroy
	].
	speakers := IdentitySet new.

	isRecording := false.
	QLogger logInfo: 'stopped recording'.! !

!QAudioRecorder methodsFor: 'accessing' stamp: 'crl 1/22/2010 16:58'!
removeClient: anObject
	clients remove: anObject ifAbsent: [].
	clients ifEmpty: [self privateStopRecording]! !

!QAudioRecorder methodsFor: 'accessing' stamp: 'crl 4/21/2010 16:19'!
session
	^session! !

QAudioRecorder subclass: #QAudioRecorderForNonMixSources
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Recording'!

!QAudioRecorderForNonMixSources class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioRecorderForNonMixSources methodsFor: 'private' stamp: 'crl 4/30/2010 17:49'!
mixOutputForRecording: aQClientSpeakerOutput
	| speaker |

	QLogger logInfo: 'deciding whether to mix ', aQClientSpeakerOutput printString.
	speaker := aQClientSpeakerOutput speaker.
	speaker ifNotNil: [
		(speaker ref get: #isForSecureVideo)
			ifTrue: [QLogger logInfo: 'didn''t add speaker output ', (speaker ref get: #objectID), ' because it''s marked for secure video.']
			ifFalse: [
				QLogger logInfo: 'added speaker output ', (speaker ref get: #objectID), ' because it''s not marked for secure video.'.
				super mixOutputForRecording: aQClientSpeakerOutput]]! !

TObject subclass: #QClientSpeakerOutput
	instanceVariableNames: 'speaker soundQueue playing codec audioFormat mutex transform attenuation volume'
	classVariableNames: ''
	poolDictionaries: 'OpenALConstants'
	category: 'Qwaq-Sound-Speaker'!

!QClientSpeakerOutput commentStamp: '<historical>' prior: 0!
(c) 2007 Qwaq Inc.  Originally a clone of TVoiceChat, QVoiceChat was refactored into subclasses specialized for a particular low-level sound API (Squeak or OpenAL).  The result is not backward-compatible with TVoiceChat.!

QClientSpeakerOutput subclass: #QClientSpeakerOpenALOutput
	instanceVariableNames: 'openAL source freeBuffers busyBuffers bufferCount allBuffers playProcess lastPitch requiredMargin lastProcessBuffersTime'
	classVariableNames: ''
	poolDictionaries: 'OpenALConstants'
	category: 'Qwaq-Sound-Speaker'!

!QClientSpeakerOpenALOutput commentStamp: '<historical>' prior: 0!
Plays back decoded sound via OpenAL.!

QClientSpeakerOpenALOutput subclass: #QClientSpeakerExternalOutput
	instanceVariableNames: 'speexSink oalSink'
	classVariableNames: 'UseJitterbuffer'
	poolDictionaries: 'OpenALConstants'
	category: 'Qwaq-Sound-Speaker'!

!QClientSpeakerExternalOutput commentStamp: '<historical>' prior: 0!
Like our superclass, we play decoded sound via OpenAL.  The difference is that we also allow sound to be played back directly in the plugin (thus allowing us to use the Speex jitter-buffer).

In the future, the requirement for OpenAL might be dropped... the plugin might choose to use platform-specific playback mechanisms like CoreAudio/DirectSound. !

!QClientSpeakerExternalOutput class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QClientSpeakerExternalOutput class methodsFor: 'testing' stamp: 'hrs 11/21/2008 20:17'!
useJitterbuffer
	^UseJitterbuffer ifNil: [true]! !

!QClientSpeakerExternalOutput class methodsFor: 'testing' stamp: 'jcg 8/25/2008 09:50'!
useJitterbuffer: trueOrFalse
	UseJitterbuffer := trueOrFalse! !

!QClientSpeakerExternalOutput methodsFor: 'accessing' stamp: 'bgf 9/1/2008 02:25'!
attenuation: aFloat
	super attenuation: aFloat.
	self isExternalPlaybackEnabled 
		ifTrue: [ oalSink gain: self gain ]
! !

!QClientSpeakerExternalOutput methodsFor: 'actions' stamp: 'jcg 8/20/2009 13:46'!
beginSilentPeriod
	"If there is anything that needs to be done when a silent period starts, do it here."
	[speexSink beginSilentPeriod]
		on: Error do: [:err |
			QLogger logWarning: 'error in #beginSilentPeriod :  ', err
		]
! !

!QClientSpeakerExternalOutput methodsFor: 'initialize' stamp: 'jcg 8/20/2009 14:00'!
destroy
	super destroy.
	oalSink ifNotNilDo: [:sink | sink destroy. oalSink := nil].
	speexSink ifNotNilDo: [:sink | sink destroy. speexSink := nil].
	self stopScript: #jitterbufferMarginChanged:.
! !

!QClientSpeakerExternalOutput methodsFor: 'initialize' stamp: 'jcg 8/20/2009 14:00'!
initialize
	super initialize.
	speexSink := QAudioSinkSpeex new.
	self runScript: #jitterbufferMarginChanged: when: {speexSink. #marginChanged}.
	oalSink := QAudioSinkOpenAL new.
	oalSink source: speexSink.
	oalSink gain: 1.0.
	oalSink 
		setRefDist: 50.0 "very little distance effect" 
		maxDist: 1000.0 
		rolloff: 0.2 
		innerAngle: 180.0 
		outerAngle: 360.0 
		outerGain: 0.8.
! !

!QClientSpeakerExternalOutput methodsFor: 'testing' stamp: 'jcg 8/25/2008 10:55'!
isExternalPlaybackEnabled
	^self class useJitterbuffer! !

!QClientSpeakerExternalOutput methodsFor: 'debugging' stamp: 'jcg 9/28/2008 01:06'!
isRecordingForDebugging
	"Delegate to speex-sink."
	speexSink ifNotNilDo: [:sink | ^sink isDebugRecording].
	^false! !

!QClientSpeakerExternalOutput methodsFor: 'accessing' stamp: 'jcg 10/20/2008 12:25'!
jitterBufferActivityThreshold: zeroTo100
	"The Speex jitter-buffer has a way to check the 'activity' (roughly, 'volume') of the previously decoded frame.  It also has a way to hint that 'now would be a good time to extrapolate or drop a frame'.  We use a heuristic that says 'when the activity is below a threshold, hint to the jitter-buffer that now is a good time to make time adjustments'.  This method sets this threshold."
	speexSink ctlSetActivityThreshold: zeroTo100! !

!QClientSpeakerExternalOutput methodsFor: 'private' stamp: 'jcg 8/20/2009 13:51'!
jitterbufferMarginChanged: newValue "in msecs"
	speaker ifNotNilDo: [:spkr |
		QLogger logInfo: 
			'changed jitterbuffer margin to ', newValue, 'ms  for ', spkr sourceDescription
	]! !

!QClientSpeakerExternalOutput methodsFor: 'initialize' stamp: 'jcg 8/20/2009 13:46'!
marginRange: anInterval "in msecs"
	"Set the minimum and maximum jitterbuffer-margin values."
	speexSink marginRange: anInterval
! !

!QClientSpeakerExternalOutput methodsFor: 'accessing' stamp: 'jcg 8/20/2009 14:08'!
millisecondsOfMargin
	^speexSink millisecondsOfMargin! !

!QClientSpeakerExternalOutput methodsFor: 'recording' stamp: 'jcg 7/6/2010 21:34'!
mixForRecordingOn: recorder "a QAudioRecorder"
	recorder mixer addSource: oalSink
! !

!QClientSpeakerExternalOutput methodsFor: 'actions' stamp: 'jcg 2/25/2010 00:21'!
playSoundData: data timestamp: timestamp
	playing ifFalse: [^self].
	(self isExternalPlaybackEnabled and: [audioFormat codecClass == QSpeexCodec])
		ifFalse: [
			"We can only do playback directly within the plugin when using Speex (and
			when explicitly enabled).  Implicitly, we must have OpenAL enabled (otherwise
			we'd be using QVoiceChatSqueak instead of this class).  If all of these 
			conditions aren't satisfied, fall back to the old way."
			^super playSoundData: data timestamp: timestamp
		].
	speexSink ifNotNilDo: [:spx | 
		spx dechunkDejitterAndDecode: data timestamp: timestamp
	].
! !

!QClientSpeakerExternalOutput methodsFor: 'private' stamp: 'jcg 4/7/2009 23:42'!
privateUpdateTransform
	super privateUpdateTransform.
	self isExternalPlaybackEnabled ifTrue: [oalSink transform: transform].! !

!QClientSpeakerExternalOutput methodsFor: 'accessing' stamp: 'jcg 10/20/2008 12:02'!
speexSink
	^speexSink! !

!QClientSpeakerExternalOutput methodsFor: 'debugging' stamp: 'jcg 9/28/2008 01:05'!
startRecordingForDebugging: filePath
	"Delegate to speex-sink."
	speexSink ifNotNilDo: [:sink | sink startDebugRecording: filePath]! !

!QClientSpeakerExternalOutput methodsFor: 'debugging' stamp: 'jcg 9/28/2008 01:27'!
stopRecordingForDebugging
	"Delegate to speex-sink."
	speexSink ifNotNilDo: [:sink | sink stopDebugRecording]! !

!QClientSpeakerExternalOutput methodsFor: 'accessing' stamp: 'jcg 3/17/2009 23:28'!
volume: aFloat
	super volume: aFloat.
	self isExternalPlaybackEnabled 
		ifTrue: [ oalSink gain: self gain ]
! !

!QClientSpeakerOpenALOutput class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QClientSpeakerOpenALOutput class methodsFor: 'class initialization' stamp: 'bgf 3/9/2007 21:07'!
initialize
	"QVoiceChatOpenAL initialize."
	Smalltalk addToShutDownList: self.! !

!QClientSpeakerOpenALOutput class methodsFor: 'system startup' stamp: 'bgf 3/9/2007 21:20'!
shutDown: bQuitting
	super shutDown: bQuitting.

	"No matter what, we do not want sound source state in a saved image;
	 the FFI gets very unhappy about reloading when that happens."
	self allInstancesDo: [ :i | [i stop] on: Error do: [:exc|] ].! !

!QClientSpeakerOpenALOutput methodsFor: 'buffering' stamp: 'bgf 11/24/2007 12:48'!
continuePlaying

	"Forked to continue play when processBuffers does not exhaust the buffer queue.
	 (A sort of tail-future done with fork.)"
	(Delay forMilliseconds: 50) wait.
	self processBuffers
			! !

!QClientSpeakerOpenALOutput methodsFor: 'accessing' stamp: 'bgf 9/8/2008 02:48'!
createSource

	"The sound source for voice gives only hints of distance and very little directional dropoff,
	 so in-forum chat is not disrupted by wandering."

	source ifNil: [
		source := QSoundSource new.
		openAL ifNotNilDo: [ : oal | oal nameOf: source ]. "force OpenAL initialization"
		source 
			gain: 1.0;
			referenceDistance: 50.0;		"very little distance effect"
			maxDistance: 1000.0;
			rolloffFactor: 0.2;		
			coneInnerAngle: 180.0;
			coneOuterAngle: 360.0;
			coneOuterGain: 0.8.			"modest rotation effect."
		self privateUpdateTransform.
	].
	^ source! !

!QClientSpeakerOpenALOutput methodsFor: 'accessing' stamp: 'bgf 11/18/2008 16:28'!
destroySource

	"Careful here...
	 the low-level source destroy might be pre-empted by a runScript, so hide the source immediately."
	source ifNotNil: [
		| src |
		src := source.
		source := nil. 
		src destroy
	].
! !

!QClientSpeakerOpenALOutput methodsFor: 'buffering' stamp: 'jcg 3/17/2009 09:27'!
initialMarginValue
	"Store up this number of frames in the soundQueue before starting to play."
	^4! !

!QClientSpeakerOpenALOutput methodsFor: 'initialize' stamp: 'jcg 3/17/2009 08:43'!
initialize
	super initialize.
	bufferCount := 4.
	lastPitch := 1.0.
	lastProcessBuffersTime := -100000.  "i.e. never"! !

!QClientSpeakerOpenALOutput methodsFor: 'buffering' stamp: 'bgf 5/29/2009 23:11'!
initializeBuffers
	"Prepare to play: allocate a set of buffers."
	openAL ifNil: [ ^ self ].

	openAL statusMutex critical: [
		openAL makeCurrent.
		openAL checkError: 'speaker buffer allocation'.

		allBuffers := openAL alGenBuffers: bufferCount.
		(openAL checkError: 'speaker generate buffers') ifTrue: [
			allBuffers := nil.
			^ self.
		] ifFalse: [
			allBuffers do: [ :buf| openAL log: 'voice buf new ',  buf, ' for ', self identityHash ]
		].
		freeBuffers :=OrderedCollection withAll: allBuffers.
		busyBuffers := OrderedCollection new.
	].! !

!QClientSpeakerOpenALOutput methodsFor: 'private' stamp: 'bgf 11/30/2007 15:28'!
isSourceReallyPlaying
	"Is the open AL sound source active?"
	| name |
	source ifNil: [ ^ false ].
	openAL ifNil: [ ^ false ].
	name := openAL nameOf: source ifAbsent: [nil].
	^ name ifNil: [false] ifNotNil: [name isPlaying]! !

!QClientSpeakerOpenALOutput methodsFor: 'initialize' stamp: 'jcg 2/23/2007 12:54'!
openAL: oal
	openAL := oal.! !

!QClientSpeakerOpenALOutput methodsFor: 'private' stamp: 'bgf 5/29/2009 23:11'!
privateStop
	| sourceID queued |

	allBuffers ifNil: [ ^ self ].  	"Never started, or failed to get resources."
	openAL ifNil: [ ^ self ].

 	openAL statusMutex critical: [
		openAL checkError: 'preparing for speaker stop'.

		playProcess ifNotNil: [ playProcess terminate. playProcess := nil ].
		openAL hasContext ifFalse: [ 	self destroySource. ^self ].
		openAL makeCurrent.

		"If we have a sound source, shut it down."
		source ifNotNil: [
			sourceID := (openAL idOfResource: source).
			sourceID ifNotNil: [
				(openAL isPlaying: sourceID) ifTrue: [
					openAL alSourceStop: sourceID.
				].
				openAL checkError: 'stop voice ', sourceID.

				queued := openAL alGetSourcei: sourceID with: ALBuffersQueued.
				openAL alSourceUnqueueBuffers: sourceID with: queued.
				(openAL checkError: 'unqueue voice ', sourceID) ifTrue: [ ^ self ].

				"Forces openAL to disassociate the buffers."
				openAL alSourcei: sourceID with: ALBuffer with: 0.
				(openAL checkError: 'drop voice buffers ', sourceID) ifTrue: [ ^ self ].
			].
		].
		"Delete all the buffers."
	
		allBuffers do: [ :buf| openAL log: 'voice buf del ', buf, ' for ', self identityHash ].
		openAL alDeleteBuffers: bufferCount with: allBuffers.
		openAL checkError: 'delete voice buffers ', sourceID.
		allBuffers := nil.
		freeBuffers := nil.
		busyBuffers := nil.

		self destroySource.
	].! !

!QClientSpeakerOpenALOutput methodsFor: 'accessing' stamp: 'bgf 5/29/2009 23:11'!
privateUpdateTransform
	openAL ifNil: [ ^self ].
	transform ifNil: [ ^self ].
	openAL statusMutex critical: [
		source ifNil: [ ^self ].
		source position: transform translation.
		source direction: transform column3 normalized.
	].! !

!QClientSpeakerOpenALOutput methodsFor: 'buffering' stamp: 'jcg 9/13/2009 15:48'!
processBuffers
	| sourceID holder pitch soundQueueExcess |

	"Transfer sound to the openAL source buffers, if any are free,
	 after freeing buffers we've already played.  Consumes from 'soundQueue',
	 but may not empty the queue, since we used a small set of openAL buffers."

	((playing == false) | (openAL isNil)) ifTrue:[
		"Don't let stale sound accumulate when not playing
	   	 (and if openAL is nil we'll probably never play it.)"
		soundQueue flush.
		^ self.
	].

  	openAL statusMutex critical: [
	
		"If we're received no sound for more than a second, assume that there was an intentional silent period, and buffer a margin of data before beginning to play."
		(Time coarseMillisecondsSince: lastProcessBuffersTime) > 1000 
			ifTrue: [requiredMargin := self initialMarginValue].
		lastProcessBuffersTime := Time coarseClockValue.
		requiredMargin ifNotNilDo: [:mr |
			mr > soundQueue size ifTrue: [^self "haven't stashed enough audio"].
			requiredMargin := nil. "we've stashed enough audio, now start playing."
		].

		"There are two paths into this routine.
		  It is called when new sounds are appended to the 'soundQueue'.
		  It also future-tail-calls itself if, at the end, there are still sounds to process.
		  If playProcess is non-nil, but not the current process,
		  then this is new sound delivery while a playback is ongoing,
	 	  and so we do nothing here... the playProcess will pick up the queue.
		  See the bottom of this method for the tail-call part."
		((playProcess notNil) and:  
		[playProcess ~= Processor activeProcess] and:
		[playProcess isTerminated not]) 
			ifTrue: [^self ].

		openAL checkError: 'preparing for voice process'.		"Clear stale error states."
		openAL hasContext ifFalse: [^self ].	"Bulletproof."
		allBuffers ifNil: [ ^ self ].				"Couldn't allocate buffers."

		openAL makeCurrent.
		self createSource.	"(Idempotent)."
		source gain: (self gain).

		sourceID := ((openAL nameOf: source) ifNil: [^self "bulletproof"]) alID.

		"Free buffers that have already been processed."
		holder := WordArray new: 1.
		openAL alGetSourcei: sourceID with: ALBuffersProcessed with: holder.

		((openAL checkError: 'get processed buffers ', sourceID) not 
		  and: [(holder at: 1) > 0]) ifTrue: [
			holder := WordArray new: (holder at: 1).
			openAL alSourceUnqueueBuffers: sourceID with: holder size with: holder.
			(openAL checkError: 'unqueue voice buffers ', sourceID) ifFalse: [
				holder do: [:id |
					freeBuffers addLast: id.
					(busyBuffers remove: id ifAbsent: [nil]) ifNil: [
						self error: 'unqueued an unexpected buffer'
					].
				].
			].
		].

		"Fill up buffers with the data that is currently queued."
		holder := WordArray new: 1.
		[soundQueue isEmpty or: [freeBuffers isEmpty]] whileFalse: [
			| id sound |
			sound := soundQueue next.

			"Mac OS really dislikes empty buffers."
			(sound byteSize > 0) ifTrue: [
				busyBuffers addLast: (id := freeBuffers removeFirst).
				openAL  
					alBufferData: id
					with: ALFormatMono16
					with: sound
					with: sound byteSize
					with: audioFormat samplingRate.
				(openAL checkError: 'voice buffer data ', sourceID) ifFalse: [
					holder at: 1 put: id.
					openAL alSourceQueueBuffers: sourceID with: 1 with: holder.
				] ifTrue: [
					freeBuffers addLast: id.
					busyBuffers remove: id ifAbsent: [nil].
				].
			].
		].
		false ifTrue: [openAL checkError: 'queue voice buffers ', sourceID].

		"If we fall behind, smoothly increase the playback speed depending on how far behind we are.  At about ~10 buffers/second, the scaling factor of 2000 means that we reach our maximum speedup (in this case, 1.15) when we are >4 seconds behind.
(Calibrated to accord with QVoiceRecorder class bufferSize.)"
		soundQueueExcess := soundQueue size - self initialMarginValue.
		pitch := (soundQueueExcess > 0)
			ifFalse: [pitch := 1.0]
			ifTrue: [1.0 + (soundQueueExcess squared / 2000.0 * 0.15 min: 0.15)].
		pitch ~= lastPitch ifTrue: [
			openAL
				alSourcef: sourceID
				with: ALPitch
				with: pitch.
				openAL checkError: 'voice pitch ', sourceID.
		].

		(openAL isPlaying: sourceID) ifFalse: [
			openAL alSourcePlay: sourceID.
			openAL checkError: 'voice play ', sourceID.
		].

		"Schedule a continuation if the buffer is not exhausted."
		 (soundQueue isEmpty not or: [self isSourceReallyPlaying]) ifTrue: [
			playProcess := self fork: #continuePlaying at: Processor highIOPriority.
		] ifFalse: [
			playProcess := nil.
			self destroySource.
		].
	 ].! !

!QClientSpeakerOpenALOutput methodsFor: 'accessing' stamp: 'bgf 7/26/2007 15:00'!
source
	"Current TSoundSource; this is non-nil only if I am playing."
	^ source! !

!QClientSpeakerOutput class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QClientSpeakerOutput methodsFor: 'accessing' stamp: 'bgf 2/19/2008 16:23'!
attenuation
	mutex critical: [
		^ attenuation
	].! !

!QClientSpeakerOutput methodsFor: 'accessing' stamp: 'bgf 2/19/2008 16:22'!
attenuation: aScalar
	mutex critical: [ 
		attenuation := aScalar
	].! !

!QClientSpeakerOutput methodsFor: 'accessing' stamp: 'jcg 8/19/2009 15:36'!
audioFormat
	"Answer a QAudioFormat."
	^audioFormat! !

!QClientSpeakerOutput methodsFor: 'initialize' stamp: 'jcg 9/13/2009 16:19'!
audioFormat: aQAudioFormat
	audioFormat == aQAudioFormat ifTrue: [^self].
	audioFormat := aQAudioFormat.
	codec ifNotNil: [codec destroy].
	codec := audioFormat codecClass ifNotNilDo: [:cls | cls new].
! !

!QClientSpeakerOutput methodsFor: 'accessing' stamp: 'jcg 8/20/2008 13:18'!
beginSilentPeriod
	"If there is anything that needs to be done when a silent period starts, do it here."! !

!QClientSpeakerOutput methodsFor: 'initialize' stamp: 'bgf 8/4/2007 19:57'!
destroy
	self stop.
! !

!QClientSpeakerOutput methodsFor: 'accessing' stamp: 'jcg 3/17/2009 23:27'!
gain
	"0 to 1 volume adjustment imposed by my sound region attenuation"
	^ (1.0 - self attenuation) * volume min: 1.0 max: 0.0! !

!QClientSpeakerOutput methodsFor: 'initialize' stamp: 'jcg 9/13/2009 16:01'!
initialize
	super initialize.
	mutex := Mutex new.		"Protects playing/playProcess atomicity."
	soundQueue := SharedQueue new.
	playing := false.
	attenuation := 0.0.
	volume := 1.0.

! !

!QClientSpeakerOutput methodsFor: 'buffering' stamp: 'jcg 2/23/2007 12:52'!
initializeBuffers
	self subclassResponsibility! !

!QClientSpeakerOutput methodsFor: 'debugging' stamp: 'jcg 9/28/2008 00:35'!
isRecordingForDebugging
	"By default, we don't have the capability to record audio-events for debugging purposes... maybe subclasses do."
	^false! !

!QClientSpeakerOutput methodsFor: 'accessing' stamp: 'jcg 10/20/2008 12:10'!
jitterBufferActivityThreshold: ignore
	"For subclasses to implement."! !

!QClientSpeakerOutput methodsFor: 'recording' stamp: 'jcg 8/10/2009 12:10'!
mixForRecordingOn: recorder "a QAudioRecorder"
	"Subclasses should override, if possible."
	QLogger logWarning: 'instances of ', self class name, ' do not support audio-recording'! !

!QClientSpeakerOutput methodsFor: 'controls' stamp: 'bgf 8/6/2007 11:03'!
play
	mutex critical: [
		playing ifTrue: [^self "already playing"].
		playing := true.
		self initializeBuffers.
	].! !

!QClientSpeakerOutput methodsFor: 'playing' stamp: 'jcg 2/25/2010 00:57'!
playSoundData: data timestamp: timestamp "ignored, for now"
	"Add the given sound to the sound queue for playback,"
	playing ifTrue: [
		| decoded |
		decoded := codec 
						ifNil: [data "already a SoundBuffer"]
						ifNotNil: [codec decodeCompressedDataNoReset: data].
		soundQueue nextPut: decoded.
		self processBuffers.
	].! !

!QClientSpeakerOutput methodsFor: 'private' stamp: 'jcg 2/23/2007 13:24'!
privateStop
	self subclassResponsibility! !

!QClientSpeakerOutput methodsFor: 'private' stamp: 'jcg 11/26/2007 00:48'!
privateUpdateTransform
	self subclassResponsibility! !

!QClientSpeakerOutput methodsFor: 'buffering' stamp: 'bgf 8/5/2007 13:24'!
processBuffers

	"Playback: consume as much of the sounds queue as possible.
	 If this always consumes  the entire sounds queue, then no separate playProcess is needed,
	 as this method is called once for each sound data receipt."
	self subclassResponsibility! !

!QClientSpeakerOutput methodsFor: 'accessing' stamp: 'jcg 6/1/2008 17:36'!
sounds
	^ soundQueue! !

!QClientSpeakerOutput methodsFor: 'accessing' stamp: 'jcg 3/30/2009 16:29'!
speaker
	^speaker "the QClientSpeaker"! !

!QClientSpeakerOutput methodsFor: 'initialize' stamp: 'jcg 3/30/2009 16:22'!
speaker: aQClientSpeaker
	speaker := aQClientSpeaker.! !

!QClientSpeakerOutput methodsFor: 'debugging' stamp: 'jcg 9/28/2008 01:03'!
startRecordingForDebugging: filePath
	"No-op... subclasses may override this."! !

!QClientSpeakerOutput methodsFor: 'controls' stamp: 'jcg 6/1/2008 17:36'!
stop

	mutex critical: [
		playing ifTrue: [
			playing := false.
			self privateStop.
			soundQueue flush.
		].
	].
	transform := nil.! !

!QClientSpeakerOutput methodsFor: 'debugging' stamp: 'jcg 9/28/2008 00:35'!
stopRecordingForDebugging
	"No-op... subclasses may override this."! !

!QClientSpeakerOutput methodsFor: 'private' stamp: 'jcg 1/12/2010 23:19'!
updatePlayState
	"Subclasses may (nay, should) override.  Actually, only QClientSpeakerPipelineOutput needs to, because it's only with session-recording/webcast (where we must receive/mix audio even when muted... but not play it) that this is necessary, and we can't do session-recording with Squeak-sound."! !

!QClientSpeakerOutput methodsFor: 'accessing' stamp: 'jcg 11/26/2007 00:48'!
updateTransform: newTransform
	transform = newTransform ifFalse: [
		transform := newTransform.
		self privateUpdateTransform.
	].
! !

!QClientSpeakerOutput methodsFor: 'accessing' stamp: 'jcg 3/17/2009 23:26'!
volume
	mutex critical: [
		^ volume
	].! !

!QClientSpeakerOutput methodsFor: 'accessing' stamp: 'jcg 3/17/2009 23:27'!
volume: newVolume "ranges from 0.0 to 1.0"
	mutex critical: [ 
		volume := newVolume
	].! !

QClientSpeakerOutput subclass: #QClientSpeakerPipelineOutput
	instanceVariableNames: 'inputSink outputSink useOpenAL'
	classVariableNames: ''
	poolDictionaries: 'OpenALConstants'
	category: 'Qwaq-Sound-Speaker'!

!QClientSpeakerPipelineOutput class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QClientSpeakerPipelineOutput class methodsFor: 'instance creation' stamp: 'jcg 8/20/2009 14:24'!
newForAudioFormat: aQAudioFormat useOpenAL: bool
	^self new
		initializeForAudioFormat: aQAudioFormat useOpenAL: bool;
		yourself
		! !

!QClientSpeakerPipelineOutput methodsFor: 'openAL' stamp: 'jcg 8/20/2009 15:37'!
attenuation: aFloat
	super attenuation: aFloat.
	useOpenAL ifTrue: [outputSink gain: self gain]
! !

!QClientSpeakerPipelineOutput methodsFor: 'speex' stamp: 'jcg 8/20/2009 15:16'!
beginSilentPeriod
	"If there is anything that needs to be done when a silent period starts, do it here."
	self usesSpeexInput ifFalse: [^self].
	[inputSink beginSilentPeriod]
		on: Error do: [:err |
			QLogger logWarning: 'error in #beginSilentPeriod :  ', err
		]
! !

!QClientSpeakerPipelineOutput methodsFor: 'initialize' stamp: 'jcg 8/20/2009 15:17'!
destroy
	inputSink ifNotNilDo: [:sink |inputSink := nil. sink destroy].
	outputSink ifNotNilDo: [:sink | outputSink := nil. sink destroy].
	self stopScript: #jitterbufferMarginChanged:.! !

!QClientSpeakerPipelineOutput methodsFor: 'private' stamp: 'jcg 8/20/2009 15:39'!
initializeBuffers
	"Nothing to do... it's all done in the plugin."! !

!QClientSpeakerPipelineOutput methodsFor: 'initialize' stamp: 'jcg 9/13/2009 15:45'!
initializeForAudioFormat: aQAudioFormat useOpenAL: bool
	useOpenAL := bool.
	audioFormat := aQAudioFormat.
	self initializeInputSinkForAudioFormat: aQAudioFormat.
	self initializeOutputSink.
	outputSink source: inputSink! !

!QClientSpeakerPipelineOutput methodsFor: 'private' stamp: 'jcg 6/30/2010 08:23'!
initializeInputSinkForAudioFormat: aQAudioFormat
	aQAudioFormat codecClass caseOf: {
		[QSpeexCodec] -> [inputSink := QAudioSinkSpeex new].
		[nil] -> [
			inputSink := QAudioSinkBufferedResampler new.
			inputSink inputSamplingRate: aQAudioFormat samplingRate.
			inputSink outputSamplingRate: 16000.
			
			"HACK... the only current place we use pre-decoded audio is for streaming
			 MP4-playback, where we always use a 0.5 second buffer."
			inputSink bufferedFrameCount: 25.
		]
	} otherwise: [self error: 'unexpected codec class: ', aQAudioFormat codecClass].
	self runScript: #jitterbufferMarginChanged: when: {inputSink. #marginChanged}.! !

!QClientSpeakerPipelineOutput methodsFor: 'private' stamp: 'jcg 8/20/2009 14:50'!
initializeOutputSink
	useOpenAL 
		ifFalse: [outputSink := QAudioSinkPortAudio new]
		ifTrue: [
			outputSink := QAudioSinkOpenAL new.
			outputSink
				gain: 1.0;
				setRefDist: 50.0 "very little distance effect" 
				maxDist: 1000.0 
				rolloff: 0.2 
				innerAngle: 180.0 
				outerAngle: 360.0 
				outerGain: 0.8.
		].
! !

!QClientSpeakerPipelineOutput methodsFor: 'debugging' stamp: 'jcg 8/20/2009 15:20'!
isRecordingForDebugging
	"Delegate to speex-sink."
	self usesSpeexInput ifFalse: [^false].
	^inputSink isDebugRecording! !

!QClientSpeakerPipelineOutput methodsFor: 'speex' stamp: 'jcg 8/20/2009 15:20'!
jitterBufferActivityThreshold: zeroTo100
	"The Speex jitter-buffer has a way to check the 'activity' (roughly, 'volume') of the previously decoded frame.  It also has a way to hint that 'now would be a good time to extrapolate or drop a frame'.  We use a heuristic that says 'when the activity is below a threshold, hint to the jitter-buffer that now is a good time to make time adjustments'.  This method sets this threshold."
	self usesSpeexInput ifTrue: [inputSink ctlSetActivityThreshold: zeroTo100]! !

!QClientSpeakerPipelineOutput methodsFor: 'private' stamp: 'jcg 8/20/2009 15:18'!
jitterbufferMarginChanged: newValue "in msecs"
	speaker ifNotNilDo: [:spkr |
		QLogger logInfo: 
			'changed jitterbuffer margin to ', newValue, 'ms  for ', spkr sourceDescription
	]! !

!QClientSpeakerPipelineOutput methodsFor: 'speex' stamp: 'jcg 8/20/2009 15:21'!
marginRange: anInterval "in msecs"
	"Set the minimum and maximum jitterbuffer-margin values."
	self usesSpeexInput ifTrue: [inputSink marginRange: anInterval]! !

!QClientSpeakerPipelineOutput methodsFor: 'speex' stamp: 'jcg 8/20/2009 15:32'!
millisecondsOfMargin
	^self usesSpeexInput 
		ifTrue: [inputSink millisecondsOfMargin] 
		ifFalse: [
			QLogger logWarning: 'only speex-input supports #millisecondsOfMargin'.
			0.
		]! !

!QClientSpeakerPipelineOutput methodsFor: 'recording' stamp: 'jcg 7/6/2010 21:34'!
mixForRecordingOn: recorder "a QAudioRecorder"
	recorder mixer addSource: outputSink
! !

!QClientSpeakerPipelineOutput methodsFor: 'actions' stamp: 'jcg 2/25/2010 00:14'!
playSoundData: data timestamp: timestamp
	playing ifFalse: [^self].
	inputSink ifNotNilDo: [:sink | sink playSoundData: data timestamp: timestamp].! !

!QClientSpeakerPipelineOutput methodsFor: 'private' stamp: 'jcg 6/8/2010 23:22'!
privateStop
	"Disconnect input from output."
	outputSink ifNotNil: [:out | out removeSource].! !

!QClientSpeakerPipelineOutput methodsFor: 'private' stamp: 'jcg 8/20/2009 15:37'!
privateUpdateTransform
	useOpenAL ifTrue: [outputSink transform: transform].! !

!QClientSpeakerPipelineOutput methodsFor: 'speex' stamp: 'jcg 8/20/2009 15:23'!
speexSink
	^self usesSpeexInput ifTrue: [inputSink] ifFalse: [nil]! !

!QClientSpeakerPipelineOutput methodsFor: 'speex' stamp: 'jcg 8/20/2009 15:30'!
startRecordingForDebugging: filePath
	"Delegate to speex-sink."
	self usesSpeexInput ifFalse: [
		^QLogger logWarning: 'only Speex-sink supports debug-recording'
	].
	inputSink startDebugRecording: filePath! !

!QClientSpeakerPipelineOutput methodsFor: 'speex' stamp: 'jcg 5/20/2010 12:48'!
stopRecordingForDebugging
	"Delegate to speex-sink."
	self usesSpeexInput ifFalse: [
		^QLogger logWarning: 'only Speex-sink supports debug-recording'
	].
	inputSink stopDebugRecording! !

!QClientSpeakerPipelineOutput methodsFor: 'private' stamp: 'jcg 1/12/2010 22:53'!
updatePlayState
	speaker isMute 
		ifTrue: [outputSink ifNotNilDo: [:out | out removeSource]]
		ifFalse: [outputSink ifNotNilDo: [:out | out source: inputSink]]! !

!QClientSpeakerPipelineOutput methodsFor: 'testing' stamp: 'jcg 8/20/2009 15:16'!
usesSpeexInput
	^inputSink class == QAudioSinkSpeex! !

!QClientSpeakerPipelineOutput methodsFor: 'openAL' stamp: 'jcg 8/20/2009 15:37'!
volume: aFloat
	super volume: aFloat.
	useOpenAL ifTrue: [outputSink gain: self gain]
! !

QClientSpeakerOutput subclass: #QClientSpeakerPortAudioOutput
	instanceVariableNames: 'speexSink resampleSink portAudioSink'
	classVariableNames: ''
	poolDictionaries: 'OpenALConstants'
	category: 'Qwaq-Sound-Speaker'!

!QClientSpeakerPortAudioOutput commentStamp: '<historical>' prior: 0!
Plays sound using PortAudio.  For now, handles two types of audio:
- 16kHz Speex
- raw audio samples at arbitrary sampling rates.

In both cases, each audio-segment is expected to be 20ms.!

!QClientSpeakerPortAudioOutput class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QClientSpeakerPortAudioOutput methodsFor: 'initialize' stamp: 'jcg 9/13/2009 15:56'!
audioFormat: aQAudioFormat
	audioFormat == aQAudioFormat ifTrue: [^self].
	super audioFormat: aQAudioFormat.

	self destroyAllSinks.  "we'll recreate them"
	audioFormat codecClass = QSpeexCodec ifTrue: [
		speexSink := QAudioSinkSpeex new.
		portAudioSink := QAudioSinkPortAudio new.
		portAudioSink source: speexSink.
		^true
	].

	audioFormat codecClass ifNil: [
		resampleSink := QAudioSinkBufferedResampler new.
		resampleSink inputSamplingRate: audioFormat samplingRate.
		resampleSink outputSamplingRate: 16000.
		portAudioSink := QAudioSinkPortAudio new.
		portAudioSink source: resampleSink.
		^true
	].
	self error: 'expected either Speex or raw samples'.
	^false
! !

!QClientSpeakerPortAudioOutput methodsFor: 'initialize' stamp: 'jcg 6/9/2009 14:36'!
destroy
	super destroy.
	self destroyAllSinks.! !

!QClientSpeakerPortAudioOutput methodsFor: 'private' stamp: 'jcg 6/9/2009 14:34'!
destroyAllSinks
	speexSink ifNotNilDo: [:sink | sink destroy].
	resampleSink ifNotNilDo: [:sink | sink destroy].
	portAudioSink ifNotNilDo: [:sink | sink destroy].
	speexSink := resampleSink := portAudioSink := nil.! !

!QClientSpeakerPortAudioOutput methodsFor: 'private' stamp: 'jcg 6/9/2009 18:50'!
initializeBuffers
	"Nothing to do... it's all done in the plugin."! !

!QClientSpeakerPortAudioOutput methodsFor: 'actions' stamp: 'jcg 2/25/2010 00:58'!
playSoundData: data  timestamp: timestamp
	playing ifFalse: [^self].
	resampleSink ifNotNilDo: [:sink | ^sink pushRawAudio: data "timestamp is ignored"].
	speexSink ifNotNilDo: [:sink | 
		^sink dechunkDejitterAndDecode: data timestamp: timestamp
	].
	QLogger logWarning: 'no audio input-sink' every: 5000.! !

!QClientSpeakerPortAudioOutput methodsFor: 'private' stamp: 'jcg 6/9/2009 18:51'!
privateStop! !

!QClientSpeakerPortAudioOutput methodsFor: 'private' stamp: 'jcg 6/9/2009 18:50'!
privateUpdateTransform
	"TODO: spatialize the voice chat (the responsibility for this is distributed between this method, and the place where the sound is actually played."! !

QClientSpeakerOutput subclass: #QClientSpeakerSqueakOutput
	instanceVariableNames: 'sound'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Speaker'!

!QClientSpeakerSqueakOutput commentStamp: '<historical>' prior: 0!
Plays back decoded sound via Squeak audio interface.!

!QClientSpeakerSqueakOutput class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QClientSpeakerSqueakOutput class methodsFor: 'hacking' stamp: 'jcg 3/17/2007 18:57'!
chopUpAndReassembleWithADPCMCodec
	"QVoiceChatSqueak chopUpAndReassembleWithADPCMCodec play"
	| originalSound chopped codec buffer start |
	originalSound := SampledSound fromWaveFileNamed: '/Users/Josh/Downloads/bouncing.wav'.
	chopped := OrderedCollection new.
	self 
		simulateVoiceChatMicrophone: originalSound
		accumulator: [:frame | chopped add: frame]
		codec: (ADPCMCodec newBitsPerSample: 5)
		useDelay: false.
	codec := ADPCMCodec newBitsPerSample: 5.
	chopped := chopped collect: [:frame | codec decodeCompressedDataNoReset: frame].
	chopped inspect.
	buffer := SoundBuffer newMonoSampleCount: 
							(chopped collect: [:frame | frame monoSampleCount]) sum.
	start := 1.
	chopped do: [:frame |
		buffer replaceFrom: start to: (start + frame monoSampleCount - 1) with: frame.
		start := start + frame monoSampleCount
	].
	^ SampledSound samples: buffer samplingRate: 11025
	
	! !

!QClientSpeakerSqueakOutput class methodsFor: 'hacking' stamp: 'jcg 3/17/2007 18:58'!
chopUpAndReassembleWithGSMCodec
	"QVoiceChatSqueak chopUpAndReassembleWithGSMCodec play"
	| originalSound chopped codec buffer start |
	originalSound := SampledSound fromWaveFileNamed: '/Users/Josh/Downloads/bouncing.wav'.
	chopped := OrderedCollection new.
	self 
		simulateVoiceChatMicrophone: originalSound
		accumulator: [:frame | chopped add: frame]
		codec: GSMCodec new
		useDelay: false.
	codec := GSMCodec new.
	chopped := chopped collect: [:frame | codec decodeCompressedDataNoReset: frame].
	buffer := SoundBuffer newMonoSampleCount: 
							(chopped collect: [:frame | frame monoSampleCount]) sum.
	start := 1.
	chopped do: [:frame |
		buffer replaceFrom: start to: (start + frame monoSampleCount - 1) with: frame.
		start := start + frame monoSampleCount
	].
	^ SampledSound samples: buffer samplingRate: 11025
	
	! !

!QClientSpeakerSqueakOutput class methodsFor: 'hacking' stamp: 'jcg 3/17/2007 19:00'!
chopUpAndReassembleWithMuLawCodec
	"QVoiceChatSqueak chopUpAndReassembleWithMuLawCodec play"
	| originalSound chopped codec buffer start |
	originalSound := SampledSound fromWaveFileNamed: '/Users/Josh/Downloads/bouncing.wav'.
	chopped := OrderedCollection new.
	self 
		simulateVoiceChatMicrophone: originalSound
		accumulator: [:frame | chopped add: frame]
		codec: MuLawCodec new
		useDelay: false.
	codec := MuLawCodec new.
	chopped := chopped collect: [:frame | codec decodeCompressedDataNoReset: frame].
	buffer := SoundBuffer newMonoSampleCount: 
							(chopped collect: [:frame | frame monoSampleCount]) sum.
	start := 1.
	chopped do: [:frame |
		buffer replaceFrom: start to: (start + frame monoSampleCount - 1) with: frame.
		start := start + frame monoSampleCount
	].
	^ SampledSound samples: buffer samplingRate: 11025
	
	! !

!QClientSpeakerSqueakOutput class methodsFor: 'hacking' stamp: 'jcg 3/17/2007 15:32'!
chopUpAndReassembleWithNoCodec
	"QVoiceChatSqueak chopUpAndReassembleWithNoCodec play"
	| originalSound chopped buffer start |
	originalSound := SampledSound fromWaveFileNamed: '/Users/Josh/Downloads/bouncing.wav'.
	chopped := OrderedCollection new.
	self 
		simulateVoiceChatMicrophone: originalSound
		accumulator: [:frame | chopped add: frame]
		codec: nil
		useDelay: false.
	buffer := SoundBuffer newMonoSampleCount: 
							(chopped collect: [:frame | frame monoSampleCount]) sum.
	start := 1.
	chopped do: [:frame |
		buffer replaceFrom: start to: (start + frame monoSampleCount - 1) with: frame.
		start := start + frame monoSampleCount
	].
	^ SampledSound samples: buffer samplingRate: 11025
	
	! !

!QClientSpeakerSqueakOutput class methodsFor: 'hacking' stamp: 'jcg 3/17/2007 18:56'!
encodeAndDecodeWithGSMCodec
	"QVoiceChatSqueak encodeAndDecodeWithGSMCodec play"
	| originalSound encoded buffer |
	originalSound := SampledSound fromWaveFileNamed: '/Users/Josh/Downloads/bouncing.wav'.
	encoded := GSMCodec new encodeSoundBufferNoReset: originalSound samples.
	buffer := GSMCodec new decodeCompressedDataNoReset: encoded.
	^ SampledSound samples: buffer samplingRate: 11025
	
	! !

!QClientSpeakerSqueakOutput class methodsFor: 'hacking' stamp: 'jcg 3/19/2007 12:07'!
simulateNetworkVoiceChat
	"QVoiceChatSqueak simulateNetworkVoiceChat"
	| queue originalSound microphone speaker |
	queue := SharedQueue new.
	originalSound := SampledSound fromWaveFileNamed: '/Users/Josh/Downloads/bouncing.wav'.
	microphone := [self 
						simulateVoiceChatMicrophone: originalSound
						accumulator: [:val | queue nextPut: val] 
						codec: GSMCodec new 
						useDelay: true
						jitterSize: 100] forkAt: 50.
	speaker := [self simulateVoiceChatSpeaker: queue] forkAt: 50.
	^ {microphone. speaker}
! !

!QClientSpeakerSqueakOutput class methodsFor: 'hacking' stamp: 'jcg 3/19/2007 15:56'!
simulateNetworkVoiceChatNoJitter
	"QVoiceChatSqueak simulateNetworkVoiceChatNoJitter"
	| queue originalSound microphone speaker |
	queue := SharedQueue new.
	originalSound := SampledSound fromWaveFileNamed: '/Users/Josh/Downloads/bouncing.wav'.
	microphone := [self 
						simulateVoiceChatMicrophone: originalSound
						accumulator: [:val | queue nextPut: val] 
						codec: GSMCodec new 
						useDelay: true
						jitterSize: 0] forkAt: 50.
	speaker := [self simulateVoiceChatSpeaker: queue] forkAt: 50.
	^ {microphone. speaker}
! !

!QClientSpeakerSqueakOutput class methodsFor: 'hacking' stamp: 'jcg 3/19/2007 10:18'!
simulateVoiceChatMicrophone: originalSound accumulator: accumBlock codec: codec useDelay: useDelay
	self 
		simulateVoiceChatMicrophone: originalSound 
		accumulator: accumBlock 
		codec: codec 
		useDelay: useDelay 
		jitterSize: 0	! !

!QClientSpeakerSqueakOutput class methodsFor: 'hacking' stamp: 'jcg 10/14/2008 12:21'!
simulateVoiceChatMicrophone: originalSound accumulator: accumBlock codec: codec useDelay: useDelay jitterSize: jitterSize
	| bufferSize chopped remaining buffer startTime nextTime delayTime now jitter count |
	
	count := 0.
	bufferSize := QMicrophone bufferSize.
	codec ifNotNil: 
		[bufferSize := (bufferSize truncateTo: codec samplesPerFrame) 
																max: codec samplesPerFrame].
	chopped := OrderedCollection new.
	remaining := originalSound samples size.
	1 to: originalSound samples size by: bufferSize do: [:i | 
		buffer := originalSound samples copyFrom: i to: ((i + bufferSize - 1) min: (originalSound samples size)).
		"buffer := SoundBuffer new: bufferSize.
		buffer 
			replaceFrom: 1
			to: (bufferSize min: remaining)
			with: originalSound samples
			startingAt: i."
		remaining := remaining - bufferSize.
		chopped add: buffer
	].

	startTime := Time millisecondClockValue.
	nextTime := startTime.
	jitter := 0.
	chopped withIndexDo: [:c :i |
		now := Time millisecondClockValue.
		useDelay ifTrue: [
			jitter := jitter + (jitterSize atRandom - (jitterSize // 2)).
			delayTime := nextTime - now + jitter.
			delayTime < 0 
				ifFalse: [jitter := 0]
				ifTrue: [
					jitter := delayTime.
					delayTime := 0.
				].
			delayTime > 0 ifTrue: [(Delay forMilliseconds: delayTime) wait].
		].
		accumBlock value:
			(codec ifNil: [c] ifNotNil: [codec encodeSoundBufferNoReset: c]).
		count := count + 1.
		nextTime := startTime + (bufferSize * 1000 * i // originalSound originalSamplingRate).

		Processor yield.
	].
	accumBlock value: (ByteArray with: 0).
	Transcript show: 'TRANSMITTED ', count, ' SAMPLES'; cr.
! !

!QClientSpeakerSqueakOutput class methodsFor: 'hacking' stamp: 'jcg 2/26/2009 11:07'!
simulateVoiceChatSpeaker: queue
	| count delay codec sound buffer next finished |
	
	count := 0.
	delay := Delay forMilliseconds: 20.
	codec := GSMCodec new.
	sound := QueueSound new.
	sound play.

	finished := false.
	[finished] whileFalse: [
		(next := queue nextOrNil) 
			ifNil: [delay wait]
			ifNotNil: [
				next size == 1 
					ifTrue: [finished := true]
					ifFalse: [
						buffer := codec decodeCompressedDataNoReset: next.
						sound add: (SampledSound samples: buffer samplingRate: GSMCodec samplingRate ).
						count := count + 1.
					].
			].
	].
	Transcript show: 'RECEIVED ', count, ' SAMPLES'; cr.
! !

!QClientSpeakerSqueakOutput methodsFor: 'initialize' stamp: 'jdm 8/21/2007 08:18'!
initialize
	super initialize.
	sound := QueueSound new.
	sound play.
	transform := Matrix4x4 new.! !

!QClientSpeakerSqueakOutput methodsFor: 'initialize' stamp: 'bgf 8/3/2007 15:58'!
initializeBuffers
	"Just make sure the QueueSound is playable, in case we stopped previously."
	sound play.
 ! !

!QClientSpeakerSqueakOutput methodsFor: 'private' stamp: 'jcg 2/23/2007 13:55'!
privateStop
	sound stopAfterMSecs: 0! !

!QClientSpeakerSqueakOutput methodsFor: 'private' stamp: 'jcg 11/26/2007 00:49'!
privateUpdateTransform
	"TODO: spatialize the voice chat (the responsibility for this is distributed between this method, and the place where the sound is actually played."! !

!QClientSpeakerSqueakOutput methodsFor: 'buffering' stamp: 'jcg 9/13/2009 16:00'!
processBuffers
	"Transfer all received sound into the Squeak sound queue."
	| soundBuffer |
	[soundBuffer := soundQueue nextOrNil] whileNotNil: [
		| sampledSound |
		sampledSound := SampledSound 
							samples: soundBuffer 
							samplingRate: audioFormat samplingRate.
		sampledSound loudness: (self gain).
		sound add: sampledSound.
	].! !

TObject subclass: #QStreamingSoundRelay
	instanceVariableNames: 'speaker playing streamID publication isMicrophoneEnabled loginName lastActivity lastShownActivity serverTimeOffset'
	classVariableNames: ''
	poolDictionaries: 'OpenALConstants TMediaStreamConstants'
	category: 'Qwaq-Sound-Chat'!

!QStreamingSoundRelay commentStamp: '<historical>' prior: 0!
The following is an old comment from QSoundRelay, which this class evolved from.  Some of it is no longer correct (eg: voice is no longer transported via future-sends).

Mediator between QVoiceRecorder (a harness-side object managed by OpenALHarness) and QSpeaker (a Croquet object within a TIsland.)   Acts as a 'streamer' for the voice recorder, by future-sending requests from the recorder to the speaker.

The 'speaker' instance variable is always the TFarRef of a QSpeaker, and we operated by future-sending sound buffers to it as they arrive from the recorder.  Those future messages are delivered to all replicants, which is how sound from a user's microphone is broadcast to all participants.!

!QStreamingSoundRelay class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QStreamingSoundRelay class methodsFor: 'utilities' stamp: 'jcg 3/7/2010 20:01'!
createAudioDatagramPayload: data at: frameAndServerTimes codec: codec level: level
	"Convenience method for creating a datagram payload for our standard voice-chat."
	| allData codecByte |
	allData := ByteArray new: 1 + 4 + 4 + 1 + 8 + data size.

	"This isn't necessary in QStreamingSoundRelay (eg: in #reallyPlaySound:at:samplingRate:codec:level:)... now that we're sending the data down a stream sub-channel, we don't need to differentiate between Media vs. Control datagrams.  However, we add this byte anyway to maintain compatibility with Sami/Howard's mobile-client, which uses the old approach."
	allData at: 1 put: Media.

	"Instead of storing the timestamp as a double-precision floating point number, store it as a 4-byte unsigned integer.  In the remaining four bytes, store the 'server-timestamp' (see #serverTimeStampFor:)."
	allData networkUnsignedLongAt: 2 put: frameAndServerTimes first.
	allData networkUnsignedLongAt: 6 put: frameAndServerTimes second.

	false ifTrue: [Transcript show: 'INPUT LEVEL: ', level printString; cr].

	"TODO: make this prettier and more robust"
	codec == nil ifTrue: [codecByte := 0].
	codec == GSMCodec ifTrue: [codecByte := 1].
	codec == QSpeexCodec ifTrue: [codecByte := 2].

	allData at: 10 put: codecByte.
	allData networkDoubleAt: 11 put: level asFloat.
	allData replaceFrom: 19 to: allData size with: data.

	^allData! !

!QStreamingSoundRelay class methodsFor: 'utilities' stamp: 'jcg 3/7/2010 21:25'!
createAudioDatagramPayloadForEndOfAudiblePeriod
	"Convenience method for creating an 'end-of-utterance' datagram payload for our standard voice-chat."
	| allData |
	allData := ByteArray new: 1 + 8 + 1 + 8.

	"This isn't necessary in QStreamingSoundRelay (eg: in #reallyPlaySound:at:samplingRate:codec:level:)... now that we're sending the data down a stream sub-channel, we don't need to differentiate between Media vs. Control datagrams.  However, we add this byte anyway to maintain compatibility with Sami/Howard's mobile-client, which uses the old approach."
	allData at: 1 put: Media.

	allData networkDoubleAt: 2 put: 0.0 "frame time... will be ignored".
	allData at: 10 put: 255 "codec byte of 255 means 'silence'.".
	allData networkDoubleAt: 11 put: 0.0.

	^allData
! !

!QStreamingSoundRelay class methodsFor: 'utilities' stamp: 'crl 3/5/2010 17:44'!
datagramPayloadFor: encodedAudio at: frameAndServerTimes codec: codec level: level
	"Convenience method for sending date from a QSoundRelay.  We could just send ourselves #sendMedia:, but this saves an extra copy of the data.  We put it on the event queue rather than sending it directly.

NOTE: this is in Qwaq-Sound because it uses QSpeexCodec, which is also in Qwaq-Sound."
	| allData codecByte |
	allData := ByteArray new: 4 + 4 + 1 + 8 + encodedAudio size.

	"Instead of storing the timestamp as a double-precision floating point number, store it as a 4-byte unsigned integer.  In the remaining four bytes, store the 'server-timestamp' (see #serverTimeStampFor:)."
	allData networkUnsignedLongAt: 1 put: frameAndServerTimes first.
	allData networkUnsignedLongAt: 5 put: frameAndServerTimes second.

	false ifTrue: [Transcript show: 'INPUT LEVEL: ', level printString; cr].

	"TODO: make this prettier and more robust"
	codec == nil ifTrue: [codecByte := 0].
	codec == GSMCodec ifTrue: [codecByte := 1].
	codec == QSpeexCodec ifTrue: [codecByte := 2].

	allData at: 9 put: codecByte.
	allData networkDoubleAt: 10 put: level asFloat.
	allData replaceFrom: 18 to: allData size with: encodedAudio.

	^allData! !

!QStreamingSoundRelay methodsFor: 'initialize' stamp: 'jcg 3/7/2010 02:55'!
destroy
	self destroyPublication. ! !

!QStreamingSoundRelay methodsFor: 'private' stamp: 'jcg 3/7/2010 02:55'!
destroyPublication
	"Destroy the publication; we don't need it any longer."
	publication ifNotNil: [:p |
		publication := nil.
		p destroy
	].
	! !

!QStreamingSoundRelay methodsFor: 'accessing' stamp: 'bgf 6/30/2009 15:05'!
disableMicrophone
	self isMicrophoneEnabled: false! !

!QStreamingSoundRelay methodsFor: 'accessing' stamp: 'bgf 6/30/2009 15:05'!
enableMicrophone
	self isMicrophoneEnabled: true! !

!QStreamingSoundRelay methodsFor: 'initialize' stamp: 'jcg 3/3/2010 12:23'!
initialize
	super initialize.
	playing := false.
	isMicrophoneEnabled := true.
	lastActivity := 0.
	lastShownActivity := 0.
	loginName := '(no name set)'.! !

!QStreamingSoundRelay methodsFor: 'accessing' stamp: 'bgf 6/30/2009 14:55'!
isMicrophoneEnabled
	"Is the sound relay enabled at source?
	 If not, no sound from the client - microphone is passed to the stream."
	^ isMicrophoneEnabled! !

!QStreamingSoundRelay methodsFor: 'accessing' stamp: 'jcg 3/3/2010 11:52'!
isMicrophoneEnabled: bEnabled
	"Is the sound relay enabled at source?
	 If not, no sound from the client-microphone is passed to the stream."
	isMicrophoneEnabled = bEnabled ifFalse: [
		isMicrophoneEnabled := bEnabled.
		isMicrophoneEnabled ifFalse: [self sendEndOfAudiblePeriod].
		self signal: #enabledChanged with: bEnabled
	].! !

!QStreamingSoundRelay methodsFor: 'accessing' stamp: 'jcg 3/7/2010 02:13'!
jitter
	^publication ifNotNil: [:pub | pub jitter]
! !

!QStreamingSoundRelay methodsFor: 'accessing' stamp: 'jcg 4/4/2007 17:02'!
loginName: nameString
	"Used to make explicit who created a media stream."
	loginName := nameString.! !

!QStreamingSoundRelay methodsFor: 'sound' stamp: 'bgf 6/30/2009 15:06'!
playSound:data at:frameTime samplingRate: samplingRate codec:codec level: level

	"Input sound may be disabled while a test sound is sent,  or for meeting-governance."
	isMicrophoneEnabled ifFalse: [^self].

	self 
		reallyPlaySound: data 
		at: frameTime 
		samplingRate: samplingRate
		codec: codec
		level: level
! !

!QStreamingSoundRelay methodsFor: 'sound' stamp: 'hrs 4/1/2010 16:22'!
reallyPlaySound:data at:frameTime samplingRate: samplingRate codec: codec level: level

	"Sound from the voice recorder or wherever.  Use streaming media to transport the sound, and future sends to transport visual speaker notifications.  See also #playSound:at:samplingRate:codec: (which is used by the sound recorder, but can be disabled."

	| |
	(playing & (speaker notNil)) ifTrue: [
		publication ifNotNil: [:pub |
			| payload |
			payload := QStreamingSoundRelay 
							createAudioDatagramPayload: data 
							at: {frameTime. self serverTimeStamp ifNil: [0]} 
							codec: codec 
							level: level.
			self signal: #sendingVoicePayload with: payload.
			[pub sendData: payload] 
				on: QStreamUnavailable 
				do: [QLogger logWarning: 'stream-input unavailable for sending audio'].
		
			self updateLevel: level.
		].
	].

	"Sound has been received from the microphone; 
	 we can use this to trigger visual updates, level changes, etc, in the UI.
	 The microphone lies sometimes, tells us zero when there is hiss-level noise."
	self signal: #activity with: ((level ifNil: [0]) max:1).
! !

!QStreamingSoundRelay methodsFor: 'sound' stamp: 'jcg 3/7/2010 02:29'!
sendEndOfAudiblePeriod
	publication ifNotNil: [:pub |
		| payload |
		payload := QStreamingSoundRelay
						createAudioDatagramPayloadForEndOfAudiblePeriod.
		[pub sendData: payload] 
			on: QStreamUnavailable 
			do: [QLogger logWarning: 'stream unavailable for sending end-of-utterance'].
	].
! !

!QStreamingSoundRelay methodsFor: 'accessing' stamp: 'jcg 1/8/2009 12:05'!
serverTimeStamp
	"Answer a reasonably good server based time stamp for the current time"
	^self serverTimeStampFor: Time millisecondClockValue! !

!QStreamingSoundRelay methodsFor: 'accessing' stamp: 'jcg 1/8/2009 22:40'!
serverTimeStampFor: localTime
	"Answer a reasonably good server based time stamp for the given local time.  (copied from version in QStreamingController)"
	^serverTimeOffset ifNotNil:[localTime + serverTimeOffset bitAnd: Time millisecondClockMask]! !

!QStreamingSoundRelay methodsFor: 'accessing' stamp: 'jcg 8/29/2008 14:21'!
speaker
	"Answer a far-ref to a QSpeaker."
	^ speaker! !

!QStreamingSoundRelay methodsFor: 'initialize' stamp: 'jcg 6/16/2010 18:49'!
speaker: aQSpeaker 

	| publishID p |

	self destroyPublication.

	speaker := aQSpeaker.
	speaker ifNil:[^self].
	serverTimeOffset := speaker controller cachedServerTimeOffset.

	"Need to create a new stream input."
	publishID := TObjectID new.
	streamID := TCryptoRandom hashMessage: publishID.

	publication := QAudioStreamPublication 
						publishID: publishID
						mediaController: speaker controller hub.
	publication propertyAt: 'name' put: loginName.
	publication propertyAt: 'streamName' put: 'Voice stream for ', loginName.
	p := publication connectWithTimeout: 120000 "msecs".
	p whenFulfilled: [:pub |
		pub isConnected
			ifTrue: [speaker future streamID: publication streamID]
			ifFalse: [
				pub == publication
					ifFalse: ["Do nothing... we destroyed the publication ourself"]
					ifTrue: [QLogger logWarning: 'could not publish audio stream']
			]
	].
! !

!QStreamingSoundRelay methodsFor: 'sound' stamp: 'bgf 11/8/2008 14:38'!
start
	playing := true.
	speaker isValidFarRef 
		ifTrue: [speaker future startPlaying]
		ifFalse: [speaker := nil]
! !

!QStreamingSoundRelay methodsFor: 'sound' stamp: 'jcg 3/7/2010 02:55'!
stop
	playing := false.
	self destroyPublication.
	speaker isValidFarRef ifTrue: [ 
		speaker future stopPlaying.
		speaker future streamID: nil.
	].! !

!QStreamingSoundRelay methodsFor: 'accessing' stamp: 'ar 10/1/2007 12:37'!
streamID
	^streamID! !

!QStreamingSoundRelay methodsFor: 'sound' stamp: 'hrs 4/1/2010 16:09'!
updateLevel: level
	"For visual feedback and X-is-speaking messages,
	 which are not needed at nearly the frequency of sound packets'
	 This is a future message, so capping the flow aids scalability."
	| time |
	time := Time millisecondClockValue.
	((time - lastActivity) > (QSpeaker activityMessageInterval)) ifTrue: [
		(level = 0 and: [ lastShownActivity = 0 ]) ifFalse: [
			speaker future showActivity: level.
		].
		lastActivity := time.
		lastShownActivity := level.
	].
! !

SharedPool subclass: #QCodecConstants
	instanceVariableNames: ''
	classVariableNames: 'CodecTypeAAC CodecTypeH264 CodecTypeSpeex'
	poolDictionaries: ''
	category: 'Qwaq-Sound-Codec'!

!QCodecConstants commentStamp: 'jcg 2/22/2009 23:14' prior: 0!
Constants used to specify codec types and parameters.  Used for both audio and video codecs (currently only for audio).!

Object subclass: #QAudioDecoder
	instanceVariableNames: 'handle configData'
	classVariableNames: ''
	poolDictionaries: 'QCodecConstants'
	category: 'Qwaq-Sound-Codec'!

!QAudioDecoder commentStamp: '<historical>' prior: 0!
Base class for audio-decoders.!

!QAudioDecoder class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioDecoder methodsFor: 'initialize' stamp: 'jcg 2/22/2009 23:15'!
codecType
	"Answer the appropriate type from QCodecConstants."
	self subclassResponsibility! !

!QAudioDecoder methodsFor: 'initialize' stamp: 'jcg 5/4/2010 18:52'!
createHandle: cd
	configData := cd.
	handle := self primCreateDecoder: self codecType configData: configData! !

!QAudioDecoder methodsFor: 'decoding' stamp: 'jcg 2/27/2009 02:46'!
decode: inputBytes into: buf "a SoundBuffer"
	^self decode: inputBytes offset: 0 into: buf! !

!QAudioDecoder methodsFor: 'decoding' stamp: 'jcg 5/4/2010 18:52'!
decode: inputBytes offset: inputOffset into: buf "a SoundBuffer"
	handle ifNil: [
		"More BS due to unloading QAudioPlugin.dll in reset-sound.  
		 See #hackClearHandle."
		configData 
			ifNotNil: [
				QLogger logWarning: 'creating handle from existing config-data'.
				self createHandle: configData
			]
			ifNil: [self error: 'decoder has no handle to decode with'].
	].

	buf size > 0 ifFalse: [
		QLogger logWarning: 'cannot decode into zero-length buf' every: 10000.
		^self
	].
	^self 
		primDecode: handle 
		input: inputBytes 
		count: inputBytes size - inputOffset 
		offset: inputOffset 
		into: buf 
		offset: 0 
		flags: 0! !

!QAudioDecoder methodsFor: 'initialize' stamp: 'jcg 2/22/2009 23:26'!
destroy
	handle ifNotNilDo: [:h |
		handle := nil.
		self primDestroyDecoder: h
	].! !

!QAudioDecoder methodsFor: 'initialize' stamp: 'jcg 5/4/2010 18:53'!
hackClearHandle
	"BS due to unloading QAudioPlugin.dll in reset-sound.  All QAudioDecoders now have invalid handles."
	handle := nil.! !

!QAudioDecoder methodsFor: 'primitives' stamp: 'jcg 2/22/2009 23:25'!
primCreateDecoder: codecType configData: configData
	"'codecType' is an integer specified in QCodecConstants, and 'configData' is a ByteArray whose size may differ for each codec type... it corresponds to a C-struct."
	<primitive: 'primitiveCreateAudioDecoder' module: 'QAudioPlugin'>
	self primitiveFailed! !

!QAudioDecoder methodsFor: 'primitives' stamp: 'jcg 3/26/2010 19:00'!
primDecode: hndl input: bytes count: inputSize offset: inputOffset into: aSoundBuffer offset: outputOffset flags: flags
	<primitive: 'primitiveAudioDecode' module: 'QAudioPlugin'>
	self primitiveFailed! !

!QAudioDecoder methodsFor: 'primitives' stamp: 'jcg 2/22/2009 23:25'!
primDestroyDecoder: decoderHandle
	<primitive: 'primitiveDestroyAudioDecoder' module: 'QAudioPlugin'>
	self primitiveFailed! !

QAudioDecoder subclass: #QAudioDecoderAAC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Codec'!

!QAudioDecoderAAC commentStamp: 'jcg 3/2/2009 12:23' prior: 0!
Decodes AAC (MPEG-4) audio.


HERE IS SOME TEST-CODE FOR EXERCISING THE DECODER

"Read encoded chunks from .media file."
track1 := (MP4BoxNHMLParser parseFileNamed: 'streamable/sample_h264_300kbit_track1.nhml') tracks anyOne.
hdr1 := track1 rawDecoderSpecificInfo.   "AudioSpecificConfig from ISO/IEC 14496-3:2001(E)"
file := FileStream readOnlyFileNamed: 'streamable/sample_h264_300kbit_track1.media'.
file binary.
data1 := track1 samples collect: [:s | 
	s filePosition = file position ifFalse: [self error: 'file-pos mismatch'].
	file next: s dataLength.
].
file close.

"Decoded and play the sound."
dec := QAudioDecoderAAC new.
dec createHandle: hdr1.
decoded := WriteStream on: (SoundBuffer newMonoSampleCount: 1024).
data1 do: [:d | | samp | 
	samp := SoundBuffer newMonoSampleCount: 1024.
	dec decode: d into: samp.
	decoded nextPutAll: samp.
].
snd := SampledSound samples: decoded contents samplingRate: 22050.
snd play.


BUT, YOU ASK, WHAT IS THIS  "AudioSpecificConfig" I'VE BEEN HEARING ABOUT?
Here are the AudioSpecificConfigs for the AAC tracks of a couple of real .mp4 files, "sample_h264_300kbit.mp4" and "MatrixReloaded-FightBeforeOracle.mp4", respectively.  Each of these consists of 2 bytes, but other lengths are possible

#(19 144) asByteArray =
16r1390
00010011 10010000
00010 0111 0010 0 0 0
base object type = 2		(5 bits)
sr_index = 7 = 22050		(4 bits)
num_channels = 2			(4 bits)
frame_length flag = 0		(1 bit)
delay = 0					(1 bit)
ext_flag = 0				(1 bit)

#(18 16) asByteArray =
16r1210
00010010 00010000
00010 0100 0010 0 0 0
base object type = 2		(5 bits)
sr_index = 4 = 44100		(4 bits)
num_channels = 2			(4 bits)
frame_length flag = 0		(1 bit)
delay = 0					(1 bit)
ext_flag = 0.  				(1 bit)!

!QAudioDecoderAAC class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioDecoderAAC methodsFor: 'initialize' stamp: 'jcg 2/22/2009 23:27'!
codecType
	^CodecTypeAAC! !

Object subclass: #QAudioEncoder
	instanceVariableNames: 'handle'
	classVariableNames: ''
	poolDictionaries: 'QCodecConstants'
	category: 'Qwaq-Sound-Codec'!

!QAudioEncoder commentStamp: '<historical>' prior: 0!
Base class for audio-encoders.!

!QAudioEncoder class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioEncoder methodsFor: 'initialize' stamp: 'jcg 6/12/2009 12:06'!
codecType
	"Answer the appropriate type from QCodecConstants."
	self subclassResponsibility! !

!QAudioEncoder methodsFor: 'initialize' stamp: 'jcg 6/13/2009 07:28'!
createHandle: configData
	handle := self 
				primCreateEncoder: self codecType 
				feedbackChannel: nil
				configData: configData! !

!QAudioEncoder methodsFor: 'initialize' stamp: 'jcg 8/12/2009 13:29'!
destroy
	handle ifNotNilDo: [:h |
		handle := nil.
		self primDestroyEncoder: h
	].! !

!QAudioEncoder methodsFor: 'primitives' stamp: 'jcg 6/13/2009 07:28'!
primCreateEncoder: codecType feedbackChannel: feedbackChannelHandle configData: configData
	"'codecType' is an integer specified in QCodecConstants, and 'configData' is a ByteArray whose size may differ for each codec type... it corresponds to a C-struct."
	<primitive: 'primitiveCreateAudioEncoder' module: 'QAudioPlugin'>
	self primitiveFailed! !

!QAudioEncoder methodsFor: 'initialize' stamp: 'jcg 6/12/2009 12:09'!
primDestroyEncoder: encoderHandle
	<primitive: 'primitiveDestroyAudioEncoder' module: 'QAudioPlugin'>
	self primitiveFailed! !

QAudioEncoder subclass: #QAudioEncoderAAC
	instanceVariableNames: 'feedbackChannel encodedSegments'
	classVariableNames: ''
	poolDictionaries: 'QCodecConstants'
	category: 'Qwaq-Sound-Codec'!

!QAudioEncoderAAC class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioEncoderAAC methodsFor: 'initialize' stamp: 'jcg 6/12/2009 20:08'!
codecType
	^CodecTypeAAC! !

!QAudioEncoderAAC methodsFor: 'initialize' stamp: 'jcg 6/13/2009 07:35'!
createHandle: configData
	feedbackChannel := QAudioFeedbackChannel new.
	feedbackChannel eventHandler: self.
	handle := self 
				primCreateEncoder: self codecType 
				feedbackChannel: feedbackChannel getHandle
				configData: configData.
! !

!QAudioEncoderAAC methodsFor: 'initialize' stamp: 'jcg 8/25/2009 20:52'!
destroy
	super destroy.
	feedbackChannel ifNotNil: [
		feedbackChannel destroy.
		feedbackChannel := nil.
	]! !

!QAudioEncoderAAC methodsFor: 'encoding' stamp: 'jcg 6/13/2009 16:03'!
encode: aSoundBuffer
	handle
		ifNil: [QLogger logWarning: 'encoder has no plugin-handle' every: 2000]
		ifNotNilDo: [:h | self primAsyncEncode: h input: aSoundBuffer].
! !

!QAudioEncoderAAC methodsFor: 'primitives' stamp: 'jcg 6/13/2009 16:02'!
primAsyncEncode: hndl input: aSoundBuffer
	<primitive: 'primitiveAudioAsyncEncode' module: 'QAudioPlugin'>
	self primitiveFailed! !

!QAudioEncoderAAC methodsFor: 'private' stamp: 'jcg 8/13/2009 02:25'!
processADTS: buffer
	"Work-in-progress.  We process the ADTS data, but don't actually do anything with it (except possibly blit it on the Display)."
	| stream isProtected objectType samplingFrequency privateBit channelConfig origCopy home emphasis frameLength bufferFullness numberRawBlocks |
	"
	Fixed (30 bits):
		Syncword						(12)
		ID								(1)
		Layer							(2)
		protection_absent				(1)
		Profile_ObjectType				(2)
		sampling_frequency_index	(4)
		private_bit						(1)
		channel_configuration			(3)
		original/copy					(1)
		home							(1)
		Emphasis						(2)
	Variable (28 bits):
		copyright_identification_bit		(1)
		copyright_identification_start		(1)
		aac_frame_length					(13)
		adts_buffer_fullness				(11)
		no_raw_data_blocks_in_frame		(2)
"

	stream := QBigEndianBitStream on: buffer.

	"ADTS fixed header."
	(stream next: 12) = 4095 ifFalse: [self error: 'expected ADTS syncword'].
	stream next = 0 ifFalse: [self error: 'expected MPEG-4 AAC, not MPEG-2'].
	(stream next: 2) = 0 ifFalse: [self error: 'layer should be 0x00'].
	isProtected := stream next = 0.
	objectType := stream next: 2.
	samplingFrequency := stream next: 4.
	privateBit := stream next.
	channelConfig := stream next: 3.
	origCopy := stream next.
	home := stream next.
	emphasis := stream next: 2.

	"ADTS variable header."
	stream next: 2.  "burn copyright bits"
	frameLength := stream next: 13.
	bufferFullness := stream next: 11.
	numberRawBlocks := stream next: 2.

true ifTrue: [
	('is protected: ', isProtected, '\objectType: ', objectType, '\samplingFrequency: ', samplingFrequency, '\privateBit: ', privateBit, '\channelConfig: ', channelConfig, '\origCopy: ', origCopy, '\home: ', home, '\emphasis: ', emphasis, '\\frameLength: ', frameLength, '\bufferFullness: ', bufferFullness, '\number of raw blocks: ', numberRawBlocks) withCRs displayAt: 0@0.
].

	^buffer
! !

!QAudioEncoderAAC methodsFor: 'feedback-channel' stamp: 'jcg 7/21/2011 23:22'!
processFeedbackChannelEvent: event from: channel
	| buf |
	feedbackChannel == channel ifFalse: [self error: 'received event from wrong channel'].
	buf := event buffer.

	"I don't believe that the issues below apply; we don't need to strip of ADTS headers."
	self signal: #encodedFrame with: buf.

	"Strip off the first 7 bytes of ADTS header (not quite sure why this works, 
	 because the header is 58 bits).  This is dumb... I'd rather not generate the 
	 header in the first place, but I can't get the MainConcept encoder to do it
	 (see comments in qAudioEncoderACC.cpp)."
"	self signal: #encodedFrame with: (buf copyFrom: 8 to: buf size)."
"	self signal: #encodedFrame with: (self processADTS: buf)."

	! !

QAudioEncoder subclass: #QAudioEncoderAAC
	instanceVariableNames: 'feedbackChannel encodedSegments'
	classVariableNames: ''
	poolDictionaries: 'QCodecConstants'
	category: 'Qwaq-Sound-Codec'!

!QCodecConstants class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QCodecConstants class methodsFor: 'class initialization' stamp: 'jcg 2/22/2009 23:13'!
initialize
	"QCodecConstants initialize"

	"Audio codec types."
	CodecTypeAAC := 1.
	CodecTypeSpeex := 2.

	"Video codec types."
	CodecTypeH264 := 1001.! !

SharedPool subclass: #QPhoneConstants
	instanceVariableNames: ''
	classVariableNames: 'IAXCCallStateActive IAXCCallStateBusy IAXCCallStateComplete IAXCCallStateFree IAXCCallStateOutgoing IAXCCallStateRinging IAXCCallStateSelected IAXCCallStateTransfer IAXCEventAudio IAXCEventDtmf IAXCEventLevels IAXCEventNetstat IAXCEventRegistration IAXCEventState IAXCEventText IAXCEventURL IAXCEventVideo IAXCEventVideostats IAXCRegistrationReplyAck IAXCRegistrationReplyRej IAXCRegistrationReplyTimeout QwaqGSMFrame'
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Feedback'!

!QPhoneConstants commentStamp: '<historical>' prior: 0!
Constants used by the various POTS-integration classes.!

Object subclass: #QIAXCallStateEventChangeRecord
	instanceVariableNames: 'oldState newState'
	classVariableNames: ''
	poolDictionaries: 'QPhoneConstants'
	category: 'Qwaq-Sound-POTS-Asterisk'!

!QIAXCallStateEventChangeRecord commentStamp: '<historical>' prior: 0!
Records the change between iaxclient call-states.!

!QIAXCallStateEventChangeRecord class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QIAXCallStateEventChangeRecord methodsFor: 'private' stamp: 'jcg 8/11/2008 16:40'!
changeString
	"Answer a string describing the changes between the old and new states."
	| changes output |
	changes := OrderedCollection new.
	{
		IAXCCallStateActive -> 'active'.
		IAXCCallStateOutgoing -> 'outgoing'. 
		IAXCCallStateRinging -> 'ringing'. 
		IAXCCallStateComplete -> 'complete'.
		IAXCCallStateSelected -> 'selected'. 
		IAXCCallStateBusy -> 'busy'. 
		IAXCCallStateTransfer -> 'transfer'
	} do: [:pair | | flag flagName |
		flag := pair key. flagName := pair value.
		(self changedFlags bitAnd: flag) >0 ifTrue: [
			changes add: 
				((newState bitAnd: flag) > 0 ifTrue: ['+'] ifFalse: ['-']), flagName.
		]
	].
	output := '('.
	changes do: [:c | output := output, c] separatedBy: [output := output, ','].
	output := output, ')'.
	^output! !

!QIAXCallStateEventChangeRecord methodsFor: 'accessing' stamp: 'jcg 8/11/2008 16:09'!
changedFlags
	^oldState bitXor: newState! !

!QIAXCallStateEventChangeRecord methodsFor: 'initialize' stamp: 'jcg 8/11/2008 15:56'!
old: oldStateFlags new: newStateFlags
	oldState := oldStateFlags.
	newState := newStateFlags.! !

Object subclass: #QPhoneCall
	instanceVariableNames: 'state outStream user callID recipient'
	classVariableNames: ''
	poolDictionaries: 'QPhoneConstants'
	category: 'Qwaq-Sound-POTS'!

!QPhoneCall commentStamp: '<historical>' prior: 0!
Instance variables:
	state		-	the current state of the phone call.
	outStream - 	the stream that this end of the phone call is sending audio over.
	user 		-	the local user who is participating in this call
	callID 		-	unique identifier for the call
	recipient	-	name/phone# of the person we're calling
	
Call states:
A phone call can be in one of the following states:
- #start
- #connecting
- #ringingInbound
- #ringingOutbound
- #talking
- #onHold
- #disconnected (actually, this might be orthogonal?)
- #busy
- #finished!

!QPhoneCall class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPhoneCall methodsFor: 'accessing' stamp: 'jcg 7/26/2008 10:25'!
callID
	^callID! !

!QPhoneCall methodsFor: 'initialize' stamp: 'jcg 7/26/2008 10:54'!
callID: cid
	callID := cid! !

!QPhoneCall methodsFor: 'accessing' stamp: 'jcg 8/28/2008 13:42'!
callState: newState

	"XXXXX: I would prefer to call this #state:, but it's easier to develop (due to less cluttered senders/implementors-of)"

	| previousState |
	state == newState ifTrue: [^self log: 'call ', callID hex, ' was already in state: ', state].

	QLogger logInfo: 'State changing to: ', newState, '  from: ', state.

	previousState := state.
	state := newState.
	state caseOf: {
		[#connecting] -> [self stateChangeToConnecting: previousState].
		[#ringingInbound] -> [self stateChangeToRingingInbound: previousState].
		[#ringingOutbound] -> [self stateChangeToRingingOutbound: previousState].
		[#talking] -> [self stateChangeToTalking: previousState].
		[#onHold] -> [self stateChangeToOnHold: previousState].
		[#disconnected] -> [self stateChangeToDisconnected: previousState].
		[#busy] -> [self stateChangeToBusy: previousState].
		[#finished] -> [self stateChangeToFinished: previousState].
	} otherwise: [self error: 'cannot transition to invalid call state: ', state].
	self signal: #stateChanged withArguments: {newState. previousState}.! !

!QPhoneCall methodsFor: 'initialize' stamp: 'jcg 8/27/2008 15:00'!
destroy
	"If user is already nil, this call has already been destroyed."
	user ifNotNilDo: [:u |
		| destroyedCall |
		user := nil. "avoid infinite recursion"
		destroyedCall := u destroyCallID: callID.
		(destroyedCall notNil and: [self ~~ destroyedCall]) ifTrue: [
			"We don't expect this to happen, and want to notice if it does."
			QLogger logError: 'user destroyed call: ', callID hex, ' but it was not me'.
		].
		"Finish destruction.  We might still need the user for this, so explicitly pass it as an argument."
		self privateDestroyInUser: u.
		self signal: #destroyed with: self.
	].

 ! !

!QPhoneCall methodsFor: 'synchronization' stamp: 'jcg 8/10/2008 23:55'!
futureDo: aSelector at: deltaMSecs args: args
	"Put this on our user's event-loop."
	deltaMSecs = 0 
		ifFalse:[^self error: 'Can only send messages in the indeterminite future'].
	user ifNotNilDo: [:u | u enqueueEvent: (MessageSend 
													receiver: self 
													selector: aSelector 
													arguments: args)].
	^nil
! !

!QPhoneCall methodsFor: 'synchronization' stamp: 'jcg 8/10/2008 23:56'!
futureSend: aSelector at: deltaMSecs args: args
	"Put this on our user's event-loop."
	| promise |
	deltaMSecs = 0 
		ifFalse:[^self error: 'Can only send messages in the indeterminite future'].
	promise := TPromise new.
	user ifNotNilDo: [:u | u enqueueEvent: (PromiseMessageSend 
															promise: promise
															receiver: self 
															selector: aSelector 
															arguments: args)].
	^promise
! !

!QPhoneCall methodsFor: 'private-xml' stamp: 'jcg 7/30/2008 00:58'!
handleXmlUpdateCallState: node
	node elementsDo: [:elem | self handleXmlUpdateCallStateElement: elem]! !

!QPhoneCall methodsFor: 'private-xml' stamp: 'jcg 8/14/2008 13:55'!
handleXmlUpdateCallStateElement: elem
	"Called by subclasses when they can't figure out what to do.  For now, we just drop it."		
	QLogger logWarning: 'unknown call-state element: ', elem printString
	! !

!QPhoneCall methodsFor: 'initialize' stamp: 'jcg 8/4/2008 11:25'!
initialize
	super initialize.
	state := #start.! !

!QPhoneCall methodsFor: 'logging' stamp: 'jcg 8/8/2008 00:23'!
log: msg
	QLogger log: msg from: self
	! !

!QPhoneCall methodsFor: 'accessing' stamp: 'jcg 7/30/2008 01:41'!
outStream
	^outStream! !

!QPhoneCall methodsFor: 'accessing' stamp: 'jcg 8/1/2008 17:57'!
outStreamID
	^outStream ifNotNilDo: [:s | s streamID].
! !

!QPhoneCall methodsFor: 'sound' stamp: 'jcg 8/29/2008 15:03'!
playSound: data at: frameTime samplingRate: samplingRate codec: codec level: level
	outStream ifNil: [^self].
	outStream stream ifNotNilDo: [:s |
		s addSoundData: data at: frameTime codec: codec level: level
	].! !

!QPhoneCall methodsFor: 'initialize' stamp: 'jcg 7/26/2008 12:45'!
privateDestroyInUser: myUser
	"Do whatever is necessary to finish destruction.  'myUser' is passed as an argument because the 'user' instance-variable has already been cleared (see #destroy)."
	outStream ifNotNilDo: [:s |
		outStream := nil.
		s destroy.
	].! !

!QPhoneCall methodsFor: 'publishing' stamp: 'jcg 11/23/2009 13:17'!
publishOutStream: publishID
	outStream ifNotNil: [self error: 'outStream already exists!!'].
	outStream := TMediaStreamPublication
							publishID: publishID
							mediaController: user mediaController
							inputClass: TAudioStreamInput
							outputClass: TAudioStreamOutput.
	outStream streamName: 'POTS audio stream for call: ', callID hex.

	outStream connectWithTimeout: 120000.! !

!QPhoneCall methodsFor: 'initialize' stamp: 'jcg 8/8/2008 01:25'!
recipient: phoneNumber
	recipient := phoneNumber! !

!QPhoneCall methodsFor: 'accessing' stamp: 'jcg 8/11/2008 00:11'!
state
	"The corresponding setter is #callState:, not #state (see comment in #callState:)."
	^state! !

!QPhoneCall methodsFor: 'private' stamp: 'jcg 8/8/2008 01:32'!
stateChangeToBusy: previousState
	self subclassResponsibility! !

!QPhoneCall methodsFor: 'private' stamp: 'jcg 8/8/2008 00:34'!
stateChangeToConnecting: previousState
	self subclassResponsibility! !

!QPhoneCall methodsFor: 'private' stamp: 'jcg 8/8/2008 00:34'!
stateChangeToDisconnected: previousState
	self subclassResponsibility! !

!QPhoneCall methodsFor: 'private' stamp: 'jcg 8/10/2008 17:40'!
stateChangeToFinished: previousState
	self destroy.! !

!QPhoneCall methodsFor: 'private' stamp: 'jcg 8/8/2008 00:34'!
stateChangeToOnHold: previousState
	self subclassResponsibility! !

!QPhoneCall methodsFor: 'private' stamp: 'jcg 8/8/2008 00:34'!
stateChangeToRingingInbound: previousState
	self subclassResponsibility! !

!QPhoneCall methodsFor: 'private' stamp: 'jcg 8/8/2008 00:34'!
stateChangeToRingingOutbound: previousState
	self subclassResponsibility! !

!QPhoneCall methodsFor: 'private' stamp: 'jcg 8/12/2008 15:21'!
stateChangeToTalking: previousState
	"Can only be talking if call was previously ringing, or on hold."
	(#(ringingInbound ringingOutbound onHold) includes: previousState)
		ifFalse: [self error: 'phone-calls can only be #talking state after ringing or on-hold'].! !

!QPhoneCall methodsFor: 'initialize' stamp: 'jcg 7/26/2008 10:54'!
user: aQPhoneUser 
	user := aQPhoneUser
! !

QPhoneCall subclass: #QPhoneCallOnClient
	instanceVariableNames: 'inStream speakerOutput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS'!

!QPhoneCallOnClient class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPhoneCallOnClient methodsFor: 'actions' stamp: 'jcg 8/26/2008 12:38'!
answer
	"Delegate to my user."
	user answerCall: callID.! !

!QPhoneCallOnClient methodsFor: 'sound' stamp: 'jcg 2/25/2010 14:11'!
handleAudioData: data
	"We've hardwired the following format:
		Byte 1		: command byte for TMessageChannel
		Byte 2-5		: time since beginning of utterance
		Byte 6-9		: approximate server time
		Byte 10		: codec
		Byte 11-18	: record level
		Byte 19-end	: audio data"
	| frameTime codec recordLevel audioData |

	frameTime := data networkUnsignedLongAt: 2.
	codec := data at: 10.
	codec == 0 ifTrue: [codec := nil].
	codec == 1 ifTrue: [codec := GSMCodec].
	codec == 2 ifTrue: [codec := QSpeexCodec].
	codec == 255 ifTrue: [^self "end of audible interval... now silence for a bit"].

	recordLevel := data networkDoubleAt: 11.
	audioData := data copyFrom: 19 to: 19+33-1.

	codec == GSMCodec ifFalse: [
		QLogger log: '#handleAudioData: can only handle GSM' from: self.
		^self
	].

	speakerOutput playSoundData: audioData timestamp: frameTime
! !

!QPhoneCallOnClient methodsFor: 'sound' stamp: 'jcg 8/10/2008 18:05'!
handleServerError: description stack: stack
	"Do we want to do anything beyond log'n'die?"
	| msg |
	msg := String streamContents: [:stream |
		stream 
			nextPutAll: 'call error on server: ';
			nextPutAll: description;
			cr;
			nextPutAll: stack;
			cr.
	].
	self log: msg.

	"This will cause the call the call to be removed from the user's list of calls."
	self callState: #finished. 

	self signal: #serverError.  "so that the UI can choose to react differently."! !

!QPhoneCallOnClient methodsFor: 'private-xml' stamp: 'jcg 8/14/2008 14:47'!
handleXmlUpdateCallStateElement: elem
	elem name caseOf: {
		['call-id'] -> ["Ignore; it was already used to look up this call."].
		['stream-id'] -> [
			"Subscribe to the specified stream, and publish our own stream."
			self subscribeToInStream: (TObjectID readHexFrom: elem contentString).
		].
		['state'] -> [
			"Set our state to mirror that of the server."
			self callState: elem contentString asSymbol.			
		].
	} otherwise: [super handleXmlUpdateCallStateElement: elem "let superclass try"].

! !

!QPhoneCallOnClient methodsFor: 'actions' stamp: 'jcg 8/27/2008 15:27'!
hangup
	"Delegate to my user."
	user hangupCall: callID.! !

!QPhoneCallOnClient methodsFor: 'initialize' stamp: 'jcg 8/19/2009 17:00'!
initialize
	super initialize.
	speakerOutput := QClientSpeakerSqueakOutput new.
	speakerOutput audioFormat: (QAudioFormat 
										codecClass: GSMCodec
										samplingRate: 8000
										numChannels: 1).
	speakerOutput play.! !

!QPhoneCallOnClient methodsFor: 'initialize' stamp: 'jcg 7/26/2008 12:45'!
privateDestroyInUser: myUser
	"Do whatever is necessary to finish destruction.  'myUser' is passed as an argument because the 'user' instance-variable has already been cleared (see #destroy)."
	super privateDestroyInUser: myUser.
	inStream ifNotNilDo: [:s |
		inStream := nil.
		s destroy.
	].! !

!QPhoneCallOnClient methodsFor: 'private' stamp: 'jcg 8/28/2008 10:57'!
stateChangeToBusy: previousState
	"#busy is for when the client places a call, and has heard back from the server that the call is busy."
	previousState == #ringingOutbound ifFalse: [
		self error: 'client phone-calls should only enter #busy state from #ringingOutbound'
	].
! !

!QPhoneCallOnClient methodsFor: 'private' stamp: 'jcg 8/10/2008 23:12'!
stateChangeToConnecting: previousState
	"#connecting is for when the client places a call, but no response from the server has yet been received."
	previousState == #start ifFalse: [
		self error: 'client phone-calls should only enter #connecting state from #start'
	].
! !

!QPhoneCallOnClient methodsFor: 'private' stamp: 'jcg 8/12/2008 01:59'!
stateChangeToRingingInbound: previousState
	"#ringingOutbound is for when the client places a call, and has heard back from the server that the call is ringing."
	previousState == #start ifFalse: [
		self error: 'client phone-calls should only enter #ringingInbound state from #start'
	].
! !

!QPhoneCallOnClient methodsFor: 'private' stamp: 'jcg 8/11/2008 14:52'!
stateChangeToRingingOutbound: previousState
	"#ringingOutbound is for when the client places a call, and has heard back from the server that the call is ringing."
	previousState == #connecting ifFalse: [
		self error: 'client phone-calls should only enter #ringingOutbound state from #connecting'
	].
! !

!QPhoneCallOnClient methodsFor: 'subscribing' stamp: 'jcg 11/23/2009 13:17'!
subscribeToInStream: streamID
	inStream ifNotNil: [
		| errMsg |
		inStream streamID = streamID ifTrue: [^self "no problem, just a duplicate"].
		errMsg := 'phone-call already has an in-stream (', inStream streamID, 
					')... new stream-id does not match (', streamID hex, ')'.
		self error: errMsg.
	].
	inStream := TMediaStreamSubscription
							streamID: streamID
							mediaController: user mediaController
							inputClass: TAudioStreamInput
							outputClass: TAudioStreamOutput.
	self runScript: #handleAudioData: when: {inStream. #sendMedia}.
	inStream unpause.

	inStream connectWithTimeout: 120000.! !

QPhoneCall subclass: #QPhoneCallOnServer
	instanceVariableNames: 'inStreams callNo stateFlags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS'!

!QPhoneCallOnServer commentStamp: '<historical>' prior: 0!
Instance variables:
	inStreams 	- 	in-Forum streams that the server must subscribe to, mix, 
					and send to the phone participants
	callNo		- 	iaxclient callNo!

!QPhoneCallOnServer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPhoneCallOnServer methodsFor: 'accessing' stamp: 'jcg 8/7/2008 14:57'!
callNo
	"This is an iaxclient thing... if we eventually have more than one phone-system-interface (with corresponding QPhoneCallOnServer subclasses) then we'll probably want to move this to a subclass."
	^callNo! !

!QPhoneCallOnServer methodsFor: 'initialize' stamp: 'jcg 8/7/2008 14:56'!
callNo: anInteger 
	"This is an iaxclient thing... if we eventually have more than one phone-system-interface (with corresponding QPhoneCallOnServer subclasses) then we'll probably want to move this to a subclass."
	callNo := anInteger.
! !

!QPhoneCallOnServer methodsFor: 'sound' stamp: 'jcg 1/8/2009 16:25'!
handleAudioData: data
	"We've hardwired the following format:
		Byte 1		: command byte for TMessageChannel
		Byte 2-9		: float time of the audio sample
		Byte 10		: codec
		Byte 11-18	: record level
		Byte 19-end	: audio data"
	| frameTime codec recordLevel audioData |

	frameTime := data networkUnsignedLongAt: 2.
	codec := data at: 10.
	codec == 0 ifTrue: [codec := nil].
	codec == 1 ifTrue: [codec := GSMCodec].
	codec == 2 ifTrue: [codec := QSpeexCodec].
	codec == 255 ifTrue: [^self "end of audible interval... now silence for a bit"].

	recordLevel := data networkDoubleAt: 11.
	audioData := data copyFrom: 19 to: data size.

	codec == GSMCodec ifFalse: [
		QLogger log: '#handleAudioData: can only handle GSM' from: self.
		^self
	].

	"The user's phone-system interface will ultimately decide what to do with this."
	user ifNotNilDo: [:u | u hackPushGSM: audioData].

	
"
	str := WriteStream on: (String new: 1000).
	str 
		nextPutAll: 'FRAME TIME: '; nextPutAll: frameTime printString;
		nextPutAll: '   CODEC: '; nextPutAll: codec printString;
		nextPutAll: '   AUDIO DATA: '; nextPutAll: audioData printString.
	str contents displayAt: 10@10.
"
	

! !

!QPhoneCallOnServer methodsFor: 'initialize' stamp: 'jcg 8/10/2008 23:24'!
initialize
	super initialize.
	inStreams := Dictionary new.

	stateFlags := IAXCCallStateFree.! !

!QPhoneCallOnServer methodsFor: 'downstream messages' stamp: 'jcg 8/14/2008 15:00'!
sendCallStateDownstream
	[
		user sendCommand: 'call-state' xmlBlock: [:writer |
			writer tag: 'call-id' pcData: callID hex.
			writer tag: 'state' pcData: state.
			self outStreamID ifNotNilDo: [:id | writer tag: 'stream-id' pcData: id hex].
		].
	] on: Error do: [:err |
		self logError: 'failed to send call-state downstream because: ', err description.
	]
! !

!QPhoneCallOnServer methodsFor: 'private' stamp: 'jcg 8/28/2008 10:48'!
stateChangeToBusy: previousState
	previousState == #ringingOutbound ifFalse: 
		[QLogger logWarning: 'should only transition to #busy from #ringingOutbound'].
	self sendCallStateDownstream.! !

!QPhoneCallOnServer methodsFor: 'private' stamp: 'jcg 8/8/2008 00:36'!
stateChangeToConnecting: previousState
	"#connecting is for when the client places a call, but no response from the server has yet been received."
	self error: 'server phone-calls should not enter #connecting state'! !

!QPhoneCallOnServer methodsFor: 'private' stamp: 'jcg 8/12/2008 01:23'!
stateChangeToOnHold: previousState
	"Notify downstream clients of the state-change."
	self sendCallStateDownstream
! !

!QPhoneCallOnServer methodsFor: 'private' stamp: 'jcg 8/12/2008 01:58'!
stateChangeToRingingInbound: previousState
	"Notify downstream clients of the state-change."
	self sendCallStateDownstream
! !

!QPhoneCallOnServer methodsFor: 'private' stamp: 'jcg 8/11/2008 00:34'!
stateChangeToRingingOutbound: previousState
	"Notify downstream clients of the state-change."
	self sendCallStateDownstream
! !

!QPhoneCallOnServer methodsFor: 'private' stamp: 'jcg 8/12/2008 15:22'!
stateChangeToTalking: previousState
	"Notify downstream clients of the state-change."
	super stateChangeToTalking: previousState. "check for previous-state error"
	self sendCallStateDownstream
! !

!QPhoneCallOnServer methodsFor: 'accessing' stamp: 'jcg 8/7/2008 18:33'!
stateFlags
	"Answer the flags from the most recent IAXClient call-state event."
	^stateFlags! !

!QPhoneCallOnServer methodsFor: 'accessing' stamp: 'jcg 8/7/2008 18:33'!
stateFlags: iaxFlags
	"Set the flags from the most recent IAXClient call-state event."
	stateFlags := iaxFlags.! !

!QPhoneCallOnServer methodsFor: 'subscribing' stamp: 'jcg 11/23/2009 13:17'!
subscribeToStream: streamID session: sessionID
	"XXXXX: This will need to be fixed when we want to have multiple Forums participants in a conversation."
	| stream |

	stream := inStreams at: sessionID ifAbsent: [nil].
	stream ifNotNil: [
		stream streamID = streamID 
			ifTrue: [^self "no change"]
			ifFalse: [
				"Replace with new stream."
				stream destroy.
				inStreams removeKey: streamID
			]
	].
	
	stream := TMediaStreamSubscription
									streamID: streamID
									mediaController: user mediaController
									inputClass: TAudioStreamInput
									outputClass: TAudioStreamOutput.
	self runScript: #handleAudioData: when: {stream. #sendMedia}.
	inStreams at: sessionID put: stream.
	stream unpause.

	stream connectWithTimeout: 120000.! !

!QPhoneConstants class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPhoneConstants class methodsFor: 'initialize' stamp: 'jcg 9/1/2008 11:58'!
initialize
	IAXCEventText := 1.
	IAXCEventLevels := 2.
	IAXCEventState := 3.
	IAXCEventNetstat := 4.
	IAXCEventURL := 5.
	IAXCEventVideo := 6.
	IAXCEventRegistration := 8.
	IAXCEventDtmf := 9.
	IAXCEventAudio := 10.
	IAXCEventVideostats := 11.

	IAXCCallStateFree := 0.
	IAXCCallStateActive := 2.
	IAXCCallStateOutgoing := 4.
	IAXCCallStateRinging := 8.
	IAXCCallStateComplete := 16.
	IAXCCallStateSelected := 32.
	IAXCCallStateBusy := 64.
	IAXCCallStateTransfer := 128.

	IAXCRegistrationReplyAck := 18.
	IAXCRegistrationReplyRej := 30.
	IAXCRegistrationReplyTimeout := 6.

	QwaqGSMFrame := 1000000.
! !

ExternalStructure subclass: #QPhoneFeedbackEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'QPhoneConstants'
	category: 'Qwaq-Sound-POTS-Feedback'!

!QPhoneFeedbackEvent commentStamp: '<historical>' prior: 0!
Base class for all POTS events received from QAudioPlugin. Includes IAX events, incoming audio data, etc.!

QPhoneFeedbackEvent subclass: #IAXEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'QPhoneConstants'
	category: 'Qwaq-Sound-POTS-Asterisk'!

!IAXEvent commentStamp: '<historical>' prior: 0!
Base class for all events defined in 'iaxclient.h'.

Subclasses act like 'deunionization' of 'struct iax_event_struct' (which consists of a 'type' field, followed by a union of type-specific structures).  In other words, they all start with a type flag, followed by the appropriate structure for that event type.!

IAXEvent subclass: #IAXAudioEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Asterisk'!

!IAXAudioEvent commentStamp: '<historical>' prior: 0!
Corresponds to 'struct iaxc_ev_audio' (type: IAXC_EVENT_AUDIO == 10).  See IAXEvent class comment.!

!IAXAudioEvent class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!IAXAudioEvent class methodsFor: 'field definition' stamp: 'jcg 7/25/2008 02:40'!
fields
	"IAXAudioEvent defineFields"
	^#(
		(type 'long')
		(callNo 'long')
		(ts 'ulong')
		(format 'long')
		(encoded 'long')
		(source 'long')
		(dataSize 'long')
		(data 'char*')
	)! !

!IAXAudioEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:40'!
callNo
	"This method was automatically generated"
	^handle signedLongAt: 5! !

!IAXAudioEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:40'!
callNo: anObject
	"This method was automatically generated"
	handle signedLongAt: 5 put: anObject! !

!IAXAudioEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:40'!
data
	"This method was automatically generated"
	^ExternalData fromHandle: (handle pointerAt: 29) type: ExternalType char asPointerType! !

!IAXAudioEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:40'!
data: anObject
	"This method was automatically generated"
	handle pointerAt: 29 put: anObject getHandle.! !

!IAXAudioEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:40'!
dataSize
	"This method was automatically generated"
	^handle signedLongAt: 25! !

!IAXAudioEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:40'!
dataSize: anObject
	"This method was automatically generated"
	handle signedLongAt: 25 put: anObject! !

!IAXAudioEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:40'!
encoded
	"This method was automatically generated"
	^handle signedLongAt: 17! !

!IAXAudioEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:40'!
encoded: anObject
	"This method was automatically generated"
	handle signedLongAt: 17 put: anObject! !

!IAXAudioEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:40'!
format
	"This method was automatically generated"
	^handle signedLongAt: 13! !

!IAXAudioEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:40'!
format: anObject
	"This method was automatically generated"
	handle signedLongAt: 13 put: anObject! !

!IAXAudioEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:40'!
source
	"This method was automatically generated"
	^handle signedLongAt: 21! !

!IAXAudioEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:40'!
source: anObject
	"This method was automatically generated"
	handle signedLongAt: 21 put: anObject! !

!IAXAudioEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:40'!
ts
	"This method was automatically generated"
	^handle unsignedLongAt: 9! !

!IAXAudioEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:40'!
ts: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 9 put: anObject! !

!IAXAudioEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:40'!
type
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!IAXAudioEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:40'!
type: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

IAXEvent subclass: #IAXCallStateEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Asterisk'!

!IAXCallStateEvent commentStamp: '<historical>' prior: 0!
Corresponds to 'struct iaxc_ev_call_state' (type: IAXC_EVENT_STATE == 3).  See IAXEvent class comment.!

!IAXCallStateEvent class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!IAXCallStateEvent class methodsFor: 'field definition' stamp: 'jcg 7/24/2008 23:16'!
fields
	"IAXCallStateEvent defineFields"
	^#(
		(type 'long')
		(callNo 'long')
		(state 'long')
		(format 'long')
		(vformat 'long')
		(remote 'char[256]')
		(remoteName 'char[256]')
		(local 'char[256]')
		(localContext 'char[256]')
	)! !

!IAXCallStateEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:17'!
callNo
	"This method was automatically generated"
	^handle signedLongAt: 5! !

!IAXCallStateEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:17'!
callNo: anObject
	"This method was automatically generated"
	handle signedLongAt: 5 put: anObject! !

!IAXCallStateEvent methodsFor: 'private' stamp: 'jcg 7/24/2008 15:02'!
charDataIndex
	"For some reason, it seems like that char* data starts on an 8-byte boundary within the 'struct iaxc_ev_call_state'."
	^21! !

!IAXCallStateEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:17'!
format
	"This method was automatically generated"
	^handle signedLongAt: 13! !

!IAXCallStateEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:17'!
format: anObject
	"This method was automatically generated"
	handle signedLongAt: 13 put: anObject! !

!IAXCallStateEvent methodsFor: 'testing' stamp: 'jcg 8/8/2008 00:07'!
isActive
	^ (self state bitAnd: IAXCCallStateActive) > 0! !

!IAXCallStateEvent methodsFor: 'testing' stamp: 'jcg 8/8/2008 00:08'!
isBusy
	^ (self state bitAnd: IAXCCallStateBusy) > 0! !

!IAXCallStateEvent methodsFor: 'testing' stamp: 'jcg 8/8/2008 00:08'!
isComplete
	^ (self state bitAnd: IAXCCallStateComplete) > 0! !

!IAXCallStateEvent methodsFor: 'testing' stamp: 'jcg 8/8/2008 00:07'!
isFree
	^self state = 0! !

!IAXCallStateEvent methodsFor: 'testing' stamp: 'jcg 8/8/2008 00:08'!
isOutgoing
	^ (self state bitAnd: IAXCCallStateOutgoing) > 0! !

!IAXCallStateEvent methodsFor: 'testing' stamp: 'jcg 8/8/2008 00:08'!
isRinging
	^ (self state bitAnd: IAXCCallStateRinging) > 0! !

!IAXCallStateEvent methodsFor: 'testing' stamp: 'jcg 8/8/2008 00:08'!
isSelected
	^ (self state bitAnd: IAXCCallStateSelected) > 0! !

!IAXCallStateEvent methodsFor: 'testing' stamp: 'jcg 8/8/2008 00:09'!
isTransferring
	^ (self state bitAnd: IAXCCallStateTransfer) > 0! !

!IAXCallStateEvent methodsFor: 'accessing-manual' stamp: 'jcg 7/24/2008 14:51'!
local
	"This method was MANUALLY generated"
	^self stringStartingAt: self charDataIndex +256+256! !

!IAXCallStateEvent methodsFor: 'accessing-manual' stamp: 'jcg 7/24/2008 14:52'!
localContext
	"This method was MANUALLY generated"
	^self stringStartingAt: self charDataIndex +256+256+256! !

!IAXCallStateEvent methodsFor: 'printing' stamp: 'jcg 9/1/2008 13:16'!
printOn: aStream
	| states |
	super printOn: aStream.
	states :={
				IAXCCallStateActive->'active'. 
				IAXCCallStateBusy->'busy'.
				IAXCCallStateComplete->'complete'.
				IAXCCallStateOutgoing->'outgoing'.
				IAXCCallStateRinging->'ringing'.
				IAXCCallStateSelected->'selected'.
				IAXCCallStateTransfer->'transfer'.
			}.
	states := states 
				select: [:st | (self state bitAnd: st key) > 0] 
				thenCollect: [:st | st value].
	states ifEmpty: [states := #('free')].

	aStream nextPut: $(.
	aStream nextPutAll: 'id-', self callNo, ':'.
	states do: [:st | aStream nextPutAll: st] separatedBy: [aStream nextPut: $|].
	aStream nextPut: $).
! !

!IAXCallStateEvent methodsFor: 'accessing-manual' stamp: 'jcg 7/24/2008 14:52'!
remote
	"This method was MANUALLY generated"
	^self stringStartingAt: self charDataIndex! !

!IAXCallStateEvent methodsFor: 'accessing-manual' stamp: 'jcg 7/24/2008 14:52'!
remoteName
	"This method was MANUALLY generated"
	^self stringStartingAt: self charDataIndex +256! !

!IAXCallStateEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:17'!
state
	"This method was automatically generated"
	^handle signedLongAt: 9! !

!IAXCallStateEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:17'!
state: anObject
	"This method was automatically generated"
	handle signedLongAt: 9 put: anObject! !

!IAXCallStateEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:17'!
type
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!IAXCallStateEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:17'!
type: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

!IAXCallStateEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:17'!
vformat
	"This method was automatically generated"
	^handle signedLongAt: 17! !

!IAXCallStateEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:17'!
vformat: anObject
	"This method was automatically generated"
	handle signedLongAt: 17 put: anObject! !

!IAXEvent class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!IAXEvent methodsFor: 'testing' stamp: 'jcg 7/28/2008 16:52'!
isIAXEvent
	^true! !

!IAXEvent methodsFor: 'private' stamp: 'jcg 7/24/2008 11:19'!
stringStartingAt: index
	"This method was manually generated"
	0 to: 255 do: [:i |
		(handle unsignedByteAt: index+i) == 0 ifTrue: [
			^ (handle copyFrom: index to: index + i - 1) asString
		]
	].
	^nil! !

IAXEvent subclass: #IAXLevelsEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Asterisk'!

!IAXLevelsEvent commentStamp: '<historical>' prior: 0!
Corresponds to 'struct iaxc_ev_levels' (type: IAXC_EVENT_LEVELS == 2).  See IAXEvent class comment.!

!IAXLevelsEvent class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!IAXLevelsEvent class methodsFor: 'field definition' stamp: 'jcg 7/24/2008 11:09'!
fields
	"IAXLevelsEvent defineFields"
	^#(
		(type 'long')
		(input 'float')
		(output 'float')
	)! !

!IAXLevelsEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 11:18'!
input
	"This method was automatically generated"
	^handle floatAt: 5! !

!IAXLevelsEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 11:18'!
input: anObject
	"This method was automatically generated"
	handle floatAt: 5 put: anObject! !

!IAXLevelsEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 11:18'!
output
	"This method was automatically generated"
	^handle floatAt: 9! !

!IAXLevelsEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 11:18'!
output: anObject
	"This method was automatically generated"
	handle floatAt: 9 put: anObject! !

!IAXLevelsEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 11:18'!
type
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!IAXLevelsEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 11:18'!
type: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

IAXEvent subclass: #IAXNetstatEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Asterisk'!

!IAXNetstatEvent commentStamp: '<historical>' prior: 0!
Corresponds to 'struct iaxc_ev_netstats' (type: IAXC_EVENT_NETSTAT == 4).  See IAXEvent class comment.!

!IAXNetstatEvent class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!IAXNetstatEvent class methodsFor: 'field definition' stamp: 'jcg 7/24/2008 22:27'!
fields
	"IAXNetstatEvent defineFields"
	^#(
		(type 'long')
		(callNo 'long')
		(rtt 'long')
		(localJitter 'long')
		(localLosspct 'long')
		(localLosscnt 'long')
		(localPackets 'long')
		(localDelay 'long')
		(localDropped 'long')
		(localOoo 'long')
		(remoteJitter 'long')
		(remoteLosspct 'long')
		(remoteLosscnt 'long')
		(remotePackets 'long')
		(remoteDelay 'long')
		(remoteDropped 'long')
		(remoteOoo 'long')
	)! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
callNo
	"This method was automatically generated"
	^handle signedLongAt: 5! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
callNo: anObject
	"This method was automatically generated"
	handle signedLongAt: 5 put: anObject! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
localDelay
	"This method was automatically generated"
	^handle signedLongAt: 29! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
localDelay: anObject
	"This method was automatically generated"
	handle signedLongAt: 29 put: anObject! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
localDropped
	"This method was automatically generated"
	^handle signedLongAt: 33! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
localDropped: anObject
	"This method was automatically generated"
	handle signedLongAt: 33 put: anObject! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
localJitter
	"This method was automatically generated"
	^handle signedLongAt: 13! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
localJitter: anObject
	"This method was automatically generated"
	handle signedLongAt: 13 put: anObject! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
localLosscnt
	"This method was automatically generated"
	^handle signedLongAt: 21! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
localLosscnt: anObject
	"This method was automatically generated"
	handle signedLongAt: 21 put: anObject! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
localLosspct
	"This method was automatically generated"
	^handle signedLongAt: 17! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
localLosspct: anObject
	"This method was automatically generated"
	handle signedLongAt: 17 put: anObject! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
localOoo
	"This method was automatically generated"
	^handle signedLongAt: 37! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
localOoo: anObject
	"This method was automatically generated"
	handle signedLongAt: 37 put: anObject! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
localPackets
	"This method was automatically generated"
	^handle signedLongAt: 25! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
localPackets: anObject
	"This method was automatically generated"
	handle signedLongAt: 25 put: anObject! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
remoteDelay
	"This method was automatically generated"
	^handle signedLongAt: 57! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
remoteDelay: anObject
	"This method was automatically generated"
	handle signedLongAt: 57 put: anObject! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
remoteDropped
	"This method was automatically generated"
	^handle signedLongAt: 61! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
remoteDropped: anObject
	"This method was automatically generated"
	handle signedLongAt: 61 put: anObject! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
remoteJitter
	"This method was automatically generated"
	^handle signedLongAt: 41! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
remoteJitter: anObject
	"This method was automatically generated"
	handle signedLongAt: 41 put: anObject! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
remoteLosscnt
	"This method was automatically generated"
	^handle signedLongAt: 49! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
remoteLosscnt: anObject
	"This method was automatically generated"
	handle signedLongAt: 49 put: anObject! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
remoteLosspct
	"This method was automatically generated"
	^handle signedLongAt: 45! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
remoteLosspct: anObject
	"This method was automatically generated"
	handle signedLongAt: 45 put: anObject! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
remoteOoo
	"This method was automatically generated"
	^handle signedLongAt: 65! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
remoteOoo: anObject
	"This method was automatically generated"
	handle signedLongAt: 65 put: anObject! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
remotePackets
	"This method was automatically generated"
	^handle signedLongAt: 53! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
remotePackets: anObject
	"This method was automatically generated"
	handle signedLongAt: 53 put: anObject! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
rtt
	"This method was automatically generated"
	^handle signedLongAt: 9! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
rtt: anObject
	"This method was automatically generated"
	handle signedLongAt: 9 put: anObject! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
type
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!IAXNetstatEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 22:28'!
type: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

IAXEvent subclass: #IAXRegistrationEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Asterisk'!

!IAXRegistrationEvent commentStamp: '<historical>' prior: 0!
Corresponds to 'struct iaxc_ev_registration' (type: IAXC_EVENT_REGISTRATION == 8).  See IAXEvent class comment.!

!IAXRegistrationEvent class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!IAXRegistrationEvent class methodsFor: 'field definition' stamp: 'jcg 7/25/2008 02:37'!
fields
	"IAXRegistrationEvent defineFields"
	^#(
		(type 'long')
		(id 'long')
		(reply 'long')
		(msgcount 'long')
	)! !

!IAXRegistrationEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:37'!
id
	"This method was automatically generated"
	^handle signedLongAt: 5! !

!IAXRegistrationEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:37'!
id: anObject
	"This method was automatically generated"
	handle signedLongAt: 5 put: anObject! !

!IAXRegistrationEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:37'!
msgcount
	"This method was automatically generated"
	^handle signedLongAt: 13! !

!IAXRegistrationEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:37'!
msgcount: anObject
	"This method was automatically generated"
	handle signedLongAt: 13 put: anObject! !

!IAXRegistrationEvent methodsFor: 'printing' stamp: 'jcg 9/1/2008 13:16'!
printOn: aStream
	| msg |
	super printOn: aStream.
	msg := 'id-', self id, ':'.
	self reply caseOf: {
		[IAXCRegistrationReplyAck] -> [msg := msg, 'ack'].
		[IAXCRegistrationReplyRej] -> [msg := msg, 'rej'].
		[IAXCRegistrationReplyTimeout] -> [msg := msg, 'timeout'].
	} otherwise: [msg := msg, 'unknown/', self reply].
	aStream nextPut: $(.
	aStream nextPutAll: msg.
	aStream nextPut: $).
	
	! !

!IAXRegistrationEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:37'!
reply
	"This method was automatically generated"
	^handle signedLongAt: 9! !

!IAXRegistrationEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:37'!
reply: anObject
	"This method was automatically generated"
	handle signedLongAt: 9 put: anObject! !

!IAXRegistrationEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:37'!
type
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!IAXRegistrationEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:37'!
type: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

IAXEvent subclass: #IAXTextEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Asterisk'!

!IAXTextEvent commentStamp: '<historical>' prior: 0!
Corresponds to 'struct iaxc_ev_text' (type: IAXC_EVENT_TEXT == 1).  See IAXEvent class comment.!

!IAXTextEvent class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!IAXTextEvent class methodsFor: 'field definition' stamp: 'jcg 7/24/2008 22:59'!
fields
	"IAXTextEvent defineFields"
	^#(
		(type 'long')
		(textType 'long')
		(callNo 'long')
		(message 'char[256]')
	)! !

!IAXTextEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:00'!
callNo
	"This method was automatically generated"
	^handle signedLongAt: 9! !

!IAXTextEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:00'!
callNo: anObject
	"This method was automatically generated"
	handle signedLongAt: 9 put: anObject! !

!IAXTextEvent methodsFor: 'accessing-manual' stamp: 'jcg 7/24/2008 17:12'!
message
	"This method was MANUALLY generated"
	^self stringStartingAt: 13! !

!IAXTextEvent methodsFor: 'printing' stamp: 'jcg 7/27/2008 12:40'!
printOn: aStream
	| msg |
	super printOn: aStream.
	msg := self message.
	msg size > 0 ifTrue: [
		aStream nextPut: $(.
		msg size > 30 ifTrue: [msg := (msg first: 30), '...'].
		aStream nextPutAll: msg.
		aStream nextPut: $).
	]
	
	! !

!IAXTextEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:00'!
textType
	"This method was automatically generated"
	^handle signedLongAt: 5! !

!IAXTextEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:00'!
textType: anObject
	"This method was automatically generated"
	handle signedLongAt: 5 put: anObject! !

!IAXTextEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:00'!
type
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!IAXTextEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:00'!
type: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

IAXEvent subclass: #IAXUrlEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Asterisk'!

!IAXUrlEvent commentStamp: '<historical>' prior: 0!
Corresponds to 'struct iaxc_ev_url' (type: IAXC_EVENT_URL == 5).  See IAXEvent class comment.!

!IAXUrlEvent class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!IAXUrlEvent class methodsFor: 'field definition' stamp: 'jcg 7/24/2008 16:49'!
fields
	"IAXUrlEvent defineFields"
	^#(
		(type 'long')
		(callNo 'long')
		(urlType 'long')
		(url 'char[256]')
	)! !

!IAXUrlEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 16:49'!
callNo
	"This method was automatically generated"
	^handle signedLongAt: 5! !

!IAXUrlEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 16:49'!
callNo: anObject
	"This method was automatically generated"
	handle signedLongAt: 5 put: anObject! !

!IAXUrlEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 16:49'!
type
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!IAXUrlEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 16:49'!
type: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

!IAXUrlEvent methodsFor: 'accessing-manual' stamp: 'jcg 7/24/2008 16:50'!
url
	"This method was MANUALLY generated"
	^self stringStartingAt: 13! !

!IAXUrlEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 16:50'!
urlType
	"This method was automatically generated"
	^handle signedLongAt: 9! !

!IAXUrlEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 16:50'!
urlType: anObject
	"This method was automatically generated"
	handle signedLongAt: 9 put: anObject! !

IAXEvent subclass: #IAXVideoEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Asterisk'!

!IAXVideoEvent commentStamp: '<historical>' prior: 0!
Corresponds to 'struct iaxc_ev_video' (type: IAXC_EVENT_VIDEO == 6).  See IAXEvent class comment.!

!IAXVideoEvent class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!IAXVideoEvent class methodsFor: 'field definition' stamp: 'jcg 7/24/2008 23:24'!
fields
	"IAXVideoEvent defineFields"
	^#(
		(type 'long')
		(callNo 'long')
		(ts 'ulong')
		(format 'long')
		(width 'long')
		(height 'long')
		(encoded 'long')
		(source 'long')
		(dataSize 'long')
		(data 'char*')
	)! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
callNo
	"This method was automatically generated"
	^handle signedLongAt: 5! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
callNo: anObject
	"This method was automatically generated"
	handle signedLongAt: 5 put: anObject! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
data
	"This method was automatically generated"
	^ExternalData fromHandle: (handle pointerAt: 37) type: ExternalType char asPointerType! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
data: anObject
	"This method was automatically generated"
	handle pointerAt: 37 put: anObject getHandle.! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
dataSize
	"This method was automatically generated"
	^handle signedLongAt: 33! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
dataSize: anObject
	"This method was automatically generated"
	handle signedLongAt: 33 put: anObject! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
encoded
	"This method was automatically generated"
	^handle signedLongAt: 25! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
encoded: anObject
	"This method was automatically generated"
	handle signedLongAt: 25 put: anObject! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
format
	"This method was automatically generated"
	^handle signedLongAt: 13! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
format: anObject
	"This method was automatically generated"
	handle signedLongAt: 13 put: anObject! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
height
	"This method was automatically generated"
	^handle signedLongAt: 21! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
height: anObject
	"This method was automatically generated"
	handle signedLongAt: 21 put: anObject! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
source
	"This method was automatically generated"
	^handle signedLongAt: 29! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
source: anObject
	"This method was automatically generated"
	handle signedLongAt: 29 put: anObject! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
ts
	"This method was automatically generated"
	^handle unsignedLongAt: 9! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
ts: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 9 put: anObject! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
type
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
type: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
width
	"This method was automatically generated"
	^handle signedLongAt: 17! !

!IAXVideoEvent methodsFor: 'accessing' stamp: 'jcg 7/24/2008 23:24'!
width: anObject
	"This method was automatically generated"
	handle signedLongAt: 17 put: anObject! !

IAXEvent subclass: #IAXVideostatsEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Asterisk'!

!IAXVideostatsEvent commentStamp: '<historical>' prior: 0!
Corresponds to 'struct iaxc_ev_video_stats' (type: IAXC_EVENT_VIDEOSTATS == 11).  See IAXEvent class comment.!

!IAXVideostatsEvent class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!IAXVideostatsEvent class methodsFor: 'field definition' stamp: 'jcg 7/25/2008 02:44'!
fields
	"IAXVideostatsEvent defineFields"
	^#(
		(type 'long')
		(callNo 'long')
		(receivedSlices 'ulong')
		(accRecvSize 'ulong')
		(sentSlices 'ulong')
		(accSentSize 'ulong')
		(droppedFrames 'ulong')
		(inboundFrames 'ulong')
		(outboundFrames 'ulong')
		(avgInboundFPS 'float')
		(avgInboundBPS 'ulong')
		(avgOutboundFPS 'float')
		(avgOutboundBPS 'ulong')
		"Not sure what to do about 'start_time', which is a 'struct timeval'."
	)! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
accRecvSize
	"This method was automatically generated"
	^handle unsignedLongAt: 13! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
accRecvSize: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 13 put: anObject! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
accSentSize
	"This method was automatically generated"
	^handle unsignedLongAt: 21! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
accSentSize: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 21 put: anObject! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
avgInboundBPS
	"This method was automatically generated"
	^handle unsignedLongAt: 41! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
avgInboundBPS: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 41 put: anObject! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
avgInboundFPS
	"This method was automatically generated"
	^handle floatAt: 37! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
avgInboundFPS: anObject
	"This method was automatically generated"
	handle floatAt: 37 put: anObject! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
avgOutboundBPS
	"This method was automatically generated"
	^handle unsignedLongAt: 49! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
avgOutboundBPS: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 49 put: anObject! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
avgOutboundFPS
	"This method was automatically generated"
	^handle floatAt: 45! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
avgOutboundFPS: anObject
	"This method was automatically generated"
	handle floatAt: 45 put: anObject! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
callNo
	"This method was automatically generated"
	^handle signedLongAt: 5! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
callNo: anObject
	"This method was automatically generated"
	handle signedLongAt: 5 put: anObject! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
droppedFrames
	"This method was automatically generated"
	^handle unsignedLongAt: 25! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
droppedFrames: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 25 put: anObject! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
inboundFrames
	"This method was automatically generated"
	^handle unsignedLongAt: 29! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
inboundFrames: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 29 put: anObject! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
outboundFrames
	"This method was automatically generated"
	^handle unsignedLongAt: 33! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
outboundFrames: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 33 put: anObject! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
receivedSlices
	"This method was automatically generated"
	^handle unsignedLongAt: 9! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
receivedSlices: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 9 put: anObject! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
sentSlices
	"This method was automatically generated"
	^handle unsignedLongAt: 17! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
sentSlices: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 17 put: anObject! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
type
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!IAXVideostatsEvent methodsFor: 'accessing' stamp: 'jcg 7/25/2008 02:44'!
type: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

!QPhoneFeedbackEvent class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPhoneFeedbackEvent methodsFor: 'testing' stamp: 'jcg 7/30/2008 16:52'!
isIAXEvent
	^false! !

QPhoneFeedbackEvent subclass: #QwaqGSMFrameEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Feedback'!

!QwaqGSMFrameEvent commentStamp: '<historical>' prior: 0!
Contains a 33-byte GSM-encoded frame!

!QwaqGSMFrameEvent class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QwaqGSMFrameEvent class methodsFor: 'field definition' stamp: 'jcg 7/30/2008 16:32'!
fields
	"QwaqGSMFrameEvent defineFields"
	^#(
		(type 'long')
		(callNo 'long')
		(data 'char[33]')
	)! !

!QwaqGSMFrameEvent methodsFor: 'accessing' stamp: 'jcg 7/30/2008 16:32'!
callNo
	"This method was automatically generated"
	^handle signedLongAt: 5! !

!QwaqGSMFrameEvent methodsFor: 'accessing' stamp: 'jcg 7/30/2008 16:32'!
callNo: anObject
	"This method was automatically generated"
	handle signedLongAt: 5 put: anObject! !

!QwaqGSMFrameEvent methodsFor: 'accessing' stamp: 'jcg 7/30/2008 16:55'!
data
	^handle copyFrom: 9 to: handle size! !

!QwaqGSMFrameEvent methodsFor: 'accessing' stamp: 'jcg 7/30/2008 16:32'!
type
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!QwaqGSMFrameEvent methodsFor: 'accessing' stamp: 'jcg 7/30/2008 16:32'!
type: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

Object subclass: #QPhoneSystemInterface
	instanceVariableNames: 'user handle feedback'
	classVariableNames: ''
	poolDictionaries: 'QPhoneConstants'
	category: 'Qwaq-Sound-POTS'!

!QPhoneSystemInterface commentStamp: 'jcg 8/7/2008 17:07' prior: 0!
Abstracts away the details of how a QPhoneUserOnServer interacts with the actual phone-system/telephony-platform that we are using (i.e Asterisk via iaxclient or SIP, etc.).  

The interface between the phone-user and the phone-system interface is bidirectional.  Native phone-system events are received and translated into message sends conforming to QPhoneUserOnServer's "phone-system interface" protocol.  In the other direction, the QPhoneSystemInterface specifies a "phone-user interface" protocol; subclasses are required to implement the methods in this protocol.

For now, the QPhoneSystemInterface is required to "future-send" these protocol messages to the QPhoneUserOnServer.  Perhaps the phone-user should provide an indirection so that #future is only used internally, but it doesn't work that way right now (and there might be good reasons not to).
!

QPhoneSystemInterface subclass: #QIaxclientInterface
	instanceVariableNames: 'callsByCallNo isDebugging iaxEvents stateTransitions chunkSpacer lastRegistration'
	classVariableNames: 'AllObservedStates'
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Asterisk'!

!QIaxclientInterface commentStamp: '<historical>' prior: 0!
Concrete implementation of QPhoneSystemInterface that knows how to talk with an Asterisk server via the "iaxclient" library.!

!QIaxclientInterface class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QIaxclientInterface class methodsFor: 'debugging' stamp: 'jcg 8/8/2008 12:37'!
clearObservedStates
	AllObservedStates := nil! !

!QIaxclientInterface class methodsFor: 'debugging' stamp: 'jcg 8/8/2008 12:37'!
observedStates
	AllObservedStates ifNil: [AllObservedStates := Set new].
	^AllObservedStates! !

!QIaxclientInterface methodsFor: 'phone-user interface' stamp: 'jcg 8/12/2008 02:20'!
answerCall: call "the actual call, not a callID"
	self primitiveIaxcSelectCall: call callNo
	! !

!QIaxclientInterface methodsFor: 'private' stamp: 'jcg 8/28/2008 15:52'!
attemptTransitionFor: call state: stateFlags
	"Answer true if a transition was found and performed, and false otherwise."
	| transitions |
	transitions := stateTransitions at: call state ifAbsent: [^false].
	transitions do: [:t |
		| filter action |
		filter := t key.  action := t value.
		(filter bitAnd: stateFlags) == filter ifTrue: [
			| extraFlags |
			extraFlags := stateFlags bitXor: filter.
			"XXXXX: good place to see which iaxclient events cause state changes."
			false "extraFlags > 0" ifTrue: [QLogger logInfo: 'matched transition from #', 
															call state, ' with extra flags: ', 
															extraFlags].
			action value: call value: stateFlags. 
			^true
		].
	].
	^false! !

!QIaxclientInterface methodsFor: 'accessing' stamp: 'jcg 8/10/2008 18:07'!
callClass
	^QPhoneCallOnServer! !

!QIaxclientInterface methodsFor: 'initialize' stamp: 'jcg 9/2/2008 12:49'!
createHandle

	handle ifNotNil: [^self].
	self primitiveIaxcInit.

	feedback := QPhoneUserFeedbackChannel new.
	feedback interface: self.
	"feedback setLogging: true."

	handle := self
				primitiveCreateHandle: user mungedUsername
				password: user password
				hostname: user phoneSystemHost
				feedbackChannel: feedback getHandle.

	"Put this here for now, since we don't have an #initialize/#destroy pair."
	chunkSpacer := QAudioChunkSpacer new.
	chunkSpacer interval: 20 "milliseconds".
	chunkSpacer consumer: self.
! !

!QIaxclientInterface methodsFor: 'initialize' stamp: 'jcg 9/5/2008 17:42'!
destroyHandle
	handle ifNotNil: [
		self primitiveDestroyHandle: handle.
		handle := nil
	].
	feedback ifNotNil: [
		"Important to do this after destroying the handle (so we don't try to use it)."
		feedback destroy.
		feedback := nil.
	].
	chunkSpacer ifNotNil: [
		chunkSpacer destroy.
		chunkSpacer := nil.
	].
	self primitiveIaxcShutdown.


! !

!QIaxclientInterface methodsFor: 'audio-processing' stamp: 'jcg 8/21/2008 15:25'!
hackPushGSM: bytes
	"We received an 80ms chunk of GSM-encoded audio.  Break it into 20ms chunks, and space the chunks temporally before sending them to iaxclient."
	| chunks str |
	chunks := OrderedCollection new.
	str := ReadStream on: bytes.
	[str atEnd] whileFalse: [chunks add: (str next: 33)].
	chunkSpacer enqueue: chunks.! !

!QIaxclientInterface methodsFor: 'audio-processing' stamp: 'jcg 8/21/2008 15:14'!
handleAudioChunk: bytes
	"Passed back to us by our QAudioChunkSpacer."
	self primitiveHackPushGSM: bytes! !

!QIaxclientInterface methodsFor: 'private' stamp: 'jcg 9/1/2008 12:59'!
handleCall: call stateEvent: iaxEvent
	| stateChange transitionResult |

	"Figure out which flags changes (we only use this for debugging), and replace the old flags with the new ones."
	
	"Check if the call is 'Free'; if so, we can exit early."
	iaxEvent isFree ifTrue: [
		^(call state == #finished)
			ifTrue: [QLogger logWarning: 'Call already finished, yet we received "Free"']
			ifFalse: [
				QLogger logInfo: 'Call ', call callID hex, ' was freed by iaxclient'.
				call callState: #finished "it will take care of tearing itself down"
			].
	].

	"If nothing has changed, exit early.  We're not currently expecting this, so log it; if this turns out to be commonplace, we'll change to return silently."
	iaxEvent state = call stateFlags ifTrue: [
		^QLogger logWarning: 'received call-state event (', iaxEvent, 
												'), but flags have not changed'.
	].	

	"Note what has changed."
	stateChange := QIAXCallStateEventChangeRecord new 
											old: call stateFlags new: iaxEvent state.
	call stateFlags: iaxEvent state.

	"Attempt to transition to a new state... if we can't, raise an error."
	transitionResult := self attemptTransitionFor: call state: iaxEvent state.
	transitionResult ifFalse: [
		self error: 'failed state transition from ', 
						call state printString, ' ', iaxEvent, '  ', stateChange changeString.
	].


! !

!QIaxclientInterface methodsFor: 'feedback-events' stamp: 'jcg 8/8/2008 12:34'!
handleCallStateEvent: iaxEvent
	"Interpret the IAX event, and either create a new call (if the call doesn't already exists), or make the appropriate change to an existing call."
	| call |

	self observeState: iaxEvent state.

	call := callsByCallNo at: iaxEvent callNo ifAbsent: [nil].
	call 
		ifNil: [self handleCallStateEventForNewCall: iaxEvent]
		ifNotNil: [self handleCall: call stateEvent: iaxEvent].
! !

!QIaxclientInterface methodsFor: 'private' stamp: 'jcg 8/13/2008 17:48'!
handleCallStateEventForNewCall: event
	| isRinging newCall |

	event isFree ifTrue: [
		"We expect an explicit hang-up first, which will cause the call to be destroyed.  If the call still exists in 'callsByCallNo', we should figure out why and address this issue."
		callsByCallNo at: event callNo ifPresent: [:c |
			QLogger logWarning: 
				'IAX "free" call-state for existing call: ', c callID hex, '  callNo: ', c callNo.
		].
		^self	
	].

	isRinging := (event state bitAnd: IAXCCallStateRinging) > 0.
	isRinging ifFalse: [^self log: 'new call event (ignoring because not ringing):  ', event].
	newCall := self callClass new
									user: user;
									callID: TObjectID new; 	
									callNo: event callNo;	
									publishOutStream: TObjectID new
									yourself.
	callsByCallNo at: newCall callNo put: newCall.
	user addNewCall: newCall state: #ringingInbound.
! !

!QIaxclientInterface methodsFor: 'feedback-events' stamp: 'jcg 8/7/2008 15:44'!
handleFeedbackEvent: event	
	event isIAXEvent 
		ifTrue: [self future handleIAXEvent: event "handle it within user's event-loop"]
		ifFalse: [
			"If it's not an IAX event, it must be a GSM event."
			event class == QwaqGSMFrameEvent
				ifTrue: [self handleGSMFrameFromIaxclient: event]
				ifFalse: [QLogger log: 'unhandled non-IAX event: ', event from: self]
		]
! !

!QIaxclientInterface methodsFor: 'feedback-events' stamp: 'jcg 1/8/2009 16:04'!
handleGSMFrameFromIaxclient: gsmFrameEvent
	| call |
	call := callsByCallNo at: gsmFrameEvent callNo ifAbsent: [
		^self log: 'received gsm frame, but no matching call for #', 
														gsmFrameEvent callNo.
	].
	call 
		playSound: gsmFrameEvent data 
		at: 0 "don't have a meaningful timestamp yet."
		samplingRate: 8000 
		codec: GSMCodec 
		level: 0 "don't yet compute the level".! !

!QIaxclientInterface methodsFor: 'feedback-events' stamp: 'jcg 8/7/2008 15:23'!
handleIAXEvent: event

	isDebugging ifTrue: [iaxEvents add: event "for later, manual perusal"].

	event class caseOf: {
		[IAXCallStateEvent] -> [self handleCallStateEvent: event].
		[IAXNetstatEvent] -> [self handleNetstatEvent: event].
		[IAXRegistrationEvent] -> [self handleRegistrationEvent: event].
		[IAXTextEvent] -> [self handleTextEvent: event].
	} otherwise: [QLogger log: 'unhandled IAX event: ', event from: self].
! !

!QIaxclientInterface methodsFor: 'feedback-events' stamp: 'jcg 8/10/2008 18:10'!
handleNetstatEvent: event
	"Maybe someday we'll care."! !

!QIaxclientInterface methodsFor: 'feedback-events' stamp: 'jcg 9/9/2008 02:46'!
handleRegistrationEvent: iaxEvent
	| isFailure |

	iaxEvent reply == IAXCRegistrationReplyAck ifTrue: [
		"As expected..."
		lastRegistration := Time millisecondClockValue.
		^user registrationAcknowledged
	].

	isFailure := {IAXCRegistrationReplyTimeout. IAXCRegistrationReplyRej} 
															includes: iaxEvent reply.
	isFailure ifFalse: [
		"It wasn't a success, and it wasn't a failure.. this is an unknown response.  Let's keep an eye on it."
		^QLogger logWarning: 'unknown registration event: ', iaxEvent
	].

	"If registration fails then log the error..."
	lastRegistration := nil.
	QLogger logWarning: 'Registration failure: ', iaxEvent printString.
	user sendCommand: 'user-error' xmlBlock: [:writer | 
		writer 
			startTag: 'registration-failure'; endTag;
				"XXXXX: probably want user-name, etc. here"
				tag: 'host' pcData: user phoneSystemHost;
			endTag: 'registration-failure'. 
	].

	"... and kill ourselves."
	"XXXXX: but not immediately... we want to avoid a race-condition in media-streams when a stream is being destroyed at the same time a request (i.e.w/ continuation to be resolved later) is simultaneously sent upstream.  This happens repeatably in the current implementation (where the client and server both reside within the Forums client) when a user is not registered with Asterisk."
	[	
		user ifNotNilDo: [:u | 
			(Delay forSeconds: 2) wait. 
			u future destroy
		]
	] fork.
! !

!QIaxclientInterface methodsFor: 'feedback-events' stamp: 'jcg 8/10/2008 18:09'!
handleTextEvent: event
	"Simply log the text-event (we'll probably want to send it down to the client later)."
	QLogger log: 'recieved text event: ', event from: self.! !

!QIaxclientInterface methodsFor: 'phone-user interface' stamp: 'jcg 8/27/2008 15:29'!
hangupCall: call "the actual call, not a callID"
	self primitiveIaxcHangupCall: call callNo
	! !

!QIaxclientInterface methodsFor: 'initialize' stamp: 'jcg 8/11/2008 18:15'!
initialize
	super initialize.
	isDebugging := false.
	callsByCallNo := Dictionary new.
	iaxEvents := OrderedCollection new.

	self initializeStateTransitions.! !

!QIaxclientInterface methodsFor: 'initialize' stamp: 'jcg 9/1/2008 02:40'!
initializeStateTransitions
	| transitions filter |
	stateTransitions := IdentityDictionary new.

	"Transitions from #start"
	stateTransitions at: #start put: (transitions := OrderedCollection new).
	filter := IAXCCallStateActive + IAXCCallStateOutgoing + IAXCCallStateRinging.
	transitions add: filter -> [:call :state | call callState: #ringingOutbound].
	filter := filter - IAXCCallStateRinging.
	transitions add: filter -> [:call :state | QLogger logInfo: 'iaxclient ignoring transition 1'].

	"Transitions from #ringingOutbound"
	stateTransitions at: #ringingOutbound put: (transitions := OrderedCollection new).
	filter := IAXCCallStateActive + IAXCCallStateOutgoing + IAXCCallStateComplete.
	transitions add: filter -> [:call :state |
		"XXXXX: should we use #primitiveIaxcSelectCall: here?"
		call callState: #talking.
	].
	"ringing can stop and start"
	filter :=  IAXCCallStateActive + IAXCCallStateOutgoing.
	transitions add: filter -> [:call :state | QLogger logInfo: 'iaxclient ignoring transition 2'].
	filter := IAXCCallStateActive + IAXCCallStateOutgoing + IAXCCallStateBusy.
	transitions add: filter -> [:call :state | call callState: #busy].

	"Transitions from #ringingInbound"
	stateTransitions at: #ringingInbound put: (transitions := OrderedCollection new).
	filter := IAXCCallStateActive + IAXCCallStateComplete.
	transitions add: filter -> [:call :state | call callState: #talking].

	"Transitions from #talking"
	stateTransitions at: #talking put: (transitions := OrderedCollection new).
	filter := IAXCCallStateTransfer.
	transitions add: filter -> [:call :state |
		"XXXXX: maybe this should be rolled into the #ringingOutbound transition"
		QLogger logInfo: 'ignoring "transfer" flag while in #talking state'.
	].

! !

!QIaxclientInterface methodsFor: 'private' stamp: 'jcg 8/8/2008 12:36'!
observeState: stateFlags
	isDebugging ifFalse: [^self].
	AllObservedStates ifNil: [AllObservedStates := Set new].
	AllObservedStates add: stateFlags! !

!QIaxclientInterface methodsFor: 'phone-user interface' stamp: 'jcg 8/10/2008 23:19'!
placeCall: callID recipient: dialString
	"Should only be called by a QPhoneUserOnServer."

	self log: 'placing call (id: ', callID hex, '  /  dialstring: ', dialString, ')'.

	user critical: [ 
		"It is also synchronized by the user (see #placeCall:recipient:), 
		but let's be explicit."
		| callNo newCall |
		callNo := self primitiveIaxcCall: dialString.
		callNo = -1 ifTrue: [self error: 'iaxc_call() failed'].
		callsByCallNo at: callNo ifPresent: [:c |
			"XXXXX: Uh-oh, we already have a call with that callNo.
			Not sure what to do; for now just stomp on it."
			self log: 'stomping on existing call: ', c callID hex, '/', callNo.
			user destroyCallID: c callID.
		].
		newCall := self callClass new
										user: user;
										callID: callID; 	
										callNo: callNo;	
										publishOutStream: TObjectID new
										yourself.
		callsByCallNo at: callNo put: newCall.
		^newCall		
	].! !

!QIaxclientInterface methodsFor: 'phone-user interface' stamp: 'jcg 8/13/2008 01:54'!
postDestroyCall: call
	"XXXXX: this is ugly; maybe interface can be more involved in #destroyCallID: ?"
	| foundCall |

	"Sanity check."
	foundCall := callsByCallNo removeKey: call callNo ifAbsent: [nil].
	foundCall == call ifFalse: [
		"If this happens, we're quite probably fubared."
		QLogger logError: 'call: ', call callID hex, ' with callNo ', call callNo, 
								' does not match call: ', 
								(foundCall ifNotNil: [foundCall callID hex]).
	].
	QLogger logInfo: 'hanging up call: ', call callID hex, '  callNo: ', call callNo.
	self primitiveIaxcHangupCall: call callNo.
	call callNo: #destroyed.
! !

!QIaxclientInterface methodsFor: 'primitives' stamp: 'jcg 2/24/2009 21:20'!
primitiveCreateHandle: nameString password: passwordString hostname: hostnameString feedbackChannel: channelHandle
	"The 'channelHandle' is the 'handle' of an ExternalAddress: the byte-array that holds a C-ptr."
	<primitive: 'primitiveCreatePhoneUser' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QIaxclientInterface methodsFor: 'primitives' stamp: 'jcg 8/13/2008 22:38'!
primitiveDestroyHandle: interfaceHandle
	"XXXXX: the primitive in QAudioPlugin should be renamed."
	<primitive: 'primitiveDestroyPhoneInterfaceIAX' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QIaxclientInterface methodsFor: 'primitives' stamp: 'jcg 8/1/2008 15:06'!
primitiveHackPushGSM: bytes
	"BLECH!! Push straight into our Digium-hacked iaxclient.  No mixing of multiple streams."
	<primitive: 'primitiveHackPushGSM' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QIaxclientInterface methodsFor: 'primitives' stamp: 'jcg 8/28/2008 15:02'!
primitiveIaxcAnswerCall: callNo
	"Answer the specified call."
	<primitive: 'primitiveIaxcAnswerCall' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QIaxclientInterface methodsFor: 'primitives' stamp: 'jcg 8/1/2008 15:06'!
primitiveIaxcCall: dialString
	"Dial the specified number, and answer the iaxclient 'callNo' (-1 represents an error condition)."
	<primitive: 'primitiveIaxcCall' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QIaxclientInterface methodsFor: 'primitives' stamp: 'jcg 8/13/2008 01:33'!
primitiveIaxcHangupCall: callNo
	"Select the specified call."
	<primitive: 'primitiveIaxcHangupCall' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QIaxclientInterface methodsFor: 'primitives' stamp: 'jcg 9/2/2008 11:40'!
primitiveIaxcInit
	"Inititialize iaxclient library (idempotent)."
	<primitive: 'primitiveIaxcInit' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QIaxclientInterface methodsFor: 'primitives' stamp: 'jcg 8/28/2008 15:04'!
primitiveIaxcQuelchCall: callNo musicOnHold: zeroOrOne "false or true"
	"Select the specified call."
	<primitive: 'primitiveIaxcQuelchCall' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QIaxclientInterface methodsFor: 'primitives' stamp: 'jcg 8/28/2008 15:02'!
primitiveIaxcRejectCall: callNo
	"Reject the specified call."
	<primitive: 'primitiveIaxcRejectCall' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QIaxclientInterface methodsFor: 'primitives' stamp: 'jcg 8/1/2008 15:06'!
primitiveIaxcSelectCall: callNo
	"Select the specified call."
	<primitive: 'primitiveIaxcSelectCall' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QIaxclientInterface methodsFor: 'primitives' stamp: 'jcg 8/28/2008 15:02'!
primitiveIaxcSendBusyForCall: callNo
	"Tell the other end of the specified call that we're busy."
	<primitive: 'primitiveIaxcSendBusyForCall' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QIaxclientInterface methodsFor: 'primitives' stamp: 'jcg 9/2/2008 11:40'!
primitiveIaxcShutdown
	"Shutdown iaxclient library (idempotent).  WARNING: most IAX primitives assume that iaxclient is initialized... it's up to you not to call them unless you know that iaxclient is initialized."
	<primitive: 'primitiveIaxcShutdown' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QIaxclientInterface methodsFor: 'primitives' stamp: 'jcg 8/28/2008 15:04'!
primitiveIaxcUnquelchCall: callNo
	"Select the specified call."
	<primitive: 'primitiveIaxcUnquelchCall' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QIaxclientInterface methodsFor: 'phone-user interface' stamp: 'jcg 8/28/2008 15:15'!
sendBusyForCall: call "the actual call, not a callID"
	self primitiveIaxcSendBusyForCall: call callNo
	! !

!QIaxclientInterface methodsFor: 'accessing' stamp: 'jcg 8/27/2008 11:02'!
timeSinceLastRegistration
	^lastRegistration ifNotNil: [Time millisecondsSince: lastRegistration].! !

!QPhoneSystemInterface class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPhoneSystemInterface class methodsFor: 'instance creation' stamp: 'jcg 8/1/2008 13:54'!
forUser: aQPhoneUserOnServer
	^self new initializeForUser: aQPhoneUserOnServer! !

!QPhoneSystemInterface methodsFor: 'phone-user interface' stamp: 'jcg 8/12/2008 02:18'!
answerCall: call "the actual call, not a callID"
	self subclassResponsibility! !

!QPhoneSystemInterface methodsFor: 'initialize' stamp: 'jcg 8/1/2008 13:52'!
createHandle
	self subclassResponsibility! !

!QPhoneSystemInterface methodsFor: 'synchronization' stamp: 'jcg 8/7/2008 15:55'!
futureDo: aSelector at: deltaMSecs args: args
	"Put this on our user's event-loop."
	deltaMSecs = 0 
		ifFalse:[^self error: 'Can only send messages in the indeterminite future'].
	user enqueueEvent: (MessageSend 
									receiver: self 
									selector: aSelector 
									arguments: args).
	^nil
! !

!QPhoneSystemInterface methodsFor: 'synchronization' stamp: 'jcg 8/10/2008 21:49'!
futureSend: aSelector at: deltaMSecs args: args
	"Put this on our user's event-loop."
	| promise |
	deltaMSecs = 0 
		ifFalse:[^self error: 'Can only send messages in the indeterminite future'].
	promise := TPromise new.
	user enqueueEvent: (PromiseMessageSend 
									promise: promise
									receiver: self 
									selector: aSelector 
									arguments: args).
	^promise
! !

!QPhoneSystemInterface methodsFor: 'initialize' stamp: 'jcg 8/1/2008 13:55'!
initializeForUser: aQPhoneUserOnServer
	user := aQPhoneUserOnServer! !

!QPhoneSystemInterface methodsFor: 'logging' stamp: 'jcg 8/1/2008 17:32'!
log: msg
	QLogger log: msg from: self! !

!QPhoneSystemInterface methodsFor: 'phone-user interface' stamp: 'jcg 8/1/2008 16:22'!
placeCall: callID recipient: dialString
	self subclassResponsibility! !

!QPhoneSystemInterface methodsFor: 'phone-user interface' stamp: 'jcg 8/13/2008 01:38'!
postDestroyCall: call
	"XXXXX: this is ugly; maybe interface can be more involved in #destroyCallID: ?"
	self subclassResponsibility! !

TObject subclass: #QPhoneUser
	instanceVariableNames: 'mutex name mediaController controlStreamID calls eventLoop eventQueue isRegistered'
	classVariableNames: ''
	poolDictionaries: 'QPhoneConstants'
	category: 'Qwaq-Sound-POTS'!

!QPhoneUser commentStamp: '<historical>' prior: 0!
A phone-user is an entity which can make or receive calls.  It need not correspond directly to a person; it could correspond to a role (sysadmin on duty) or a place (a particular Forum).  The responsibilities of phone-user differ somewhat between client and server code; subclasses are used to capture these differences.

TO-DO: make this a subclass of QNetworkElement, which generalized and improves the client-server communcication functionality.!

!QPhoneUser class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPhoneUser methodsFor: 'private' stamp: 'jcg 8/26/2008 11:34'!
addNewCall: callID
	| newCall |
	mutex critical: [
		calls at: callID ifPresent: [:ignore | self error: 'existing call with ID ', callID hex].
		newCall := self callClass new
									user: self;
									callID: callID;
									publishOutStream: TObjectID new;
									yourself.
		calls at: callID put: newCall.
		self signal: #addedCall with: newCall with: self.
		^newCall
	]! !

!QPhoneUser methodsFor: 'accessing' stamp: 'jcg 7/26/2008 17:07'!
callAt: callID
	^calls at: callID ifAbsent: [nil]! !

!QPhoneUser methodsFor: 'private' stamp: 'jcg 7/26/2008 01:19'!
callClass
	"Answer the class that is used to represent phone-calls (since calls need to be treated somewhat differently depending on whether they're on the client- or server-side)."
	self subclassResponsibility! !

!QPhoneUser methodsFor: 'accessing' stamp: 'jcg 7/30/2008 01:40'!
callsDo: aBlock
	calls valuesDo: [:c | aBlock value: c]! !

!QPhoneUser methodsFor: 'accessing' stamp: 'jcg 7/17/2008 01:34'!
controlStreamID
	^controlStreamID! !

!QPhoneUser methodsFor: 'synchronization' stamp: 'jcg 8/1/2008 16:21'!
critical: aBlock
	mutex critical: aBlock! !

!QPhoneUser methodsFor: 'initialize' stamp: 'jcg 8/27/2008 12:48'!
destroy
	mutex critical: [
		self stopEventLoop.
		self privateDestroy.
		self signal: #destroyed with: self.
	].
	QLogger logInfo: 'phone-user destroyed'.! !

!QPhoneUser methodsFor: 'actions' stamp: 'jcg 7/26/2008 11:07'!
destroyCallID: callID
	"Destroy the call with the specified callID.  Answer the call that was just destroyed (if any)."
	| call |
	mutex critical: [
		call := self unregisterCallID: callID.
		call ifNil: [^nil].
		call destroy.
	].
	self postDestroyCall: call.
	^call
! !

!QPhoneUser methodsFor: 'private' stamp: 'jcg 8/11/2008 13:38'!
enqueueEvent: msgSend
	eventQueue nextPut: msgSend.
! !

!QPhoneUser methodsFor: 'synchronization' stamp: 'jcg 8/7/2008 15:56'!
futureDo: aSelector at: deltaMSecs args: args
	"Send a message deltaSeconds into the future"
	deltaMSecs = 0 
		ifFalse:[^self error: 'Can only send messages in the indeterminite future'].
	self enqueueEvent: (MessageSend 
									receiver: self 
									selector: aSelector 
									arguments: args).
	^nil
! !

!QPhoneUser methodsFor: 'synchronization' stamp: 'jcg 8/7/2008 15:56'!
futureSend: aSelector at: deltaMSecs args: args
	"Send a message deltaSeconds into the future"
	| promise |
	deltaMSecs = 0 
		ifFalse:[^self error: 'Can only send messages in the indeterminite future'].
	promise := TPromise new.
	self enqueueEvent: (PromiseMessageSend 
									promise: promise
									receiver: self 
									selector: aSelector 
									arguments: args).
	^promise
! !

!QPhoneUser methodsFor: 'private' stamp: 'jcg 7/18/2008 10:41'!
generateCommand: cmdName xmlBlock: xmlWriterBlock
	^String streamContents: 
		[:s |
			| writer |
			writer := XMLWriter on: s.
			writer 
				startTag: 'command'; 
				attribute: 'type' value: cmdName;
				endTag.
			xmlWriterBlock value: writer.
			writer endTag: 'command'.
		].! !

!QPhoneUser methodsFor: 'network-commands' stamp: 'jcg 9/1/2008 01:02'!
handleCommandDatagram: dgram
	^ [self handleCommand: (self parseCommandDatagram: dgram)]
			on: Error 
			do: [:err |
				"Log the error, and generate an XML request
				(this might have been a request, not a command)."
				QLogger logError: 'failed to handle command datagram: ', err description.
				self generateCommand: 'user-error' xmlBlock: [:writer |
					writer tag: 'request-failure' pcData: err description, ' (in handler)'.
				].
			]! !

!QPhoneUser methodsFor: 'private' stamp: 'jcg 8/22/2008 15:29'!
handleEventLoopError: err
	"XXXXX: need some sensible error handling."
	QLogger logError: 'UNHANDLED EVENT LOOP ERROR: ', err description.! !

!QPhoneUser methodsFor: 'private-xml' stamp: 'jcg 8/8/2008 15:00'!
handleXmlCallError: node
	| callID description stack call |

	callID := node contentStringAt: 'call-id'.
	callID := callID ifEmpty: [nil] ifNotEmpty: [TObjectID readHexFrom: callID].

	description := node contentStringAt: 'description'.
	stack := node contentStringAt: 'stack'.

	"Find the corresponding call... if we can't find one, there's not much we can do."
	callID ifNil: [
		"If we don't have the callID, we have nothing."
		^self log: 'received call-error with no call-id (', description, ')'.
	].
	call := self callAt: callID.
	call ifNil: [
		"If we don't have the call, we also have nothing."
		^self log: 'received call-error, but could not find call: ', 
				callID hex, ' (', description, ')'.
	].

	call handleServerError: description stack: stack.! !

!QPhoneUser methodsFor: 'private-xml' stamp: 'jcg 8/8/2008 14:43'!
handleXmlUserError: node
	"Currently, the only user-error that we specifically handle is registration-failure, and even then only by logging it."
	node elements do: [:e |
		e name caseOf: {
			['registration-failure'] -> [self log: 'POTS registration failed'].
		} otherwise: [self log: 'unrecognized user-error: ', node].
	].! !

!QPhoneUser methodsFor: 'initialize' stamp: 'bgf 3/21/2009 21:13'!
initialize
	super initialize.
	isRegistered := false.
	mutex := Mutex new.
	calls := Dictionary new.

	eventQueue := SharedQueue new.
	self startEventLoop.! !

!QPhoneUser methodsFor: 'accessing' stamp: 'jcg 8/27/2008 12:34'!
isRegistered
	^isRegistered! !

!QPhoneUser methodsFor: 'logging' stamp: 'jcg 7/26/2008 10:32'!
log: logString
	QLogger log: logString from: self.! !

!QPhoneUser methodsFor: 'accessing' stamp: 'jcg 7/29/2008 23:03'!
mediaController
	^mediaController! !

!QPhoneUser methodsFor: 'initialize' stamp: 'jcg 7/11/2008 12:54'!
mediaController: hub
	mediaController := hub.! !

!QPhoneUser methodsFor: 'accessing' stamp: 'jcg 7/26/2008 15:13'!
name
	^name! !

!QPhoneUser methodsFor: 'initialize' stamp: 'jcg 7/11/2008 12:45'!
name: userName
	name := userName.! !

!QPhoneUser methodsFor: 'private' stamp: 'jcg 9/1/2008 02:48'!
parseCommandBytes: bytes
	"Parse the bytes into an XML-node, and do some minimal sanity checking."
	| doc node |
	doc := XMLDOMParser parseDocumentFrom: bytes asString readStream.
	node := doc elements first.
	node name == #command ifFalse: 
		[self error: '#parseCommandBytes:  expected "command" tag'].
	(node attributeAt: 'type') ifNil:
		[self error: '#parseCommandBytes:  no command type specified'].
	^node! !

!QPhoneUser methodsFor: 'private' stamp: 'jcg 9/1/2008 02:48'!
parseCommandDatagram: dgram
	"We're only interested in the datagram's payload.  Parse it, and answer the resulting XML-node."
	^self parseCommandBytes: dgram data! !

!QPhoneUser methodsFor: 'private' stamp: 'jcg 7/26/2008 11:00'!
postDestroyCall: call
	"The call was just destroyed.  Do any desired logging, notification, etc."
	self subclassResponsibility! !

!QPhoneUser methodsFor: 'private' stamp: 'jcg 7/18/2008 12:09'!
privateDestroy
	"This is called by #destroy, which wraps it in a critical section.  Subclasses should extend this method, not #destroy."
	calls do: [:c | c destroy].! !

!QPhoneUser methodsFor: 'private' stamp: 'jcg 7/9/2010 21:37'!
processEventLoopMessage: msg
	| result desc promise |

	"Debugging."
	false ifTrue: [
		desc := msg selector printString.
		msg arguments size > 0 ifTrue: [desc := desc, ' with: ', msg arguments].
		QLogger log: 'PROCESSING MESSAGE: ', desc from: msg receiver.
	].

	"Process the next event, and resolve the promise (if any)."
	promise := msg promise.
	[	result := msg receiver perform: msg selector withArguments: msg arguments.
		promise ifNotNil: [:p | p fulfill: result].
	] ifCurtailed: [promise ifNotNil: [:p | p break: 'event-loop process terminated']].

	"Debugging."
	false ifTrue: [QLogger log: 'END PROCESSING MESSAGE: ', desc from: msg receiver].
! !

!QPhoneUser methodsFor: 'private' stamp: 'jcg 8/27/2008 13:00'!
registrationAcknowledged
	QLogger logInfo: 'registration was acknowledged'.
	isRegistered := true.
	self signal: #registered with: self.! !

!QPhoneUser methodsFor: 'private' stamp: 'jcg 7/18/2008 10:41'!
sendCommand: cmdName xmlBlock: xmlWriterBlock
	"Clients need to send upstream, servers need to send downstream."
	self subclassResponsibility! !

!QPhoneUser methodsFor: 'initialize' stamp: 'jcg 8/10/2008 21:45'!
startEventLoop
	mutex critical: [
		self stopEventLoop.
		eventLoop := QSafeProcessLoop new.
		eventLoop priority: Processor lowIOPriority - 1. "not quite as high as network I/O"
		eventLoop actionBlock: [self processEventLoopMessage: eventQueue next].
		eventLoop handlerBlock: [:err | self handleEventLoopError: err].
		eventLoop start.
	]! !

!QPhoneUser methodsFor: 'initialize' stamp: 'bgf 8/30/2008 17:51'!
stopEventLoop
	mutex critical: [
		eventLoop ifNotNil: [
			eventLoop stop.
			eventLoop := nil.
			"The event loop won't stop until it can leave its event-queue wait."
			eventQueue nextPut: (MessageSend receiver: nil selector: #yourself).
		]
	]! !

!QPhoneUser methodsFor: 'private' stamp: 'jcg 8/12/2008 16:51'!
unregisterCallID: callID
	"Remove the call identified by 'callID' from my internal Dictionary(s).  Answer the call that was just unregistered."
	^calls removeKey: callID ifAbsent: [nil]! !

!QPhoneUser methodsFor: 'private-xml' stamp: 'jcg 8/14/2008 13:38'!
xmlCallID: node
	^self xmlOID: node for: 'call-id'! !

!QPhoneUser methodsFor: 'private-xml' stamp: 'jcg 8/14/2008 13:48'!
xmlOID: node for: elemName
	"Answer a TObjectID created from the pcData of the specified xml-element."
	^TObjectID readHexFrom: (node contentStringAt: elemName)! !

QPhoneUser subclass: #QPhoneUserOnClient
	instanceVariableNames: 'connectionState subscription sessionID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS'!

!QPhoneUserOnClient class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPhoneUserOnClient methodsFor: 'network-commands' stamp: 'jcg 8/27/2008 15:31'!
answerCall: callID
	| call |

	"Ensure that this call is answerable."
	call := self callAt: callID.
	call ifNil: [^QLogger logWarning: 'cannot answer call; no call with id', callID hex].
	call state == #ringingInbound ifFalse: [
		^QLogger logWarning: 'cannot answer call because state is ', call state printString
	].

	"Send the network command to answer the call."
	self sendCommand: 'answer-call' xmlBlock: [:writer |
		writer tag: 'call-id' pcData: callID hex.
	].

	"Now tell the server how to subscribe to our audio-stream."
	self sendCommand: 'set-call-inputStream'	xmlBlock: [:writer |
		writer tag: 'call-id' pcData: callID hex.
		writer tag: 'session-id' pcData: sessionID hex.
		writer tag: 'stream-id' pcData: call outStreamID hex.
	].

	^call

! !

!QPhoneUserOnClient methodsFor: 'private' stamp: 'jcg 7/26/2008 01:00'!
callClass
	"Answer the class that is used to represent phone-calls."
	^QPhoneCallOnClient! !

!QPhoneUserOnClient methodsFor: 'initialize' stamp: 'jcg 8/12/2008 12:06'!
destroySubscription
	mutex critical: [
		subscription ifNil: [^self].

		subscription destroy.
		subscription := nil.
		connectionState := #initial.

		self stopScript: #subscriptionDestroyed.
		self stopScript: #subscriptionConnected.
		self stopScript: #handleMedia:.
		self stopScript: #handleControl:.
	]! !

!QPhoneUserOnClient methodsFor: 'private' stamp: 'jcg 9/1/2008 00:35'!
handleCommand: node "an XML node"
	^(node attributeAt: 'type') caseOf: {
		['destroy-user'] -> [self future destroy.].
		['register-user'] -> [self future registrationAcknowledged.].
		['destroy-call'] -> [self future destroyCallID: (self xmlCallID: node)].
		['call-state'] -> [self future handleXmlUpdateCallState: node].
		['call-error'] -> [self future handleXmlCallError: node].
		['user-error'] -> [self future handleXmlUserError: node].
	}.
! !

!QPhoneUserOnClient methodsFor: 'private-xml' stamp: 'jcg 8/26/2008 11:32'!
handleXmlUpdateCallState: node
	| callID call |
	callID := self xmlCallID: node.
	call := calls at: callID ifAbsent: [
		| state |
		state := (node contentStringAt: 'state') asSymbol.
		state == #ringingInbound 
			ifFalse: [
				^self log: 'received call-state for unknown call ', callID hex,
							' but the state was not #ringingInbound ',
							' (instead: ', state printString, ')'.
			].

		"Someone is calling us... add a new call."
		QLogger logInfo: 'received new ringing, incoming call', callID hex.
		call := self addNewCall: callID.
		call callState: state.
	].
	call handleXmlUpdateCallState: node.
	! !

!QPhoneUserOnClient methodsFor: 'network-commands' stamp: 'jcg 8/27/2008 15:28'!
hangupCall: callID
	| call |

	"Ensure that this call is hangup-able."
	call := self callAt: callID.
	call ifNil: [^self log: 'cannot hangup call; no call with id', callID hex].

	"Send the network command to hangup the call."
	self sendCommand: 'hangup-call' xmlBlock: [:writer |
		writer tag: 'call-id' pcData: callID hex.
	].


! !

!QPhoneUserOnClient methodsFor: 'initialize' stamp: 'jcg 8/12/2008 12:06'!
initialize
	super initialize.
	connectionState := #initial.! !

!QPhoneUserOnClient methodsFor: 'network-commands' stamp: 'jcg 8/14/2008 14:37'!
placeCall: callID recipient: recipientUsername
	| call |
	call := self addNewCall: callID.
	call recipient: recipientUsername.

	"To signify that we're trying to connect a call, but haven't yet heard from the server."
	call callState: #connecting.

	"Send the network command to place the call."
	self sendCommand: 'place-call' xmlBlock: [:writer |
		writer tag: 'call-id' pcData: callID hex.
		writer tag: 'recipient' pcData: recipientUsername.
	].

	"Send the network command to establish an outbound audio channel (from us to the server.  This used to be part of the 'place-call' command above, but this failed to reflect that once we are doing public per-forum calls (instead of private per-user calls), the server will be subscribing to streams from multiple clients, not just the 'one who placed the call' (<- ignore the implication about how will will implement placing the call."
	self sendCommand: 'set-call-inputStream'	xmlBlock: [:writer |
		writer tag: 'call-id' pcData: callID hex.
		writer tag: 'session-id' pcData: sessionID hex.
		writer tag: 'stream-id' pcData: call outStreamID hex.
	].

	^call

! !

!QPhoneUserOnClient methodsFor: 'commands' stamp: 'jcg 8/10/2008 17:53'!
placeCallTo: recipientUsername
	"Answer a promise that will resolve to the placed call."
	^self future placeCall: TObjectID new recipient: recipientUsername
	! !

!QPhoneUserOnClient methodsFor: 'private' stamp: 'jcg 8/12/2008 16:46'!
postDestroyCall: call
	"XXXXX: we'll need to implement this later (for notifying the UI, removing script triggers, etc.)."! !

!QPhoneUserOnClient methodsFor: 'private' stamp: 'jcg 7/18/2008 12:10'!
privateDestroy
	"This is called by #destroy, which wraps it in a critical section.  Subclasses should extend this method, not #destroy."
	super privateDestroy.
	self destroySubscription.! !

!QPhoneUserOnClient methodsFor: 'private' stamp: 'jcg 8/31/2008 16:18'!
sendCommand: cmdName xmlBlock: writerBlock
	mutex critical: [
		[
			| cmd |
			subscription ifNil: [QStreamUnavailable signal].
			cmd := self generateCommand: cmdName xmlBlock: writerBlock.
			subscription sendCommand: cmd.
		] on: Error do: [:err |
			(err isKindOf: QStreamUnavailable)
				ifTrue: [QLogger logWarning: 'no stream to send command: ', cmdName]
				ifFalse: [
					QLogger logError: 'unexpected error while sending POTS command ',
								 						cmdName, ' (', err description, ')'.
					"XXXXX: should we kill ourselves?" "self destroy."
				].
		].
	].! !

!QPhoneUserOnClient methodsFor: 'private' stamp: 'jcg 6/16/2010 18:52'!
sendRequest: cmdName xmlBlock: writerBlock
	"Answer a promise that will be resolved when the request is answered (resolves to a parsed XML node), or when an error occurs (resolves to nil)."
	| promise |
	promise := TPromise new.
	mutex critical: [
		[
			| cmd |
			subscription ifNil: [QStreamUnavailable signal].
			cmd := self generateCommand: cmdName xmlBlock: writerBlock.
			(subscription sendRequest: cmd) whenFulfilled: [:result | 
				promise fulfill: (self parseCommandBytes: result).
			].
		] 
			on: Error 
			do: [:err |
				(err isKindOf: QStreamUnavailable)
					ifTrue: [QLogger logWarning: 'no stream to send request: ', cmdName]
					ifFalse: [
						QLogger logError: 'unexpected error while sending POTS request ',
									 					cmdName, ' (', err description, ')'.
					].
				promise fulfill: nil
			].
	].
	^ promise! !

!QPhoneUserOnClient methodsFor: 'initialize' stamp: 'jcg 8/14/2008 12:46'!
sessionID: clientSessionID
	"Unique ID that corresponds to a client session."
	sessionID := clientSessionID.! !

!QPhoneUserOnClient methodsFor: 'initialize' stamp: 'jcg 11/23/2009 13:17'!
streamID: aTObjectID
	mutex critical: [
		self destroySubscription "if there is one".
		controlStreamID := aTObjectID.
		controlStreamID ifNil: [^self "nothing to subscribe to"].
		subscription := QPhoneUserSubscription
										streamID: controlStreamID
										mediaController: mediaController
										inputClass: QControlStreamInput
										outputClass: QControlStreamOutput.
		subscription user: self.
		subscription unpause.
		self runScript: #subscriptionDestroyed: when: {subscription. #destroyed}.
		self runScript: #subscriptionConnected: when: {subscription. #connected}.

		connectionState := #connecting.

		subscription connectWithTimeout: 120000. "async"
	]! !

!QPhoneUserOnClient methodsFor: 'initialize' stamp: 'jcg 9/1/2008 00:06'!
subscriptionConnected: aSubscription
	mutex critical: [
		subscription == aSubscription ifFalse: [
			QLogger logWarning: '#subscriptionConnected: ...  subscription does not match'.
		].
		connectionState := #connected.
		self syncRequest.
	]! !

!QPhoneUserOnClient methodsFor: 'initialize' stamp: 'jcg 8/31/2008 15:59'!
subscriptionDestroyed: aSubscription
	mutex critical: [
		subscription == aSubscription ifFalse: [
			QLogger logError: '#subscriptionDestroyed: ...   subscription does not match' from: self.
			^self
		].
		connectionState := #initial.
		self stopScript: #subscriptionDestroyed:.
		self stopScript: #subscriptionConnected:.
		subscription := nil.
	]! !

!QPhoneUserOnClient methodsFor: 'network-commands' stamp: 'jcg 6/16/2010 18:51'!
syncRequest
	"Completely sync up with phone-user on server."
	| promise |
	promise := self sendRequest: 'sync-user-request' xmlBlock: [:writer | ].
	promise whenFulfilled: [:result "an XML node" | 
		| type |
		type := result ifNotNil: [result attributeAt: 'type'].
		type caseOf: {
			[nil] -> [QLogger logWarning: '#syncRequest failed locally'].
			['user-error'] -> [
				"Lazy... should format this better."
				QLogger logWarning: '#syncRequest failed remotely: ', result printString.
			].
			['sync-user-response'] -> [
				"XXXXX: placeholder, will be replaced soon."
				| callCount |
				callCount := 0.
				result elementsDo: [:e |
					e name caseOf: {
						['call'] -> [callCount := callCount + 1].
						['register-user'] -> [
							| serverIsRegistered |
							serverIsRegistered := e contentString = 'true'.
							serverIsRegistered ifTrue: [self registrationAcknowledged]
						].
					} otherwise: [
						QLogger logWarning: 'unknown #syncRequest element: ', e name.
					].
					QLogger logInfo: 'synced with server.  ', callCount, ' calls, ',
						(isRegistered ifTrue: ['is'] ifFalse: ['is not']), ' registered'.
				]
			]
		}
	].
! !

QPhoneUser subclass: #QPhoneUserOnServer
	instanceVariableNames: 'publishID publication password phoneSystemHost interface'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS'!

!QPhoneUserOnServer commentStamp: '<historical>' prior: 0!
Acts as the communications interface to 'iaxclient'.!

!QPhoneUserOnServer class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPhoneUserOnServer methodsFor: 'phone-system interface' stamp: 'jcg 8/10/2008 17:42'!
addNewCall: newCall state: newState
	calls 
		at: newCall callID 
		ifPresent: [:ignore | self error: 'existing call with ID ', newCall callID].
	calls at: newCall callID put: newCall.
	newCall callState: newState.! !

!QPhoneUserOnServer methodsFor: 'private' stamp: 'jcg 8/27/2008 15:30'!
answerCall: callID
	| call |

	"Ensure that the call is answerable."
	call := self callAt: callID.
	call ifNil: [^QLogger logWarning: 'cannot answer call; no call with id', callID hex].
	call state == #ringingInbound ifFalse: [
		^QLogger logWarning: 
					'cannot answer call because state is ', call state printString
	].

	"Delegate actual answering of the call to the phone-system interface."
	interface answerCall: call! !

!QPhoneUserOnServer methodsFor: 'private' stamp: 'jcg 8/7/2008 14:38'!
callClass
	"Answer the class that is used to represent phone-calls; delegate to the phone-system interface."
	^interface callClass! !

!QPhoneUserOnServer methodsFor: 'initialize' stamp: 'jcg 8/1/2008 14:24'!
createInterface
	self destroyInterface.  "destroy any existing interface before creating a new one."
	interface := QIaxclientInterface forUser: self.
	interface createHandle "XXXXX: dislike this, should be private to the interface." 
	! !

!QPhoneUserOnServer methodsFor: 'initialize' stamp: 'jcg 8/13/2008 01:59'!
destroyInterface
	interface ifNotNil: [
		interface destroyHandle.  "XXXXX: dislike this, should be private to the interface." 
		interface := nil
	]! !

!QPhoneUserOnServer methodsFor: 'private' stamp: 'jcg 7/18/2008 12:11'!
destroyPublication
	mutex critical: [
		publication ifNil: [^self].
		publication destroy.
		publication := nil.
	]! !

!QPhoneUserOnServer methodsFor: 'private' stamp: 'jcg 8/1/2008 16:15'!
generateDialString: recipientUsername
	"The phone-system interface should probably have some say in this, but it doesn't now."

	^	self mungedUsername, ':', 
		(QPhoneServer basicNew passwordFromUsername: self name), '@',
		phoneSystemHost, '/', 
		(recipientUsername copyReplaceAll: '@' with: '__AT__').! !

!QPhoneUserOnServer methodsFor: 'private' stamp: 'jcg 9/1/2008 09:22'!
generateSyncResponse

	"XXXXX: placeholder, will be replaced soon."

	^self generateCommand: 'sync-user-response' xmlBlock: [:writer |
		writer tag: 'register-user' pcData: isRegistered printString.
		calls do: [:call | 
			writer startTag: 'call'; endTag.
			writer tag: 'call-id' pcData: call callID hex.
			writer tag: 'state' pcData: call state.
			call outStreamID ifNotNilDo: [:id | writer tag: 'stream-id' pcData: id hex]. 
			writer endTag: 'call'.		
		]
	]! !

!QPhoneUserOnServer methodsFor: 'private' stamp: 'jcg 8/21/2008 15:19'!
hackPushGSM: bytes
	"BLECH!! Push straight into our Digium-hacked iaxclient.  No mixing of multiple streams."
	interface hackPushGSM: bytes! !

!QPhoneUserOnServer methodsFor: 'private' stamp: 'jcg 9/1/2008 02:50'!
handleCommand: node "an XML node"
	(node attributeAt: 'type') caseOf: {
		"Commands (no response required)"
		['place-call'] -> [self future
								placeCall: (self xmlCallID: node) 
								recipient: (node contentStringAt: 'recipient')].
		['answer-call'] -> [self future answerCall: (self xmlCallID: node)].
		['hangup-call'] -> [self future hangupCall: (self xmlCallID: node)].
		['set-call-inputStream'] -> [
			| callID streamID sessionID |
			callID := self xmlCallID: node.
			streamID := self xmlOID: node for: 'stream-id'.
			sessionID := self xmlOID: node for: 'session-id'.
			self future setCall: callID inputStreamID: streamID sessionID: sessionID.
		].
		"Requests (response required)."
		['sync-user-request'] -> [^self future generateSyncResponse]
	} otherwise: [self error: '#handleCommand: cannot match node: ', node printString].
! !

!QPhoneUserOnServer methodsFor: 'private' stamp: 'jcg 8/27/2008 15:33'!
hangupCall: callID
	| call |

	"Ensure that the call is hangup-able."
	call := self callAt: callID.
	call ifNil: [^QLogger logWarning: 'cannot hangup call; no call with id', callID hex].

	"Delegate actual hanging-up of the call to the phone-system interface."
	interface hangupCall: call! !

!QPhoneUserOnServer methodsFor: 'initialize' stamp: 'jcg 8/10/2008 22:09'!
initialize
	super initialize.
	self initializeStreamIDs.
! !

!QPhoneUserOnServer methodsFor: 'initialize' stamp: 'jcg 7/11/2008 12:47'!
initializeStreamIDs
	publishID := TObjectID new.
	controlStreamID := TCryptoRandom hashMessage: publishID.
	! !

!QPhoneUserOnServer methodsFor: 'accessing' stamp: 'jcg 8/28/2008 12:41'!
interface
	^interface! !

!QPhoneUserOnServer methodsFor: 'private' stamp: 'jcg 8/1/2008 13:59'!
mungeUsername: userName
	"Replace '@' with '__AT__' to make Asterisk happy (apparently '-' isn't a valid character for channel names... good luck finding that in any books/documentation)."
	^ userName copyReplaceAll: '@' with: '__AT__'.! !

!QPhoneUserOnServer methodsFor: 'accessing' stamp: 'jcg 8/1/2008 13:59'!
mungedUsername
	"Replace '@' with '__AT__' to make Asterisk happy (apparently '-' isn't a valid character for channel names... good luck finding that in any books/documentation)."
	^ self mungeUsername: name! !

!QPhoneUserOnServer methodsFor: 'initialize' stamp: 'jcg 8/1/2008 14:27'!
name: newNameString password: newPassword host: newHostname
	name = newNameString ifTrue: [^self "no change"].
	self name: newNameString.
	password := newPassword.
	phoneSystemHost := newHostname.

	self createInterface.
! !

!QPhoneUserOnServer methodsFor: 'accessing' stamp: 'jcg 8/1/2008 13:59'!
password
	^password! !

!QPhoneUserOnServer methodsFor: 'accessing' stamp: 'jcg 8/1/2008 13:57'!
phoneSystemHost
	"Answer the hostname of our interface to the phone system (eg: our Asterisk server)."
	^phoneSystemHost! !

!QPhoneUserOnServer methodsFor: 'private' stamp: 'jcg 8/14/2008 13:50'!
placeCall: callID recipient: recipientUsername
	[
		| newCall dialString |	
		(calls includesKey: callID) 
			ifTrue: [self error: 'call with ID: ', callID hex, ' already exists'].

		"XXXXX: 'interface' should play some role in generating dial-string."
		dialString := self generateDialString: recipientUsername. 

		newCall := interface placeCall: callID recipient: dialString.
		calls at: callID put: newCall.
	]
		on: Error 
		do: [:err | self sendError: err downstreamForCallID: callID]

! !

!QPhoneUserOnServer methodsFor: 'private' stamp: 'jcg 9/2/2008 12:54'!
postDestroyCall: call
	"Notify the client that the call is dead."

	"XXXXX: this is ugly; maybe interface can be more involved in #destroyCallID: ?"
	interface postDestroyCall: call.

	self sendCommand: 'destroy-call' xmlBlock: [:writer |
		writer tag: 'call-id' pcData: call callID hex.
	].

	"XXXXX: big hammer... destroy all calls and reset iaxclient."
	QLogger logWarning: 'BIG HAMMER: shutting down and restarting iaxclient'.
	calls do: [:c | c destroy].
	self destroyInterface.
	(Delay forSeconds: 1) wait.
	self createInterface.
	QLogger logWarning: 'BIG HAMMER: finished'.
! !

!QPhoneUserOnServer methodsFor: 'private' stamp: 'jcg 8/27/2008 12:47'!
privateDestroy
	super privateDestroy.
	self destroyInterface.
	self sendCommand: 'destroy-user' xmlBlock: [:writer | ].
	self destroyPublication.
! !

!QPhoneUserOnServer methodsFor: 'private' stamp: 'jcg 8/31/2008 15:59'!
publicationDestroyed: aPublication
	mutex critical: [
		publication == aPublication ifFalse: [
			QLogger logError: '#publicationDestroyed: ...   publication does not match' from: self.
			^self
		].
		self stopScript: #publicationDestroyed:.
		publication := nil.
	].
! !

!QPhoneUserOnServer methodsFor: 'private' stamp: 'jcg 11/23/2009 13:17'!
publishControlStreamIfNecessary
	mutex critical: [
		publication ifNotNil: [^self].
		publication := QPhoneUserPublication
										publishID: publishID
										mediaController: mediaController
										inputClass: QControlStreamInput
										outputClass: QControlStreamOutput.
		publication user: self.
		self runScript: #publicationDestroyed: when: {publication. #destroyed}.

		publication connectWithTimeout: 120000. "async"
	].

	"XXXXX: AARGH!! If we don't give connection a chance to happen, we'll end up with a
'Where is that stream node???' error in TMediaPlugin>>publish:in:out:.  This should only be a problem in the QFakePhoneManager case... in a real deployment the publisher and subscriber won't be directly connecting to the same (i.e. on the same machine) hub, so once we actually have the phone server deployed in our data center we can remove this code.

Nevertheless, it would be good to have simultaneous publish/subscribe to a local controller 'just work' (there's no good reason why it shouldn't."
	QLogger 
		log: 'Waiting a moment to let control-stream publication happen.  Fix ASAP, please.'
		from: self.
	(Delay forSeconds: 2) wait.
! !

!QPhoneUserOnServer methodsFor: 'phone-system interface' stamp: 'jcg 8/7/2008 17:25'!
receiveCall: newCall
	"All incoming commands from the phone-system interface should be synchronized on the user's event-loop."
	(calls includesKey: newCall callID) 
		ifTrue: [self error: 'call with ID: ', newCall callID hex, ' already exists'].
	calls at: newCall callID put: newCall.
! !

!QPhoneUserOnServer methodsFor: 'private' stamp: 'jcg 8/27/2008 13:01'!
registrationAcknowledged
	super registrationAcknowledged.
	self sendCommand: 'register-user' xmlBlock: [:writer | ].! !

!QPhoneUserOnServer methodsFor: 'private' stamp: 'jcg 8/31/2008 16:18'!
sendCommand: cmdName xmlBlock: writerBlock
	mutex critical: [
		[
			| cmd |
			publication ifNil: [QStreamUnavailable signal].
			cmd := self generateCommand: cmdName xmlBlock: writerBlock.
			publication sendCommand: cmd.
		] on: Error do: [:err |
			(err isKindOf: QStreamUnavailable)
				ifTrue: [QLogger logWarning: 'no stream to send command: ', cmdName]
				ifFalse: [
					QLogger logError: 'unexpected error while sending POTS command ',
								 						cmdName, ' (', err description, ')'.
					"XXXXX: should we kill ourselves?" "self destroy."
				].
		].
	].! !

!QPhoneUserOnServer methodsFor: 'downstream messages' stamp: 'jcg 8/8/2008 14:35'!
sendError: anError downstreamForCallID: callID
	| stack logMsg |

	"We want the full stack to help us debug this unexpected error."
	stack := anError signalerContext stackOfSize: 40 ignoringFirst: 0 indentedBy: 2.

	"Log the message ourselves."
	logMsg := String streamContents: [:str |
		str 
			nextPutAll: 'call error'; cr; tab;
			nextPutAll: 'callID: ', callID hex; cr; tab;
			nextPutAll: 'description: ', anError description; cr; tab;
			nextPutAll: 'stack:'; cr;
			nextPutAll: stack.
	].
	QLogger logError: logMsg from: self.

	"Send the error info downstream (essentially the same info that we logged here)."
	self  sendCommand: 'call-error' xmlBlock: [:writer |
		writer tag: 'call-id' pcData: callID hex.
		writer tag: 'description' pcData: anError description.
		writer tag: 'stack' pcData: stack.
	].! !

!QPhoneUserOnServer methodsFor: 'private' stamp: 'jcg 8/14/2008 13:58'!
setCall: callID inputStreamID: streamID sessionID: sessionID
	| call |

	call := calls at: callID ifAbsent: [
		^QLogger logWarning: 'cannot find call to set stream/session-ID'
	].
	call subscribeToStream: streamID session: sessionID.


! !

QAudioPluginFeedbackChannel subclass: #QPhoneUserFeedbackChannel
	instanceVariableNames: 'interface'
	classVariableNames: ''
	poolDictionaries: 'QPhoneConstants'
	category: 'Qwaq-Sound-POTS-Feedback'!

!QPhoneUserFeedbackChannel commentStamp: '<historical>' prior: 0!
Communicates asynchronous events from Asterisk (via QAudioPlugin) back to Squeak.!

!QPhoneUserFeedbackChannel class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPhoneUserFeedbackChannel methodsFor: 'initialize' stamp: 'jcg 7/30/2008 15:57'!
initializeTypeMap
	typeMap := {
		IAXCEventText -> IAXTextEvent.
		IAXCEventLevels -> IAXLevelsEvent.
		IAXCEventState -> IAXCallStateEvent.
		IAXCEventNetstat -> IAXNetstatEvent.
		IAXCEventURL -> IAXUrlEvent .
		IAXCEventVideo -> IAXVideoEvent.
		IAXCEventRegistration -> IAXRegistrationEvent.
		IAXCEventAudio -> IAXAudioEvent.
		IAXCEventVideostats -> IAXVideostatsEvent.
		QwaqGSMFrame -> QwaqGSMFrameEvent.
	}! !

!QPhoneUserFeedbackChannel methodsFor: 'initialize' stamp: 'jcg 8/7/2008 15:08'!
interface: aQPhoneSystemInterface 
	interface := aQPhoneSystemInterface! !

!QPhoneUserFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 8/7/2008 15:09'!
processEvent: event
	interface ifNil: [
		^QLogger logError: 'no phone-system interface to handle event: ', event from: self
	].
	interface handleFeedbackEvent: event.
! !

QPhoneUserFeedbackChannel subclass: #QPhoneUserTestFeedbackChannel
	instanceVariableNames: 'mutex expectedEventSelectors handledEventCount failedEventCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-POTS-Feedback'!

!QPhoneUserTestFeedbackChannel commentStamp: '<historical>' prior: 0!
A special feedback-channel that calls a primitive to enqueue some events, and makes sure that the events that it receives are the ones that it expects.

Usage: 'QPhoneUserTestFeedbackChannel runTest'... if there are errors, they will be printed out on the Transcript, and the offending event will be opened in an inspector.!

!QPhoneUserTestFeedbackChannel class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QPhoneUserTestFeedbackChannel methodsFor: 'initialize' stamp: 'bgf 3/21/2009 21:14'!
initialize
	super initialize.
	mutex := Mutex new.
	expectedEventSelectors := OrderedCollection new.
	handledEventCount := failedEventCount := 0.! !

!QPhoneUserTestFeedbackChannel methodsFor: 'primitives' stamp: 'jcg 7/24/2008 15:46'!
primitiveGenerateTestPhoneEvents: hndl
	"Generate one of each of the expected event types and enqueue it on the feed"
	<primitive: 'primitiveGenerateTestPhoneEvents' module: 'QAudioPlugin'>
	self primitiveFailed! !

!QPhoneUserTestFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 7/25/2008 02:50'!
processAudioEvent: evt
	evt class == IAXAudioEvent ifFalse: 
		[self error: '#processAudioEvent: unexpected class ', evt class name].

	evt callNo = 42 ifFalse:
		[self error: '#processAudioEvent: bad callNo: ', evt callNo].

	evt ts = 43 ifFalse:
		[self error: '#processAudioEvent: bad ts: ', evt ts].

	evt format = 44 ifFalse:
		[self error: '#processAudioEvent: bad format: ', evt format].

	evt encoded = 45 ifFalse:
		[self error: '#processAudioEvent: bad encoded: ', evt encoded].

	evt source = 46 ifFalse:
		[self error: '#processAudioEvent: bad source: ', evt source].

	evt dataSize = 47 ifFalse:
		[self error: '#processAudioEvent: bad dataSize: ', evt dataSize].

	evt data getHandle asInteger = 16r42 ifFalse:
		[self error: '#processAudioEvent: bad data ptr: ', evt data].


! !

!QPhoneUserTestFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 7/24/2008 23:04'!
processCallStateEvent: evt
	evt class == IAXCallStateEvent ifFalse: 
		[self error: '#processCallStateEvent: unexpected class ', evt class name].

	evt callNo = 42 ifFalse: 
		[self error: '#processCallStateEvent: bad callNo: ', evt callNo].

	evt state = 43 ifFalse: 
		[self error: '#processCallStateEvent: bad state: ', evt state].

	evt format = 44 ifFalse: 
		[self error: '#processCallStateEvent: bad format: ', evt format].

	evt vformat = 45 ifFalse: 
		[self error: '#processCallStateEvent: bad vformat: ', evt vformat].

	evt remote = 'PhoneCallStateEvent: remote' ifFalse: 
		[self error: '#processCallStateEvent: bad remote string: ', evt remote].

	evt remoteName = 'PhoneCallStateEvent: remote_name' ifFalse: 
		[self error: '#processCallStateEvent: bad remote_name string: ', evt remoteName].

	evt local = 'PhoneCallStateEvent: local' ifFalse: 
		[self error: '#processCallStateEvent: bad local string: ', evt local].

	evt localContext = 'PhoneCallStateEvent: local_context' ifFalse: 
		[self error: '#processCallStateEvent: bad local_context string: ', evt localContext].
! !

!QPhoneUserTestFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 8/22/2008 15:28'!
processEvent: anEvent
	[
		self 
			perform: (mutex critical: [expectedEventSelectors removeFirst]) 
			with: anEvent.
		handledEventCount := handledEventCount + 1.
	] on: Error do: [:err |
		QLogger logError: 'failed to process a ', anEvent class name, ' because: ', err description.
		failedEventCount := failedEventCount + 1.
	]! !

!QPhoneUserTestFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 7/24/2008 22:46'!
processLevelsEvent: evt
	evt class == IAXLevelsEvent ifFalse: 
		[self error: '#processLevelsEvent: unexpected class ', evt class name].

	evt input = 0.25 ifFalse:
		[self error: '#processLevelsEvent: bad input level: ', evt input].

	evt output = 0.75 ifFalse:
		[self error: '#processLevelsEvent: bad output level: ', evt output].! !

!QPhoneUserTestFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 7/24/2008 22:42'!
processNetstatEvent: evt
	evt class == IAXNetstatEvent ifFalse: 
		[self error: '#processNetstatEvent: unexpected class ', evt class name].

	evt callNo = 42 ifFalse:
		[self error: '#processNetstatEvent: bad callNo: ', evt callNo].

	evt rtt = 43 ifFalse:
		[self error: '#processNetstatEvent: bad rtt: ', evt rtt].

	evt localJitter = 44 ifFalse:
		[self error: '#processNetstatEvent: bad localJitter: ', evt localJitter].

	evt localLosspct = 45 ifFalse:
		[self error: '#processNetstatEvent: bad localLosspct: ', evt localLosspct].

	evt localLosscnt = 46 ifFalse:
		[self error: '#processNetstatEvent: bad localLosscnt: ', evt localLosscnt].

	evt localPackets = 47 ifFalse:
		[self error: '#processNetstatEvent: bad localPackets: ', evt localPackets].

	evt localDelay = 48 ifFalse:
		[self error: '#processNetstatEvent: bad localDelay: ', evt localDelay].

	evt localDropped = 49 ifFalse:
		[self error: '#processNetstatEvent: bad localDropped: ', evt localDropped].

	evt localOoo = 50 ifFalse:
		[self error: '#processNetstatEvent: bad localOoo: ', evt localOoo].

	evt remoteJitter = 51 ifFalse:
		[self error: '#processNetstatEvent: bad remoteJitter: ', evt remoteJitter].

	evt remoteLosspct = 52 ifFalse:
		[self error: '#processNetstatEvent: bad remoteLosspct: ', evt remoteLosspct].

	evt remoteLosscnt = 53 ifFalse:
		[self error: '#processNetstatEvent: bad remoteLosscnt: ', evt remoteLosscnt].

	evt remotePackets = 54 ifFalse:
		[self error: '#processNetstatEvent: bad remotePackets: ', evt remotePackets].

	evt remoteDelay = 55 ifFalse:
		[self error: '#processNetstatEvent: bad remoteDelay: ', evt remoteDelay].

	evt remoteDropped = 56 ifFalse:
		[self error: '#processNetstatEvent: bad remoteDropped: ', evt remoteDropped].

	evt remoteOoo = 57 ifFalse:
		[self error: '#processNetstatEvent: bad remoteOoo: ', evt remoteOoo].
! !

!QPhoneUserTestFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 7/25/2008 02:46'!
processRegistrationEvent: evt
	evt class == IAXRegistrationEvent ifFalse: 
		[self error: '#processRegistrationEvent: unexpected class ', evt class name].

	evt id = 42 ifFalse:
		[self error: '#processRegistrationEvent: bad id: ', evt id].

	evt reply = 43 ifFalse:
		[self error: '#processRegistrationEvent: bad reply: ', evt reply].

	evt msgcount = 44 ifFalse:
		[self error: '#processRegistrationEvent: bad msgcount: ', evt msgcount].
! !

!QPhoneUserTestFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 7/24/2008 23:01'!
processTextEvent: evt
	evt class == IAXTextEvent ifFalse: 
		[self error: '#processTextEvent: unexpected class ', evt class name].

	evt textType = 42 ifFalse: 
		[self error: '#processTextEvent: bad textType: ', evt textType].

	evt callNo = 43 ifFalse: 
		[self error: '#processTextEvent: bad callNo: ', evt callNo].

	evt message = 'PhoneTextEvent: message' ifFalse:
		[self error: '#processTextEvent: bad message: ', evt message].! !

!QPhoneUserTestFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 7/24/2008 22:48'!
processUrlEvent: evt
	evt class == IAXUrlEvent ifFalse: 
		[self error: '#processUrlEvent: unexpected class ', evt class name].

	evt callNo =42 ifFalse:
		[self error: '#processUrlEvent: bad callNo: ', evt callNo].

	evt urlType =43 ifFalse:
		[self error: '#processUrlEvent: bad urlType: ', evt urlType].

	evt url = 'PhoneUrlEvent: url' ifFalse:
		[self error: '#processUrlEvent: bad url: ', evt url].! !

!QPhoneUserTestFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 7/24/2008 23:26'!
processVideoEvent: evt
	evt class == IAXVideoEvent ifFalse: 
		[self error: '#processVideoEvent: unexpected class ', evt class name].

	evt callNo = 42 ifFalse:
		[self error: '#processVideoEvent: bad callNo: ', evt callNo].

	evt ts = 43 ifFalse:
		[self error: '#processVideoEvent: bad ts: ', evt ts].

	evt format = 44 ifFalse:
		[self error: '#processVideoEvent: bad format: ', evt format].

	evt width = 45 ifFalse:
		[self error: '#processVideoEvent: bad width: ', evt width].

	evt height =46 ifFalse:
		[self error: '#processVideoEvent: bad height: ', evt height].

	evt encoded = 47 ifFalse:
		[self error: '#processVideoEvent: bad encoded: ', evt encoded].

	evt dataSize = 48 ifFalse:
		[self error: '#processVideoEvent: bad dataSize: ', evt dataSize].

	evt data getHandle asInteger =16r42 ifFalse:
		[self error: '#processVideoEvent: bad data ptr: ', evt data].
! !

!QPhoneUserTestFeedbackChannel methodsFor: 'subclass responsibilities' stamp: 'jcg 7/25/2008 02:55'!
processVideostatsEvent: evt
	evt class == IAXVideostatsEvent ifFalse: 
		[self error: '#processVideostatsEvent: unexpected class ', evt class name].

	evt callNo = 42 ifFalse:
		[self error: '#processVideostatsEvent: bad callNo: ', evt callNo].

	evt receivedSlices = 43 ifFalse:
		[self error: '#processVideostatsEvent: bad receivedSlices: ', evt receivedSlices].

	evt accRecvSize = 44 ifFalse:
		[self error: '#processVideostatsEvent: bad accRecvSize: ', evt accRecvSize].

	evt sentSlices = 45 ifFalse:
		[self error: '#processVideostatsEvent: bad sentSlices: ', evt sentSlices].

	evt accSentSize = 46 ifFalse:
		[self error: '#processVideostatsEvent: bad accSentSize: ', evt accSentSize].

	evt droppedFrames = 47 ifFalse:
		[self error: '#processVideostatsEvent: bad droppedFrames: ', evt droppedFrames].

	evt inboundFrames = 48 ifFalse:
		[self error: '#processVideostatsEvent: bad inboundFrames: ', evt inboundFrames].

	evt outboundFrames = 49 ifFalse:
		[self error: '#processVideostatsEvent: bad outboundFrames: ', evt outboundFrames].

	evt avgInboundFPS = 50.0 ifFalse:
		[self error: '#processVideostatsEvent: bad avgInboundFPS: ', evt avgInboundFPS].

	evt avgInboundBPS = 51 ifFalse:
		[self error: '#processVideostatsEvent: bad avgInboundBPS: ', evt avgInboundBPS].

	evt avgOutboundFPS = 52.0 ifFalse: 
		[self error: '#processVideostatsEvent: bad avgOutboundFPS: ', 
													evt avgOutboundFPS].

	evt avgOutboundBPS = 53 ifFalse:
		[self error: '#processVideostatsEvent: bad avgOutboundBPS: ', 
													evt avgOutboundBPS].
! !

!QPhoneUserTestFeedbackChannel methodsFor: 'testing' stamp: 'jcg 7/25/2008 02:45'!
runTest
	mutex critical: [
		expectedEventSelectors addAll: #(
												processTextEvent: 
												processLevelsEvent:
												processCallStateEvent:
												processNetstatEvent:
												processUrlEvent:
												processVideoEvent:
												processRegistrationEvent:
												processAudioEvent:
												processVideostatsEvent:
											).
		self primitiveGenerateTestPhoneEvents: self getHandle.
	]! !

!MixedSound methodsFor: '*Qwaq-Sound' stamp: 'bgf 2/25/2009 22:59'!
adjustSoundAt: index pan: leftRightPan volume: volume
	"Used for pseudo-spatialization.
	 For a true Mixed Sound, we do nothing, and let squeak govern."! !

MixedSound subclass: #QMixedSound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Chat'!

!QMixedSound class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QMixedSound methodsFor: 'composition' stamp: 'jcg 2/25/2007 20:07'!
adjustSoundAt: index pan: leftRightPan volume: volume
	"Used for pseudo-spatialization."
	| pan vol |
	pan := ((leftRightPan * ScaleFactor) asInteger max: 0) min: ScaleFactor.
	vol := ((volume * ScaleFactor) asInteger max: 0) min: ScaleFactor.
	leftVols at: index put: ((ScaleFactor - pan) * vol) // ScaleFactor.
	rightVols at: index put: (pan * vol) // ScaleFactor.
! !

SoundRecorder subclass: #QMicrophone
	instanceVariableNames: 'startTime volumeAverage volumeBuffers streamer suppressRecording noiseThreshold jitterometer bufCount rawRecordStream echoCancellationEnabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Chat'!

!QMicrophone commentStamp: '<historical>' prior: 0!
QMicrophone new!

!QMicrophone class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QMicrophone class methodsFor: 'accessing' stamp: 'bgf 11/19/2007 20:15'!
bufferSize
	"Buffer size should be small enough to
		* fit into a UDP packet even if worst-case compressed
		* be small enough not to introduce addl. latency (even on 11kHz)
	"
	"^ 320  -- twice the samples per GSM frame.  1/36th second of sound;
	               Too fine-grained for in-band use."

	^1280 	"About 1/9th of a second worth of sound.. 
			 enough to span most render cycles"


! !

!QMicrophone methodsFor: 'private' stamp: 'ar 3/12/2002 22:01'!
allocateBuffer
	"Allocate a new buffer and reset nextIndex."
	| bufSize |
	"Multiple of samplesPerFrame that is approx. bufferTime long"
	bufSize := (self bufferSize truncateTo: self samplesPerFrame) max: self samplesPerFrame.
	(currentBuffer == nil or:[currentBuffer monoSampleCount ~= bufSize]) ifTrue:[
		currentBuffer := SoundBuffer newMonoSampleCount: bufSize.
	].
	nextIndex := 1.
! !

!QMicrophone methodsFor: 'private' stamp: 'jcg 11/10/2008 11:04'!
audiblePeriodEnded
	"We reached the end of an audible period... we either detected silence, or were explicitly paused/stopped."
	startTime := nil. "will re-initialized the next time we record an 'audible' buffer"
	jitterometer reset.
	streamer ifNotNilDo: [:s | s sendEndOfAudiblePeriod].
! !

!QMicrophone methodsFor: 'private' stamp: 'jcg 6/7/2008 16:25'!
bufferIsLouderThanThreshold: buffer
	self meterFrom: 1 count: buffer monoSampleCount in: buffer.
	volumeBuffers > 10 ifTrue:[volumeBuffers := 0. volumeAverage := 0].
	volumeAverage := volumeAverage + meterLevel.
	volumeBuffers := volumeBuffers+1.
	^ meterLevel >  self noiseThreshold.! !

!QMicrophone methodsFor: 'private' stamp: 'jcg 3/3/2007 16:19'!
bufferSize
	^ self class bufferSize! !

!QMicrophone methodsFor: 'accessing' stamp: 'jcg 2/26/2009 11:08'!
codec: aSoundCodec
	| wasPaused |
	codec == aSoundCodec ifTrue: [^self].
	codec ifNotNil: [codec destroy].
	super codec: aSoundCodec.

	"Need to set the sampling rate depending on the codec we're using."
	codec class == QSpeexCodec
		ifTrue: [samplingRate := QSpeexCodec samplingRate]
		ifFalse: [samplingRate := GSMCodec samplingRate].
	
	"If we're recording, we need to restart in order for the new sampling rate to kick in."
	self isRecording ifTrue: [
		wasPaused := self isPaused.
		self stopRecording; startRecording.
		wasPaused ifFalse: [ self resumeRecording ]
	].
! !

!QMicrophone methodsFor: 'accessing' stamp: 'jcg 3/26/2010 17:11'!
echoCancellationEnabled
	"Should probably add a primitive so that we *know* that we're in sync with the plugin."
	^ echoCancellationEnabled
! !

!QMicrophone methodsFor: 'private' stamp: 'jcg 11/7/2008 15:00'!
elapsedTime
	"Answer the amount of time that has elapsed in this 'run' of sound (i.e. from the time that the first 'audible' buffer was recorded)."
	startTime ifNotNil: [^RealTime millisecondsSince: startTime].
	startTime := RealTime millisecondClockValue.
	bufCount := 0.
	jitterometer reset.
	^ 0! !

!QMicrophone methodsFor: 'private' stamp: 'ar 3/12/2002 21:28'!
emitBuffer: buffer
	"Do nothing here - all work is done in #sendBuffer:"! !

!QMicrophone methodsFor: 'recording controls' stamp: 'jcg 3/26/2010 17:13'!
enableEchoCancellation: trueOrFalse
	"Turn AEC on or off."
	echoCancellationEnabled == trueOrFalse ifTrue: [^self "no change"].
	[	super enableEchoCancellation: trueOrFalse. 
	 	echoCancellationEnabled := trueOrFalse.
		QLogger logInfo: 'set echo-cancellation to: ', trueOrFalse.
	] on: Error do: [
		QLogger logWarning: 'failed to set echo-cancellation to: ', trueOrFalse.
		echoCancellationEnabled := false.
	].
! !

!QMicrophone methodsFor: 'initialization' stamp: 'jcg 3/26/2010 17:14'!
initialize
	super initialize.

	"Will be overwritten by user preference (Speex or GSM)."
	self codec: GSMCodec new.  

	noiseThreshold := 300.			"Heuristic."
	volumeBuffers := 1.
	volumeAverage := 0.
	suppressRecording := false.
"	self addLocalFeedback."

	jitterometer := TJitterometer new.
	self disableEchoCancellation.
! !

!QMicrophone methodsFor: 'accessing' stamp: 'bgf 6/13/2008 22:21'!
isPaused
	"The paused flag, when true, makes the microphone continue to receive signal
	 and maintain level information, but it does not emit buffers."
	^ paused! !

!QMicrophone methodsFor: 'recording controls' stamp: 'ar 5/20/2002 16:19'!
isRecording
	^recordProcess notNil! !

!QMicrophone methodsFor: 'accessing' stamp: 'ar 12/4/2008 17:04'!
jitterStats
	"Microphone jitter statistics"
	^jitterometer jitterStats! !

!QMicrophone methodsFor: 'accessing' stamp: 'ar 12/4/2008 17:03'!
jitterStats: aTWindowedStatistics
	"Microphone jitter statistics"
	jitterometer jitterStats: aTWindowedStatistics! !

!QMicrophone methodsFor: 'accessing' stamp: 'bgf 8/15/2007 13:28'!
noiseThreshold
	"Heuristic value for now... not so sensitive that it picks up typing, but sensitive enough not to miss normal speech."
	^ noiseThreshold! !

!QMicrophone methodsFor: 'accessing' stamp: 'bgf 8/15/2007 13:28'!
noiseThreshold: aScalar
	"The minimum input threshold.  Default is 300."
	noiseThreshold := aScalar! !

!QMicrophone methodsFor: 'recording controls' stamp: 'jcg 11/8/2008 00:21'!
pause
	paused ifTrue: [^self "already paused"].
	super pause.
	self audiblePeriodEnded. 
! !

!QMicrophone methodsFor: 'recording controls' stamp: 'bgf 5/28/2009 19:12'!
pauseSoonUnless: aBooleanBlock

	"Pause the microphone after a brief delay, unless the boolean block yields true at that time.
	 (I.e the block is evaluated after the delay, and if it returns false, we pause;
	 it should return true to continue recording-mode after the delay.)

	 The delay is a 300-ms 'catch the tail of utterance' margin 
	 so quick-fingered speakers don't clip themselves."

	paused ifTrue: [^self "already paused"].

	"See recordSamplesIntoCurrentBuffer ... let the loop capture the tail.
	 This is a substitute for 'emitPartialBuffer' in the base class."
	bufferAvailableSema ifNotNil: [ 
		bufferAvailableSema signal.
		"Give the high-p thread just a little more time for input 
		 before we announce eo-audible.
		 This fights against too-sharp cuts from the quick-fingered...
		 a sort of workaround for a human bug."
		(Delay forMilliseconds: 250) wait.
	].	
	aBooleanBlock value == true ifFalse: [  
		self pause.
	].! !

!QMicrophone methodsFor: 'accessing' stamp: 'jcg 11/5/2008 17:22'!
recordJitter
	"Answer the jitter in the time between obtaining encoded buffers."
	^jitterometer jitter! !

!QMicrophone methodsFor: 'private' stamp: 'bgf 8/21/2008 15:35'!
recordLoop
	"Record process loop that records samples."
	| repeat isAudible n |

	[
		repeat := 5.
		[true] whileTrue: [
			paused ifTrue: [ 
				"Just meter, in case we want it later for tools..."
				n := self primRecordSamplesInto: meteringBuffer startingAt: 1.
				self meterFrom: 1 count: n in: meteringBuffer.
				startTime := nil.
				n = 0 ifTrue: [bufferAvailableSema wait].
			] ifFalse: [
				self recordSamplesIntoCurrentBuffer.  "fill it up from start to end"
				suppressRecording 
					ifTrue: [isAudible := false. nextIndex := 1.]
					ifFalse: [isAudible := self sendBuffer: currentBuffer ifSilent: (repeat > 0)].
				repeat := isAudible ifTrue:[5] ifFalse:[repeat - 1].
				repeat == 0 ifTrue: [self audiblePeriodEnded].
				self allocateBuffer.
			].
		].
	] on: Error do:[ : ex |
		"Swallow errors; there is not much we can do here otherwise"
		paused ifFalse: [
			QLogger logWarning: 'Audio input problem: ', (ex description).
		].
		ex return.
	].
							"We only get here in case of an error"
	recordProcess := nil. 	"Avoid terminating ourselves."
	[self stopRecording] on: Error do:[:ex|].
! !

!QMicrophone methodsFor: 'private' stamp: 'bgf 3/26/2009 13:55'!
recordSamplesIntoCurrentBuffer
	| n sampleCount |
	sampleCount := stereo
			ifTrue: [currentBuffer stereoSampleCount]
			ifFalse: [currentBuffer monoSampleCount].
	[true] whileTrue: [
		n := self primRecordSamplesInto: currentBuffer startingAt: nextIndex.
		nextIndex := nextIndex + n.
		nextIndex > sampleCount ifTrue: [^self]. "currentBuffer is full"
		"If not done yet and no current samples, wait for the next buffer to become available"
		((paused not) and: [n = 0]) ifTrue: [bufferAvailableSema wait].
	].! !

!QMicrophone methodsFor: 'private' stamp: 'jcg 3/17/2009 11:01'!
sendBuffer: buffer ifSilent: sendAnyways
	"Send the shared buffer"
	| data isAudible elapsed |

	isAudible := self bufferIsLouderThanThreshold: buffer.
	(isAudible | sendAnyways) ifFalse: [^false].
	paused ifTrue: [^false].

	"If we're recording the raw microphone data to disk, do what we need to do."
	rawRecordStream ifNotNil: [
		rawRecordStream nextPutAll: buffer.
		"If we've recorded 8sec (assuming 16kHz), we're done; write it to disk."
		rawRecordStream position >= 128000 ifTrue: [self writeRawDataToDisk].
	].

	"If we have a codec, use it to encode the buffer.  Otherwise, just convert the data to a ByteArray."
	codec 
		ifNil:[data := buffer asByteArray]
 		ifNotNil:[data := codec encodeSoundBufferNoReset: buffer].

	"Measure the jitter in the time taken to obtain/encode audio buffers."
	elapsed := self elapsedTime.
	jitterometer add: bufCount * 80 at: elapsed.
	bufCount := bufCount + 1.

	streamer ifNotNil:[
		streamer 
			playSound: data 
			at: elapsed 
			samplingRate: samplingRate 
			codec: (codec ifNotNil:[codec class])
			level: self meterLevel.
	].

	^isAudible! !

!QMicrophone methodsFor: 'recording controls' stamp: 'jcg 3/17/2009 11:23'!
startRawRecording
	"Set up a stream to record raw samples on.. when a predetermined number of samples has been recorded, write them to disk as a .WAV file."
	rawRecordStream ifNotNil: [
		QLogger logInfo: 'interrupted recording of raw microphone data'.
	].
	QLogger logInfo: 'started recording of raw microphone data'.
	rawRecordStream := WriteStream on: (SoundBuffer newMonoSampleCount: 128000).
	! !

!QMicrophone methodsFor: 'accessing' stamp: 'ar 6/17/2002 00:09'!
statusString
	self isRecording ifFalse:[^''].
	^'Chat Volume: ', self volumeAverage printString, '%'! !

!QMicrophone methodsFor: 'recording controls' stamp: 'jcg 6/16/2008 13:37'!
stopRecording

	"Do this first, because it will be a no-op if we're currently stopped/paused."
	self audiblePeriodEnded. 

	super stopRecording.
	paused := false.		"So the flag state doesn't carry over to the next start."! !

!QMicrophone methodsFor: 'accessing' stamp: 'pbm 3/16/2006 12:51'!
streamer
	^ streamer! !

!QMicrophone methodsFor: 'accessing' stamp: 'pbm 3/16/2006 12:51'!
streamer: aTSoundStreamer
	streamer := aTSoundStreamer.! !

!QMicrophone methodsFor: 'initialization' stamp: 'jcg 6/7/2008 17:45'!
suppressRecordingDuring: aBlock
	
	"XXXXX: this method isn't currently used anywhere.  If you decide to use it, be advised that it probably doensn't play well with timestamping, and with sending a 'sound ended' message when we've heard 'silence' for a while."

	| saved |
	saved := suppressRecording.
	[suppressRecording := true. aBlock value] ensure: [suppressRecording := saved].! !

!QMicrophone methodsFor: 'accessing' stamp: 'ar 6/16/2002 23:58'!
volumeAverage
	^(volumeAverage max: 0) * 100 / volumeBuffers // 32768! !

!QMicrophone methodsFor: 'private' stamp: 'ar 9/8/2009 18:59'!
writeRawDataToDisk
	| rawData fileName sound |
	rawData := rawRecordStream contents.
	rawRecordStream := nil.  "we're done with it"
	WorldState addDeferredUIMessage:[
		[fileName := FileDirectory logDirectory fullNameFor: 
							'RawMicrophone-', DateAndTime now asFileNameString, '.wav'.
		sound := SampledSound samples: rawData samplingRate: 16000.
		sound storeWAVOnFileNamed: fileName.
		QLogger logInfo: 'successfully recorded raw microphone data to: ', fileName.
		] on: Error do:[:ex|
			QLogger logError: ex.
		].
	].! !

CroquetTestCase subclass: #QSoundTest
	instanceVariableNames: 'mediaController originalSegments startTime numberOfSegments publication currentSegmentIndex subscription speexSink feedbackSink codec router dispatcher captureCorrelation encodingCorrelation queuingCorrelation transportCorrelation decodingCorrelation usesOwnController testSignal encodedTestSignal testSignalDatagrams'
	classVariableNames: 'EncodedTestSignal NumberOfSegmentsInTestData TestSignal TestSignalDatagrams'
	poolDictionaries: ''
	category: 'Qwaq-Sound-Tests'!

!QSoundTest commentStamp: 'crl 3/15/2010 12:55' prior: 0!
'
	Each of my instances tests the network audio pipeline through capture, encoding, queuing, reception, and decoding.

	Requires test data files from SVN (Objects/Sounds/SoundTest).!

!QSoundTest class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QSoundTest class methodsFor: 'instantiation' stamp: 'crl 4/28/2010 17:49'!
forSeconds: numberOfSeconds
	^self new durationInSeconds: numberOfSeconds! !

!QSoundTest class methodsFor: 'initialization' stamp: 'crl 5/7/2010 17:01'!
generateTestData
	"Generate files containing the test data, as PCM audio samples, Speex-encoded samples, and datagrams. For the raw samples, use a sine wave with frequency varying linearly up and down over an octave in the vocal range, over a second, looped over a minute."
	"The Speex encoder output generally varies by host platform and over time, in a benign way (e.g., due to different versions of the Speex source, or how a particular compiler deals with vectorization, fast-math vs. precise-math, etc.). We'll have to re-run this method (and check the results into the appropriate SVN location) whenever those causes occur."
	"self generateTestData"

	| onePass codec fileStream testSignal encodedTestSignal testSignalDatagrams |

	onePass := (SoundBuffer newMonoSampleCount: NumberOfSegmentsInTestData * 16 * 80) writeStream.
	codec := QSpeexCodec new.

	"To make the test signal fit in an integer number of 80ms segments, and avoid clicking, fiddle with the frequency, linearity, and duration a little bit. Sweeping between 220 Hz and 440 Hz at our typical sampling rate of 16 kHz with four cycles at each frequency is almost right."
	74
		to: 38
		by: -1
		do: [:framesPerCycle |
			(
				(framesPerCycle = 64)
					ifTrue: [5]
					ifFalse: [4]
			)
				timesRepeat: [
					0
						to: framesPerCycle - 1
						do: [:frameIndex | onePass nextPut: (8000.0 * (2 * Float pi * frameIndex / framesPerCycle) sin) rounded]]].

	38
		to: 74
		by: 1
		do: [:framesPerCycle |
			4 timesRepeat: [
				0
					to: framesPerCycle - 1
					do: [:frameIndex | onePass nextPut: (8000.0 * (2 * Float pi * frameIndex / framesPerCycle) sin) rounded]]].

	onePass := onePass contents readStream.
	
	"Encoding multiple passes through a sound loop doesn't necessarily yield the same result as repeating the encoding of a single pass through the loop, so create an actual 60-pass version of the loop."
	"60 passes, 13 segments per pass, is 780 segments"
	testSignal := (Array new: 780) writeStream.
	"80 ms per segment, 16kHz sampling rate, 1280 samples per segment"
	60 timesRepeat: [
		onePass reset.
		13 timesRepeat: [testSignal nextPut: (onePass next: 1280)]].
	testSignal := testSignal contents.

	encodedTestSignal := testSignal collect: [:segment | codec encodeSoundBufferNoReset: segment].
	testSignalDatagrams := (
		(1 to: testSignal size) collect: [:segmentIndex |
			QStreamingSoundRelay
				datagramPayloadFor: (encodedTestSignal at: segmentIndex)
				at: {80 * (segmentIndex - 1). 80 * (segmentIndex - 1)}
				codec: QSpeexCodec
				level: 20]).

	[
		fileStream := FileDirectory default forceNewFileNamed: 'QSoundTestSegmentsPCM'.
		fileStream binary.
		testSignal do: [:bytes |
			"2560 bytes each"
			fileStream nextPutAll: bytes]
	]
		ensure: [fileStream close].

	[
		fileStream := FileDirectory default forceNewFileNamed: 'QSoundTestSegmentsSpeex'.
		fileStream binary.
		encodedTestSignal do: [:bytes |
			"285 bytes each"
			fileStream nextPutAll: bytes]
	]
		ensure: [fileStream close].

	[
		fileStream := FileDirectory default forceNewFileNamed: 'QSoundTestDatagrams'.
		fileStream binary.
		testSignalDatagrams do: [:bytes |
			"302 bytes each"
			fileStream nextPutAll: bytes]
	]
		ensure: [fileStream close]! !

!QSoundTest class methodsFor: 'initialization' stamp: 'crl 3/29/2010 10:27'!
initialize
	NumberOfSegmentsInTestData := 13! !

!QSoundTest methodsFor: 'events' stamp: 'crl 5/12/2010 16:39'!
acceptAndDecodeData: datagram
	"Feed one datagram from the controller."
	"Don't actually pull the data and timing from speex until it has all been pushed in (and a bit more time has passed besides, to allow for the jitter buffer's margin). See >>testDecoding."

	self acceptData: datagram.
	speexSink
		dechunkDejitterAndDecode: (datagram data copyFrom: 18 to: datagram data size)
		timestamp: (datagram data networkUnsignedLongAt: 1)! !

!QSoundTest methodsFor: 'events' stamp: 'crl 5/12/2010 17:20'!
acceptData: datagram
	"Receive one datagram from the controller."

	transportCorrelation
		actualDataAt: currentSegmentIndex
		put: datagram data.
	currentSegmentIndex := currentSegmentIndex + 1! !

!QSoundTest methodsFor: 'testing' stamp: 'crl 5/12/2010 10:29'!
assert: aBlockClosure
	usesOwnController ifTrue: [super assert: aBlockClosure]! !

!QSoundTest methodsFor: 'processing' stamp: 'crl 3/25/2010 14:05'!
capture: pcmSegment toBufferAt: segmentIndex
	"Simulate one step of the microphone."

	"We can simulate microphone jitter by adding a random delay here."
	captureCorrelation
		expectedTimeAt: segmentIndex
		put: (segmentIndex - 1) * 80;
		actualDataAt: segmentIndex
		put: pcmSegment! !

!QSoundTest methodsFor: 'initialization' stamp: 'crl 3/23/2010 18:59'!
controller: aQServiceController
	usesOwnController := false.
	mediaController := aQServiceController! !

!QSoundTest methodsFor: 'initialization' stamp: 'crl 4/28/2010 18:06'!
correlationNamed: name withLatencyThreshold: latencyThreshold andJitterThreshold: jitterThreshold
	^QTimedSequenceCorrelation
		named: name
		withLatencyThreshold: latencyThreshold
		andJitterThreshold: jitterThreshold
		forTest: self! !

!QSoundTest methodsFor: 'accessing' stamp: 'crl 3/23/2010 17:26'!
correlations
	^{
		captureCorrelation.
		encodingCorrelation.
		queuingCorrelation.
		transportCorrelation.
		decodingCorrelation}! !

!QSoundTest methodsFor: 'accessing' stamp: 'crl 3/23/2010 17:27'!
correlationsDo: aBlockClosure
	{
		captureCorrelation.
		encodingCorrelation.
		queuingCorrelation.
		transportCorrelation.
		decodingCorrelation
	}
		do: aBlockClosure! !

!QSoundTest methodsFor: 'initialization' stamp: 'crl 3/23/2010 17:42'!
createController
	"Create my own local media controller. The participant-based versions of the test will use normally-connected controllers."

	| userName propertyList promise |

	userName := 'audio pipeline unit test'.
	dispatcher := TConnectionDispatcher new.
	dispatcher listenOn: 2234.
	router := QServiceRouter new.
	router dispatcher: dispatcher.
	router beMediaRouter.

	propertyList := router addClient: userName unique: false.
	mediaController := QServiceController new.
	mediaController
		loginFacet: (propertyList at: #loginFacet);
		sessionKey: (propertyList at: #sessionKey);
		listFacet: (propertyList at: #listFacet);
		clientID: TObjectID new;
		connectTo: dispatcher address
		port: dispatcher port
		sessionID: TObjectID new
		via: nil.

	self assert: (mediaController status == #connected).

	promise := mediaController login: userName password: ''.
	promise wait.
	self assert: (mediaController status == #ready).
	mediaController setClientID! !

!QSoundTest methodsFor: 'accessing' stamp: 'crl 4/27/2010 15:04'!
currentJitterBufferMargin
	"Answer the current jitter buffer margin, in milliseconds."

	^speexSink currentMargin / 1280 * 80! !

!QSoundTest methodsFor: 'time' stamp: 'crl 3/5/2010 17:14'!
currentTime
	"Answer the current time (approximately consistent across the network)."

	"Not sure if we actually need server time..."
	"^mediaController serverTimeStampFor: Time now"

	^Time millisecondClockValue! !

!QSoundTest methodsFor: 'accessing' stamp: 'ar 7/13/2010 17:12'!
defaultTimeout
	"Answer the default timeout to use for tests in this test case.
	The timeout is a value in seconds."

	^30 "seconds"
	! !

!QSoundTest methodsFor: 'initialization' stamp: 'crl 5/7/2010 16:59'!
destroy
	publication ifNotNil: [publication destroy].

	subscription ifNotNil: [
		self
			stopScript: #subscriptionDestroyed:;
			stopScript: #subscriptionFailed:because:.
		subscription destroy].

	usesOwnController ifTrue: [
		mediaController ifNotNil: [mediaController destroy].
		router ifNotNil: [router destroy].
		dispatcher ifNotNil: [dispatcher destroy]].

	feedbackSink destroy.
	speexSink destroy.
	codec destroy! !

!QSoundTest methodsFor: 'accessing' stamp: 'ar 4/16/2011 17:23'!
detailsFor: aQwaqParticipantUI
	| stream |

	stream := (String new: 128) writeStream.

	stream
		cr;
		nextPutAll: 'OpenQwaq Client Experience Report';
		cr; cr; nextPutAll: '---'; cr; cr;
		nextPutAll: aQwaqParticipantUI login summaryString;
		cr; tab;
		nextPutAll: 'Connected to Forums: ';
		print: (aQwaqParticipantUI servicesPane allServices select: [:service | service category = 1]);
		cr; cr; nextPutAll: '---'; cr; cr;
		nextPutAll: (self summary copyReplaceAll: Character tab asString with: Character space asString);
		cr; cr; nextPutAll: '---'; cr; cr;
		nextPutAll: aQwaqParticipantUI statisticsPane reportString;
		cr; cr; nextPutAll: '---'; cr; cr;
		nextPutAll: aQwaqParticipantUI usersPane loggedInUserSummaryString;
		cr; cr; nextPutAll: '---'; cr; cr;
		nextPutAll: QwaqVersion sysProfile.

	^stream contents! !

!QSoundTest methodsFor: 'accessing' stamp: 'crl 4/27/2010 15:37'!
durationInMilliseconds
	^numberOfSegments * 80! !

!QSoundTest methodsFor: 'initialization' stamp: 'crl 5/7/2010 17:01'!
durationInSeconds: anInteger
	| soundBufferStream expectedDatagrams |

	self readTestData.
	numberOfSegments := anInteger * NumberOfSegmentsInTestData.
	originalSegments := testSignal copyFrom: 1 to: numberOfSegments.
	soundBufferStream := (SoundBuffer newMonoSampleCount: numberOfSegments * 1280) writeStream.
	originalSegments do: [:segment | soundBufferStream nextPutAll: segment].

	self correlationsDo: [:correlation | correlation size: numberOfSegments].

	captureCorrelation expectData: originalSegments.
	encodingCorrelation expectData: (encodedTestSignal copyFrom: 1 to: numberOfSegments).
	encodingCorrelation expectActualTimesOf: captureCorrelation.
	queuingCorrelation expectActualTimesOf: encodingCorrelation.
	expectedDatagrams := testSignalDatagrams copyFrom: 1 to: numberOfSegments.
	{queuingCorrelation. transportCorrelation} do: [:correlation | correlation expectData: expectedDatagrams].
	transportCorrelation expectActualTimesOf: queuingCorrelation.
	decodingCorrelation expectData: (SampledSound samples: soundBufferStream contents samplingRate: 16000).
	decodingCorrelation expectActualTimesOf: transportCorrelation.

	{captureCorrelation. encodingCorrelation. queuingCorrelation. transportCorrelation. decodingCorrelation} do: [:correlation | correlation durationInSeconds: anInteger]! !

!QSoundTest methodsFor: 'time' stamp: 'crl 2/26/2010 15:24'!
elapsedTime
	"The time elapsed since I started."

	^self currentTime - startTime! !

!QSoundTest methodsFor: 'processing' stamp: 'crl 5/6/2010 18:15'!
encode: pcmSegment toBufferAt: segmentIndex
	"Encode a buffer's worth of PCM samples."

	"We can simulate encoding jitter by adding a random delay here."
	self capture: pcmSegment toBufferAt: segmentIndex.
	encodingCorrelation
		actualDataAt: segmentIndex
		put: (codec encodeSoundBufferNoReset: (captureCorrelation actualDataAt: segmentIndex))! !

!QSoundTest methodsFor: 'processing' stamp: 'crl 3/25/2010 14:56'!
encodeAndSend: pcmSegment toBufferAt: segmentIndex
	"Encode and send a buffer's worth of PCM samples."

	| datagram |

	self encode: pcmSegment toBufferAt: segmentIndex.

	datagram := (
		QStreamingSoundRelay
			datagramPayloadFor: (encodingCorrelation actualDataAt: segmentIndex)
			at: {
				captureCorrelation expectedTimeAt: segmentIndex.
				captureCorrelation expectedTimeAt: segmentIndex.}
			codec: QSpeexCodec
			level: 20).

	publication sendData: datagram.
	queuingCorrelation
		actualDataAt: segmentIndex
		put: datagram! !

!QSoundTest methodsFor: 'initialization' stamp: 'crl 6/8/2010 16:13'!
initialize
	usesOwnController := true.
	speexSink := QAudioSinkSpeex new.
	feedbackSink := QAudioSinkFeedback new.
	QAudioSession setPluginLogFile: (FileDirectory default fullNameFor: 'QAudioPlugin.log').
	QAudioSession primAudioPluginTickerSetVerbosity: 10.
	QAudioSession primAudioPluginTickerSetInterval: 20.
	QAudioSession primAudioPluginTickerStart.

	codec := QSpeexCodec new.

	captureCorrelation := (
		self
			correlationNamed: 'capture'
			withLatencyThreshold: 100
			andJitterThreshold: 20).

	encodingCorrelation := (
		self
			correlationNamed: 'encoding'
			withLatencyThreshold: 100
			andJitterThreshold: 20).

	queuingCorrelation := (
		self
			correlationNamed: 'queuing'
			withLatencyThreshold: 100
			andJitterThreshold: 10).

	transportCorrelation := (
		self
			correlationNamed: 'transport'
			withLatencyThreshold: 100
			andJitterThreshold: 20).

	decodingCorrelation := (
		QSoundCorrelation
			named: 'decoding'
			withLatencyThreshold: 200
			jitterThreshold: 50
			averageNormalizedSampleDifferenceThreshold: 70
			andMaximumNormalizedSampleDifferenceThreshold: 9000
			forTest: self).

	currentSegmentIndex := 1.

	speexSink profiler startProfiling! !

!QSoundTest methodsFor: 'testing' stamp: 'crl 3/23/2010 18:54'!
playDecodedSound
	decodingCorrelation playActualSound! !

!QSoundTest methodsFor: 'testing' stamp: 'crl 3/23/2010 18:53'!
playOriginalSound
	decodingCorrelation playExpectedSound! !

!QSoundTest methodsFor: 'processing' stamp: 'jcg 6/22/2010 16:06'!
processOriginalSegmentsUsing: selector
	| targetElapsed elapsed finished errorOccurred|

	targetElapsed := 0.
	startTime := self currentTime.

	errorOccurred := false.
	finished := Semaphore new.
	[
		[1 to: numberOfSegments do: [:segmentIndex |
			self
				perform: selector
				with: (originalSegments at: segmentIndex)
				with: segmentIndex.
			elapsed := self elapsedTime.
			targetElapsed := targetElapsed + 80.
			elapsed < targetElapsed ifTrue: [(Delay forMilliseconds: (targetElapsed - elapsed)) wait]]
		] on: Error do: [:err | 
			errorOccurred := true.
			QLogger logError: err
		].

		finished signal
	] forkAt: Processor highIOPriority.

	finished wait.
	errorOccurred ifTrue: [self error: 'error occurred in #processOriginalSegmentsUsing:'].! !

!QSoundTest methodsFor: 'testing' stamp: 'jcg 7/13/2010 16:07'!
publish
	publication ifNil: [
		mediaController ifNil: [self createController].
		publication := (
			QControlStreamPublication
				publishID: TObjectID new
				mediaController: mediaController
				inputClass: QControlStreamInput
				outputClass: QControlStreamOutput).

		"Nonsense command handler... just so the subscriber can wait for an answer."
		publication commandHandler: [:dgram |
			(dgram data asString = 'how are you?')
				ifTrue: ['fine, thanks for asking']
				ifFalse: ['what are you talking about?']
		].

		(publication connectWithTimeout: 1000) wait.
		self should: [publication state == #connected]]! !

!QSoundTest methodsFor: 'initialization' stamp: 'crl 5/7/2010 16:33'!
readTestData
	"Set class variables from files containing the test data, as PCM audio samples, Speex-encoded samples, and datagrams."
	"self readTestData"

	| fileStream |

	testSignal := (Array new: 780) writeStream.
	encodedTestSignal := (Array new: 780) writeStream.
	testSignalDatagrams := (Array new: 780) writeStream.

	[
		fileStream := FileStream readOnlyFileNamed: (FileDirectory pathFromURI: 'Objects/Sounds/SoundTest/QSoundTestSegmentsPCM').
		fileStream binary.
		[fileStream atEnd] whileFalse: [
			"2560 bytes each"
			testSignal nextPut: (SoundBuffer fromLSBByteArray: (fileStream next: 2560))]
	]
		ensure: [fileStream close].

	[
		fileStream := FileStream readOnlyFileNamed: (FileDirectory pathFromURI: 
						'Objects/Sounds/SoundTest/', Smalltalk platformName, '/QSoundTestSegmentsSpeex').
		fileStream binary.
		[fileStream atEnd] whileFalse: [
			"285 bytes each"
			encodedTestSignal nextPut: (fileStream next: 285)]
	]
		ensure: [fileStream close].

	[
		fileStream := FileStream readOnlyFileNamed: (FileDirectory pathFromURI: 
						'Objects/Sounds/SoundTest/', Smalltalk platformName, '/QSoundTestDatagrams').
		fileStream binary.
		[fileStream atEnd] whileFalse: [
			"302 bytes each"
			testSignalDatagrams nextPut: (fileStream next: 302)]
	]
		ensure: [fileStream close].

	testSignal := testSignal contents.
	encodedTestSignal := encodedTestSignal contents.
	testSignalDatagrams := testSignalDatagrams contents! !

!QSoundTest methodsFor: 'initialization' stamp: 'crl 5/7/2010 17:01'!
setUp
	self durationInSeconds: 5! !

!QSoundTest methodsFor: 'testing' stamp: 'jcg 7/13/2010 16:09'!
subscribe
	subscription := (
		QControlStreamSubscription
			streamID: publication streamID
			mediaController: mediaController
			inputClass: TAudioStreamInput
			outputClass: TAudioStreamOutput).

	subscription forceConnectionToRouter.

	self startScript: #subscriptionDestroyed: when: {subscription. #destroyed}.
	self startScript: #subscriptionFailed:because: when: {subscription. #connectionFailed}.
	(subscription connectWithTimeout: 120000) wait.
	subscription unpause.
	
	"Ensure that the publisher received the unpause message before we proceed."
	((subscription sendRequest: 'how are you?') waitTimeoutSeconds: 5)
		ifFalse: [self error: 'failed to receive response after subscription'].
! !

!QSoundTest methodsFor: 'events' stamp: 'crl 3/8/2010 11:09'!
subscriptionDestroyed: sub
	QLogger logInfo: 'subscription destroyed'.
	subscription := nil.
	self stopScript: #subscriptionFailed:because:.
	self stopScript: #acceptAndDecodeData:.

	"Last, because we're probably running this script right now."
	self stopScript: #subscriptionDestroyed:! !

!QSoundTest methodsFor: 'events' stamp: 'crl 3/8/2010 11:09'!
subscriptionFailed: sub because: reasonString
	| msg |
	msg := 'Could not subscribe to audio stream ', sub streamID hex, 
			' because: ', reasonString.
	QLogger logInfo: msg! !

!QSoundTest methodsFor: 'accessing' stamp: 'crl 3/25/2010 16:58'!
summary
	| summary |

	summary := (String new: 128) writeStream.

	summary
		nextPutAll: 'Latencies and jitter:';
		cr.
	self correlationsDo: [:correlation | correlation printSummaryOn: summary].

	^summary contents! !

!QSoundTest methodsFor: 'initialization' stamp: 'crl 3/8/2010 11:58'!
tearDown
	self destroy! !

!QSoundTest methodsFor: 'testing' stamp: 'crl 3/30/2010 15:59'!
testCapturing
	"Unit test to measure the baseline data for our simulated recording loop of the whole sample."

	QLogger logInfo: 'testing capture'.
	self processOriginalSegmentsUsing: #capture:toBufferAt:.
	captureCorrelation assert! !

!QSoundTest methodsFor: 'testing' stamp: 'crl 5/19/2010 17:10'!
testDecoding
	"Unit test to measure everything through decoding."

	| timingData desiredFrameCount decodedSoundBuffer acquisitionStartTime acquisitionDelay |

	QLogger logInfo: 'testing decoding'.
	self publish; subscribe.
	subscription dataHandler: [:datagram | self acceptAndDecodeData: datagram].
	feedbackSink source: speexSink.

	acquisitionDelay := Delay forMilliseconds: 200.

	self testEncodingAndSending.

	desiredFrameCount := numberOfSegments * 1280 / 320.
	acquisitionStartTime := self currentTime.
	QLogger logInfo: 'waiting for decoded frames...'.
	[feedbackSink decodedFrameCount <= desiredFrameCount and: [(self currentTime - acquisitionStartTime) < 10000]] whileTrue: [acquisitionDelay wait].

	"Stop the flow of samples through the feedbackSink."
	feedbackSink source: nil.

	(feedbackSink decodedFrameCount >= desiredFrameCount)
		ifTrue: [
			QLogger logInfo: 'decoded frames complete after ', (self currentTime - acquisitionStartTime), ' milliseconds'.
			decodedSoundBuffer := feedbackSink makeSound samples]
		ifFalse: [
			QLogger logInfo: 'decoded frames incomplete after ten seconds'.
			^self assert: false].

	"Allow for the maximum jitter buffer margin (600ms), and the profiling frequency (200ms)."
	timingData := OrderedCollection new: 259.

	acquisitionStartTime := self currentTime.

	QLogger logInfo: 'collecting timing data...'.
	[timingData size < 257 and: [(self currentTime - acquisitionStartTime) < 10000]] whileTrue: [
		timingData addAll: (speexSink profiler window timesAndValuesFrom: 0).
		acquisitionDelay wait].

	timingData size < 257
		ifTrue: [
			QLogger logInfo: 'timingData incomplete after ten seconds'.
			^self assert: false]
		ifFalse: [QLogger logInfo: 'timingData complete after ', (self currentTime - acquisitionStartTime), ' milliseconds'].

	"Calculate decodingTimes using the timing data from the speex sink's profiler."
	1
		to: numberOfSegments
		do: [:segmentIndex |
			decodingCorrelation
				actualTimeAt: segmentIndex
				put: ((transportCorrelation actualTimeAt: segmentIndex) + (timingData at: (segmentIndex - 1) * 4 + 1) value)].

	captureCorrelation assert.
	encodingCorrelation assert.
	queuingCorrelation assert.
	transportCorrelation assert.
	decodingCorrelation
		actualData: (SampledSound samples: decodedSoundBuffer samplingRate: 16000);
		assert! !

!QSoundTest methodsFor: 'testing' stamp: 'crl 5/7/2010 12:19'!
testEncoding
	"Unit test to measure the data after going through the capture and encoding stages."

	QLogger logInfo: 'testing encoding'.
	self processOriginalSegmentsUsing: #encode:toBufferAt:.
	captureCorrelation assert.
	encodingCorrelation assert! !

!QSoundTest methodsFor: 'testing' stamp: 'crl 5/7/2010 12:19'!
testEncodingAndSending
	"Unit test to measure the data for everything through sending the whole sample."

	QLogger logInfo: 'testing encoding and sending'.
	self
		publish;
		processOriginalSegmentsUsing: #encodeAndSend:toBufferAt:.

	captureCorrelation assert.
	encodingCorrelation assert.
	queuingCorrelation assert! !

!QSoundTest methodsFor: 'testing' stamp: 'crl 3/30/2010 16:00'!
testReceiving
	"Unit test to measure everything through receiving the whole sample."

	QLogger logInfo: 'testing receiving'.
	self publish; subscribe.

	subscription dataHandler: [:datagram | self acceptData: datagram].

	self testEncodingAndSending.
	transportCorrelation assert! !

!TAudioStreamInput methodsFor: '*Qwaq-Sound' stamp: 'crl 3/2/2010 16:41'!
addSoundData: data at: frameAndServerTimes codec: codec level: level
	"Convenience method for sending data from a QSoundRelay.  We could just send ourselves #sendMedia:, but this saves an extra copy of the data.  We put it on the event queue rather than sending it directly.

NOTE: this is in Qwaq-Sound because it uses QSpeexCodec, which is also in Qwaq-Sound."
	| allData codecByte datagram |
	allData := ByteArray new: 1 + 4 + 4 + 1 + 8 + data size.
	allData at: 1 put: Media.

	"Instead of storing the timestamp as a double-precision floating point number, store it as a 4-byte unsigned integer.  In the remaining four bytes, store the 'server-timestamp' (see #serverTimeStampFor:)."
	allData networkUnsignedLongAt: 2 put: frameAndServerTimes first.
	allData networkUnsignedLongAt: 6 put: frameAndServerTimes second.

	false ifTrue: [Transcript show: 'INPUT LEVEL: ', level printString; cr].

	"TODO: make this prettier and more robust"
	codec == nil ifTrue: [codecByte := 0].
	codec == GSMCodec ifTrue: [codecByte := 1].
	codec == QSpeexCodec ifTrue: [codecByte := 2].

	allData at: 10 put: codecByte.
	allData networkDoubleAt: 11 put: level asFloat.
	allData replaceFrom: 19 to: allData size with: data.

	datagram := (
		TDatagram 
			facet: nil 
			data: allData "already prefixed"
			tag: self trafficTag).

	self future sendMediaDgramDownstream: datagram.

	^datagram! !

!TAudioStreamInput methodsFor: '*Qwaq-Sound' stamp: 'jcg 10/9/2008 09:35'!
sendEndOfAudiblePeriod 
	"Convenience method for sending data from a QSoundRelay.  Data format mimics #addSoundData:at:codec:level:... although the frame-time and volume-level are ignored, and there is no additional data."
	| allData |
	allData := ByteArray new: 1 + 8 + 1 + 8.
	allData at: 1 put: Media.
	allData networkDoubleAt: 2 put: 0.0 "frame time... will be ignored".
	allData at: 10 put: 255 "codec byte of 255 means 'silence'.".
	allData networkDoubleAt: 11 put: 0.0.

	self future sendMediaDgramDownstream: 
									(TDatagram 
										facet: nil 
										data: allData "already prefixed"
										tag: self trafficTag).! !

!GSMCodec class methodsFor: '*Qwaq-Sound' stamp: 'jcg 2/25/2009 18:19'!
samplingRate
	"If this codec is hardwired to a specific sampling-rate, answer it.  Otherwise, answer nil."
	^8000! !

QEventLoop2 subclass: #QAudioSession
	instanceVariableNames: 'microphone isPressToTalk soundEffects useSoundEffects speakerManager ui view soundFramePlayers audioInterface isMute isSuspended listenerTransform phoneManager micStats jitterbufferMarginRange isRecordingSession recorder voiceRelay deviceManager needsOpenALReset errorCount noMixedSourcesRecorder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Qwaq-Sound-Session'!

!QAudioSession commentStamp: 'ar 4/16/2011 17:40' prior: 0!
Manages audio.  Mediates between the UI, the replicated spatialized sound sources within the Croquet space, and the underlying sound API (either OpenAL or Squeak sound... see subclasses).

In April 2010, QAudioSession was made a subclass of QEventLoop.  Most operations are still not synchronized by this event-loop, but we'll move stuff in bit-by-bit.!

!QAudioSession class methodsFor: 'LICENSE' stamp: 'ar 4/20/2011 09:46'!
LICENSE
	^'Project OpenQwaq

	Copyright (c) 2005-20011, Teleplace, Inc., All Rights Reserved

	Redistributions in source code form must reproduce the above
	copyright and this condition.

	The contents of this file are subject to the GNU General Public
	License, Version 2 (the "License"); you may not use this file
	except in compliance with the License. A copy of the License is
	available at http://www.opensource.org/licenses/gpl-2.0.php.'! !

!QAudioSession class methodsFor: 'utility' stamp: 'eem 3/18/2010 17:44'!
hasQAudioPlugin
	^self primGetPluginVerbosityOrNil ~~ nil! !

!QAudioSession class methodsFor: 'utility' stamp: 'bgf 11/20/2008 13:22'!
heapCheck: msg
	"Expensive way to get filed-out confirmation of heap integrity.
	 This lives here because it uses the audio-session direct-to-disk logger."
	false ifTrue: [
		self pluginLogMsg: 'Heap-check ', msg.
		OpenAL allInstances.
		self pluginLogMsg: 'Heap-check ', msg, ' - OK'.
	].
	! !

!QAudioSession class methodsFor: 'utility' stamp: 'jcg 6/9/2009 11:17'!
logPortAudioDeviceInfo
	"For diagnostic purposes."
	<primitive: 'primitivePortAudioPrintDeviceInfo' module: 'QAudioPlugin'>
	^self primitiveFailed
! !

!QAudioSession class methodsFor: 'primitives' stamp: 'jcg 11/17/2008 19:03'!
pluginLogMsg: msgString
	"Allows us to log to the current plugin log-file (typically QAudioPlugin.log)."
	[self primLogMsg: msgString]
		on: Error
		do: [QLogger logWarning: 'failed to log to QAudioPlugin.log: ', msgString]
			! !

!QAudioSession class methodsFor: 'primitives' stamp: 'jcg 6/19/2008 14:23'!
primAudioPluginTickerSetInterval: milliseconds
	<primitive: 'primitiveTickerSetInterval' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSession class methodsFor: 'primitives' stamp: 'jcg 6/19/2008 14:24'!
primAudioPluginTickerSetVerbosity: oneToTen
	<primitive: 'primitiveTickerSetVerbosity' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSession class methodsFor: 'primitives' stamp: 'jcg 6/19/2008 14:24'!
primAudioPluginTickerStart
	<primitive: 'primitiveTickerStart' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSession class methodsFor: 'primitives' stamp: 'jcg 6/19/2008 14:24'!
primAudioPluginTickerStop
	<primitive: 'primitiveTickerStop' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSession class methodsFor: 'primitives' stamp: 'jcg 6/27/2008 09:09'!
primAudioPluginTickerTickNow
	<primitive: 'primitiveTickerTickNow' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSession class methodsFor: 'primitives' stamp: 'jcg 8/18/2008 11:49'!
primGetPluginVerbosity
	<primitive: 'primitiveGetLogVerbosity' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSession class methodsFor: 'primitives' stamp: 'eem 3/18/2010 17:42'!
primGetPluginVerbosityOrNil
	"For quick determination of the plugin being present"
	<primitive: 'primitiveGetLogVerbosity' module: 'QAudioPlugin'>
	^nil! !

!QAudioSession class methodsFor: 'primitives' stamp: 'jcg 11/17/2008 19:03'!
primLogMsg: msgString
	"Allows us to log to the current plugin log-file (typically QAudioPlugin.log)."
	<primitive: 'primitiveLogMsg' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSession class methodsFor: 'primitives' stamp: 'jcg 6/9/2009 00:29'!
primPortAudioResetDevice
	<primitive: 'primitivePortAudioResetDevice' module: 'QAudioPlugin'>
	^self primitiveFailed
! !

!QAudioSession class methodsFor: 'primitives' stamp: 'jcg 9/26/2008 10:10'!
primSetPluginLogFile: filePath
	<primitive: 'primitiveSetLogFile' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSession class methodsFor: 'primitives' stamp: 'jcg 8/18/2008 11:49'!
primSetPluginVerbosity: oneToTen
	<primitive: 'primitiveSetLogVerbosity' module: 'QAudioPlugin'>
	^self primitiveFailed! !

!QAudioSession class methodsFor: 'utility' stamp: 'jcg 6/8/2009 13:52'!
setOpenALDeviceName: deviceNameOrNil
	"Set deviceNameOrNil as the default device to be used as the next output device to be opened (nil means the default device)."
	<primitive: 'primitiveOalSetAudioDevice' module: 'QAudioPlugin'>
	^self primitiveFailed
	! !

!QAudioSession class methodsFor: 'utility' stamp: 'jcg 9/26/2008 10:21'!
setPluginLogFile: filePath
	"Set the log-file used by QAudioPlugin."
	[
		self primSetPluginLogFile: filePath.
		QLogger logInfo: 'set QAudioPlugin log-file to: ', filePath.
	]
		on: Error 
		do: [:err | QLogger logWarning: 'failed to set log-file to: ', filePath, 
														'  (', err description, ')' 
		]! !

!QAudioSession methodsFor: 'actions' stamp: 'jcg 4/13/2010 14:28'!
aboutToRender

	"Per-frame, update the avatar listener position if necessary."
	view ifNotNil: [:v | v avatar ifNotNil: [:av |
		self future updateListenerPosition: av localTransform.
	]].
! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 4/9/2010 17:28'!
addRecordingClient: client
	self assertIsInTurn.
	recorder addClient: client.
	recorder isRecording ifFalse: [
		"Update speaker play-states on transitions.  For example, If we stopped recording because the user switched to another space.  this ensures that there is no spill-over from the previous space to this one.  Also, if we start recording with global speaker muting turned on, this ensures that we unpause the input streams."
		speakerManager ifNotNilDo: [:sm | 
			"Bulletproof... speaker-manager might be nil during shutdown."
			sm updateAllPlayStates]
	]! !

!QAudioSession methodsFor: 'accessing' stamp: 'bgf 5/5/2009 16:07'!
allIslands
	"All the TIslands in the session that potentially contain Speakers
	 (passthrough to the croquet session.)"
	view ifNotNil: [
		"N.B. there are no Speakers in org services."
		^ view session allSessionIslands
	].
	^#()! !

!QAudioSession methodsFor: 'assertion' stamp: 'jcg 5/17/2010 17:00'!
assertIsInTurn
	"We don't want to explode, since we'll probably be OK.  Just log an error, and carry on as though nothing happened."
	[super assertIsInTurn] on: Error do: [:err | self future handleError: err].! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 2/23/2007 13:36'!
audioInterface
	^ audioInterface! !

!QAudioSession methodsFor: 'accessing' stamp: 'crl 1/22/2010 17:34'!
audioRecorder
	^recorder! !

!QAudioSession methodsFor: 'actions' stamp: 'jcg 2/19/2007 17:39'!
clearSounds
	"HACK!! Tell the audio interface to clear all of its sounds; they will be lazily recreated if necessary."
	audioInterface clearSounds! !

!QAudioSession methodsFor: 'private' stamp: 'jcg 2/17/2010 12:36'!
destroyAllPlayers

	"Destroy all SoundFramePlayers in the session."
	soundFramePlayers ifNotNil: [:players |
		soundFramePlayers := Dictionary new.
		players values copy do: [ :player | player destroy].
	]
! !

!QAudioSession methodsFor: 'initialize' stamp: 'bgf 2/6/2009 22:02'!
destroyPhoneManager
	"At the end of a croquet session."

	phoneManager ifNotNil: [phoneManager destroy].
	phoneManager := nil.
! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 4/7/2010 22:27'!
deviceManager
	^deviceManager
! !

!QAudioSession methodsFor: 'resources' stamp: 'ar 4/16/2011 17:40'!
discardIsland: aTIsland
	"Per-forum logout support."
	self assertIsInTurn.
	speakerManager ifNotNil: [ speakerManager discardIsland: aTIsland ].! !

!QAudioSession methodsFor: 'accessing' stamp: 'bgf 1/29/2009 17:02'!
documentManager
	^ view ifNotNil: [ view session documentManager ]! !

!QAudioSession methodsFor: 'voice chat' stamp: 'jcg 4/30/2010 11:20'!
endVoiceChat
	"Stop recording on behalf of the given avatar."
	self assertIsInTurn.
	microphone isRecording ifTrue: [microphone stopRecording].
	microphone streamer: nil.		"I.e. disconnect."

! !

!QAudioSession methodsFor: 'initialize' stamp: 'jcg 8/30/2008 00:10'!
flushForIslandReconnect: anIsland

	"Discard existing client-side players
	 to prepare for a reconnect of the active island.
	 Client/island uses objectIDs (which are preserved by reconnect)
	 so to get fresh sound frame players we have to clear all the old ones."

	soundFramePlayers := 
		soundFramePlayers select: [ :sfp  | 
			sfp ref isValidFarRef and: [sfp ref island ~~ anIsland] ].

! !

!QAudioSession methodsFor: 'initialize' stamp: 'jcg 4/10/2010 18:27'!
forceAudioInterfaceClass: subclassOfQwaqAudioInterface
	"Forcedly recreate the receiver with the audio class"
	| newInterface oldEffects |
	
	self assertIsInTurn.

	"For example, if this is called from #resetAudioInterface with OpenAL enabled,
	 then  we need to do this first so that the first OpenAL context is destroyed before
	 we create the new one."
	audioInterface ifNotNil: [
		audioInterface destroy.
		audioInterface := nil.
	].

	newInterface := subclassOfQwaqAudioInterface new.

	self useAudioInterface: newInterface.
	QLogger logInfo: 'Changed audio interface to ', subclassOfQwaqAudioInterface name.

	"The sound effects may be using Open AL activity at the time of reset
	 (for wandering ambient  sounds), but we want them released when OpenAL is reset."
	oldEffects := soundEffects.
	soundEffects := QSoundEffects new.
	soundEffects audioSession: self.
	oldEffects ifNotNil: [ oldEffects destroy ].

	self useNormalOutputVolume.! !

!QAudioSession methodsFor: 'private' stamp: 'ar 6/3/2010 10:31'!
handleError: err
	| stack |

	(self owner notNil and:[self owner isSealedApplication])
		ifTrue: [
			errorCount := errorCount + 1.
			errorCount > 5 ifTrue: [
				"Don't spam too many emails."
				^QLogger logWarning: 'only reporting 5 errors, this is number ', errorCount
			].
			stack := [err signalerContext stackOfSize: 200] on: Error do: [
				QLogger logWarning: 'failed to get stack in #handleError'.
				OrderedCollection new
			].
			ui 
				reportIncident: 'QAudioSession event-loop error number: ', errorCount 
				error: err 
				stack: stack
		] ifFalse: [
			[err pass "handy for debugging"] ifCurtailed:[self startEventLoop].
		].! !

!QAudioSession methodsFor: 'initialize' stamp: 'crl 4/19/2010 18:39'!
initialize
	super initialize.

	"First thing: set up logging."
	self class setPluginLogFile: (FileDirectory logDirectory fullNameFor: 'QAudioPlugin.log').
	micStats := TWindowedStatistics forWindowDuration: 60000.
	micStats tagName: #Mic.
	voiceRelay := QStreamingSoundRelay new.
	self resetMicrophone: 500.
	isMute := false.
	isSuspended := false.
	isPressToTalk := false.
	needsOpenALReset := false.
	errorCount := 0.

	"This will be overridden by the user's preferences."
	soundEffects := QSoundEffects new.
	useSoundEffects := true.

	soundFramePlayers := Dictionary new.

	speakerManager := QSpeakerManager new.
	speakerManager audioSession: self.
	speakerManager view: view.

	deviceManager := QAudioDeviceManager new.
	deviceManager audioSession: self.

	listenerTransform := Matrix4x4 new. 

	"Ensure that this is true (we were relying on the class variable being set properly to begin with."
	QClientSpeakerExternalOutput useJitterbuffer: true.

	"Extra guard in case not everyone has plugin support for these operations."
	[QAudioSession 
		primAudioPluginTickerSetInterval: 20;
		primAudioPluginTickerStart
	] on: Error do: [:err | QLogger logWarning: 'failed to start ticking'].


		[recorder := QAudioRecorder on: self]
			on: Error
			do: [:err |
				"If there's an error, then we haven't started recording. Pass the error on for someone else to handle."
				err pass.
			].

		[noMixedSourcesRecorder := QAudioRecorderForNonMixSources on: self]
			on: Error
			do: [:err |
				"If there's an error, then we haven't started recording. Pass the error on for someone else to handle."
				err pass.
			]	! !

!QAudioSession methodsFor: 'initialize' stamp: 'hrs 1/12/2010 10:49'!
initializeFromPreferences: prefs "a QUserPreferences"
	| device |
	[
		SoundPlayer defaultPlayer isEmptyOrNil ifTrue: [
			"Important on windows where sys default might be different than our preference.
			Set it now before things get started."
			device := prefs audioPlayer.
			device  ifNotNil: [
				SoundPlayer defaultPlayer: device.  "Needs to be guarded against nul device"
				self openALDevice: device.
			] ifNil: [  "Notify, but do not give error. Can still record if we have appropriate interface."
				QLogger logWarning: 'There is no sound device plugged in. There will be no sound.'.
			].
		].
		self useOpenAL: prefs useOpenAL.
		self startScript: #useOpenAL: when: {prefs. #useOpenALChanged}.

	] on: Error do: [  : ex |
		QLogger logWarning: 'failed to initialize audio-session (there will be no sound)'.
		QLogger logError: ex.
	]! !

!QAudioSession methodsFor: 'testing' stamp: 'jcg 10/14/2008 12:24'!
isConnected
	"Am I poised for voice input/transmission?
	 This may be true when not recording, if I am 'press-to-talk'."

	^ microphone streamer notNil! !

!QAudioSession methodsFor: 'testing' stamp: 'jcg 2/19/2007 15:38'!
isMute
	^ isMute! !

!QAudioSession methodsFor: 'testing' stamp: 'jcg 4/30/2010 17:20'!
isMute: bool
	self isInTurn ifFalse: [self future isMute: bool. ^self].
	bool == isMute ifTrue: [^self].
	isMute := bool.
	isMute ifTrue: [speakerManager beMute] ifFalse: [speakerManager beUnmute].

	"So that UI can update."
	ui signal: #isMuteChanged with: isMute.! !

!QAudioSession methodsFor: 'voice chat' stamp: 'bgf 1/20/2008 03:25'!
isPressToTalk
	^ isPressToTalk! !

!QAudioSession methodsFor: 'voice chat' stamp: 'jcg 4/30/2010 14:23'!
isPressToTalk: yesNo
	"In press-to-talk, we main the sound stream,
	 but only engage the recorder while pressTalkDown: is true."
	self assertIsInTurn.

	isPressToTalk == yesNo ifTrue: [^self].
	isPressToTalk := yesNo.
	self microphone stopRecording.		"So we have clean, unpaused state."

	self useNormalOutputVolume.
	self isConnected ifTrue: [
		self microphone startRecording.
		isPressToTalk ifFalse: [ 
			self microphone resumeRecording ].
	].
! !

!QAudioSession methodsFor: 'testing' stamp: 'jcg 10/14/2008 12:25'!
isRecorderPaused
	^ microphone notNil and: [ microphone isPaused ]! !

!QAudioSession methodsFor: 'testing' stamp: 'jcg 10/14/2008 12:24'!
isRecording
	^ microphone isRecording! !

!QAudioSession methodsFor: 'accessing' stamp: 'crl 4/20/2010 18:43'!
isRecordingSession
	"True if the client is currently recording the session (in which case voice streams should not be paused even when mute etc)"
	^recorder isRecording or: [noMixedSourcesRecorder isRecording]! !

!QAudioSession methodsFor: 'testing' stamp: 'bgf 1/29/2009 19:36'!
isSessionOfUser: aSessionID
	"True if the given user-sessionID corresponds to this client/harness...
	 used to decide whether to handle event-signals from sound-frames."
	^ (view notNil and: [ view sessionID = aSessionID] )! !

!QAudioSession methodsFor: 'accessing' stamp: 'bgf 1/5/2008 18:42'!
isSuspended
	^ isSuspended! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 3/2/2009 01:56'!
jitterbufferMarginRange
	"Answer an Interval describing the range of acceptable jitter-buffer margin values in milliseconds."
	^jitterbufferMarginRange! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 2/25/2007 01:47'!
listenerPosition
	^ listenerTransform translation! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 2/25/2007 22:36'!
listenerTransform
	^ listenerTransform! !

!QAudioSession methodsFor: 'private' stamp: 'jcg 4/2/2010 17:46'!
logResetSound: msg
	| fullMsg |
	fullMsg := 'RESET-SOUND:  ', msg.
	QLogger logInfo: fullMsg.
	QAudioSession pluginLogMsg: fullMsg.! !

!QAudioSession methodsFor: 'actions' stamp: 'bgf 2/21/2009 13:13'!
makeCurrent
	audioInterface ifNotNil: [ audioInterface makeCurrent ]! !

!QAudioSession methodsFor: 'accessing' stamp: 'ar 12/4/2008 15:27'!
micStats
	"Microphone jitter statistics"
	^micStats! !

!QAudioSession methodsFor: 'accessing' stamp: 'ar 12/4/2008 15:28'!
micStats: aTWindowedStats
	"Microphone jitter statistics"
	micStats := aTWindowedStats! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 11/4/2008 00:11'!
microphone
	^microphone! !

!QAudioSession methodsFor: 'initialize' stamp: 'crl 4/29/2010 14:39'!
mixOutputForRecording: aQClientSpeakerOutput
	recorder isRecording ifTrue: [recorder mixOutputForRecording: aQClientSpeakerOutput].
	noMixedSourcesRecorder isRecording ifTrue: [noMixedSourcesRecorder mixOutputForRecording: aQClientSpeakerOutput].
	! !

!QAudioSession methodsFor: 'accessing' stamp: 'crl 4/19/2010 18:48'!
mixedSourcesRecorder
	^recorder! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 4/8/2010 14:29'!
nextResetShouldUnloadOpenAL
	"Next time reset-sound is called, unload OpenAL."
	needsOpenALReset := true! !

!QAudioSession methodsFor: 'accessing' stamp: 'crl 4/19/2010 18:48'!
noMixedSourcesRecorder
	^noMixedSourcesRecorder! !

!QAudioSession methodsFor: 'initialize' stamp: 'jcg 4/9/2010 17:33'!
onSoundRegionChanged: newRegion
	"The listener's sound region assignment has changed;
	 switch all client-speakers to use the new attenuation rules."

	"Ensure that we react in the event-loop."
	self isInTurn ifFalse: [
		DropAllButLastEvent signal.
		self future onSoundRegionChanged: newRegion.
		 ^self
	].

	"Let the region reference resolve"
	newRegion ifNotNil: [ newRegion waitTimeoutSeconds: 15 ].
	speakerManager listenerRegion: newRegion
					 attenuation: ((newRegion get:#attenuation) ifNil: [ 0.0 ]).

! !

!QAudioSession methodsFor: 'accessing' stamp: 'bgf 2/6/2009 21:39'!
openAL
	"My main OpenAL session/context, if one exists."
	^ audioInterface ifNotNil: [ audioInterface openAL ]! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 6/15/2010 21:32'!
openALDevice: qDev
	"On startup or after unloading the plugin, the QAudioPlugin::g_oal_devicename is cleared.
	On Mac that does not matter because we set the operating system default
	device to what we want. On Windows, we have to use a primitive to tell oAL
	to use a specific device device when we resetAudioInterface."	
	|  oalDev msg |
	Smalltalk platformName = 'Win32' ifFalse: [^self].
	oalDev :=  'DirectSound Software'.
	(qDev = 'Primary Sound Driver') ifFalse: [oalDev := oalDev, ' on ', qDev].
	QAudioSession setOpenALDeviceName: oalDev.
	msg := 'Set openAL device to ''', oalDev, ''''.
	QLogger logInfo: msg.
	QAudioSession pluginLogMsg: msg.! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 8/9/2009 20:57'!
owner
	"Answer the QwaqParticipantUI."
	^ view ifNotNilDo: [:v | v owner]! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 7/11/2008 11:51'!
phoneManager
	^phoneManager! !

!QAudioSession methodsFor: 'client sources' stamp: 'bgf 2/6/2009 20:40'!
playSoundEffect: aSymbol at: aVector3
	"Play the named sound effect at the given spatial position; the sound is looked up in a QSoundEffects."
	(isMute | useSoundEffects not) ifTrue: [^self "don't play sound effect"].
	audioInterface ifNotNil: [
		audioInterface playSoundEffect: aSymbol at: aVector3.
	].! !

!QAudioSession methodsFor: 'voice chat' stamp: 'bgf 5/28/2009 19:04'!
pressTalkDown: yesNo
	"The press-to-talk button has been depressed or released."

	(self isPressToTalk and: [self isConnected]) ifTrue: [
		yesNo 
			ifTrue: [ self useLowOutputVolume. 
					microphone resumeRecording ]
			ifFalse: [ 
					self useNormalOutputVolume.
					microphone pauseSoonUnless: [ 
						view notNil and: [ view owner controlBar pttAndControlIsDown ]] ].
	] ifFalse: [
		"Just safety in case recover states overlap."
		self useNormalOutputVolume.
	].
	
! !

!QAudioSession methodsFor: 'stats reporting' stamp: 'jcg 5/17/2010 12:11'!
printStatsReportOn: aStream
	"User-visible stats in QStatisticsPane."
	| recordJitter sendJitter  speakers |

	self assertIsInTurn.

	recordJitter := microphone recordJitter 
					ifNil: ['n/a'] 
					ifNotNilDo: [:j | (j roundTo: 0.1) printString, 'ms']. 
	sendJitter := voiceRelay jitter
					ifNil: ['n/a'] 
					ifNotNilDo: [:j | (j roundTo: 0.1) printString, 'ms']. 
	aStream nextPutAll: 'Mic Jitter - Record: ', recordJitter, ' Net-Queue: ', sendJitter; cr.

	speakers := speakerManager speakers.
	speakers := speakers select: [:spkr | spkr isConnectedAndStreaming].
	speakers ifNotNil: [
		aStream nextPutAll: 'Speakers: ', speakers size; cr.
		speakers do: [:spkr |
			aStream tab.
			spkr printStatisticsOn: aStream.
			aStream cr.
		].
	]! !

!QAudioSession methodsFor: 'initialize' stamp: 'crl 4/23/2010 18:18'!
privateDestroy
	QLogger logInfo: 'destroying audio-session'.


	"See CObject #destroy; stop all scripts now."
	self myScripts do:[:script| script terminateScript].
	self myScripts:nil.

	recorder ifNotNil: [:r |
		recorder := nil.
		r destroy.
	].

	noMixedSourcesRecorder ifNotNil: [:r |
		noMixedSourcesRecorder := nil.
		r destroy.
	].

	voiceRelay ifNotNil: [:relay |
		voiceRelay := nil.
		relay destroy.
	].

	speakerManager ifNotNil: [:sm |
		speakerManager := nil.
		sm destroy
	].
	
	self destroyAllPlayers.
	
	soundEffects ifNotNil: [:effects |
		soundEffects := nil.
		effects destroy
	].

	audioInterface ifNotNil: [:interface |
		audioInterface := nil.
		interface destroy
	].

	self destroyPhoneManager.

	"Extra guard in case not everyone has plugin support for these operations."
	[QAudioSession primAudioPluginTickerStop]
		on: Error do: [:err | QLogger logWarning: 'failed to stop ticking'].

	QLogger logInfo: 'finished destroying audio-session'.


! !

!QAudioSession methodsFor: 'private' stamp: 'sn 5/22/2013 13:23'!
privateResetSound
	"Should only be called by QwaqParticipantUI>>privateResetSound:"
		"Reset the core sound systems and audio handlers;
	 this is called with all-islands locked to block render-pass events, 
	 resource events, etc."
	| restartMic bUnloadOpenAL |

	self logResetSound: 'at the beginning...'.
	self assertIsInTurn.
	
	"Step -1 : Do some stuff that used to be in QwaqParticipantUI, but shouldn't be."
	self useSoundEffects: false.

	"Step 0 : turn off sound injection and sound receipt from others."
	self logResetSound: 'Hiding voices.' translateMe .
	voiceRelay ifNotNilDo: [:vr | 
		vr speaker isValidFarRef ifTrue: [ 
			vr speaker future unregisterResource.
		]].


	"Without this, when we try to unload OpenAL32.dll on Windows, it won't work.  For some reason that we don't understand, this must precede #destroyAllSpeakers below (otherwise, we'd just put in the block guarded by 'bUnloadOpenAL' below)."
	speakerManager beMute.

	[ speakerManager destroyAllSpeakers ] 
		on: Error 
		do: [ :ex| QLogger logWarning: 'Resetting speakers ? ', ex ].
		"Just hangonasec man, let the world deal with all that."
	ProcessorScheduler relinquishProcessorForMicroseconds: 5000.

	"Disable OpenAL unloading for now... if all goes well with the new
	 OpenAL32.dll then we'll be able to remove this code permanently."
	bUnloadOpenAL := false. "needsOpenALReset."
	bUnloadOpenAL ifTrue: [
		QLogger logWarning: 'Unloading OpenAL to accomodate changed device-list'.
		needsOpenALReset := false.

		QAudioSession primAudioPluginTickerStop.
		self useOpenAL: false.

		"Josh:  WTF?  It can't hurt to reset the codec, I guess, 
		 but why only if we've unloaded OpenAL?"
		microphone codec: nil.
		
		"These dudes will crash if you use them post-rest-sound. 
		 Better to have a primitive-failed error that we can catch."
		QSpeexCodec allInstancesDo: [:codec | codec destroy].
		QSoundTest allInstancesDo: [:test | test destroy].
	].

	"Step 1: Shutdown OpenAL"
	"XXXXX: this is a bit weird... ideally, 
	 this should be taken care of when we destroy/recreate the audio-interface below
	(and maybe it is... I think that this step pre-dates the reification of the audio-interface."
	OpenAL allSubInstancesDo:[:oal| oal destroy].

	"Step 2: Shutdown Squeak sound"
	SoundPlayer shutDown.

	"Step 3: Pause all active SoundRecorders."
	self logResetSound: 'Pausing sound recorders'.
	restartMic := false.
	[ 
		microphone isActive ifTrue: [
			microphone stopRecording.
			restartMic := true 
		] 
	] on: Error do: [ : ex | QLogger logWarning: 'Microphone stop - ', ex ].
	recorder beginResetSound.
	noMixedSourcesRecorder beginResetSound.

	"Step 4: Under some circumstances (see how we calculate 'bUnloadOpenAL' above) we seem to need to unload QAudioPlugin in order for OpenAL to detect changed input devices." 
	bUnloadOpenAL ifTrue: [
		| modules |
		self logResetSound: 'About to unload QAudioPlugin'.
		Smalltalk unloadModule: 'QAudioPlugin'.
		(Delay forSeconds: 1) wait. "Give time to let QAudioPlugin finish up."
		
		modules := Smalltalk listLoadedModules.
		(modules anySatisfy: [:nm | nm beginsWith: 'QAudioPlugin']) ifTrue: [
			"Uh-oh... unloading OpenAL will fail if QAudioPlugin is already reloaded."
			| msg |
			msg := 'QAudioPlugin was reloaded before attempt to unload OpenAL32.DLL'. 
			self ui isSealedApplication 
				ifTrue: [QLogger logWarning: msg]
				ifFalse: [self ui reportIncident: msg].
		].

		Smalltalk unloadModule: 'OpenAL32.dll'.
		OpenAL flushPrimitives.
		"Now that we've unloaded QAudioPlugin, all audio-decoders have invalid
		 handles (so the encoders, but we have sane ways to get at them."
		QAudioDecoder allSubInstances do: [:qad | qad hackClearHandle].
		" Unloading QAudioPlugin.dll also drops the log file so restore it "
		QAudioSession setPluginLogFile:
			(FileDirectory logDirectory fullNameFor: 'QAudioPlugin.log').
		self logResetSound: 'Just reloaded QAudioPlugin'.
	].

	"- Just hangonasec man, let the world deal with all that."
	ProcessorScheduler relinquishProcessorForMicroseconds: 5000.

	bUnloadOpenAL ifTrue: [
		QAudioSession primAudioPluginTickerSetInterval: 20.  "20 msecs"
		QAudioSession primAudioPluginTickerStart.
		"Josh:  WTF?  It can't hurt to reset the codec, 
		 I guess, but why only if we've unloaded OpenAL?"
		microphone codec: QSpeexCodec new.  
	].
	"If we muted ourself above, undo it."
	isMute ifFalse: [speakerManager beUnmute].

	"Step 5: Recreate the audio interface"
	self logResetSound: 'Resetting audio interface' translateMe .
	self openALDevice: ui preferences audioPlayer.
	"We can probably always just do the true branch, but that's not what the original
	more-well-tested code was doing."
	bUnloadOpenAL
		ifTrue: [
			self useOpenAL: ui preferences useOpenAL.
			QClientSpeakerExternalOutput useJitterbuffer: true.  "re-enable"
		]
		ifFalse: [self resetAudioInterface].

	"Step 6: Resume recording"
	restartMic ifTrue: [ 
		self logResetSound: 'Restarting recorder' translateMe .
		microphone startRecording ].
	recorder endResetSound.
	noMixedSourcesRecorder endResetSound.

	"Step 7: re-establish voice chat speaker stream."
	self logResetSound: 'Resuming voice stream' translateMe .
	voiceRelay ifNotNilDo: [:vr | 
		vr speaker isValidFarRef ifTrue: [ 
			vr speaker future unregisterResource.
			vr speaker future registerResource.
		]].

	"Step 8: re-enable sound-effects"
	self useSoundEffects: ui preferences doSoundEffects.

! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 8/13/2009 03:11'!
recorder
	^recorder! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 4/9/2010 17:27'!
removeRecordingClient: client
	self assertIsInTurn.
	recorder ifNil: [^self]. "if already stopped when we get  activeSpaceChanged"
	recorder removeClient: client.
	recorder hasClients ifFalse: [
		"Update speaker play-states on transitions.  For example, If we stopped recording because the user switched to another space.  this ensures that there is no spill-over from the previous space to this one.  Also, if we start recording with global speaker muting turned on, this ensures that we unpause the input streams."
		speakerManager ifNotNilDo: [:sm | 
			"Bulletproof... speaker-manager might be nil during shutdown."
			sm updateAllPlayStates]
	]! !

!QAudioSession methodsFor: 'initialize' stamp: 'bgf 11/21/2008 19:07'!
resetAudioInterface
	"Reset the audio interface"
	| |
	audioInterface ifNotNil:[self forceAudioInterfaceClass: audioInterface class].
! !

!QAudioSession methodsFor: 'initialize' stamp: 'jcg 3/25/2010 17:46'!
resetMicrophone: threshold
	"(Re)initialize the microphone with the given noiseThreshold."

	"Previously, we were simply abandoning the existing microphone without doing any cleanup, thereby leaking the mic's SpeexCodec and who-knows-what-else.  Until we know how to properly clean up existing microphones, add this to avoid doing something insane without knowing it."
	microphone ifNotNil: [self error: 'previous microphone was not properly cleaned up'].

	microphone := QMicrophone new.
	microphone jitterStats: micStats.
	microphone noiseThreshold: threshold.
	self useSpeex: true. "always"
! !

!QAudioSession methodsFor: 'reset-sound' stamp: 'jcg 4/7/2010 12:08'!
resetSoundAfterLockingSession: aCroquetSession
	"Main reset - with all TIslands locked to prevent runScript deadlocks from audio-phase render."
	| tries |
	self assertIsInTurn.
	tries := 0.
	[tries < 3] whileTrue: [
		aCroquetSession ifNil: [^false].
		aCroquetSession 
			allIslandsCritical: [self privateResetSound. ^true]
			ifLocked: [
				(Delay forMilliseconds: 5) wait.
				tries := tries + 1.
			].
	].
	^false
	! !

!QAudioSession methodsFor: 'actions' stamp: 'jcg 4/8/2010 08:40'!
resumeAudio
	"Must be run in event-loop."
	self assertIsInTurn.

	"Restore audibility if suspended."
	isSuspended := false.

	"If we're not mute, then neither is the speaker-manager."
	isMute ifFalse: [speakerManager beUnmute].

	"Back to live mic, if we're connected.)"
	(microphone streamer notNil 
	 and: [ microphone isRecording not ] ) 
	ifTrue: [
		microphone startRecording.
		self isPressToTalk ifFalse: [ microphone resumeRecording ].
	].
! !

!QAudioSession methodsFor: 'initialize' stamp: 'hrs 8/15/2008 14:26'!
setupPhoneManagerForSession: aCroquetSession
	phoneManager ifNil: [

		aCroquetSession owner hasPhoneSupport ifFalse: [^self].

		[phoneManager := QFakePhoneManager forSession: aCroquetSession]
			on: Error
			do: [:err | QLogger logError: err].

		aCroquetSession owner phonePane phoneManager: phoneManager.
	].! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 2/19/2007 17:37'!
soundEffects
	^ soundEffects! !

!QAudioSession methodsFor: 'testing' stamp: 'bgf 1/26/2009 15:36'!
soundEffectsAudible
	"Boolean: should sound effects be audible at this moment?
	 Sound effects are misc. sound frames (not voice)"
	^ useSoundEffects & (isMute not) & (isSuspended not)! !

!QAudioSession methodsFor: 'private' stamp: 'jcg 3/30/2009 16:15'!
soundQualityParams: params
	| minMargin maxMargin |

	minMargin := [
		Number readFrom: (params at: 'SoundQuality.MinJitterBuffer')
	] on: Error do: [400].
	maxMargin := [
		Number readFrom: (params at: 'SoundQuality.MaxJitterBuffer')
	] on: Error do: [400].
	(minMargin > maxMargin) ifTrue: [
		QLogger logWarning: 'min jitterbuffer margin > max margin (', 
													minMargin, ' vs. ', maxMargin, ')'.
		maxMargin := minMargin.
	].
	minMargin := minMargin roundUpTo: 80.
	maxMargin := maxMargin roundUpTo: 80.

	QLogger logInfo: 'jitterbuffer margin now ranges from ', minMargin, ' to ', maxMargin.
	jitterbufferMarginRange := minMargin to: maxMargin.! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 2/12/2007 13:21'!
speakerManager
	^ speakerManager! !

!QAudioSession methodsFor: 'voice chat' stamp: 'jcg 4/30/2010 14:23'!
startVoiceChat
	"Start the recorder -> streamer feed for voice chat.
       Start actual sound feed unless we're in PTT.
 	 In PTT, we start recording but don't resume just yet; the pressTalkDown: operation does that."
	self assertIsInTurn.
	self endVoiceChat.		"Safety - get a clean unpaused start."
	microphone streamer: voiceRelay.
	microphone startRecording.
	self isPressToTalk ifFalse: [ microphone resumeRecording ].
	voiceRelay start.
! !

!QAudioSession methodsFor: 'accessing' stamp: 'bgf 9/24/2009 09:43'!
step
	"Audio session per-frame stepping...
	 ensure we're only playing sounds we ought to be able to hear."

	self updateAllIslands! !

!QAudioSession methodsFor: 'private' stamp: 'jcg 4/8/2010 08:55'!
stopMicrophoneRecordingDuring: aBlock
	"Briefly stop the microphone, and restart it after evaluating aBlock."
	| wasRecording |
	wasRecording := microphone isRecording.
	wasRecording ifTrue: [microphone stopRecording].
	aBlock value.
	wasRecording ifTrue: [
		microphone startRecording.
		self isPressToTalk ifFalse: [ microphone resumeRecording ].
	].
	! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 8/12/2009 14:22'!
streamMixer
	^recorder! !

!QAudioSession methodsFor: 'actions' stamp: 'jcg 4/9/2010 17:33'!
suspendAudio
	"Suspend of playback - make all streams inactive until further notice;
	 this differs from mute in that it is not under user control, 
 	 but instead is used to suppress playback when I am Away,
	 or when my avatar appears to be disconnected or timed-out."
	self assertIsInTurn.
	isSuspended := true.
	speakerManager beMute.
	microphone streamer ifNotNil: [ microphone stopRecording ].! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 4/7/2010 10:52'!
ui
	"Answer the QwaqParticipantUI that we're a part of."
	^ ui! !

!QAudioSession methodsFor: 'initialize' stamp: 'jcg 4/2/2010 17:13'!
ui: aQwaqParticipantUI
	ui ifNotNil: [self error: 'UI is already set'].
	ui := aQwaqParticipantUI.! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 4/10/2010 08:10'!
updateAllIslands
	"Audio session per-frame stepping...
	 ensure we're only playing sounds we ought to be able to hear.
	 This rechecks all sound sources, to suppress sound from all but the current island.
	 A  bit more expensive than updateCurrentIsland...,
	 but we need to be sure to mute all non-current speakers. "

	"We're called when #activeSpaceChanged is signalled"
	self isInTurn ifFalse: [
		DropAllButLastEvent signal.
		self future updateAllIslands.
		^self
	].

	view ifNil: [ ^ self ].
	view avatar ifNil: [ ^ self ].

	self speakerManager ifNotNilDo: [ : manager |
		manager speakers 
			do: [ : clientSpeaker | clientSpeaker updateAudibleForView: view audioSession: self ] ].

	soundFramePlayers values 
		do: [ : player | player updateAudibleForView: view audioSession: self ].
! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 5/17/2010 10:39'!
updateCurrentIsland
	"Audio session per-frame stepping...
	 ensure we're only playing sounds we ought to be able to hear.
	 UNUSED - see updateAllIslands....
	 the problem is that any given test of updateAllIslands, after teleporting,
	 may run into locked far-refs, so we can't count on 'occasional' updateAll,
	 instead we do updateAll for each step."

	| isle |
	view ifNil: [ ^ self ].
	view avatar ifNil: [ ^ self ].
	(isle :=view activeIsland) isValidFarRef ifFalse: [ ^ self ].

	"This method isn't currently invoked, but if it is, it will need to be run
	 in the event-loop."
	self assertIsInTurn.

	self speakerManager ifNotNilDo: [ : manager |
		manager speakers 
			select: [ : clientSpeaker | clientSpeaker isInIsland: isle]
			thenDo: [ : clientSpeaker | clientSpeaker updateAudibleForView: view audioSession: self ].
	].

	soundFramePlayers values 
		select: [ : player | player isInIsland:  isle]
		thenDo: [ : player | player updateAudibleForView: view audioSession: self ].
! !

!QAudioSession methodsFor: 'private' stamp: 'jcg 4/10/2010 08:07'!
updateListenerPosition: transform
	"The sound that is played is dependent on the avatar's position; make the necessary updates."

	self assertIsInTurn.
	audioInterface ifNil: [ ^ self ].
	transform = listenerTransform ifTrue: [^self "nothing changed"].
	listenerTransform := transform copy.
	audioInterface updateListenerPosition: listenerTransform.

	"And check all the speakers for appropriate position - we may have moved beside someone."
	speakerManager speakers do: [ : spkr | spkr isMe ifFalse: [ spkr updateTransform ] ].! !

!QAudioSession methodsFor: 'resources' stamp: 'jcg 4/9/2010 17:47'!
updateResourceType: type in: anIsland
	self assertIsInTurn.
	audioInterface ifNotNil: [
		type == QSoundFrame resourceType ifTrue: [
			soundFramePlayers := 
				TClientObject 
					matchupWithResources: type 
					in: anIsland
					existing: soundFramePlayers
					createWith: [:ref | audioInterface createSoundFramePlayerFor: ref].
			^self
		]].

	speakerManager ifNotNil: [
		type == QSpeaker resourceType ifTrue: [
			speakerManager updateSpeakersInIsland: anIsland.
			^ self.
		].
	].! !

!QAudioSession methodsFor: 'private' stamp: 'jcg 4/12/2010 12:13'!
useAudioInterface: newAudioInterface
	"Remake audio session for the new audio interface, 
	 giving every sound frame a new player."

	"Redundant... also checked in #forceAudioInterfaceClass: "
	self assertIsInTurn.

	audioInterface == newAudioInterface ifTrue: [^self].
	audioInterface ifNotNil: [audioInterface destroy].

	audioInterface := newAudioInterface.
	audioInterface audioSession: self.

	"Clear old listenerXFrom so the idempotence check in update isn't fooled during reset."
	listenerTransform := Matrix4x4 new.
	audioInterface updateListenerPosition: listenerTransform.

	self destroyAllPlayers.
	(self allIslands) do: [ :island|
		self updateResourceType: QSoundFrame resourceType in: island
	].

	speakerManager useAudioInterface: newAudioInterface forSession: self.

	"Changing the audio-interface will cause all speakers to be destroyed
	 and re-created.  When the speaker for our avatar is re-created, it will 
	 always have round-trip sound turned off (i.e. we won't Hear Ourself).
	 This ensures that we will Hear Ourself if we want to."
	ui signal: #refreshRoundTripSound

! !

!QAudioSession methodsFor: 'initialize' stamp: 'ar 3/12/2007 17:41'!
useAudioInterfaceClass: subclassOfQwaqAudioInterface
	audioInterface class == subclassOfQwaqAudioInterface ifTrue: [^self].
	^self forceAudioInterfaceClass: subclassOfQwaqAudioInterface! !

!QAudioSession methodsFor: 'voice chat' stamp: 'bgf 3/26/2009 12:44'!
useLowOutputVolume
	audioInterface ifNotNil: [audioInterface useLowOutputVolume]! !

!QAudioSession methodsFor: 'voice chat' stamp: 'bgf 3/26/2009 12:37'!
useNormalOutputVolume
	"Restore to default sound output volume."
	audioInterface ifNotNil: [ audioInterface useNormalOutputVolume ]

! !

!QAudioSession methodsFor: 'private' stamp: 'jcg 6/24/2010 15:08'!
useOpenAL: aBool
	self isInTurn ifFalse: [self future useOpenAL: aBool. ^self].
	aBool ifFalse: [self error: 'OpenAL is always enabled now'].
	self useAudioInterfaceClass: (aBool
									ifTrue: [QwaqOpenALInterface] 
									ifFalse: [QwaqPortAudioInterface]).! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 2/12/2007 13:08'!
useSoundEffects
	^ useSoundEffects! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 2/12/2007 13:08'!
useSoundEffects: aBool
	useSoundEffects := aBool! !

!QAudioSession methodsFor: 'private' stamp: 'jcg 10/14/2008 12:24'!
useSpeex: wantSpeex
	"If 'wantSpeex' is true, try to use Speex codec, otherwise use GSM."
	| codec |
	wantSpeex ifTrue: [ "Attempt to use Speex codec"
		[codec := QSpeexCodec new]
			on: Error do: [QLogger logError: 'Failed to instantiate QSpeexCodec' from: self].
	].
	codec ifNil: [ "Either we wanted GSM, or failed when trying to use Speex"
		codec := GSMCodec new
	].
	microphone codec: codec! !

!QAudioSession methodsFor: 'initialize' stamp: 'jcg 4/10/2010 08:12'!
view: aCroquetView
	"Hook me up to the main croquet view...
	 this sets up managing client-side players for speakers and sound-frames."

	self isInTurn ifFalse: [
		QLogger logInfo: 'resending #view: as future-send'.
		self future view: aCroquetView.
		^self
	].

	(view == aCroquetView) ifTrue: [ ^ self ].

	QLogger logInfo: 'setting audio-session view to: ', aCroquetView.

	self stopScript: #onSoundRegionChanged:.
	self stopScript: #updateAllIslands.

	view := aCroquetView.
	listenerTransform := Matrix4x4 identity.

	speakerManager ifNotNilDo: [:mgr | mgr view: view].

	view ifNotNil: [
		self startScript: #onSoundRegionChanged: 
			when: { view avatar . #soundRegionChanged }.
		"Reset all the audibility flags whenever we change spaces."
		self startScript: #updateAllIslands 
			when: { view owner . #activeSpaceChanged }.

		"Obtain SoundQuality.* parameters from ServiceProvider."
		self soundQualityParams:
			(view owner serviceMgr 
								matchProperty: 'SoundQuality.*'
								scopes: #(user organization tier global)).

		voiceRelay loginName: view owner userLogin. "for media-stream debugging"
		
	] ifNil: [
		self endVoiceChat.
		voiceRelay speaker: nil.
		self destroyAllPlayers.
		self destroyPhoneManager.
	].! !

!QAudioSession methodsFor: 'accessing' stamp: 'jcg 3/4/2010 17:52'!
voiceRelay
	"Answers our QStreamingSoundRelay."
	^voiceRelay! !
QSoundFramePlayerOpenAL initialize!
QAudioFeedbackChannel initialize!
QClientSpeakerOpenALOutput initialize!
QCodecConstants initialize!
QPhoneConstants initialize!
QSoundTest initialize!
